/* Runnable.c generated by valac 0.44.11, the Vala compiler
 * generated from Runnable.vala, do not modify */

/*
This file is part of GameHub.
Copyright (C) 2018-2019 Anatoliy Kashkin

GameHub is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

GameHub is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GameHub.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <json-glib/json-glib.h>
#include <gobject/gvaluecollector.h>
#include <glib/gstdio.h>

#define GAME_HUB_DATA_TYPE_RUNNABLE (game_hub_data_runnable_get_type ())
#define GAME_HUB_DATA_RUNNABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnable))
#define GAME_HUB_DATA_RUNNABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnableClass))
#define GAME_HUB_DATA_IS_RUNNABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_RUNNABLE))
#define GAME_HUB_DATA_IS_RUNNABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_TYPE_RUNNABLE))
#define GAME_HUB_DATA_RUNNABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnableClass))

typedef struct _GameHubDataRunnable GameHubDataRunnable;
typedef struct _GameHubDataRunnableClass GameHubDataRunnableClass;
typedef struct _GameHubDataRunnablePrivate GameHubDataRunnablePrivate;
typedef enum  {
	GAME_HUB_DATA_PLATFORM_LINUX,
	GAME_HUB_DATA_PLATFORM_WINDOWS,
	GAME_HUB_DATA_PLATFORM_MACOS,
	GAME_HUB_DATA_PLATFORM_EMULATED
} GameHubDataPlatform;

#define GAME_HUB_DATA_TYPE_PLATFORM (game_hub_data_platform_get_type ())
typedef enum  {
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_INTERACTIVE,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_AUTOMATIC,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_AUTOMATIC_DOWNLOAD
} GameHubDataRunnableInstallerInstallMode;

#define GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_INSTALL_MODE (game_hub_data_runnable_installer_install_mode_get_type ())

#define GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION (game_hub_data_runnable_runnable_action_get_type ())
#define GAME_HUB_DATA_RUNNABLE_RUNNABLE_ACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION, GameHubDataRunnableRunnableAction))
#define GAME_HUB_DATA_RUNNABLE_RUNNABLE_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION, GameHubDataRunnableRunnableActionClass))
#define GAME_HUB_DATA_RUNNABLE_IS_RUNNABLE_ACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION))
#define GAME_HUB_DATA_RUNNABLE_IS_RUNNABLE_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION))
#define GAME_HUB_DATA_RUNNABLE_RUNNABLE_ACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION, GameHubDataRunnableRunnableActionClass))

typedef struct _GameHubDataRunnableRunnableAction GameHubDataRunnableRunnableAction;
typedef struct _GameHubDataRunnableRunnableActionClass GameHubDataRunnableRunnableActionClass;
enum  {
	GAME_HUB_DATA_RUNNABLE_0_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_ID_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_ESCAPED_NAME_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_NORMALIZED_NAME_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_NAME_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_COMPAT_TOOL_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_COMPAT_TOOL_SETTINGS_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_ARGUMENTS_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_IS_RUNNING_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_PLATFORMS_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_EXECUTABLE_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_INSTALL_DIR_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_WORK_DIR_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_DEFAULT_INSTALL_DIR_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_ACTIONS_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_USE_COMPAT_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_NEEDS_COMPAT_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_FORCE_COMPAT_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_COMPAT_OPTIONS_SAVED_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_NUM_PROPERTIES
};
static GParamSpec* game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GAME_HUB_DATA_TYPE_COMPAT_TOOL (game_hub_data_compat_tool_get_type ())
#define GAME_HUB_DATA_COMPAT_TOOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_COMPAT_TOOL, GameHubDataCompatTool))
#define GAME_HUB_DATA_COMPAT_TOOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_TYPE_COMPAT_TOOL, GameHubDataCompatToolClass))
#define GAME_HUB_DATA_IS_COMPAT_TOOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_COMPAT_TOOL))
#define GAME_HUB_DATA_IS_COMPAT_TOOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_TYPE_COMPAT_TOOL))
#define GAME_HUB_DATA_COMPAT_TOOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_TYPE_COMPAT_TOOL, GameHubDataCompatToolClass))

typedef struct _GameHubDataCompatTool GameHubDataCompatTool;
typedef struct _GameHubDataCompatToolClass GameHubDataCompatToolClass;
typedef struct _Block5Data Block5Data;

#define GAME_HUB_UI_DIALOGS_TYPE_COMPAT_RUN_DIALOG (game_hub_ui_dialogs_compat_run_dialog_get_type ())
#define GAME_HUB_UI_DIALOGS_COMPAT_RUN_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UI_DIALOGS_TYPE_COMPAT_RUN_DIALOG, GameHubUIDialogsCompatRunDialog))
#define GAME_HUB_UI_DIALOGS_COMPAT_RUN_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UI_DIALOGS_TYPE_COMPAT_RUN_DIALOG, GameHubUIDialogsCompatRunDialogClass))
#define GAME_HUB_UI_DIALOGS_IS_COMPAT_RUN_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UI_DIALOGS_TYPE_COMPAT_RUN_DIALOG))
#define GAME_HUB_UI_DIALOGS_IS_COMPAT_RUN_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UI_DIALOGS_TYPE_COMPAT_RUN_DIALOG))
#define GAME_HUB_UI_DIALOGS_COMPAT_RUN_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UI_DIALOGS_TYPE_COMPAT_RUN_DIALOG, GameHubUIDialogsCompatRunDialogClass))

typedef struct _GameHubUIDialogsCompatRunDialog GameHubUIDialogsCompatRunDialog;
typedef struct _GameHubUIDialogsCompatRunDialogClass GameHubUIDialogsCompatRunDialogClass;

#define GAME_HUB_DATA_TYPE_GAME (game_hub_data_game_get_type ())
#define GAME_HUB_DATA_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_GAME, GameHubDataGame))
#define GAME_HUB_DATA_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_TYPE_GAME, GameHubDataGameClass))
#define GAME_HUB_DATA_IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_GAME))
#define GAME_HUB_DATA_IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_TYPE_GAME))
#define GAME_HUB_DATA_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_TYPE_GAME, GameHubDataGameClass))

typedef struct _GameHubDataGame GameHubDataGame;
typedef struct _GameHubDataGameClass GameHubDataGameClass;
typedef struct _GameHubDataRunnableRunWithCompatData GameHubDataRunnableRunWithCompatData;

#define GAME_HUB_UI_WINDOWS_TYPE_MAIN_WINDOW (game_hub_ui_windows_main_window_get_type ())
#define GAME_HUB_UI_WINDOWS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UI_WINDOWS_TYPE_MAIN_WINDOW, GameHubUIWindowsMainWindow))
#define GAME_HUB_UI_WINDOWS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UI_WINDOWS_TYPE_MAIN_WINDOW, GameHubUIWindowsMainWindowClass))
#define GAME_HUB_UI_WINDOWS_IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UI_WINDOWS_TYPE_MAIN_WINDOW))
#define GAME_HUB_UI_WINDOWS_IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UI_WINDOWS_TYPE_MAIN_WINDOW))
#define GAME_HUB_UI_WINDOWS_MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UI_WINDOWS_TYPE_MAIN_WINDOW, GameHubUIWindowsMainWindowClass))

typedef struct _GameHubUIWindowsMainWindow GameHubUIWindowsMainWindow;
typedef struct _GameHubUIWindowsMainWindowClass GameHubUIWindowsMainWindowClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define GAME_HUB_UTILS_TYPE_RUN_TASK (game_hub_utils_run_task_get_type ())
#define GAME_HUB_UTILS_RUN_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UTILS_TYPE_RUN_TASK, GameHubUtilsRunTask))
#define GAME_HUB_UTILS_RUN_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UTILS_TYPE_RUN_TASK, GameHubUtilsRunTaskClass))
#define GAME_HUB_UTILS_IS_RUN_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UTILS_TYPE_RUN_TASK))
#define GAME_HUB_UTILS_IS_RUN_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UTILS_TYPE_RUN_TASK))
#define GAME_HUB_UTILS_RUN_TASK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UTILS_TYPE_RUN_TASK, GameHubUtilsRunTaskClass))

typedef struct _GameHubUtilsRunTask GameHubUtilsRunTask;
typedef struct _GameHubUtilsRunTaskClass GameHubUtilsRunTaskClass;

#define GAME_HUB_UTILS_RUN_TASK_TYPE_RESULT (game_hub_utils_run_task_result_get_type ())
#define GAME_HUB_UTILS_RUN_TASK_RESULT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UTILS_RUN_TASK_TYPE_RESULT, GameHubUtilsRunTaskResult))
#define GAME_HUB_UTILS_RUN_TASK_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UTILS_RUN_TASK_TYPE_RESULT, GameHubUtilsRunTaskResultClass))
#define GAME_HUB_UTILS_RUN_TASK_IS_RESULT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UTILS_RUN_TASK_TYPE_RESULT))
#define GAME_HUB_UTILS_RUN_TASK_IS_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UTILS_RUN_TASK_TYPE_RESULT))
#define GAME_HUB_UTILS_RUN_TASK_RESULT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UTILS_RUN_TASK_TYPE_RESULT, GameHubUtilsRunTaskResultClass))

typedef struct _GameHubUtilsRunTaskResult GameHubUtilsRunTaskResult;
typedef struct _GameHubUtilsRunTaskResultClass GameHubUtilsRunTaskResultClass;
#define _game_hub_utils_run_task_result_unref0(var) ((var == NULL) ? NULL : (var = (game_hub_utils_run_task_result_unref (var), NULL)))
#define _game_hub_utils_run_task_unref0(var) ((var == NULL) ? NULL : (var = (game_hub_utils_run_task_unref (var), NULL)))

#define GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG_GAME (game_hub_data_sources_gog_gog_game_get_type ())
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG_GAME, GameHubDataSourcesGOGGOGGame))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG_GAME, GameHubDataSourcesGOGGOGGameClass))
#define GAME_HUB_DATA_SOURCES_GOG_IS_GOG_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG_GAME))
#define GAME_HUB_DATA_SOURCES_GOG_IS_GOG_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG_GAME))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG_GAME, GameHubDataSourcesGOGGOGGameClass))

typedef struct _GameHubDataSourcesGOGGOGGame GameHubDataSourcesGOGGOGGame;
typedef struct _GameHubDataSourcesGOGGOGGameClass GameHubDataSourcesGOGGOGGameClass;

#define GAME_HUB_DATA_SOURCES_HUMBLE_TYPE_HUMBLE_GAME (game_hub_data_sources_humble_humble_game_get_type ())
#define GAME_HUB_DATA_SOURCES_HUMBLE_HUMBLE_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_SOURCES_HUMBLE_TYPE_HUMBLE_GAME, GameHubDataSourcesHumbleHumbleGame))
#define GAME_HUB_DATA_SOURCES_HUMBLE_HUMBLE_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_SOURCES_HUMBLE_TYPE_HUMBLE_GAME, GameHubDataSourcesHumbleHumbleGameClass))
#define GAME_HUB_DATA_SOURCES_HUMBLE_IS_HUMBLE_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_SOURCES_HUMBLE_TYPE_HUMBLE_GAME))
#define GAME_HUB_DATA_SOURCES_HUMBLE_IS_HUMBLE_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_SOURCES_HUMBLE_TYPE_HUMBLE_GAME))
#define GAME_HUB_DATA_SOURCES_HUMBLE_HUMBLE_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_SOURCES_HUMBLE_TYPE_HUMBLE_GAME, GameHubDataSourcesHumbleHumbleGameClass))

typedef struct _GameHubDataSourcesHumbleHumbleGame GameHubDataSourcesHumbleHumbleGame;
typedef struct _GameHubDataSourcesHumbleHumbleGameClass GameHubDataSourcesHumbleHumbleGameClass;
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

#define GAME_HUB_DATA_SOURCES_STEAM_TYPE_STEAM_GAME (game_hub_data_sources_steam_steam_game_get_type ())
#define GAME_HUB_DATA_SOURCES_STEAM_STEAM_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_SOURCES_STEAM_TYPE_STEAM_GAME, GameHubDataSourcesSteamSteamGame))
#define GAME_HUB_DATA_SOURCES_STEAM_STEAM_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_SOURCES_STEAM_TYPE_STEAM_GAME, GameHubDataSourcesSteamSteamGameClass))
#define GAME_HUB_DATA_SOURCES_STEAM_IS_STEAM_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_SOURCES_STEAM_TYPE_STEAM_GAME))
#define GAME_HUB_DATA_SOURCES_STEAM_IS_STEAM_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_SOURCES_STEAM_TYPE_STEAM_GAME))
#define GAME_HUB_DATA_SOURCES_STEAM_STEAM_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_SOURCES_STEAM_TYPE_STEAM_GAME, GameHubDataSourcesSteamSteamGameClass))

typedef struct _GameHubDataSourcesSteamSteamGame GameHubDataSourcesSteamSteamGame;
typedef struct _GameHubDataSourcesSteamSteamGameClass GameHubDataSourcesSteamSteamGameClass;

#define GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER (game_hub_data_runnable_installer_get_type ())
#define GAME_HUB_DATA_RUNNABLE_INSTALLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER, GameHubDataRunnableInstaller))
#define GAME_HUB_DATA_RUNNABLE_INSTALLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER, GameHubDataRunnableInstallerClass))
#define GAME_HUB_DATA_RUNNABLE_IS_INSTALLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER))
#define GAME_HUB_DATA_RUNNABLE_IS_INSTALLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER))
#define GAME_HUB_DATA_RUNNABLE_INSTALLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER, GameHubDataRunnableInstallerClass))

typedef struct _GameHubDataRunnableInstaller GameHubDataRunnableInstaller;
typedef struct _GameHubDataRunnableInstallerClass GameHubDataRunnableInstallerClass;
typedef struct _GameHubDataRunnableInstallerPrivate GameHubDataRunnableInstallerPrivate;
typedef enum  {
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_UNKNOWN,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_EXECUTABLE,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_WINDOWS_EXECUTABLE,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_GOG_PART,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_ARCHIVE,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_WINDOWS_NSIS_INSTALLER
} GameHubDataRunnableInstallerInstallerType;

#define GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_INSTALLER_TYPE (game_hub_data_runnable_installer_installer_type_get_type ())
typedef struct _GameHubUtilsRunTaskResultPrivate GameHubUtilsRunTaskResultPrivate;
typedef struct _GameHubDataRunnableInstallerGuessTypeData GameHubDataRunnableInstallerGuessTypeData;
typedef struct _GameHubDataRunnableParamSpecInstaller GameHubDataRunnableParamSpecInstaller;

#define GAME_HUB_DATA_RUNNABLE_TYPE_FILE_INSTALLER (game_hub_data_runnable_file_installer_get_type ())
#define GAME_HUB_DATA_RUNNABLE_FILE_INSTALLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_FILE_INSTALLER, GameHubDataRunnableFileInstaller))
#define GAME_HUB_DATA_RUNNABLE_FILE_INSTALLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_RUNNABLE_TYPE_FILE_INSTALLER, GameHubDataRunnableFileInstallerClass))
#define GAME_HUB_DATA_RUNNABLE_IS_FILE_INSTALLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_FILE_INSTALLER))
#define GAME_HUB_DATA_RUNNABLE_IS_FILE_INSTALLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_RUNNABLE_TYPE_FILE_INSTALLER))
#define GAME_HUB_DATA_RUNNABLE_FILE_INSTALLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_FILE_INSTALLER, GameHubDataRunnableFileInstallerClass))

typedef struct _GameHubDataRunnableFileInstaller GameHubDataRunnableFileInstaller;
typedef struct _GameHubDataRunnableFileInstallerClass GameHubDataRunnableFileInstallerClass;
typedef struct _GameHubDataRunnableFileInstallerPrivate GameHubDataRunnableFileInstallerPrivate;
#define _game_hub_data_runnable_installer_unref0(var) ((var == NULL) ? NULL : (var = (game_hub_data_runnable_installer_unref (var), NULL)))
typedef struct _GameHubDataRunnableFileInstallerInstallData GameHubDataRunnableFileInstallerInstallData;

#define GAME_HUB_DATA_COMPAT_TYPE_INNOEXTRACT (game_hub_data_compat_innoextract_get_type ())
#define GAME_HUB_DATA_COMPAT_INNOEXTRACT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_COMPAT_TYPE_INNOEXTRACT, GameHubDataCompatInnoextract))
#define GAME_HUB_DATA_COMPAT_INNOEXTRACT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_COMPAT_TYPE_INNOEXTRACT, GameHubDataCompatInnoextractClass))
#define GAME_HUB_DATA_COMPAT_IS_INNOEXTRACT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_COMPAT_TYPE_INNOEXTRACT))
#define GAME_HUB_DATA_COMPAT_IS_INNOEXTRACT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_COMPAT_TYPE_INNOEXTRACT))
#define GAME_HUB_DATA_COMPAT_INNOEXTRACT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_COMPAT_TYPE_INNOEXTRACT, GameHubDataCompatInnoextractClass))

typedef struct _GameHubDataCompatInnoextract GameHubDataCompatInnoextract;
typedef struct _GameHubDataCompatInnoextractClass GameHubDataCompatInnoextractClass;
typedef enum  {
	GAME_HUB_DATA_GAME_STATE_UNINSTALLED,
	GAME_HUB_DATA_GAME_STATE_INSTALLED,
	GAME_HUB_DATA_GAME_STATE_DOWNLOADING,
	GAME_HUB_DATA_GAME_STATE_VERIFYING_INSTALLER_INTEGRITY,
	GAME_HUB_DATA_GAME_STATE_INSTALLING
} GameHubDataGameState;

#define GAME_HUB_DATA_GAME_TYPE_STATE (game_hub_data_game_state_get_type ())

#define GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD (game_hub_utils_downloader_download_get_type ())
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD, GameHubUtilsDownloaderDownload))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD, GameHubUtilsDownloaderDownloadClass))
#define GAME_HUB_UTILS_DOWNLOADER_IS_DOWNLOAD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD))
#define GAME_HUB_UTILS_DOWNLOADER_IS_DOWNLOAD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD, GameHubUtilsDownloaderDownloadClass))

typedef struct _GameHubUtilsDownloaderDownload GameHubUtilsDownloaderDownload;
typedef struct _GameHubUtilsDownloaderDownloadClass GameHubUtilsDownloaderDownloadClass;

#define GAME_HUB_DATA_GAME_TYPE_STATUS (game_hub_data_game_status_get_type ())
#define GAME_HUB_DATA_GAME_STATUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_GAME_TYPE_STATUS, GameHubDataGameStatus))
#define GAME_HUB_DATA_GAME_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_GAME_TYPE_STATUS, GameHubDataGameStatusClass))
#define GAME_HUB_DATA_GAME_IS_STATUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_GAME_TYPE_STATUS))
#define GAME_HUB_DATA_GAME_IS_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_GAME_TYPE_STATUS))
#define GAME_HUB_DATA_GAME_STATUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_GAME_TYPE_STATUS, GameHubDataGameStatusClass))

typedef struct _GameHubDataGameStatus GameHubDataGameStatus;
typedef struct _GameHubDataGameStatusClass GameHubDataGameStatusClass;
#define _game_hub_data_game_status_unref0(var) ((var == NULL) ? NULL : (var = (game_hub_data_game_status_unref (var), NULL)))
typedef struct _GameHubDataRunnableFileInstallerInstallFileData GameHubDataRunnableFileInstallerInstallFileData;

#define GAME_HUB_DATA_RUNNABLE_TYPE_DOWNLOADABLE_INSTALLER (game_hub_data_runnable_downloadable_installer_get_type ())
#define GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_DOWNLOADABLE_INSTALLER, GameHubDataRunnableDownloadableInstaller))
#define GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_RUNNABLE_TYPE_DOWNLOADABLE_INSTALLER, GameHubDataRunnableDownloadableInstallerClass))
#define GAME_HUB_DATA_RUNNABLE_IS_DOWNLOADABLE_INSTALLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_DOWNLOADABLE_INSTALLER))
#define GAME_HUB_DATA_RUNNABLE_IS_DOWNLOADABLE_INSTALLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_RUNNABLE_TYPE_DOWNLOADABLE_INSTALLER))
#define GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_DOWNLOADABLE_INSTALLER, GameHubDataRunnableDownloadableInstallerClass))

typedef struct _GameHubDataRunnableDownloadableInstaller GameHubDataRunnableDownloadableInstaller;
typedef struct _GameHubDataRunnableDownloadableInstallerClass GameHubDataRunnableDownloadableInstallerClass;
typedef struct _GameHubDataRunnableDownloadableInstallerPrivate GameHubDataRunnableDownloadableInstallerPrivate;

#define GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_TYPE_PART (game_hub_data_runnable_downloadable_installer_part_get_type ())
#define GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_TYPE_PART, GameHubDataRunnableDownloadableInstallerPart))
#define GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_TYPE_PART, GameHubDataRunnableDownloadableInstallerPartClass))
#define GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_IS_PART(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_TYPE_PART))
#define GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_IS_PART_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_TYPE_PART))
#define GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_TYPE_PART, GameHubDataRunnableDownloadableInstallerPartClass))

typedef struct _GameHubDataRunnableDownloadableInstallerPart GameHubDataRunnableDownloadableInstallerPart;
typedef struct _GameHubDataRunnableDownloadableInstallerPartClass GameHubDataRunnableDownloadableInstallerPartClass;
typedef struct _GameHubDataRunnableDownloadableInstallerFetchPartsData GameHubDataRunnableDownloadableInstallerFetchPartsData;
typedef struct _Block6Data Block6Data;
typedef struct _Block7Data Block7Data;
typedef struct _Block8Data Block8Data;

#define GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_MANAGER (game_hub_utils_downloader_download_manager_get_type ())
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_MANAGER, GameHubUtilsDownloaderDownloadManager))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_MANAGER, GameHubUtilsDownloaderDownloadManagerClass))
#define GAME_HUB_UTILS_DOWNLOADER_IS_DOWNLOAD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_MANAGER))
#define GAME_HUB_UTILS_DOWNLOADER_IS_DOWNLOAD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_MANAGER))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_MANAGER, GameHubUtilsDownloaderDownloadManagerClass))

typedef struct _GameHubUtilsDownloaderDownloadManager GameHubUtilsDownloaderDownloadManager;
typedef struct _GameHubUtilsDownloaderDownloadManagerClass GameHubUtilsDownloaderDownloadManagerClass;

#define GAME_HUB_UTILS_DOWNLOADER_TYPE_FILE_DOWNLOAD (game_hub_utils_downloader_file_download_get_type ())
#define GAME_HUB_UTILS_DOWNLOADER_FILE_DOWNLOAD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_FILE_DOWNLOAD, GameHubUtilsDownloaderFileDownload))
#define GAME_HUB_UTILS_DOWNLOADER_FILE_DOWNLOAD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_FILE_DOWNLOAD, GameHubUtilsDownloaderFileDownloadClass))
#define GAME_HUB_UTILS_DOWNLOADER_IS_FILE_DOWNLOAD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_FILE_DOWNLOAD))
#define GAME_HUB_UTILS_DOWNLOADER_IS_FILE_DOWNLOAD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_FILE_DOWNLOAD))
#define GAME_HUB_UTILS_DOWNLOADER_FILE_DOWNLOAD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_FILE_DOWNLOAD, GameHubUtilsDownloaderFileDownloadClass))

typedef struct _GameHubUtilsDownloaderFileDownload GameHubUtilsDownloaderFileDownload;
typedef struct _GameHubUtilsDownloaderFileDownloadClass GameHubUtilsDownloaderFileDownloadClass;
typedef struct _GameHubUtilsDownloaderDownloadPrivate GameHubUtilsDownloaderDownloadPrivate;

#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_TYPE_STATUS (game_hub_utils_downloader_download_status_get_type ())
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_STATUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_TYPE_STATUS, GameHubUtilsDownloaderDownloadStatus))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_TYPE_STATUS, GameHubUtilsDownloaderDownloadStatusClass))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_IS_STATUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_TYPE_STATUS))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_IS_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_TYPE_STATUS))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_STATUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_TYPE_STATUS, GameHubUtilsDownloaderDownloadStatusClass))

typedef struct _GameHubUtilsDownloaderDownloadStatus GameHubUtilsDownloaderDownloadStatus;
typedef struct _GameHubUtilsDownloaderDownloadStatusClass GameHubUtilsDownloaderDownloadStatusClass;
typedef struct _GameHubUtilsDownloaderFileDownloadPrivate GameHubUtilsDownloaderFileDownloadPrivate;

#define GAME_HUB_DATA_TYPE_GAME_SOURCE (game_hub_data_game_source_get_type ())
#define GAME_HUB_DATA_GAME_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_GAME_SOURCE, GameHubDataGameSource))
#define GAME_HUB_DATA_GAME_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_TYPE_GAME_SOURCE, GameHubDataGameSourceClass))
#define GAME_HUB_DATA_IS_GAME_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_GAME_SOURCE))
#define GAME_HUB_DATA_IS_GAME_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_TYPE_GAME_SOURCE))
#define GAME_HUB_DATA_GAME_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_TYPE_GAME_SOURCE, GameHubDataGameSourceClass))

typedef struct _GameHubDataGameSource GameHubDataGameSource;
typedef struct _GameHubDataGameSourceClass GameHubDataGameSourceClass;

#define GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_INFO (game_hub_utils_downloader_download_info_get_type ())
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_INFO, GameHubUtilsDownloaderDownloadInfo))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_INFO, GameHubUtilsDownloaderDownloadInfoClass))
#define GAME_HUB_UTILS_DOWNLOADER_IS_DOWNLOAD_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_INFO))
#define GAME_HUB_UTILS_DOWNLOADER_IS_DOWNLOAD_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_INFO))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_INFO, GameHubUtilsDownloaderDownloadInfoClass))

typedef struct _GameHubUtilsDownloaderDownloadInfo GameHubUtilsDownloaderDownloadInfo;
typedef struct _GameHubUtilsDownloaderDownloadInfoClass GameHubUtilsDownloaderDownloadInfoClass;
typedef GNotification* (*GameHubUtilsNotificationConfigureDelegate) (GNotification* notification, gpointer user_data);
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _GameHubDataRunnableDownloadableInstallerDownloadData GameHubDataRunnableDownloadableInstallerDownloadData;
typedef struct _Block9Data Block9Data;

#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_DLC (game_hub_data_sources_gog_gog_game_dlc_get_type ())
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_DLC(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_DLC, GameHubDataSourcesGOGGOGGameDLC))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_DLC_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_DLC, GameHubDataSourcesGOGGOGGameDLCClass))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_IS_DLC(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_DLC))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_IS_DLC_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_DLC))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_DLC_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_DLC, GameHubDataSourcesGOGGOGGameDLCClass))

typedef struct _GameHubDataSourcesGOGGOGGameDLC GameHubDataSourcesGOGGOGGameDLC;
typedef struct _GameHubDataSourcesGOGGOGGameDLCClass GameHubDataSourcesGOGGOGGameDLCClass;
#define _game_hub_data_runnable_runnable_action_unref0(var) ((var == NULL) ? NULL : (var = (game_hub_data_runnable_runnable_action_unref (var), NULL)))
typedef struct _GameHubDataRunnableDownloadableInstallerInstallData GameHubDataRunnableDownloadableInstallerInstallData;
typedef struct _GameHubDataRunnableDownloadableInstallerPartPrivate GameHubDataRunnableDownloadableInstallerPartPrivate;
enum  {
	GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_0_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_ID_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_URL_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_SIZE_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_REMOTE_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_LOCAL_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_CHECKSUM_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_CHECKSUM_TYPE_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_CHECKSUM_TYPE_STRING_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_NUM_PROPERTIES
};
static GParamSpec* game_hub_data_runnable_downloadable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_NUM_PROPERTIES];
typedef struct _GameHubDataRunnableRunnableActionPrivate GameHubDataRunnableRunnableActionPrivate;
typedef struct _GameHubDataRunnableRunnableActionInvokeData GameHubDataRunnableRunnableActionInvokeData;
typedef struct _GameHubDataRunnableParamSpecRunnableAction GameHubDataRunnableParamSpecRunnableAction;

struct _GameHubDataRunnable {
	GObject parent_instance;
	GameHubDataRunnablePrivate * priv;
};

struct _GameHubDataRunnableClass {
	GObjectClass parent_class;
	gboolean (*is_supported) (GameHubDataRunnable* self, GameHubDataPlatform* platform, gboolean with_compat);
	void (*install) (GameHubDataRunnable* self, GameHubDataRunnableInstallerInstallMode install_mode, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*install_finish) (GameHubDataRunnable* self, GAsyncResult* _res_);
	void (*run) (GameHubDataRunnable* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*run_finish) (GameHubDataRunnable* self, GAsyncResult* _res_);
	gboolean (*can_be_launched) (GameHubDataRunnable* self, gboolean is_launch_attempt);
	void (*run_with_compat) (GameHubDataRunnable* self, gboolean is_opened_from_menu, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*run_with_compat_finish) (GameHubDataRunnable* self, GAsyncResult* _res_);
	GtkFileChooser* (*setup_executable_chooser) (GameHubDataRunnable* self);
	void (*choose_executable) (GameHubDataRunnable* self, gboolean update);
	void (*set_chosen_executable) (GameHubDataRunnable* self, GFile* file, gboolean update);
	void (*save) (GameHubDataRunnable* self);
	void (*update_status) (GameHubDataRunnable* self);
	void (*import) (GameHubDataRunnable* self, gboolean update);
	GFile* (*get_executable) (GameHubDataRunnable* self);
	void (*set_executable) (GameHubDataRunnable* self, GFile* value);
	GFile* (*get_work_dir) (GameHubDataRunnable* self);
	void (*set_work_dir) (GameHubDataRunnable* self, GFile* value);
	GFile* (*get_default_install_dir) (GameHubDataRunnable* self);
};

struct _GameHubDataRunnablePrivate {
	gchar* _id;
	gchar* _name;
	gchar* _escaped_name;
	gchar* _normalized_name;
	gchar* _compat_tool;
	gchar* _compat_tool_settings;
	gchar* _arguments;
	gboolean _is_running;
	GeeArrayList* _platforms;
	GFile* _install_dir;
	GeeArrayList* _actions;
};

struct _Block5Data {
	int _ref_count_;
	GameHubDataRunnable* self;
	gpointer _async_data_;
};

struct _GameHubDataRunnableRunWithCompatData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataRunnable* self;
	gboolean is_opened_from_menu;
	Block5Data* _data5_;
	GameHubUIDialogsCompatRunDialog* dlg;
	GameHubUIDialogsCompatRunDialog* _tmp0_;
	GameHubUIDialogsCompatRunDialog* _tmp1_;
};

struct _GameHubDataRunnableInstaller {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameHubDataRunnableInstallerPrivate * priv;
};

struct _GameHubDataRunnableInstallerClass {
	GTypeClass parent_class;
	void (*finalize) (GameHubDataRunnableInstaller *self);
	void (*install) (GameHubDataRunnableInstaller* self, GameHubDataRunnable* runnable, GameHubDataCompatTool* tool, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*install_finish) (GameHubDataRunnableInstaller* self, GAsyncResult* _res_);
	gchar* (*get_name) (GameHubDataRunnableInstaller* self);
};

struct _GameHubDataRunnableInstallerPrivate {
	gchar* _id;
	GameHubDataPlatform _platform;
	gint64 _full_size;
	gchar* _version;
};

struct _GameHubUtilsRunTaskResult {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameHubUtilsRunTaskResultPrivate * priv;
	gint* status;
	gint* exit_code;
	gchar* output;
	gchar* errors;
};

struct _GameHubUtilsRunTaskResultClass {
	GTypeClass parent_class;
	void (*finalize) (GameHubUtilsRunTaskResult *self);
};

struct _GameHubDataRunnableInstallerGuessTypeData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GFile* file;
	gboolean is_part;
	GameHubDataRunnableInstallerInstallerType result;
	GameHubDataRunnableInstallerInstallerType type;
	GFileInfo* finfo;
	GFileInfo* _tmp0_;
	gchar* mime;
	GFileInfo* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	GameHubDataRunnableInstallerInstallerType _tmp5_;
	gchar* info;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar** _tmp9_;
	gchar** _tmp10_;
	gint _tmp10__length1;
	GameHubUtilsRunTask* _tmp11_;
	GameHubUtilsRunTask* _tmp12_;
	GameHubUtilsRunTask* _tmp13_;
	GameHubUtilsRunTask* _tmp14_;
	GameHubUtilsRunTaskResult* _tmp15_;
	GameHubUtilsRunTaskResult* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gboolean _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	const gchar* _tmp25_;
	gchar** _tmp26_;
	gchar** _tmp27_;
	gchar** _tmp28_;
	gint _tmp28__length1;
	const gchar* _tmp29_;
	gchar* _tmp30_;
	gboolean _tmp31_;
	const gchar* _tmp32_;
	const gchar* _tmp33_;
	gint _tmp34_;
	gint _tmp35_;
	const gchar* _tmp36_;
	GameHubDataRunnableInstallerInstallerType _tmp37_;
	gchar** gog_part_ext;
	gchar* _tmp38_;
	gchar** _tmp39_;
	gint gog_part_ext_length1;
	gint _gog_part_ext_size_;
	gchar** exe_ext;
	gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	gchar** _tmp44_;
	gint exe_ext_length1;
	gint _exe_ext_size_;
	gchar** win_exe_ext;
	gchar* _tmp45_;
	gchar* _tmp46_;
	gchar** _tmp47_;
	gint win_exe_ext_length1;
	gint _win_exe_ext_size_;
	gchar** arc_ext;
	gchar* _tmp48_;
	gchar* _tmp49_;
	gchar* _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	gchar* _tmp53_;
	gchar* _tmp54_;
	gchar* _tmp55_;
	gchar* _tmp56_;
	gchar** _tmp57_;
	gint arc_ext_length1;
	gint _arc_ext_size_;
	gchar** _tmp58_;
	gint _tmp58__length1;
	gchar** ext_collection;
	gint ext_collection_length1;
	gint _ext_collection_size_;
	gint ext_it;
	gchar* _tmp59_;
	gchar* ext;
	gchar* _tmp60_;
	gchar* _tmp61_;
	gchar* _tmp62_;
	gchar* _tmp63_;
	const gchar* _tmp64_;
	const gchar* _tmp65_;
	gchar* _tmp66_;
	gchar* _tmp67_;
	gboolean _tmp68_;
	gchar** _tmp69_;
	gint _tmp69__length1;
	gchar** _vala1_ext_collection;
	gint _vala1_ext_collection_length1;
	gint __vala1_ext_collection_size_;
	gint _vala1_ext_it;
	gchar* _tmp70_;
	gchar* _vala1_ext;
	gchar* _tmp71_;
	gchar* _tmp72_;
	gchar* _tmp73_;
	gchar* _tmp74_;
	const gchar* _tmp75_;
	const gchar* _tmp76_;
	gchar* _tmp77_;
	gchar* _tmp78_;
	gboolean _tmp79_;
	gchar** _tmp80_;
	gint _tmp80__length1;
	gchar** _vala2_ext_collection;
	gint _vala2_ext_collection_length1;
	gint __vala2_ext_collection_size_;
	gint _vala2_ext_it;
	gchar* _tmp81_;
	gchar* _vala2_ext;
	gchar* _tmp82_;
	gchar* _tmp83_;
	gchar* _tmp84_;
	gchar* _tmp85_;
	const gchar* _tmp86_;
	const gchar* _tmp87_;
	gchar* _tmp88_;
	gchar* _tmp89_;
	gboolean _tmp90_;
	gchar** _tmp91_;
	gint _tmp91__length1;
	gchar** _vala3_ext_collection;
	gint _vala3_ext_collection_length1;
	gint __vala3_ext_collection_size_;
	gint _vala3_ext_it;
	gchar* _tmp92_;
	gchar* _vala3_ext;
	gchar* _tmp93_;
	gchar* _tmp94_;
	gchar* _tmp95_;
	gchar* _tmp96_;
	const gchar* _tmp97_;
	const gchar* _tmp98_;
	gchar* _tmp99_;
	gchar* _tmp100_;
	gboolean _tmp101_;
	GError* e;
	GError* _inner_error0_;
};

struct _GameHubDataRunnableParamSpecInstaller {
	GParamSpec parent_instance;
};

struct _GameHubDataRunnableFileInstaller {
	GameHubDataRunnableInstaller parent_instance;
	GameHubDataRunnableFileInstallerPrivate * priv;
};

struct _GameHubDataRunnableFileInstallerClass {
	GameHubDataRunnableInstallerClass parent_class;
};

struct _GameHubDataRunnableFileInstallerPrivate {
	GFile* _file;
	gint64 _size;
};

struct _GameHubDataRunnableFileInstallerInstallData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataRunnableFileInstaller* self;
	GameHubDataRunnable* runnable;
	GameHubDataCompatTool* tool;
	GFile* _tmp0_;
};

struct _GameHubDataRunnableFileInstallerInstallFileData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GFile* file;
	gboolean is_part;
	GameHubDataRunnable* runnable;
	GameHubDataCompatTool* tool;
	gboolean is_windows_installer;
	gboolean is_nsis_installer;
	gboolean _tmp0_;
	GameHubDataGame* game;
	GameHubDataGame* _tmp1_;
	gchar* path;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	GameHubUtilsRunTask* _tmp9_;
	GameHubUtilsRunTask* _tmp10_;
	GameHubUtilsRunTaskResult* _tmp11_;
	GameHubUtilsRunTaskResult* _tmp12_;
	GFile* _tmp13_;
	GFile* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	GFile* _tmp17_;
	GFile* _tmp18_;
	GameHubDataRunnableInstallerInstallerType type;
	gboolean _tmp19_;
	GameHubDataRunnableInstallerInstallerType _tmp20_;
	gchar* desc;
	gchar* _tmp21_;
	gchar* _tmp22_;
	const gchar* _tmp23_;
	gchar* _tmp24_;
	gchar** _tmp25_;
	gchar** _tmp26_;
	gint _tmp26__length1;
	GameHubUtilsRunTask* _tmp27_;
	GameHubUtilsRunTask* _tmp28_;
	GameHubUtilsRunTask* _tmp29_;
	GameHubUtilsRunTask* _tmp30_;
	GameHubUtilsRunTaskResult* _tmp31_;
	GameHubUtilsRunTaskResult* _tmp32_;
	const gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gboolean _tmp36_;
	gboolean _tmp37_;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	gint _tmp40_;
	gint _tmp41_;
	const gchar* _tmp42_;
	gchar** cmd;
	gint cmd_length1;
	gint _cmd_size_;
	GameHubDataRunnableInstallerInstallerType _tmp43_;
	const gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	gchar* _tmp49_;
	gchar* _tmp50_;
	gchar* _tmp51_;
	GFile* _tmp52_;
	GFile* _tmp53_;
	gchar* _tmp54_;
	gchar* _tmp55_;
	gchar* _tmp56_;
	gchar** _tmp57_;
	gchar* _tmp58_;
	const gchar* _tmp59_;
	gchar* _tmp60_;
	gchar* _tmp61_;
	GFile* _tmp62_;
	GFile* _tmp63_;
	gchar* _tmp64_;
	gchar** _tmp65_;
	gchar* _tmp66_;
	const gchar* _tmp67_;
	gchar* _tmp68_;
	gchar** _tmp69_;
	GameHubDataGame* _tmp70_;
	GameHubDataGame* _tmp71_;
	GameHubDataGame* _tmp72_;
	GameHubDataGameStatus* _tmp73_;
	GameHubDataGameStatus* _tmp74_;
	gchar** _tmp75_;
	gint _tmp75__length1;
	gchar** _tmp76_;
	gint _tmp76__length1;
	GameHubUtilsRunTask* _tmp77_;
	GameHubUtilsRunTask* _tmp78_;
	GameHubUtilsRunTaskResult* _tmp79_;
	GameHubUtilsRunTaskResult* _tmp80_;
	GameHubDataRunnableInstallerInstallerType _tmp81_;
	gboolean _tmp82_;
	GameHubDataRunnableInstallerInstallerType _tmp83_;
};

struct _GameHubDataRunnableDownloadableInstaller {
	GameHubDataRunnableInstaller parent_instance;
	GameHubDataRunnableDownloadableInstallerPrivate * priv;
};

struct _GameHubDataRunnableDownloadableInstallerClass {
	GameHubDataRunnableInstallerClass parent_class;
	void (*fetch_parts) (GameHubDataRunnableDownloadableInstaller* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*fetch_parts_finish) (GameHubDataRunnableDownloadableInstaller* self, GAsyncResult* _res_);
};

struct _GameHubDataRunnableDownloadableInstallerPrivate {
	GeeArrayList* _parts;
};

struct _GameHubDataRunnableDownloadableInstallerFetchPartsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataRunnableDownloadableInstaller* self;
};

struct _Block6Data {
	int _ref_count_;
	GameHubDataRunnableDownloadableInstaller* self;
	GameHubDataRunnable* runnable;
	gpointer _async_data_;
};

struct _Block7Data {
	int _ref_count_;
	Block6Data * _data6_;
	GameHubDataGame* game;
};

struct _Block8Data {
	int _ref_count_;
	Block7Data * _data7_;
	GameHubDataRunnableDownloadableInstallerPart* part;
	GFile* file;
};

struct _GameHubUtilsDownloaderDownload {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameHubUtilsDownloaderDownloadPrivate * priv;
	gchar* id;
	GameHubUtilsDownloaderDownloadStatus* _status;
};

struct _GameHubUtilsDownloaderDownloadClass {
	GTypeClass parent_class;
	void (*finalize) (GameHubUtilsDownloaderDownload *self);
	void (*cancel) (GameHubUtilsDownloaderDownload* self);
};

struct _GameHubUtilsDownloaderFileDownload {
	GameHubUtilsDownloaderDownload parent_instance;
	GameHubUtilsDownloaderFileDownloadPrivate * priv;
	GFile* remote;
	GFile* local;
	GFile* local_tmp;
};

struct _GameHubUtilsDownloaderFileDownloadClass {
	GameHubUtilsDownloaderDownloadClass parent_class;
};

struct _GameHubDataRunnableDownloadableInstallerDownloadData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataRunnableDownloadableInstaller* self;
	GameHubDataRunnable* runnable;
	GeeArrayList* result;
	Block6Data* _data6_;
	GeeArrayList* files;
	GeeArrayList* _tmp0_;
	Block7Data* _data7_;
	GameHubDataGame* _tmp1_;
	GameHubDataGame* _tmp2_;
	GameHubDataGame* _tmp3_;
	GameHubDataGame* _tmp4_;
	GameHubDataGameStatus* _tmp5_;
	GameHubDataGameStatus* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GFile* runnable_install_dir;
	GFile* _tmp13_;
	GFile* _tmp14_;
	GFile* _tmp15_;
	guint p;
	GeeArrayList* _part_list;
	GeeArrayList* _tmp16_;
	GeeArrayList* _tmp17_;
	gint _part_size;
	GeeArrayList* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	gint _part_index;
	Block8Data* _data8_;
	GeeArrayList* _tmp21_;
	gpointer _tmp22_;
	GameHubDataRunnableDownloadableInstallerPart* _tmp23_;
	GFile* _tmp24_;
	GFile* _tmp25_;
	GFile* _tmp26_;
	GFile* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	GFile* _tmp30_;
	GFile* _tmp31_;
	gulong ds_id;
	GameHubUtilsDownloaderDownloadManager* _tmp32_;
	GameHubUtilsDownloaderDownloadManager* _tmp33_;
	gulong _tmp34_;
	gulong _tmp35_;
	gchar* partDesc;
	GameHubDataRunnableDownloadableInstallerPart* _tmp36_;
	const gchar* _tmp37_;
	const gchar* _tmp38_;
	gchar* _tmp39_;
	GeeArrayList* _tmp40_;
	gint _tmp41_;
	gint _tmp42_;
	GeeArrayList* _tmp43_;
	gint _tmp44_;
	gint _tmp45_;
	GameHubDataRunnableDownloadableInstallerPart* _tmp46_;
	const gchar* _tmp47_;
	const gchar* _tmp48_;
	gchar* _tmp49_;
	const gchar* _tmp50_;
	GameHubDataGame* _tmp51_;
	GameHubDataGame* _tmp52_;
	const gchar* _tmp53_;
	const gchar* _tmp54_;
	const gchar* _tmp55_;
	GameHubDataGame* _tmp56_;
	GameHubDataGame* _tmp57_;
	GameHubDataGameSource* _tmp58_;
	GameHubDataGameSource* _tmp59_;
	const gchar* _tmp60_;
	const gchar* _tmp61_;
	GameHubUtilsDownloaderDownloadInfo* info;
	const gchar* _tmp62_;
	const gchar* _tmp63_;
	const gchar* _tmp64_;
	GameHubUtilsDownloaderDownloadInfo* _tmp65_;
	GameHubDataRunnableDownloadableInstallerPart* _tmp66_;
	GFile* _tmp67_;
	GFile* _tmp68_;
	GameHubDataRunnableDownloadableInstallerPart* _tmp69_;
	GFile* _tmp70_;
	GFile* _tmp71_;
	GameHubUtilsDownloaderDownloadInfo* _tmp72_;
	GFile* _tmp73_;
	gboolean _tmp74_;
	GFile* _tmp75_;
	GFile* _tmp76_;
	gchar* file_checksum;
	GameHubDataRunnableDownloadableInstallerPart* _tmp77_;
	const gchar* _tmp78_;
	const gchar* _tmp79_;
	GFile* _tmp80_;
	gchar* _tmp81_;
	gchar* _tmp82_;
	gchar* _tmp83_;
	gchar* _tmp84_;
	GameHubDataRunnableDownloadableInstallerPart* _tmp85_;
	const gchar* _tmp86_;
	const gchar* _tmp87_;
	gchar* _tmp88_;
	gchar* _tmp89_;
	GameHubDataRunnableDownloadableInstallerPart* _tmp90_;
	const gchar* _tmp91_;
	const gchar* _tmp92_;
	GameHubDataGame* _tmp93_;
	GameHubDataGame* _tmp94_;
	GameHubDataGame* _tmp95_;
	GameHubDataGameStatus* _tmp96_;
	GameHubDataGameStatus* _tmp97_;
	GFile* _tmp98_;
	GameHubDataRunnableDownloadableInstallerPart* _tmp99_;
	GChecksumType _tmp100_;
	GChecksumType _tmp101_;
	gchar* _tmp102_;
	GameHubDataGame* _tmp103_;
	GameHubDataGame* _tmp104_;
	GameHubDataGame* _tmp105_;
	GameHubDataGameStatus* _tmp106_;
	GameHubDataGameStatus* _tmp107_;
	gboolean _tmp108_;
	gboolean _tmp109_;
	GameHubDataRunnableDownloadableInstallerPart* _tmp110_;
	const gchar* _tmp111_;
	const gchar* _tmp112_;
	const gchar* _tmp113_;
	GameHubDataRunnableDownloadableInstallerPart* _tmp114_;
	const gchar* _tmp115_;
	const gchar* _tmp116_;
	const gchar* _tmp117_;
	GeeArrayList* _tmp118_;
	GFile* _tmp119_;
	const gchar* _tmp120_;
	const gchar* _tmp121_;
	gchar* _tmp122_;
	gchar* _tmp123_;
	GFile* _tmp124_;
	gchar* _tmp125_;
	gchar* _tmp126_;
	gchar* _tmp127_;
	gchar* _tmp128_;
	GFile* _tmp129_;
	gchar* _tmp130_;
	gchar* _tmp131_;
	GameHubDataRunnableDownloadableInstallerPart* _tmp132_;
	const gchar* _tmp133_;
	const gchar* _tmp134_;
	const gchar* _tmp135_;
	GameHubUtilsDownloaderDownloadManager* _tmp136_;
	GameHubUtilsDownloaderDownloadManager* _tmp137_;
	guint _tmp138_;
	GameHubDataGame* _tmp139_;
	GameHubDataGame* _tmp140_;
	GameHubDataGame* _tmp141_;
	GameHubDataGameStatus* _tmp142_;
	GameHubDataGameStatus* _tmp143_;
	GError* e;
	GError* _vala1_e;
	GError* _tmp144_;
	const gchar* _tmp145_;
	GError* _inner_error0_;
};

struct _Block9Data {
	int _ref_count_;
	GameHubDataRunnableDownloadableInstaller* self;
	GameHubDataGame* game;
};

struct _GameHubDataRunnableDownloadableInstallerInstallData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataRunnableDownloadableInstaller* self;
	GameHubDataRunnable* runnable;
	GameHubDataCompatTool* tool;
	Block9Data* _data9_;
	GeeArrayList* files;
	GeeArrayList* _tmp0_;
	GameHubDataGame* _tmp1_;
	GameHubDataGame* _tmp2_;
	GameHubDataGame* _tmp3_;
	GameHubDataGame* _tmp4_;
	GameHubDataGameStatus* _tmp5_;
	GameHubDataGameStatus* _tmp6_;
	GeeArrayList* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	guint f;
	gboolean windows_installer;
	gboolean nsis_installer;
	GeeArrayList* _file_list;
	GeeArrayList* _tmp10_;
	GeeArrayList* _tmp11_;
	gint _file_size;
	GeeArrayList* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint _file_index;
	GFile* file;
	GeeArrayList* _tmp15_;
	gpointer _tmp16_;
	gboolean win;
	gboolean nsis;
	GFile* _tmp17_;
	guint _tmp18_;
	gboolean _tmp19_;
	gboolean _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp22_;
	GFile* _tmp23_;
	GFile* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gint dircount;
	gchar* dirname;
	GFileInfo* finfo;
	GFileEnumerator* enumerator;
	GFile* _tmp27_;
	GFile* _tmp28_;
	GFileEnumerator* _tmp29_;
	GFileInfo* _tmp30_;
	GFileEnumerator* _tmp31_;
	GFileInfo* _tmp32_;
	GFileInfo* _tmp33_;
	GFileInfo* _tmp34_;
	gboolean _tmp35_;
	GFileInfo* _tmp36_;
	GFileInfo* _tmp37_;
	const gchar* _tmp38_;
	gint _tmp39_;
	const gchar* _tmp40_;
	gboolean _tmp41_;
	const gchar* _tmp42_;
	GFileInfo* _tmp43_;
	const gchar* _tmp44_;
	gchar* _tmp45_;
	GFileInfo* _tmp46_;
	gboolean _tmp47_;
	const gchar* _tmp48_;
	GFile* _tmp49_;
	GFile* _tmp50_;
	const gchar* _tmp51_;
	gchar* _tmp52_;
	gchar* _tmp53_;
	gboolean _tmp54_;
	GameHubDataPlatform _tmp55_;
	GameHubDataPlatform _tmp56_;
	GError* e;
	gboolean _tmp57_;
	gboolean _tmp58_;
	gboolean _tmp59_;
	GFile* _tmp60_;
	GFile* _tmp61_;
	GFile* _tmp62_;
	gboolean _tmp63_;
	GFile* _tmp64_;
	GFile* _tmp65_;
	GFile* _tmp66_;
	gboolean _tmp67_;
	GeeArrayList* _tmp68_;
	GeeArrayList* _tmp69_;
	GeeArrayList* _tmp70_;
	GeeArrayList* _tmp71_;
	gint _tmp72_;
	gint _tmp73_;
	GeeArrayList* _action_list;
	GeeArrayList* _tmp74_;
	GeeArrayList* _tmp75_;
	GeeArrayList* _tmp76_;
	gint _action_size;
	GeeArrayList* _tmp77_;
	gint _tmp78_;
	gint _tmp79_;
	gint _action_index;
	GameHubDataRunnableRunnableAction* action;
	GeeArrayList* _tmp80_;
	gpointer _tmp81_;
	GameHubDataRunnableRunnableAction* _tmp82_;
	gboolean _tmp83_;
	gboolean _tmp84_;
	gboolean _tmp85_;
	GameHubDataRunnableRunnableAction* _tmp86_;
	GFile* _tmp87_;
	GFile* _tmp88_;
	GameHubDataRunnableRunnableAction* _tmp89_;
	GFile* _tmp90_;
	GFile* _tmp91_;
	GameHubDataRunnableRunnableAction* _tmp92_;
	GFile* _tmp93_;
	GFile* _tmp94_;
	GameHubDataRunnableRunnableAction* _tmp95_;
	GFile* _tmp96_;
	GFile* _tmp97_;
	GameHubDataRunnableRunnableAction* _tmp98_;
	const gchar* _tmp99_;
	const gchar* _tmp100_;
	gboolean _tmp101_;
	gboolean _tmp102_;
	GFile* _tmp103_;
	GFile* _tmp104_;
	GFile* _tmp105_;
	gboolean _tmp106_;
	GFile* _tmp107_;
	GFile* _tmp108_;
	GFile* _tmp109_;
	GameHubDataGame* _tmp110_;
	GameHubDataGame* _tmp111_;
	const gchar* _tmp112_;
	const gchar* _tmp113_;
	gchar* _tmp114_;
	gchar* _tmp115_;
	gboolean _tmp116_;
	GameHubDataGame* _tmp117_;
	const gchar* _tmp118_;
	const gchar* _tmp119_;
	GameHubDataGame* _tmp120_;
	const gchar* _tmp121_;
	const gchar* _tmp122_;
	GFile* gh_marker;
	GFile* _tmp123_;
	GFile* _tmp124_;
	const gchar* _tmp125_;
	const gchar* _tmp126_;
	gchar* _tmp127_;
	gchar* _tmp128_;
	GFile* _tmp129_;
	GFile* _tmp130_;
	GFile* _tmp131_;
	GFile* _tmp132_;
	gchar* _tmp133_;
	gchar* _tmp134_;
	GError* _vala1_e;
	GError* _tmp135_;
	const gchar* _tmp136_;
	GError* _inner_error0_;
};

struct _GameHubDataRunnableDownloadableInstallerPart {
	GObject parent_instance;
	GameHubDataRunnableDownloadableInstallerPartPrivate * priv;
};

struct _GameHubDataRunnableDownloadableInstallerPartClass {
	GObjectClass parent_class;
};

struct _GameHubDataRunnableDownloadableInstallerPartPrivate {
	gchar* _id;
	gchar* _url;
	gint64 _size;
	GFile* _remote;
	GFile* _local;
	gchar* _checksum;
	GChecksumType _checksum_type;
};

struct _GameHubDataRunnableRunnableAction {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameHubDataRunnableRunnableActionPrivate * priv;
};

struct _GameHubDataRunnableRunnableActionClass {
	GTypeClass parent_class;
	void (*finalize) (GameHubDataRunnableRunnableAction *self);
};

struct _GameHubDataRunnableRunnableActionPrivate {
	GameHubDataRunnable* _runnable;
	gboolean _is_primary;
	gboolean _is_hidden;
	gchar* _name;
	GFile* _file;
	GFile* _workdir;
	gchar* _args;
	GType** _compat_tools;
	gint _compat_tools_length1;
	gint __compat_tools_size_;
	gchar* _uri;
};

struct _GameHubDataRunnableRunnableActionInvokeData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataRunnableRunnableAction* self;
	GameHubDataCompatTool* tool;
	gboolean _tmp0_;
	GFile* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_;
	GameHubDataRunnable* _tmp5_;
	GameHubDataRunnable* _tmp6_;
};

struct _GameHubDataRunnableParamSpecRunnableAction {
	GParamSpec parent_instance;
};

static gint GameHubDataRunnable_private_offset;
static gpointer game_hub_data_runnable_parent_class = NULL;
extern gboolean game_hub_data_runnable_IsLaunched;
gboolean game_hub_data_runnable_IsLaunched = FALSE;
extern gint64 game_hub_data_runnable_LastLaunchAttempt;
GRecMutex __lock_game_hub_data_runnable_game_hub_data_runnable_LastLaunchAttempt = {0};
gint64 game_hub_data_runnable_LastLaunchAttempt = (gint64) 0;
extern GameHubDataCompatTool** game_hub_data_CompatTools;
extern gint game_hub_data_CompatTools_length1;
extern gboolean game_hub_data_sources_steam_steam_IsAnyAppRunning;
extern GameHubUIWindowsMainWindow* game_hub_ui_windows_main_window_instance;
static gint GameHubDataRunnableInstaller_private_offset;
static gpointer game_hub_data_runnable_installer_parent_class = NULL;
static gint GameHubDataRunnableFileInstaller_private_offset;
static gpointer game_hub_data_runnable_file_installer_parent_class = NULL;
static gint GameHubDataRunnableDownloadableInstaller_private_offset;
static gpointer game_hub_data_runnable_downloadable_installer_parent_class = NULL;
static gint GameHubDataRunnableDownloadableInstallerPart_private_offset;
static gpointer game_hub_data_runnable_downloadable_installer_part_parent_class = NULL;
static gint GameHubDataRunnableRunnableAction_private_offset;
static gpointer game_hub_data_runnable_runnable_action_parent_class = NULL;

GType game_hub_data_runnable_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataRunnable, g_object_unref)
GType game_hub_data_platform_get_type (void) G_GNUC_CONST;
GType game_hub_data_runnable_installer_install_mode_get_type (void) G_GNUC_CONST;
gpointer game_hub_data_runnable_runnable_action_ref (gpointer instance);
void game_hub_data_runnable_runnable_action_unref (gpointer instance);
GParamSpec* game_hub_data_runnable_param_spec_runnable_action (const gchar* name,
                                                               const gchar* nick,
                                                               const gchar* blurb,
                                                               GType object_type,
                                                               GParamFlags flags);
void game_hub_data_runnable_value_set_runnable_action (GValue* value,
                                                       gpointer v_object);
void game_hub_data_runnable_value_take_runnable_action (GValue* value,
                                                        gpointer v_object);
gpointer game_hub_data_runnable_value_get_runnable_action (const GValue* value);
GType game_hub_data_runnable_runnable_action_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataRunnableRunnableAction, game_hub_data_runnable_runnable_action_unref)
gboolean game_hub_data_runnable_is_supported (GameHubDataRunnable* self,
                                              GameHubDataPlatform* platform,
                                              gboolean with_compat);
static gboolean game_hub_data_runnable_real_is_supported (GameHubDataRunnable* self,
                                                   GameHubDataPlatform* platform,
                                                   gboolean with_compat);
#define GAME_HUB_DATA_PLATFORM_CURRENT GAME_HUB_DATA_PLATFORM_LINUX
GeeArrayList* game_hub_data_runnable_get_platforms (GameHubDataRunnable* self);
GType game_hub_data_compat_tool_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataCompatTool, g_object_unref)
gboolean game_hub_data_compat_tool_can_run (GameHubDataCompatTool* self,
                                            GameHubDataRunnable* runnable);
void game_hub_data_runnable_install (GameHubDataRunnable* self,
                                     GameHubDataRunnableInstallerInstallMode install_mode,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_);
void game_hub_data_runnable_install_finish (GameHubDataRunnable* self,
                                            GAsyncResult* _res_);
void game_hub_data_runnable_run (GameHubDataRunnable* self,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
void game_hub_data_runnable_run_finish (GameHubDataRunnable* self,
                                        GAsyncResult* _res_);
gboolean game_hub_data_runnable_can_be_launched (GameHubDataRunnable* self,
                                                 gboolean is_launch_attempt);
static gboolean game_hub_data_runnable_real_can_be_launched (GameHubDataRunnable* self,
                                                      gboolean is_launch_attempt);
gboolean game_hub_data_runnable_get_is_running (GameHubDataRunnable* self);
static void game_hub_data_runnable_real_run_with_compat_data_free (gpointer _data);
static void game_hub_data_runnable_real_run_with_compat (GameHubDataRunnable* self,
                                                  gboolean is_opened_from_menu,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_);
void game_hub_data_runnable_run_with_compat (GameHubDataRunnable* self,
                                             gboolean is_opened_from_menu,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
void game_hub_data_runnable_run_with_compat_finish (GameHubDataRunnable* self,
                                                    GAsyncResult* _res_);
static gboolean game_hub_data_runnable_real_run_with_compat_co (GameHubDataRunnableRunWithCompatData* _data_);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
GType game_hub_ui_dialogs_compat_run_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUIDialogsCompatRunDialog, g_object_unref)
GType game_hub_data_game_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataGame, g_object_unref)
GameHubUIDialogsCompatRunDialog* game_hub_ui_dialogs_compat_run_dialog_new (GameHubDataRunnable* game,
                                                                            gboolean is_opened_from_menu,
                                                                            GameHubDataGame* emulated_game,
                                                                            gboolean launch_in_game_dir);
GameHubUIDialogsCompatRunDialog* game_hub_ui_dialogs_compat_run_dialog_construct (GType object_type,
                                                                                  GameHubDataRunnable* game,
                                                                                  gboolean is_opened_from_menu,
                                                                                  GameHubDataGame* emulated_game,
                                                                                  gboolean launch_in_game_dir);
static void ___lambda83_ (Block5Data* _data5_);
static gboolean _game_hub_data_runnable_real_run_with_compat_co_gsource_func (gpointer self);
static void ____lambda83__gtk_widget_destroy (GtkWidget* _sender,
                                       gpointer self);
GtkFileChooser* game_hub_data_runnable_setup_executable_chooser (GameHubDataRunnable* self);
static GtkFileChooser* game_hub_data_runnable_real_setup_executable_chooser (GameHubDataRunnable* self);
GType game_hub_ui_windows_main_window_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUIWindowsMainWindow, g_object_unref)
GFile* game_hub_data_runnable_get_executable (GameHubDataRunnable* self);
static gint game_hub_data_runnable_run_executable_chooser (GameHubDataRunnable* self,
                                                    GtkFileChooser* chooser);
void game_hub_data_runnable_choose_executable (GameHubDataRunnable* self,
                                               gboolean update);
static void game_hub_data_runnable_real_choose_executable (GameHubDataRunnable* self,
                                                    gboolean update);
void game_hub_data_runnable_set_chosen_executable (GameHubDataRunnable* self,
                                                   GFile* file,
                                                   gboolean update);
static void game_hub_data_runnable_real_set_chosen_executable (GameHubDataRunnable* self,
                                                        GFile* file,
                                                        gboolean update);
void game_hub_data_runnable_set_executable (GameHubDataRunnable* self,
                                            GFile* value);
gpointer game_hub_utils_run_task_ref (gpointer instance);
void game_hub_utils_run_task_unref (gpointer instance);
GParamSpec* game_hub_utils_param_spec_run_task (const gchar* name,
                                                const gchar* nick,
                                                const gchar* blurb,
                                                GType object_type,
                                                GParamFlags flags);
void game_hub_utils_value_set_run_task (GValue* value,
                                        gpointer v_object);
void game_hub_utils_value_take_run_task (GValue* value,
                                         gpointer v_object);
gpointer game_hub_utils_value_get_run_task (const GValue* value);
GType game_hub_utils_run_task_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUtilsRunTask, game_hub_utils_run_task_unref)
GameHubUtilsRunTask* game_hub_utils_run (gchar** cmd,
                                         gint cmd_length1);
gpointer game_hub_utils_run_task_result_ref (gpointer instance);
void game_hub_utils_run_task_result_unref (gpointer instance);
GParamSpec* game_hub_utils_run_task_param_spec_result (const gchar* name,
                                                       const gchar* nick,
                                                       const gchar* blurb,
                                                       GType object_type,
                                                       GParamFlags flags);
void game_hub_utils_run_task_value_set_result (GValue* value,
                                               gpointer v_object);
void game_hub_utils_run_task_value_take_result (GValue* value,
                                                gpointer v_object);
gpointer game_hub_utils_run_task_value_get_result (const GValue* value);
GType game_hub_utils_run_task_result_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUtilsRunTaskResult, game_hub_utils_run_task_result_unref)
GameHubUtilsRunTaskResult* game_hub_utils_run_task_run_sync (GameHubUtilsRunTask* self,
                                                             gboolean capture_output);
void game_hub_data_runnable_update_status (GameHubDataRunnable* self);
void game_hub_data_runnable_save (GameHubDataRunnable* self);
static void game_hub_data_runnable_real_save (GameHubDataRunnable* self);
static void game_hub_data_runnable_real_update_status (GameHubDataRunnable* self);
void game_hub_data_runnable_import (GameHubDataRunnable* self,
                                    gboolean update);
static void game_hub_data_runnable_real_import (GameHubDataRunnable* self,
                                         gboolean update);
GType game_hub_data_sources_gog_gog_game_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataSourcesGOGGOGGame, g_object_unref)
gchar* game_hub_utils_fs_utils_paths_gog_get_Games (void);
GType game_hub_data_sources_humble_humble_game_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataSourcesHumbleHumbleGame, g_object_unref)
gchar* game_hub_utils_fs_utils_paths_humble_get_Games (void);
void game_hub_data_runnable_set_install_dir (GameHubDataRunnable* self,
                                             GFile* value);
GFile* game_hub_data_runnable_get_install_dir (GameHubDataRunnable* self);
void game_hub_data_runnable_set_work_dir (GameHubDataRunnable* self,
                                          GFile* value);
GFile* game_hub_utils_fs_utils_file (const gchar* path,
                                     const gchar* file,
                                     GeeHashMap* variables);
JsonObject* game_hub_data_runnable_get_compat_settings (GameHubDataRunnable* self,
                                                        GameHubDataCompatTool* tool);
const gchar* game_hub_data_runnable_get_compat_tool_settings (GameHubDataRunnable* self);
JsonNode* game_hub_utils_parser_parse_json (const gchar* json);
JsonObject* game_hub_utils_parser_json_object (JsonNode* root,
                                               gchar** keys,
                                               gint keys_length1);
const gchar* game_hub_data_compat_tool_get_id (GameHubDataCompatTool* self);
static void _vala_JsonNode_free (JsonNode* self);
void game_hub_data_runnable_set_compat_settings (GameHubDataRunnable* self,
                                                 GameHubDataCompatTool* tool,
                                                 JsonObject* settings);
void game_hub_data_runnable_set_compat_tool_settings (GameHubDataRunnable* self,
                                                      const gchar* value);
void game_hub_data_runnable_set_compat_options_saved (GameHubDataRunnable* self,
                                                      gboolean value);
gboolean* game_hub_data_runnable_get_compat_option_bool (GameHubDataRunnable* self,
                                                         const gchar* key);
static gboolean* _bool_dup (gboolean* self);
void game_hub_data_runnable_set_compat_option_bool (GameHubDataRunnable* self,
                                                    const gchar* key,
                                                    gboolean* value);
GameHubDataRunnable* game_hub_data_runnable_construct (GType object_type);
const gchar* game_hub_data_runnable_get_id (GameHubDataRunnable* self);
void game_hub_data_runnable_set_id (GameHubDataRunnable* self,
                                    const gchar* value);
const gchar* game_hub_data_runnable_get_escaped_name (GameHubDataRunnable* self);
void game_hub_data_runnable_set_escaped_name (GameHubDataRunnable* self,
                                              const gchar* value);
const gchar* game_hub_data_runnable_get_normalized_name (GameHubDataRunnable* self);
void game_hub_data_runnable_set_normalized_name (GameHubDataRunnable* self,
                                                 const gchar* value);
const gchar* game_hub_data_runnable_get_name (GameHubDataRunnable* self);
void game_hub_data_runnable_set_name (GameHubDataRunnable* self,
                                      const gchar* value);
gchar* game_hub_utils_strip_name (const gchar* name,
                                  const gchar* keep,
                                  gboolean move_the);
const gchar* game_hub_data_runnable_get_compat_tool (GameHubDataRunnable* self);
void game_hub_data_runnable_set_compat_tool (GameHubDataRunnable* self,
                                             const gchar* value);
const gchar* game_hub_data_runnable_get_arguments (GameHubDataRunnable* self);
void game_hub_data_runnable_set_arguments (GameHubDataRunnable* self,
                                           const gchar* value);
void game_hub_data_runnable_set_is_running (GameHubDataRunnable* self,
                                            gboolean value);
void game_hub_data_runnable_set_platforms (GameHubDataRunnable* self,
                                           GeeArrayList* value);
GFile* game_hub_data_runnable_get_work_dir (GameHubDataRunnable* self);
GFile* game_hub_data_runnable_get_default_install_dir (GameHubDataRunnable* self);
GeeArrayList* game_hub_data_runnable_get_actions (GameHubDataRunnable* self);
void game_hub_data_runnable_set_actions (GameHubDataRunnable* self,
                                         GeeArrayList* value);
gboolean game_hub_data_runnable_get_use_compat (GameHubDataRunnable* self);
gboolean game_hub_data_runnable_get_needs_compat (GameHubDataRunnable* self);
gboolean game_hub_data_runnable_get_force_compat (GameHubDataRunnable* self);
GType game_hub_data_sources_steam_steam_game_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataSourcesSteamSteamGame, g_object_unref)
static gboolean _bool_equal (const gboolean * s1,
                      const gboolean * s2);
void game_hub_data_runnable_set_force_compat (GameHubDataRunnable* self,
                                              gboolean value);
gboolean game_hub_data_runnable_get_compat_options_saved (GameHubDataRunnable* self);
gpointer game_hub_data_runnable_installer_ref (gpointer instance);
void game_hub_data_runnable_installer_unref (gpointer instance);
GParamSpec* game_hub_data_runnable_param_spec_installer (const gchar* name,
                                                         const gchar* nick,
                                                         const gchar* blurb,
                                                         GType object_type,
                                                         GParamFlags flags);
void game_hub_data_runnable_value_set_installer (GValue* value,
                                                 gpointer v_object);
void game_hub_data_runnable_value_take_installer (GValue* value,
                                                  gpointer v_object);
gpointer game_hub_data_runnable_value_get_installer (const GValue* value);
GType game_hub_data_runnable_installer_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataRunnableInstaller, game_hub_data_runnable_installer_unref)
GType game_hub_data_runnable_installer_installer_type_get_type (void) G_GNUC_CONST;
GameHubDataRunnableInstallerInstallerType game_hub_data_runnable_installer_installer_type_from_mime (const gchar* type);
void game_hub_data_runnable_installer_install (GameHubDataRunnableInstaller* self,
                                               GameHubDataRunnable* runnable,
                                               GameHubDataCompatTool* tool,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_);
void game_hub_data_runnable_installer_install_finish (GameHubDataRunnableInstaller* self,
                                                      GAsyncResult* _res_);
static void game_hub_data_runnable_installer_guess_type_data_free (gpointer _data);
void game_hub_data_runnable_installer_guess_type (GFile* file,
                                                  gboolean is_part,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_);
GameHubDataRunnableInstallerInstallerType game_hub_data_runnable_installer_guess_type_finish (GAsyncResult* _res_);
static gboolean game_hub_data_runnable_installer_guess_type_co (GameHubDataRunnableInstallerGuessTypeData* _data_);
static void game_hub_data_runnable_installer_guess_type_ready (GObject* source_object,
                                                        GAsyncResult* _res_,
                                                        gpointer _user_data_);
GameHubUtilsRunTask* game_hub_utils_run_task_log (GameHubUtilsRunTask* self,
                                                  gboolean log);
GameHubDataRunnableInstaller* game_hub_data_runnable_installer_construct (GType object_type);
const gchar* game_hub_data_runnable_installer_get_id (GameHubDataRunnableInstaller* self);
void game_hub_data_runnable_installer_set_id (GameHubDataRunnableInstaller* self,
                                              const gchar* value);
GameHubDataPlatform game_hub_data_runnable_installer_get_platform (GameHubDataRunnableInstaller* self);
void game_hub_data_runnable_installer_set_platform (GameHubDataRunnableInstaller* self,
                                                    GameHubDataPlatform value);
gint64 game_hub_data_runnable_installer_get_full_size (GameHubDataRunnableInstaller* self);
void game_hub_data_runnable_installer_set_full_size (GameHubDataRunnableInstaller* self,
                                                     gint64 value);
const gchar* game_hub_data_runnable_installer_get_version (GameHubDataRunnableInstaller* self);
void game_hub_data_runnable_installer_set_version (GameHubDataRunnableInstaller* self,
                                                   const gchar* value);
gchar* game_hub_data_runnable_installer_get_name (GameHubDataRunnableInstaller* self);
static void game_hub_data_runnable_installer_finalize (GameHubDataRunnableInstaller * obj);
GType game_hub_data_runnable_file_installer_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataRunnableFileInstaller, game_hub_data_runnable_installer_unref)
#define GAME_HUB_DATA_RUNNABLE_FILE_INSTALLER_NSIS_INSTALLER_DESCRIPTION "Nullsoft Installer"
static void game_hub_data_runnable_file_installer_real_install_data_free (gpointer _data);
static void game_hub_data_runnable_file_installer_real_install (GameHubDataRunnableInstaller* base,
                                                         GameHubDataRunnable* runnable,
                                                         GameHubDataCompatTool* tool,
                                                         GAsyncReadyCallback _callback_,
                                                         gpointer _user_data_);
static gboolean game_hub_data_runnable_file_installer_real_install_co (GameHubDataRunnableFileInstallerInstallData* _data_);
void game_hub_data_runnable_file_installer_install_file (GFile* file,
                                                         gboolean is_part,
                                                         GameHubDataRunnable* runnable,
                                                         GameHubDataCompatTool* tool,
                                                         GAsyncReadyCallback _callback_,
                                                         gpointer _user_data_);
void game_hub_data_runnable_file_installer_install_file_finish (GAsyncResult* _res_,
                                                                gboolean* is_windows_installer,
                                                                gboolean* is_nsis_installer);
GFile* game_hub_data_runnable_file_installer_get_file (GameHubDataRunnableFileInstaller* self);
static void game_hub_data_runnable_file_installer_install_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_);
static void game_hub_data_runnable_file_installer_install_file_data_free (gpointer _data);
static gboolean game_hub_data_runnable_file_installer_install_file_co (GameHubDataRunnableFileInstallerInstallFileData* _data_);
GFile* game_hub_utils_fs_utils_mkdir (const gchar* path,
                                      const gchar* file,
                                      GeeHashMap* variables);
static void game_hub_data_runnable_file_installer_install_file_ready (GObject* source_object,
                                                               GAsyncResult* _res_,
                                                               gpointer _user_data_);
GType game_hub_data_compat_innoextract_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataCompatInnoextract, g_object_unref)
GType game_hub_data_game_state_get_type (void) G_GNUC_CONST;
gpointer game_hub_utils_downloader_download_ref (gpointer instance);
void game_hub_utils_downloader_download_unref (gpointer instance);
GParamSpec* game_hub_utils_downloader_param_spec_download (const gchar* name,
                                                           const gchar* nick,
                                                           const gchar* blurb,
                                                           GType object_type,
                                                           GParamFlags flags);
void game_hub_utils_downloader_value_set_download (GValue* value,
                                                   gpointer v_object);
void game_hub_utils_downloader_value_take_download (GValue* value,
                                                    gpointer v_object);
gpointer game_hub_utils_downloader_value_get_download (const GValue* value);
GType game_hub_utils_downloader_download_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUtilsDownloaderDownload, game_hub_utils_downloader_download_unref)
GameHubDataGameStatus* game_hub_data_game_status_new (GameHubDataGameState state,
                                                      GameHubDataGame* game,
                                                      GameHubUtilsDownloaderDownload* download);
GameHubDataGameStatus* game_hub_data_game_status_construct (GType object_type,
                                                            GameHubDataGameState state,
                                                            GameHubDataGame* game,
                                                            GameHubUtilsDownloaderDownload* download);
gpointer game_hub_data_game_status_ref (gpointer instance);
void game_hub_data_game_status_unref (gpointer instance);
GParamSpec* game_hub_data_game_param_spec_status (const gchar* name,
                                                  const gchar* nick,
                                                  const gchar* blurb,
                                                  GType object_type,
                                                  GParamFlags flags);
void game_hub_data_game_value_set_status (GValue* value,
                                          gpointer v_object);
void game_hub_data_game_value_take_status (GValue* value,
                                           gpointer v_object);
gpointer game_hub_data_game_value_get_status (const GValue* value);
GType game_hub_data_game_status_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataGameStatus, game_hub_data_game_status_unref)
void game_hub_data_game_set_status (GameHubDataGame* self,
                                    GameHubDataGameStatus* value);
void game_hub_utils_run_task_run_async (GameHubUtilsRunTask* self,
                                        gboolean wait,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
GameHubUtilsRunTaskResult* game_hub_utils_run_task_run_finish (GameHubUtilsRunTask* self,
                                                               GAsyncResult* _res_);
gboolean game_hub_data_compat_tool_can_install (GameHubDataCompatTool* self,
                                                GameHubDataRunnable* runnable);
void game_hub_data_compat_tool_install (GameHubDataCompatTool* self,
                                        GameHubDataRunnable* runnable,
                                        GFile* installer,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
void game_hub_data_compat_tool_install_finish (GameHubDataCompatTool* self,
                                               GAsyncResult* _res_);
GameHubDataRunnableFileInstaller* game_hub_data_runnable_file_installer_construct (GType object_type);
void game_hub_data_runnable_file_installer_set_file (GameHubDataRunnableFileInstaller* self,
                                                     GFile* value);
gint64 game_hub_data_runnable_file_installer_get_size (GameHubDataRunnableFileInstaller* self);
void game_hub_data_runnable_file_installer_set_size (GameHubDataRunnableFileInstaller* self,
                                                     gint64 value);
static void game_hub_data_runnable_file_installer_finalize (GameHubDataRunnableInstaller * obj);
GType game_hub_data_runnable_downloadable_installer_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataRunnableDownloadableInstaller, game_hub_data_runnable_installer_unref)
GType game_hub_data_runnable_downloadable_installer_part_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataRunnableDownloadableInstallerPart, g_object_unref)
static void game_hub_data_runnable_downloadable_installer_real_fetch_parts_data_free (gpointer _data);
static void game_hub_data_runnable_downloadable_installer_real_fetch_parts (GameHubDataRunnableDownloadableInstaller* self,
                                                                     GAsyncReadyCallback _callback_,
                                                                     gpointer _user_data_);
void game_hub_data_runnable_downloadable_installer_fetch_parts (GameHubDataRunnableDownloadableInstaller* self,
                                                                GAsyncReadyCallback _callback_,
                                                                gpointer _user_data_);
void game_hub_data_runnable_downloadable_installer_fetch_parts_finish (GameHubDataRunnableDownloadableInstaller* self,
                                                                       GAsyncResult* _res_);
static gboolean game_hub_data_runnable_downloadable_installer_real_fetch_parts_co (GameHubDataRunnableDownloadableInstallerFetchPartsData* _data_);
static void game_hub_data_runnable_downloadable_installer_download_data_free (gpointer _data);
void game_hub_data_runnable_downloadable_installer_download (GameHubDataRunnableDownloadableInstaller* self,
                                                             GameHubDataRunnable* runnable,
                                                             GAsyncReadyCallback _callback_,
                                                             gpointer _user_data_);
GeeArrayList* game_hub_data_runnable_downloadable_installer_download_finish (GameHubDataRunnableDownloadableInstaller* self,
                                                                             GAsyncResult* _res_);
static gboolean game_hub_data_runnable_downloadable_installer_download_co (GameHubDataRunnableDownloadableInstallerDownloadData* _data_);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
GeeArrayList* game_hub_data_runnable_downloadable_installer_get_parts (GameHubDataRunnableDownloadableInstaller* self);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
GFile* game_hub_data_runnable_downloadable_installer_part_get_local (GameHubDataRunnableDownloadableInstallerPart* self);
GType game_hub_utils_downloader_download_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUtilsDownloaderDownloadManager, g_object_unref)
GameHubUtilsDownloaderDownloadManager* game_hub_utils_downloader_download_manager (void);
GType game_hub_utils_downloader_file_download_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUtilsDownloaderFileDownload, game_hub_utils_downloader_download_unref)
static void _____lambda41_ (Block8Data* _data8_,
                     GameHubUtilsDownloaderFileDownload* dl);
gpointer game_hub_utils_downloader_download_status_ref (gpointer instance);
void game_hub_utils_downloader_download_status_unref (gpointer instance);
GParamSpec* game_hub_utils_downloader_download_param_spec_status (const gchar* name,
                                                                  const gchar* nick,
                                                                  const gchar* blurb,
                                                                  GType object_type,
                                                                  GParamFlags flags);
void game_hub_utils_downloader_download_value_set_status (GValue* value,
                                                          gpointer v_object);
void game_hub_utils_downloader_download_value_take_status (GValue* value,
                                                           gpointer v_object);
gpointer game_hub_utils_downloader_download_value_get_status (const GValue* value);
GType game_hub_utils_downloader_download_status_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUtilsDownloaderDownloadStatus, game_hub_utils_downloader_download_status_unref)
GFile* game_hub_data_runnable_downloadable_installer_part_get_remote (GameHubDataRunnableDownloadableInstallerPart* self);
static void ___lambda42_ (Block8Data* _data8_,
                   GameHubUtilsDownloaderDownloadStatus* s);
GameHubDataGameStatus* game_hub_data_game_get_status (GameHubDataGame* self);
static void ____lambda42__game_hub_utils_downloader_download_status_change (GameHubUtilsDownloaderDownload* _sender,
                                                                     GameHubUtilsDownloaderDownloadStatus* status,
                                                                     gpointer self);
static void ______lambda41__game_hub_utils_downloader_download_manager_file_download_started (GameHubUtilsDownloaderDownloadManager* _sender,
                                                                                       GameHubUtilsDownloaderFileDownload* download,
                                                                                       gpointer self);
const gchar* game_hub_data_runnable_downloadable_installer_part_get_id (GameHubDataRunnableDownloadableInstallerPart* self);
const gchar* game_hub_data_game_get_icon (GameHubDataGame* self);
gpointer game_hub_data_game_source_ref (gpointer instance);
void game_hub_data_game_source_unref (gpointer instance);
GParamSpec* game_hub_data_param_spec_game_source (const gchar* name,
                                                  const gchar* nick,
                                                  const gchar* blurb,
                                                  GType object_type,
                                                  GParamFlags flags);
void game_hub_data_value_set_game_source (GValue* value,
                                          gpointer v_object);
void game_hub_data_value_take_game_source (GValue* value,
                                           gpointer v_object);
gpointer game_hub_data_value_get_game_source (const GValue* value);
GType game_hub_data_game_source_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataGameSource, game_hub_data_game_source_unref)
GameHubDataGameSource* game_hub_data_game_get_source (GameHubDataGame* self);
const gchar* game_hub_data_game_source_get_icon (GameHubDataGameSource* self);
GType game_hub_utils_downloader_download_info_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUtilsDownloaderDownloadInfo, g_object_unref)
GameHubUtilsDownloaderDownloadInfo* game_hub_utils_downloader_download_info_new (const gchar* name,
                                                                                 const gchar* description,
                                                                                 const gchar* icon,
                                                                                 const gchar* icon_name,
                                                                                 const gchar* type_icon,
                                                                                 const gchar* type_icon_name);
GameHubUtilsDownloaderDownloadInfo* game_hub_utils_downloader_download_info_construct (GType object_type,
                                                                                       const gchar* name,
                                                                                       const gchar* description,
                                                                                       const gchar* icon,
                                                                                       const gchar* icon_name,
                                                                                       const gchar* type_icon,
                                                                                       const gchar* type_icon_name);
void game_hub_utils_downloader_download_file (GFile* remote,
                                              GFile* local,
                                              GameHubUtilsDownloaderDownloadInfo* info,
                                              gboolean preserve_filename,
                                              gboolean queue,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_);
GFile* game_hub_utils_downloader_download_file_finish (GAsyncResult* _res_,
                                                       GError** error);
static void game_hub_data_runnable_downloadable_installer_download_ready (GObject* source_object,
                                                                   GAsyncResult* _res_,
                                                                   gpointer _user_data_);
const gchar* game_hub_data_runnable_downloadable_installer_part_get_checksum (GameHubDataRunnableDownloadableInstallerPart* self);
const gchar* game_hub_data_runnable_downloadable_installer_part_get_checksum_type_string (GameHubDataRunnableDownloadableInstallerPart* self);
void game_hub_utils_compute_file_checksum (GFile* file,
                                           GChecksumType type,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
gchar* game_hub_utils_compute_file_checksum_finish (GAsyncResult* _res_);
GChecksumType game_hub_data_runnable_downloadable_installer_part_get_checksum_type (GameHubDataRunnableDownloadableInstallerPart* self);
void game_hub_utils_notify (const gchar* title,
                            const gchar* body,
                            GNotificationPriority priority,
                            GameHubUtilsNotificationConfigureDelegate config,
                            gpointer config_target);
static GNotification* _______lambda44_ (Block8Data* _data8_,
                                 GNotification* n);
GFile* game_hub_utils_image_cache_local_file (const gchar* url,
                                              const gchar* prefix);
const gchar* game_hub_data_game_source_get_id (GameHubDataGameSource* self);
gchar* game_hub_data_game_get_full_id (GameHubDataGame* self);
#define GAME_HUB_APPLICATION_ACTION_PREFIX "app."
#define GAME_HUB_APPLICATION_ACTION_CORRUPTED_INSTALLER_PICK_ACTION "corrupted-installer.pick-action"
#define GAME_HUB_APPLICATION_ACTION_CORRUPTED_INSTALLER_SHOW "corrupted-installer.show"
#define GAME_HUB_APPLICATION_ACTION_CORRUPTED_INSTALLER_REMOVE "corrupted-installer.remove"
#define GAME_HUB_APPLICATION_ACTION_CORRUPTED_INSTALLER_BACKUP "corrupted-installer.backup"
static GNotification* ________lambda44__game_hub_utils_notification_configure_delegate (GNotification* notification,
                                                                                 gpointer self);
static void game_hub_data_runnable_downloadable_installer_real_install_data_free (gpointer _data);
static void game_hub_data_runnable_downloadable_installer_real_install (GameHubDataRunnableInstaller* base,
                                                                 GameHubDataRunnable* runnable,
                                                                 GameHubDataCompatTool* tool,
                                                                 GAsyncReadyCallback _callback_,
                                                                 gpointer _user_data_);
static gboolean game_hub_data_runnable_downloadable_installer_real_install_co (GameHubDataRunnableDownloadableInstallerInstallData* _data_);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void game_hub_data_runnable_downloadable_installer_install_ready (GObject* source_object,
                                                                  GAsyncResult* _res_,
                                                                  gpointer _user_data_);
void game_hub_utils_fs_utils_rm (const gchar* path,
                                 const gchar* file,
                                 const gchar* flags,
                                 GeeHashMap* variables);
#define GAME_HUB_UTILS_FS_UTILS_GAMEHUB_DIR "_gamehub"
GType game_hub_data_sources_gog_gog_game_dlc_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataSourcesGOGGOGGameDLC, g_object_unref)
void game_hub_utils_fs_utils_mv_up (GFile* path,
                                    const gchar* dirname);
gboolean game_hub_data_runnable_runnable_action_get_is_primary (GameHubDataRunnableRunnableAction* self);
GFile* game_hub_data_runnable_runnable_action_get_file (GameHubDataRunnableRunnableAction* self);
GFile* game_hub_data_runnable_runnable_action_get_workdir (GameHubDataRunnableRunnableAction* self);
const gchar* game_hub_data_runnable_runnable_action_get_args (GameHubDataRunnableRunnableAction* self);
static GNotification* _____lambda46_ (Block9Data* _data9_,
                               GNotification* n);
#define GAME_HUB_APPLICATION_ACTION_GAME_PROPERTIES "game.properties"
static GNotification* ______lambda46__game_hub_utils_notification_configure_delegate (GNotification* notification,
                                                                               gpointer self);
void game_hub_data_game_save_version (GameHubDataGame* self,
                                      const gchar* ver);
GameHubDataRunnableDownloadableInstaller* game_hub_data_runnable_downloadable_installer_construct (GType object_type);
void game_hub_data_runnable_downloadable_installer_set_parts (GameHubDataRunnableDownloadableInstaller* self,
                                                              GeeArrayList* value);
GameHubDataRunnableDownloadableInstallerPart* game_hub_data_runnable_downloadable_installer_part_new (const gchar* id,
                                                                                                      const gchar* url,
                                                                                                      gint64 size,
                                                                                                      GFile* remote,
                                                                                                      GFile* local,
                                                                                                      const gchar* checksum,
                                                                                                      GChecksumType checksum_type);
GameHubDataRunnableDownloadableInstallerPart* game_hub_data_runnable_downloadable_installer_part_construct (GType object_type,
                                                                                                            const gchar* id,
                                                                                                            const gchar* url,
                                                                                                            gint64 size,
                                                                                                            GFile* remote,
                                                                                                            GFile* local,
                                                                                                            const gchar* checksum,
                                                                                                            GChecksumType checksum_type);
void game_hub_data_runnable_downloadable_installer_part_set_id (GameHubDataRunnableDownloadableInstallerPart* self,
                                                                const gchar* value);
const gchar* game_hub_data_runnable_downloadable_installer_part_get_url (GameHubDataRunnableDownloadableInstallerPart* self);
void game_hub_data_runnable_downloadable_installer_part_set_url (GameHubDataRunnableDownloadableInstallerPart* self,
                                                                 const gchar* value);
gint64 game_hub_data_runnable_downloadable_installer_part_get_size (GameHubDataRunnableDownloadableInstallerPart* self);
void game_hub_data_runnable_downloadable_installer_part_set_size (GameHubDataRunnableDownloadableInstallerPart* self,
                                                                  gint64 value);
void game_hub_data_runnable_downloadable_installer_part_set_remote (GameHubDataRunnableDownloadableInstallerPart* self,
                                                                    GFile* value);
void game_hub_data_runnable_downloadable_installer_part_set_local (GameHubDataRunnableDownloadableInstallerPart* self,
                                                                   GFile* value);
void game_hub_data_runnable_downloadable_installer_part_set_checksum (GameHubDataRunnableDownloadableInstallerPart* self,
                                                                      const gchar* value);
void game_hub_data_runnable_downloadable_installer_part_set_checksum_type (GameHubDataRunnableDownloadableInstallerPart* self,
                                                                           GChecksumType value);
static void game_hub_data_runnable_downloadable_installer_part_finalize (GObject * obj);
static void _vala_game_hub_data_runnable_downloadable_installer_part_get_property (GObject * object,
                                                                            guint property_id,
                                                                            GValue * value,
                                                                            GParamSpec * pspec);
static void _vala_game_hub_data_runnable_downloadable_installer_part_set_property (GObject * object,
                                                                            guint property_id,
                                                                            const GValue * value,
                                                                            GParamSpec * pspec);
static void game_hub_data_runnable_downloadable_installer_finalize (GameHubDataRunnableInstaller * obj);
gboolean game_hub_data_runnable_runnable_action_is_available (GameHubDataRunnableRunnableAction* self,
                                                              GameHubDataCompatTool* tool);
const gchar* game_hub_data_runnable_runnable_action_get_uri (GameHubDataRunnableRunnableAction* self);
GType** game_hub_data_runnable_runnable_action_get_compat_tools (GameHubDataRunnableRunnableAction* self,
                                                                 gint* result_length1);
static GType* _g_type_dup (GType* self);
static void game_hub_data_runnable_runnable_action_invoke_data_free (gpointer _data);
void game_hub_data_runnable_runnable_action_invoke (GameHubDataRunnableRunnableAction* self,
                                                    GameHubDataCompatTool* tool,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_);
void game_hub_data_runnable_runnable_action_invoke_finish (GameHubDataRunnableRunnableAction* self,
                                                           GAsyncResult* _res_);
static gboolean game_hub_data_runnable_runnable_action_invoke_co (GameHubDataRunnableRunnableActionInvokeData* _data_);
void game_hub_utils_open_uri (const gchar* uri);
gboolean game_hub_data_compat_tool_can_run_action (GameHubDataCompatTool* self,
                                                   GameHubDataRunnable* runnable,
                                                   GameHubDataRunnableRunnableAction* action);
GameHubDataRunnable* game_hub_data_runnable_runnable_action_get_runnable (GameHubDataRunnableRunnableAction* self);
void game_hub_data_compat_tool_run_action (GameHubDataCompatTool* self,
                                           GameHubDataRunnable* runnable,
                                           GameHubDataRunnableRunnableAction* action,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
void game_hub_data_compat_tool_run_action_finish (GameHubDataCompatTool* self,
                                                  GAsyncResult* _res_);
static void game_hub_data_runnable_runnable_action_invoke_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_);
GameHubDataRunnableRunnableAction* game_hub_data_runnable_runnable_action_construct (GType object_type);
void game_hub_data_runnable_runnable_action_set_runnable (GameHubDataRunnableRunnableAction* self,
                                                          GameHubDataRunnable* value);
void game_hub_data_runnable_runnable_action_set_is_primary (GameHubDataRunnableRunnableAction* self,
                                                            gboolean value);
gboolean game_hub_data_runnable_runnable_action_get_is_hidden (GameHubDataRunnableRunnableAction* self);
void game_hub_data_runnable_runnable_action_set_is_hidden (GameHubDataRunnableRunnableAction* self,
                                                           gboolean value);
const gchar* game_hub_data_runnable_runnable_action_get_name (GameHubDataRunnableRunnableAction* self);
void game_hub_data_runnable_runnable_action_set_name (GameHubDataRunnableRunnableAction* self,
                                                      const gchar* value);
void game_hub_data_runnable_runnable_action_set_file (GameHubDataRunnableRunnableAction* self,
                                                      GFile* value);
void game_hub_data_runnable_runnable_action_set_workdir (GameHubDataRunnableRunnableAction* self,
                                                         GFile* value);
void game_hub_data_runnable_runnable_action_set_args (GameHubDataRunnableRunnableAction* self,
                                                      const gchar* value);
void game_hub_data_runnable_runnable_action_set_compat_tools (GameHubDataRunnableRunnableAction* self,
                                                              GType** value,
                                                              gint value_length1);
static GType** _vala_array_dup4 (GType** self,
                          int length);
void game_hub_data_runnable_runnable_action_set_uri (GameHubDataRunnableRunnableAction* self,
                                                     const gchar* value);
static void game_hub_data_runnable_runnable_action_finalize (GameHubDataRunnableRunnableAction * obj);
static void game_hub_data_runnable_finalize (GObject * obj);
static void _vala_game_hub_data_runnable_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_game_hub_data_runnable_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
gchar* game_hub_data_platform_id (GameHubDataPlatform self);
gchar* game_hub_data_platform_name (GameHubDataPlatform self);
gchar* game_hub_data_platform_icon (GameHubDataPlatform self);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

const GameHubDataPlatform GAME_HUB_DATA_PLATFORM_PLATFORMS[4] = {GAME_HUB_DATA_PLATFORM_LINUX, GAME_HUB_DATA_PLATFORM_WINDOWS, GAME_HUB_DATA_PLATFORM_MACOS, GAME_HUB_DATA_PLATFORM_EMULATED};

static inline gpointer
game_hub_data_runnable_get_instance_private (GameHubDataRunnable* self)
{
	return G_STRUCT_MEMBER_P (self, GameHubDataRunnable_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 62 "../src/data/Runnable.vala"
	return self ? g_object_ref (self) : NULL;
#line 1926 "Runnable.c"
}

static gboolean
game_hub_data_runnable_real_is_supported (GameHubDataRunnable* self,
                                          GameHubDataPlatform* platform,
                                          gboolean with_compat)
{
	GameHubDataPlatform* _tmp0_ = NULL;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	GeeArrayList* _tmp4_;
	GameHubDataCompatTool** _tmp9_;
	gint _tmp9__length1;
	gboolean result = FALSE;
#line 59 "../src/data/Runnable.vala"
	_tmp0_ = platform;
#line 59 "../src/data/Runnable.vala"
	if (_tmp0_ == NULL) {
#line 1945 "Runnable.c"
		GameHubDataPlatform _tmp1_;
#line 59 "../src/data/Runnable.vala"
		_tmp1_ = GAME_HUB_DATA_PLATFORM_CURRENT;
#line 59 "../src/data/Runnable.vala"
		_tmp0_ = &_tmp1_;
#line 1951 "Runnable.c"
	}
#line 59 "../src/data/Runnable.vala"
	platform = _tmp0_;
#line 60 "../src/data/Runnable.vala"
	_tmp4_ = self->priv->_platforms;
#line 60 "../src/data/Runnable.vala"
	if (_tmp4_ == NULL) {
#line 60 "../src/data/Runnable.vala"
		_tmp3_ = TRUE;
#line 1961 "Runnable.c"
	} else {
		GeeArrayList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 60 "../src/data/Runnable.vala"
		_tmp5_ = self->priv->_platforms;
#line 60 "../src/data/Runnable.vala"
		_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 60 "../src/data/Runnable.vala"
		_tmp7_ = _tmp6_;
#line 60 "../src/data/Runnable.vala"
		_tmp3_ = _tmp7_ == 0;
#line 1974 "Runnable.c"
	}
#line 60 "../src/data/Runnable.vala"
	if (_tmp3_) {
#line 60 "../src/data/Runnable.vala"
		_tmp2_ = TRUE;
#line 1980 "Runnable.c"
	} else {
		GeeArrayList* _tmp8_;
#line 60 "../src/data/Runnable.vala"
		_tmp8_ = self->priv->_platforms;
#line 60 "../src/data/Runnable.vala"
		_tmp2_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp8_, (gpointer) ((gintptr) (*platform)));
#line 1987 "Runnable.c"
	}
#line 60 "../src/data/Runnable.vala"
	if (_tmp2_) {
#line 60 "../src/data/Runnable.vala"
		result = TRUE;
#line 60 "../src/data/Runnable.vala"
		return result;
#line 1995 "Runnable.c"
	}
#line 61 "../src/data/Runnable.vala"
	if (!with_compat) {
#line 61 "../src/data/Runnable.vala"
		result = FALSE;
#line 61 "../src/data/Runnable.vala"
		return result;
#line 2003 "Runnable.c"
	}
#line 62 "../src/data/Runnable.vala"
	_tmp9_ = game_hub_data_CompatTools;
#line 62 "../src/data/Runnable.vala"
	_tmp9__length1 = game_hub_data_CompatTools_length1;
#line 2009 "Runnable.c"
	{
		GameHubDataCompatTool** tool_collection = NULL;
		gint tool_collection_length1 = 0;
		gint _tool_collection_size_ = 0;
		gint tool_it = 0;
#line 62 "../src/data/Runnable.vala"
		tool_collection = _tmp9_;
#line 62 "../src/data/Runnable.vala"
		tool_collection_length1 = _tmp9__length1;
#line 62 "../src/data/Runnable.vala"
		for (tool_it = 0; tool_it < tool_collection_length1; tool_it = tool_it + 1) {
#line 2021 "Runnable.c"
			GameHubDataCompatTool* _tmp10_;
			GameHubDataCompatTool* tool = NULL;
#line 62 "../src/data/Runnable.vala"
			_tmp10_ = _g_object_ref0 (tool_collection[tool_it]);
#line 62 "../src/data/Runnable.vala"
			tool = _tmp10_;
#line 2028 "Runnable.c"
			{
				GameHubDataCompatTool* _tmp11_;
#line 64 "../src/data/Runnable.vala"
				_tmp11_ = tool;
#line 64 "../src/data/Runnable.vala"
				if (game_hub_data_compat_tool_can_run (_tmp11_, self)) {
#line 64 "../src/data/Runnable.vala"
					result = TRUE;
#line 64 "../src/data/Runnable.vala"
					_g_object_unref0 (tool);
#line 64 "../src/data/Runnable.vala"
					return result;
#line 2041 "Runnable.c"
				}
#line 62 "../src/data/Runnable.vala"
				_g_object_unref0 (tool);
#line 2045 "Runnable.c"
			}
		}
	}
#line 66 "../src/data/Runnable.vala"
	result = FALSE;
#line 66 "../src/data/Runnable.vala"
	return result;
#line 2053 "Runnable.c"
}

gboolean
game_hub_data_runnable_is_supported (GameHubDataRunnable* self,
                                     GameHubDataPlatform* platform,
                                     gboolean with_compat)
{
#line 57 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 57 "../src/data/Runnable.vala"
	return GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->is_supported (self, platform, with_compat);
#line 2065 "Runnable.c"
}

void
game_hub_data_runnable_install (GameHubDataRunnable* self,
                                GameHubDataRunnableInstallerInstallMode install_mode,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_)
{
#line 27 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->install (self, install_mode, _callback_, _user_data_);
#line 2076 "Runnable.c"
}

void
game_hub_data_runnable_install_finish (GameHubDataRunnable* self,
                                       GAsyncResult* _res_)
{
#line 27 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->install_finish (self, _res_);
#line 2085 "Runnable.c"
}

void
game_hub_data_runnable_run (GameHubDataRunnable* self,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_)
{
#line 27 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->run (self, _callback_, _user_data_);
#line 2095 "Runnable.c"
}

void
game_hub_data_runnable_run_finish (GameHubDataRunnable* self,
                                   GAsyncResult* _res_)
{
#line 27 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->run_finish (self, _res_);
#line 2104 "Runnable.c"
}

static gboolean
game_hub_data_runnable_real_can_be_launched (GameHubDataRunnable* self,
                                             gboolean is_launch_attempt)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 81 "../src/data/Runnable.vala"
	if (game_hub_data_runnable_IsLaunched) {
#line 81 "../src/data/Runnable.vala"
		_tmp1_ = TRUE;
#line 2119 "Runnable.c"
	} else {
#line 81 "../src/data/Runnable.vala"
		_tmp1_ = game_hub_data_sources_steam_steam_IsAnyAppRunning;
#line 2123 "Runnable.c"
	}
#line 81 "../src/data/Runnable.vala"
	if (_tmp1_) {
#line 81 "../src/data/Runnable.vala"
		_tmp0_ = TRUE;
#line 2129 "Runnable.c"
	} else {
		gboolean _tmp2_;
#line 81 "../src/data/Runnable.vala"
		_tmp2_ = self->priv->_is_running;
#line 81 "../src/data/Runnable.vala"
		_tmp0_ = _tmp2_;
#line 2136 "Runnable.c"
	}
#line 81 "../src/data/Runnable.vala"
	if (_tmp0_) {
#line 81 "../src/data/Runnable.vala"
		result = FALSE;
#line 81 "../src/data/Runnable.vala"
		return result;
#line 2144 "Runnable.c"
	}
#line 82 "../src/data/Runnable.vala"
	if (is_launch_attempt) {
#line 2148 "Runnable.c"
		{
#line 84 "../src/data/Runnable.vala"
			g_rec_mutex_lock (&__lock_game_hub_data_runnable_game_hub_data_runnable_LastLaunchAttempt);
#line 2152 "Runnable.c"
			{
				gint64 launch_attempt = 0LL;
				gint64 now = 0LL;
#line 86 "../src/data/Runnable.vala"
				launch_attempt = game_hub_data_runnable_LastLaunchAttempt;
#line 87 "../src/data/Runnable.vala"
				now = g_get_real_time ();
#line 88 "../src/data/Runnable.vala"
				game_hub_data_runnable_LastLaunchAttempt = now;
#line 89 "../src/data/Runnable.vala"
				if ((now - launch_attempt) < ((gint64) 1000000)) {
#line 89 "../src/data/Runnable.vala"
					result = FALSE;
#line 2166 "Runnable.c"
					{
#line 84 "../src/data/Runnable.vala"
						g_rec_mutex_unlock (&__lock_game_hub_data_runnable_game_hub_data_runnable_LastLaunchAttempt);
#line 2170 "Runnable.c"
					}
#line 89 "../src/data/Runnable.vala"
					return result;
#line 2174 "Runnable.c"
				}
			}
			__finally3:
			{
#line 84 "../src/data/Runnable.vala"
				g_rec_mutex_unlock (&__lock_game_hub_data_runnable_game_hub_data_runnable_LastLaunchAttempt);
#line 2181 "Runnable.c"
			}
#line 84 "../src/data/Runnable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2185 "Runnable.c"
				gboolean _tmp3_ = FALSE;
#line 84 "../src/data/Runnable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 84 "../src/data/Runnable.vala"
				g_clear_error (&_inner_error0_);
#line 84 "../src/data/Runnable.vala"
				return _tmp3_;
#line 2193 "Runnable.c"
			}
		}
	}
#line 92 "../src/data/Runnable.vala"
	result = TRUE;
#line 92 "../src/data/Runnable.vala"
	return result;
#line 2201 "Runnable.c"
}

gboolean
game_hub_data_runnable_can_be_launched (GameHubDataRunnable* self,
                                        gboolean is_launch_attempt)
{
#line 79 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 79 "../src/data/Runnable.vala"
	return GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->can_be_launched (self, is_launch_attempt);
#line 2212 "Runnable.c"
}

static void
game_hub_data_runnable_real_run_with_compat_data_free (gpointer _data)
{
	GameHubDataRunnableRunWithCompatData* _data_;
	_data_ = _data;
#line 27 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/data/Runnable.vala"
	g_slice_free (GameHubDataRunnableRunWithCompatData, _data_);
#line 2224 "Runnable.c"
}

static void
game_hub_data_runnable_real_run_with_compat (GameHubDataRunnable* self,
                                             gboolean is_opened_from_menu,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_)
{
	GameHubDataRunnableRunWithCompatData* _data_;
	GameHubDataRunnable* _tmp0_;
#line 27 "../src/data/Runnable.vala"
	_data_ = g_slice_new0 (GameHubDataRunnableRunWithCompatData);
#line 27 "../src/data/Runnable.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 27 "../src/data/Runnable.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_runnable_real_run_with_compat_data_free);
#line 27 "../src/data/Runnable.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/data/Runnable.vala"
	_data_->self = _tmp0_;
#line 27 "../src/data/Runnable.vala"
	_data_->is_opened_from_menu = is_opened_from_menu;
#line 27 "../src/data/Runnable.vala"
	game_hub_data_runnable_real_run_with_compat_co (_data_);
#line 2249 "Runnable.c"
}

static void
game_hub_data_runnable_real_run_with_compat_finish (GameHubDataRunnable* self,
                                                    GAsyncResult* _res_)
{
	GameHubDataRunnableRunWithCompatData* _data_;
#line 27 "../src/data/Runnable.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2259 "Runnable.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 95 "../src/data/Runnable.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 95 "../src/data/Runnable.vala"
	return _data5_;
#line 2269 "Runnable.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 95 "../src/data/Runnable.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 2279 "Runnable.c"
		GameHubDataRunnable* self;
#line 95 "../src/data/Runnable.vala"
		self = _data5_->self;
#line 95 "../src/data/Runnable.vala"
		_g_object_unref0 (self);
#line 95 "../src/data/Runnable.vala"
		g_slice_free (Block5Data, _data5_);
#line 2287 "Runnable.c"
	}
}

static gboolean
_game_hub_data_runnable_real_run_with_compat_co_gsource_func (gpointer self)
{
	gboolean result;
	result = game_hub_data_runnable_real_run_with_compat_co (self);
#line 101 "../src/data/Runnable.vala"
	return result;
#line 2298 "Runnable.c"
}

static void
___lambda83_ (Block5Data* _data5_)
{
	GameHubDataRunnable* self;
#line 100 "../src/data/Runnable.vala"
	self = _data5_->self;
#line 101 "../src/data/Runnable.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _game_hub_data_runnable_real_run_with_compat_co_gsource_func, _data5_->_async_data_, NULL);
#line 2309 "Runnable.c"
}

static void
____lambda83__gtk_widget_destroy (GtkWidget* _sender,
                                  gpointer self)
{
#line 100 "../src/data/Runnable.vala"
	___lambda83_ (self);
#line 2318 "Runnable.c"
}

static gboolean
game_hub_data_runnable_real_run_with_compat_co (GameHubDataRunnableRunWithCompatData* _data_)
{
#line 95 "../src/data/Runnable.vala"
	switch (_data_->_state_) {
#line 95 "../src/data/Runnable.vala"
		case 0:
#line 2328 "Runnable.c"
		goto _state_0;
#line 95 "../src/data/Runnable.vala"
		case 1:
#line 2332 "Runnable.c"
		goto _state_1;
		default:
#line 95 "../src/data/Runnable.vala"
		g_assert_not_reached ();
#line 2337 "Runnable.c"
	}
	_state_0:
#line 95 "../src/data/Runnable.vala"
	_data_->_data5_ = g_slice_new0 (Block5Data);
#line 95 "../src/data/Runnable.vala"
	_data_->_data5_->_ref_count_ = 1;
#line 95 "../src/data/Runnable.vala"
	_data_->_data5_->self = g_object_ref (_data_->self);
#line 95 "../src/data/Runnable.vala"
	_data_->_data5_->_async_data_ = _data_;
#line 97 "../src/data/Runnable.vala"
	if (game_hub_data_runnable_can_be_launched (_data_->self, TRUE)) {
#line 99 "../src/data/Runnable.vala"
		_data_->_tmp0_ = game_hub_ui_dialogs_compat_run_dialog_new (_data_->self, _data_->is_opened_from_menu, NULL, FALSE);
#line 99 "../src/data/Runnable.vala"
		g_object_ref_sink (_data_->_tmp0_);
#line 99 "../src/data/Runnable.vala"
		_data_->dlg = _data_->_tmp0_;
#line 100 "../src/data/Runnable.vala"
		_data_->_tmp1_ = _data_->dlg;
#line 100 "../src/data/Runnable.vala"
		g_signal_connect_data ((GtkWidget*) _data_->_tmp1_, "destroy", (GCallback) ____lambda83__gtk_widget_destroy, block5_data_ref (_data_->_data5_), (GClosureNotify) block5_data_unref, 0);
#line 103 "../src/data/Runnable.vala"
		_data_->_state_ = 1;
#line 103 "../src/data/Runnable.vala"
		return FALSE;
#line 2364 "Runnable.c"
		_state_1:
		;
#line 97 "../src/data/Runnable.vala"
		_g_object_unref0 (_data_->dlg);
#line 2369 "Runnable.c"
	}
#line 95 "../src/data/Runnable.vala"
	block5_data_unref (_data_->_data5_);
#line 95 "../src/data/Runnable.vala"
	_data_->_data5_ = NULL;
#line 95 "../src/data/Runnable.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 95 "../src/data/Runnable.vala"
	if (_data_->_state_ != 0) {
#line 95 "../src/data/Runnable.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 95 "../src/data/Runnable.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2383 "Runnable.c"
		}
	}
#line 95 "../src/data/Runnable.vala"
	g_object_unref (_data_->_async_result);
#line 95 "../src/data/Runnable.vala"
	return FALSE;
#line 2390 "Runnable.c"
}

void
game_hub_data_runnable_run_with_compat (GameHubDataRunnable* self,
                                        gboolean is_opened_from_menu,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
#line 27 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->run_with_compat (self, is_opened_from_menu, _callback_, _user_data_);
#line 2401 "Runnable.c"
}

void
game_hub_data_runnable_run_with_compat_finish (GameHubDataRunnable* self,
                                               GAsyncResult* _res_)
{
#line 27 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->run_with_compat_finish (self, _res_);
#line 2410 "Runnable.c"
}

static GtkFileChooser*
game_hub_data_runnable_real_setup_executable_chooser (GameHubDataRunnable* self)
{
	GtkFileChooserNative* chooser = NULL;
	GameHubUIWindowsMainWindow* _tmp0_;
	GtkFileChooserNative* _tmp1_;
	GError* _inner_error0_ = NULL;
	GtkFileChooser* result = NULL;
#line 110 "../src/data/Runnable.vala"
	_tmp0_ = game_hub_ui_windows_main_window_instance;
#line 110 "../src/data/Runnable.vala"
	_tmp1_ = gtk_file_chooser_native_new (_ ("Select executable"), (GtkWindow*) _tmp0_, GTK_FILE_CHOOSER_ACTION_OPEN, _ ("Select"), _ ("Cancel"));
#line 110 "../src/data/Runnable.vala"
	chooser = _tmp1_;
#line 2427 "Runnable.c"
	{
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
#line 117 "../src/data/Runnable.vala"
		_tmp2_ = game_hub_data_runnable_get_executable (self);
#line 117 "../src/data/Runnable.vala"
		_tmp3_ = _tmp2_;
#line 117 "../src/data/Runnable.vala"
		_tmp4_ = _tmp3_;
#line 117 "../src/data/Runnable.vala"
		gtk_file_chooser_set_file ((GtkFileChooser*) chooser, _tmp4_, &_inner_error0_);
#line 117 "../src/data/Runnable.vala"
		_g_object_unref0 (_tmp4_);
#line 117 "../src/data/Runnable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2444 "Runnable.c"
			goto __catch4_g_error;
		}
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 115 "../src/data/Runnable.vala"
		e = _inner_error0_;
#line 115 "../src/data/Runnable.vala"
		_inner_error0_ = NULL;
#line 121 "../src/data/Runnable.vala"
		_tmp5_ = e;
#line 121 "../src/data/Runnable.vala"
		_tmp6_ = _tmp5_->message;
#line 121 "../src/data/Runnable.vala"
		g_warning ("Runnable.vala:121: %s", _tmp6_);
#line 115 "../src/data/Runnable.vala"
		_g_error_free0 (e);
#line 2466 "Runnable.c"
	}
	__finally4:
#line 115 "../src/data/Runnable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 115 "../src/data/Runnable.vala"
		_g_object_unref0 (chooser);
#line 115 "../src/data/Runnable.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 115 "../src/data/Runnable.vala"
		g_clear_error (&_inner_error0_);
#line 115 "../src/data/Runnable.vala"
		return NULL;
#line 2479 "Runnable.c"
	}
#line 124 "../src/data/Runnable.vala"
	result = (GtkFileChooser*) chooser;
#line 124 "../src/data/Runnable.vala"
	return result;
#line 2485 "Runnable.c"
}

GtkFileChooser*
game_hub_data_runnable_setup_executable_chooser (GameHubDataRunnable* self)
{
#line 107 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 107 "../src/data/Runnable.vala"
	return GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->setup_executable_chooser (self);
#line 2495 "Runnable.c"
}

static gint
game_hub_data_runnable_run_executable_chooser (GameHubDataRunnable* self,
                                               GtkFileChooser* chooser)
{
	gint result = 0;
#line 127 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 127 "../src/data/Runnable.vala"
	g_return_val_if_fail (chooser != NULL, 0);
#line 130 "../src/data/Runnable.vala"
	result = gtk_native_dialog_run ((GtkNativeDialog*) (G_TYPE_CHECK_INSTANCE_TYPE (chooser, gtk_file_chooser_native_get_type ()) ? ((GtkFileChooserNative*) chooser) : NULL));
#line 130 "../src/data/Runnable.vala"
	return result;
#line 2511 "Runnable.c"
}

static void
game_hub_data_runnable_real_choose_executable (GameHubDataRunnable* self,
                                               gboolean update)
{
	GtkFileChooser* chooser = NULL;
	GtkFileChooser* _tmp0_;
	GtkFileChooser* _tmp1_;
#line 138 "../src/data/Runnable.vala"
	_tmp0_ = game_hub_data_runnable_setup_executable_chooser (self);
#line 138 "../src/data/Runnable.vala"
	chooser = _tmp0_;
#line 140 "../src/data/Runnable.vala"
	_tmp1_ = chooser;
#line 140 "../src/data/Runnable.vala"
	if (game_hub_data_runnable_run_executable_chooser (self, _tmp1_) == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 2529 "Runnable.c"
		GtkFileChooser* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
#line 142 "../src/data/Runnable.vala"
		_tmp2_ = chooser;
#line 142 "../src/data/Runnable.vala"
		_tmp3_ = gtk_file_chooser_get_file (_tmp2_);
#line 142 "../src/data/Runnable.vala"
		_tmp4_ = _tmp3_;
#line 142 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_chosen_executable (self, _tmp4_, update);
#line 142 "../src/data/Runnable.vala"
		_g_object_unref0 (_tmp4_);
#line 2543 "Runnable.c"
	}
#line 136 "../src/data/Runnable.vala"
	_g_object_unref0 (chooser);
#line 2547 "Runnable.c"
}

void
game_hub_data_runnable_choose_executable (GameHubDataRunnable* self,
                                          gboolean update)
{
#line 136 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 136 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->choose_executable (self, update);
#line 2558 "Runnable.c"
}

static void
game_hub_data_runnable_real_set_chosen_executable (GameHubDataRunnable* self,
                                                   GFile* file,
                                                   gboolean update)
{
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	gboolean _tmp4_;
#line 148 "../src/data/Runnable.vala"
	game_hub_data_runnable_set_executable (self, file);
#line 149 "../src/data/Runnable.vala"
	_tmp1_ = game_hub_data_runnable_get_executable (self);
#line 149 "../src/data/Runnable.vala"
	_tmp2_ = _tmp1_;
#line 149 "../src/data/Runnable.vala"
	_tmp3_ = _tmp2_;
#line 149 "../src/data/Runnable.vala"
	_tmp4_ = _tmp3_ != NULL;
#line 149 "../src/data/Runnable.vala"
	_g_object_unref0 (_tmp3_);
#line 149 "../src/data/Runnable.vala"
	if (_tmp4_) {
#line 2585 "Runnable.c"
		GFile* _tmp5_;
		GFile* _tmp6_;
		GFile* _tmp7_;
#line 149 "../src/data/Runnable.vala"
		_tmp5_ = game_hub_data_runnable_get_executable (self);
#line 149 "../src/data/Runnable.vala"
		_tmp6_ = _tmp5_;
#line 149 "../src/data/Runnable.vala"
		_tmp7_ = _tmp6_;
#line 149 "../src/data/Runnable.vala"
		_tmp0_ = g_file_query_exists (_tmp7_, NULL);
#line 149 "../src/data/Runnable.vala"
		_g_object_unref0 (_tmp7_);
#line 2599 "Runnable.c"
	} else {
#line 149 "../src/data/Runnable.vala"
		_tmp0_ = FALSE;
#line 2603 "Runnable.c"
	}
#line 149 "../src/data/Runnable.vala"
	if (_tmp0_) {
#line 2607 "Runnable.c"
		gchar* _tmp8_;
		gchar* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
		GFile* _tmp12_;
		gchar* _tmp13_;
		gchar** _tmp14_;
		gchar** _tmp15_;
		gint _tmp15__length1;
		GameHubUtilsRunTask* _tmp16_;
		GameHubUtilsRunTask* _tmp17_;
		GameHubUtilsRunTaskResult* _tmp18_;
		GameHubUtilsRunTaskResult* _tmp19_;
#line 151 "../src/data/Runnable.vala"
		_tmp8_ = g_strdup ("chmod");
#line 151 "../src/data/Runnable.vala"
		_tmp9_ = g_strdup ("+x");
#line 151 "../src/data/Runnable.vala"
		_tmp10_ = game_hub_data_runnable_get_executable (self);
#line 151 "../src/data/Runnable.vala"
		_tmp11_ = _tmp10_;
#line 151 "../src/data/Runnable.vala"
		_tmp12_ = _tmp11_;
#line 151 "../src/data/Runnable.vala"
		_tmp13_ = g_file_get_path (_tmp12_);
#line 151 "../src/data/Runnable.vala"
		_tmp14_ = g_new0 (gchar*, 3 + 1);
#line 151 "../src/data/Runnable.vala"
		_tmp14_[0] = _tmp8_;
#line 151 "../src/data/Runnable.vala"
		_tmp14_[1] = _tmp9_;
#line 151 "../src/data/Runnable.vala"
		_tmp14_[2] = _tmp13_;
#line 151 "../src/data/Runnable.vala"
		_tmp15_ = _tmp14_;
#line 151 "../src/data/Runnable.vala"
		_tmp15__length1 = 3;
#line 151 "../src/data/Runnable.vala"
		_tmp16_ = game_hub_utils_run (_tmp15_, (gint) 3);
#line 151 "../src/data/Runnable.vala"
		_tmp17_ = _tmp16_;
#line 151 "../src/data/Runnable.vala"
		_tmp18_ = game_hub_utils_run_task_run_sync (_tmp17_, FALSE);
#line 151 "../src/data/Runnable.vala"
		_tmp19_ = _tmp18_;
#line 151 "../src/data/Runnable.vala"
		_game_hub_utils_run_task_result_unref0 (_tmp19_);
#line 151 "../src/data/Runnable.vala"
		_game_hub_utils_run_task_unref0 (_tmp17_);
#line 151 "../src/data/Runnable.vala"
		_tmp15_ = (_vala_array_free (_tmp15_, _tmp15__length1, (GDestroyNotify) g_free), NULL);
#line 151 "../src/data/Runnable.vala"
		_g_object_unref0 (_tmp12_);
#line 2661 "Runnable.c"
	}
#line 154 "../src/data/Runnable.vala"
	if (update) {
#line 156 "../src/data/Runnable.vala"
		game_hub_data_runnable_update_status (self);
#line 157 "../src/data/Runnable.vala"
		game_hub_data_runnable_save (self);
#line 2669 "Runnable.c"
	}
}

void
game_hub_data_runnable_set_chosen_executable (GameHubDataRunnable* self,
                                              GFile* file,
                                              gboolean update)
{
#line 146 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 146 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->set_chosen_executable (self, file, update);
#line 2682 "Runnable.c"
}

static void
game_hub_data_runnable_real_save (GameHubDataRunnable* self)
{
}

void
game_hub_data_runnable_save (GameHubDataRunnable* self)
{
#line 161 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 161 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->save (self);
#line 2697 "Runnable.c"
}

static void
game_hub_data_runnable_real_update_status (GameHubDataRunnable* self)
{
}

void
game_hub_data_runnable_update_status (GameHubDataRunnable* self)
{
#line 162 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 162 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->update_status (self);
#line 2712 "Runnable.c"
}

static void
game_hub_data_runnable_real_import (GameHubDataRunnable* self,
                                    gboolean update)
{
	GtkFileChooserDialog* chooser = NULL;
	GameHubUIWindowsMainWindow* _tmp0_;
	GtkFileChooserDialog* _tmp1_;
	gchar* games_dir = NULL;
	gchar* _tmp2_;
	GtkFileChooserDialog* _tmp7_;
	const gchar* _tmp8_;
	GtkFileChooserDialog* _tmp9_;
	GtkWidget* select_btn = NULL;
	GtkFileChooserDialog* _tmp10_;
	GtkWidget* _tmp11_;
	GtkWidget* _tmp12_;
	GtkWidget* _tmp13_;
	GtkStyleContext* _tmp14_;
	GtkWidget* _tmp15_;
	GtkFileChooserDialog* _tmp16_;
	GtkFileChooserDialog* _tmp46_;
#line 166 "../src/data/Runnable.vala"
	_tmp0_ = game_hub_ui_windows_main_window_instance;
#line 166 "../src/data/Runnable.vala"
	_tmp1_ = (GtkFileChooserDialog*) gtk_file_chooser_dialog_new (_ ("Select directory"), (GtkWindow*) _tmp0_, GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER, NULL);
#line 166 "../src/data/Runnable.vala"
	g_object_ref_sink (_tmp1_);
#line 166 "../src/data/Runnable.vala"
	chooser = _tmp1_;
#line 168 "../src/data/Runnable.vala"
	_tmp2_ = g_strdup ("");
#line 168 "../src/data/Runnable.vala"
	games_dir = _tmp2_;
#line 169 "../src/data/Runnable.vala"
	if (GAME_HUB_DATA_SOURCES_GOG_IS_GOG_GAME (self)) {
#line 2750 "Runnable.c"
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 171 "../src/data/Runnable.vala"
		_tmp3_ = game_hub_utils_fs_utils_paths_gog_get_Games ();
#line 171 "../src/data/Runnable.vala"
		_tmp4_ = _tmp3_;
#line 171 "../src/data/Runnable.vala"
		_g_free0 (games_dir);
#line 171 "../src/data/Runnable.vala"
		games_dir = _tmp4_;
#line 2761 "Runnable.c"
	} else {
#line 173 "../src/data/Runnable.vala"
		if (GAME_HUB_DATA_SOURCES_HUMBLE_IS_HUMBLE_GAME (self)) {
#line 2765 "Runnable.c"
			gchar* _tmp5_;
			gchar* _tmp6_;
#line 175 "../src/data/Runnable.vala"
			_tmp5_ = game_hub_utils_fs_utils_paths_humble_get_Games ();
#line 175 "../src/data/Runnable.vala"
			_tmp6_ = _tmp5_;
#line 175 "../src/data/Runnable.vala"
			_g_free0 (games_dir);
#line 175 "../src/data/Runnable.vala"
			games_dir = _tmp6_;
#line 2776 "Runnable.c"
		}
	}
#line 178 "../src/data/Runnable.vala"
	_tmp7_ = chooser;
#line 178 "../src/data/Runnable.vala"
	_tmp8_ = games_dir;
#line 178 "../src/data/Runnable.vala"
	gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp7_, _tmp8_);
#line 180 "../src/data/Runnable.vala"
	_tmp9_ = chooser;
#line 180 "../src/data/Runnable.vala"
	gtk_dialog_add_button ((GtkDialog*) _tmp9_, _ ("Cancel"), (gint) GTK_RESPONSE_CANCEL);
#line 181 "../src/data/Runnable.vala"
	_tmp10_ = chooser;
#line 181 "../src/data/Runnable.vala"
	_tmp11_ = gtk_dialog_add_button ((GtkDialog*) _tmp10_, _ ("Select"), (gint) GTK_RESPONSE_ACCEPT);
#line 181 "../src/data/Runnable.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 181 "../src/data/Runnable.vala"
	select_btn = _tmp12_;
#line 183 "../src/data/Runnable.vala"
	_tmp13_ = select_btn;
#line 183 "../src/data/Runnable.vala"
	_tmp14_ = gtk_widget_get_style_context (_tmp13_);
#line 183 "../src/data/Runnable.vala"
	gtk_style_context_add_class (_tmp14_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
#line 184 "../src/data/Runnable.vala"
	_tmp15_ = select_btn;
#line 184 "../src/data/Runnable.vala"
	gtk_widget_grab_default (_tmp15_);
#line 186 "../src/data/Runnable.vala"
	_tmp16_ = chooser;
#line 186 "../src/data/Runnable.vala"
	if (gtk_dialog_run ((GtkDialog*) _tmp16_) == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 2811 "Runnable.c"
		GtkFileChooserDialog* _tmp17_;
		GFile* _tmp18_;
		GFile* _tmp19_;
		GFile* _tmp20_;
		GFile* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		GFile* _tmp24_;
		GFile* _tmp25_;
		GFile* _tmp26_;
		GFile* _tmp27_;
		GFile* _tmp28_;
		gboolean _tmp29_;
		GFile* _tmp30_;
		GFile* _tmp31_;
		GFile* _tmp32_;
		gboolean _tmp33_;
#line 188 "../src/data/Runnable.vala"
		_tmp17_ = chooser;
#line 188 "../src/data/Runnable.vala"
		_tmp18_ = gtk_file_chooser_get_file ((GtkFileChooser*) _tmp17_);
#line 188 "../src/data/Runnable.vala"
		_tmp19_ = _tmp18_;
#line 188 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_install_dir (self, _tmp19_);
#line 188 "../src/data/Runnable.vala"
		_g_object_unref0 (_tmp19_);
#line 189 "../src/data/Runnable.vala"
		_tmp20_ = self->priv->_install_dir;
#line 189 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_work_dir (self, _tmp20_);
#line 190 "../src/data/Runnable.vala"
		_tmp21_ = self->priv->_install_dir;
#line 190 "../src/data/Runnable.vala"
		_tmp22_ = g_file_get_path (_tmp21_);
#line 190 "../src/data/Runnable.vala"
		_tmp23_ = _tmp22_;
#line 190 "../src/data/Runnable.vala"
		_tmp24_ = game_hub_utils_fs_utils_file (_tmp23_, "start.sh", NULL);
#line 190 "../src/data/Runnable.vala"
		_tmp25_ = _tmp24_;
#line 190 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_executable (self, _tmp25_);
#line 190 "../src/data/Runnable.vala"
		_g_object_unref0 (_tmp25_);
#line 190 "../src/data/Runnable.vala"
		_g_free0 (_tmp23_);
#line 192 "../src/data/Runnable.vala"
		_tmp26_ = game_hub_data_runnable_get_executable (self);
#line 192 "../src/data/Runnable.vala"
		_tmp27_ = _tmp26_;
#line 192 "../src/data/Runnable.vala"
		_tmp28_ = _tmp27_;
#line 192 "../src/data/Runnable.vala"
		_tmp29_ = !g_file_query_exists (_tmp28_, NULL);
#line 192 "../src/data/Runnable.vala"
		_g_object_unref0 (_tmp28_);
#line 192 "../src/data/Runnable.vala"
		if (_tmp29_) {
#line 194 "../src/data/Runnable.vala"
			game_hub_data_runnable_choose_executable (self, FALSE);
#line 2873 "Runnable.c"
		}
#line 197 "../src/data/Runnable.vala"
		_tmp30_ = game_hub_data_runnable_get_executable (self);
#line 197 "../src/data/Runnable.vala"
		_tmp31_ = _tmp30_;
#line 197 "../src/data/Runnable.vala"
		_tmp32_ = _tmp31_;
#line 197 "../src/data/Runnable.vala"
		_tmp33_ = g_file_query_exists (_tmp32_, NULL);
#line 197 "../src/data/Runnable.vala"
		_g_object_unref0 (_tmp32_);
#line 197 "../src/data/Runnable.vala"
		if (_tmp33_) {
#line 2887 "Runnable.c"
			gchar* _tmp34_;
			gchar* _tmp35_;
			GFile* _tmp36_;
			GFile* _tmp37_;
			GFile* _tmp38_;
			gchar* _tmp39_;
			gchar** _tmp40_;
			gchar** _tmp41_;
			gint _tmp41__length1;
			GameHubUtilsRunTask* _tmp42_;
			GameHubUtilsRunTask* _tmp43_;
			GameHubUtilsRunTaskResult* _tmp44_;
			GameHubUtilsRunTaskResult* _tmp45_;
#line 199 "../src/data/Runnable.vala"
			_tmp34_ = g_strdup ("chmod");
#line 199 "../src/data/Runnable.vala"
			_tmp35_ = g_strdup ("+x");
#line 199 "../src/data/Runnable.vala"
			_tmp36_ = game_hub_data_runnable_get_executable (self);
#line 199 "../src/data/Runnable.vala"
			_tmp37_ = _tmp36_;
#line 199 "../src/data/Runnable.vala"
			_tmp38_ = _tmp37_;
#line 199 "../src/data/Runnable.vala"
			_tmp39_ = g_file_get_path (_tmp38_);
#line 199 "../src/data/Runnable.vala"
			_tmp40_ = g_new0 (gchar*, 3 + 1);
#line 199 "../src/data/Runnable.vala"
			_tmp40_[0] = _tmp34_;
#line 199 "../src/data/Runnable.vala"
			_tmp40_[1] = _tmp35_;
#line 199 "../src/data/Runnable.vala"
			_tmp40_[2] = _tmp39_;
#line 199 "../src/data/Runnable.vala"
			_tmp41_ = _tmp40_;
#line 199 "../src/data/Runnable.vala"
			_tmp41__length1 = 3;
#line 199 "../src/data/Runnable.vala"
			_tmp42_ = game_hub_utils_run (_tmp41_, (gint) 3);
#line 199 "../src/data/Runnable.vala"
			_tmp43_ = _tmp42_;
#line 199 "../src/data/Runnable.vala"
			_tmp44_ = game_hub_utils_run_task_run_sync (_tmp43_, FALSE);
#line 199 "../src/data/Runnable.vala"
			_tmp45_ = _tmp44_;
#line 199 "../src/data/Runnable.vala"
			_game_hub_utils_run_task_result_unref0 (_tmp45_);
#line 199 "../src/data/Runnable.vala"
			_game_hub_utils_run_task_unref0 (_tmp43_);
#line 199 "../src/data/Runnable.vala"
			_tmp41_ = (_vala_array_free (_tmp41_, _tmp41__length1, (GDestroyNotify) g_free), NULL);
#line 199 "../src/data/Runnable.vala"
			_g_object_unref0 (_tmp38_);
#line 2941 "Runnable.c"
		}
#line 202 "../src/data/Runnable.vala"
		if (update) {
#line 204 "../src/data/Runnable.vala"
			game_hub_data_runnable_update_status (self);
#line 205 "../src/data/Runnable.vala"
			game_hub_data_runnable_save (self);
#line 2949 "Runnable.c"
		}
	}
#line 209 "../src/data/Runnable.vala"
	_tmp46_ = chooser;
#line 209 "../src/data/Runnable.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp46_);
#line 164 "../src/data/Runnable.vala"
	_g_object_unref0 (select_btn);
#line 164 "../src/data/Runnable.vala"
	_g_free0 (games_dir);
#line 164 "../src/data/Runnable.vala"
	_g_object_unref0 (chooser);
#line 2962 "Runnable.c"
}

void
game_hub_data_runnable_import (GameHubDataRunnable* self,
                               gboolean update)
{
#line 164 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 164 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->import (self, update);
#line 2973 "Runnable.c"
}

static void
_vala_JsonNode_free (JsonNode* self)
{
#line 266 "../src/data/Runnable.vala"
	g_boxed_free (json_node_get_type (), self);
#line 2981 "Runnable.c"
}

JsonObject*
game_hub_data_runnable_get_compat_settings (GameHubDataRunnable* self,
                                            GameHubDataCompatTool* tool)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	JsonObject* _tmp16_;
	JsonObject* result = NULL;
#line 258 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 258 "../src/data/Runnable.vala"
	g_return_val_if_fail (tool != NULL, NULL);
#line 260 "../src/data/Runnable.vala"
	_tmp1_ = self->priv->_compat_tool_settings;
#line 260 "../src/data/Runnable.vala"
	if (_tmp1_ != NULL) {
#line 3000 "Runnable.c"
		const gchar* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 260 "../src/data/Runnable.vala"
		_tmp2_ = self->priv->_compat_tool_settings;
#line 260 "../src/data/Runnable.vala"
		_tmp3_ = strlen (_tmp2_);
#line 260 "../src/data/Runnable.vala"
		_tmp4_ = _tmp3_;
#line 260 "../src/data/Runnable.vala"
		_tmp0_ = _tmp4_ > 0;
#line 3012 "Runnable.c"
	} else {
#line 260 "../src/data/Runnable.vala"
		_tmp0_ = FALSE;
#line 3016 "Runnable.c"
	}
#line 260 "../src/data/Runnable.vala"
	if (_tmp0_) {
#line 3020 "Runnable.c"
		JsonNode* root = NULL;
		const gchar* _tmp5_;
		JsonNode* _tmp6_;
		JsonObject* settings = NULL;
		JsonNode* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar** _tmp11_;
		gchar** _tmp12_;
		gint _tmp12__length1;
		JsonObject* _tmp13_;
		JsonObject* _tmp14_;
		JsonObject* _tmp15_;
#line 262 "../src/data/Runnable.vala"
		_tmp5_ = self->priv->_compat_tool_settings;
#line 262 "../src/data/Runnable.vala"
		_tmp6_ = game_hub_utils_parser_parse_json (_tmp5_);
#line 262 "../src/data/Runnable.vala"
		root = _tmp6_;
#line 263 "../src/data/Runnable.vala"
		_tmp7_ = root;
#line 263 "../src/data/Runnable.vala"
		_tmp8_ = game_hub_data_compat_tool_get_id (tool);
#line 263 "../src/data/Runnable.vala"
		_tmp9_ = _tmp8_;
#line 263 "../src/data/Runnable.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 263 "../src/data/Runnable.vala"
		_tmp11_ = g_new0 (gchar*, 1 + 1);
#line 263 "../src/data/Runnable.vala"
		_tmp11_[0] = _tmp10_;
#line 263 "../src/data/Runnable.vala"
		_tmp12_ = _tmp11_;
#line 263 "../src/data/Runnable.vala"
		_tmp12__length1 = 1;
#line 263 "../src/data/Runnable.vala"
		_tmp13_ = game_hub_utils_parser_json_object (_tmp7_, _tmp12_, (gint) 1);
#line 263 "../src/data/Runnable.vala"
		_tmp14_ = _tmp13_;
#line 263 "../src/data/Runnable.vala"
		_tmp12_ = (_vala_array_free (_tmp12_, _tmp12__length1, (GDestroyNotify) g_free), NULL);
#line 263 "../src/data/Runnable.vala"
		settings = _tmp14_;
#line 264 "../src/data/Runnable.vala"
		_tmp15_ = settings;
#line 264 "../src/data/Runnable.vala"
		if (_tmp15_ != NULL) {
#line 266 "../src/data/Runnable.vala"
			result = settings;
#line 266 "../src/data/Runnable.vala"
			__vala_JsonNode_free0 (root);
#line 266 "../src/data/Runnable.vala"
			return result;
#line 3075 "Runnable.c"
		}
#line 260 "../src/data/Runnable.vala"
		_json_object_unref0 (settings);
#line 260 "../src/data/Runnable.vala"
		__vala_JsonNode_free0 (root);
#line 3081 "Runnable.c"
	}
#line 269 "../src/data/Runnable.vala"
	_tmp16_ = json_object_new ();
#line 269 "../src/data/Runnable.vala"
	result = _tmp16_;
#line 269 "../src/data/Runnable.vala"
	return result;
#line 3089 "Runnable.c"
}

static gpointer
_json_object_ref0 (gpointer self)
{
#line 280 "../src/data/Runnable.vala"
	return self ? json_object_ref (self) : NULL;
#line 3097 "Runnable.c"
}

void
game_hub_data_runnable_set_compat_settings (GameHubDataRunnable* self,
                                            GameHubDataCompatTool* tool,
                                            JsonObject* settings)
{
	JsonObject* root_object = NULL;
	JsonObject* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	JsonNode* root_node = NULL;
	JsonNode* _tmp21_;
	JsonObject* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
#line 272 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 272 "../src/data/Runnable.vala"
	g_return_if_fail (tool != NULL);
#line 274 "../src/data/Runnable.vala"
	_tmp0_ = json_object_new ();
#line 274 "../src/data/Runnable.vala"
	root_object = _tmp0_;
#line 275 "../src/data/Runnable.vala"
	_tmp2_ = self->priv->_compat_tool_settings;
#line 275 "../src/data/Runnable.vala"
	if (_tmp2_ != NULL) {
#line 3126 "Runnable.c"
		const gchar* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
#line 275 "../src/data/Runnable.vala"
		_tmp3_ = self->priv->_compat_tool_settings;
#line 275 "../src/data/Runnable.vala"
		_tmp4_ = strlen (_tmp3_);
#line 275 "../src/data/Runnable.vala"
		_tmp5_ = _tmp4_;
#line 275 "../src/data/Runnable.vala"
		_tmp1_ = _tmp5_ > 0;
#line 3138 "Runnable.c"
	} else {
#line 275 "../src/data/Runnable.vala"
		_tmp1_ = FALSE;
#line 3142 "Runnable.c"
	}
#line 275 "../src/data/Runnable.vala"
	if (_tmp1_) {
#line 3146 "Runnable.c"
		JsonNode* root = NULL;
		const gchar* _tmp6_;
		JsonNode* _tmp7_;
		gboolean _tmp8_ = FALSE;
		JsonNode* _tmp9_;
#line 277 "../src/data/Runnable.vala"
		_tmp6_ = self->priv->_compat_tool_settings;
#line 277 "../src/data/Runnable.vala"
		_tmp7_ = game_hub_utils_parser_parse_json (_tmp6_);
#line 277 "../src/data/Runnable.vala"
		root = _tmp7_;
#line 278 "../src/data/Runnable.vala"
		_tmp9_ = root;
#line 278 "../src/data/Runnable.vala"
		if (_tmp9_ != NULL) {
#line 3162 "Runnable.c"
			JsonNode* _tmp10_;
#line 278 "../src/data/Runnable.vala"
			_tmp10_ = root;
#line 278 "../src/data/Runnable.vala"
			_tmp8_ = json_node_get_node_type (_tmp10_) == JSON_NODE_OBJECT;
#line 3168 "Runnable.c"
		} else {
#line 278 "../src/data/Runnable.vala"
			_tmp8_ = FALSE;
#line 3172 "Runnable.c"
		}
#line 278 "../src/data/Runnable.vala"
		if (_tmp8_) {
#line 3176 "Runnable.c"
			JsonNode* _tmp11_;
			JsonObject* _tmp12_;
			JsonObject* _tmp13_;
#line 280 "../src/data/Runnable.vala"
			_tmp11_ = root;
#line 280 "../src/data/Runnable.vala"
			_tmp12_ = json_node_get_object (_tmp11_);
#line 280 "../src/data/Runnable.vala"
			_tmp13_ = _json_object_ref0 (_tmp12_);
#line 280 "../src/data/Runnable.vala"
			_json_object_unref0 (root_object);
#line 280 "../src/data/Runnable.vala"
			root_object = _tmp13_;
#line 3190 "Runnable.c"
		}
#line 275 "../src/data/Runnable.vala"
		__vala_JsonNode_free0 (root);
#line 3194 "Runnable.c"
	}
#line 284 "../src/data/Runnable.vala"
	if (settings == NULL) {
#line 3198 "Runnable.c"
		JsonObject* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
#line 286 "../src/data/Runnable.vala"
		_tmp14_ = root_object;
#line 286 "../src/data/Runnable.vala"
		_tmp15_ = game_hub_data_compat_tool_get_id (tool);
#line 286 "../src/data/Runnable.vala"
		_tmp16_ = _tmp15_;
#line 286 "../src/data/Runnable.vala"
		json_object_remove_member (_tmp14_, _tmp16_);
#line 3210 "Runnable.c"
	} else {
		JsonObject* _tmp17_;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		JsonObject* _tmp20_;
#line 290 "../src/data/Runnable.vala"
		_tmp17_ = root_object;
#line 290 "../src/data/Runnable.vala"
		_tmp18_ = game_hub_data_compat_tool_get_id (tool);
#line 290 "../src/data/Runnable.vala"
		_tmp19_ = _tmp18_;
#line 290 "../src/data/Runnable.vala"
		_tmp20_ = _json_object_ref0 (settings);
#line 290 "../src/data/Runnable.vala"
		json_object_set_object_member (_tmp17_, _tmp19_, _tmp20_);
#line 3226 "Runnable.c"
	}
#line 293 "../src/data/Runnable.vala"
	_tmp21_ = json_node_new (JSON_NODE_OBJECT);
#line 293 "../src/data/Runnable.vala"
	root_node = _tmp21_;
#line 294 "../src/data/Runnable.vala"
	_tmp22_ = root_object;
#line 294 "../src/data/Runnable.vala"
	json_node_set_object (root_node, _tmp22_);
#line 295 "../src/data/Runnable.vala"
	_tmp23_ = json_to_string (root_node, FALSE);
#line 295 "../src/data/Runnable.vala"
	_tmp24_ = _tmp23_;
#line 295 "../src/data/Runnable.vala"
	game_hub_data_runnable_set_compat_tool_settings (self, _tmp24_);
#line 295 "../src/data/Runnable.vala"
	_g_free0 (_tmp24_);
#line 296 "../src/data/Runnable.vala"
	game_hub_data_runnable_set_compat_options_saved (self, TRUE);
#line 297 "../src/data/Runnable.vala"
	game_hub_data_runnable_save (self);
#line 272 "../src/data/Runnable.vala"
	__vala_JsonNode_free0 (root_node);
#line 272 "../src/data/Runnable.vala"
	_json_object_unref0 (root_object);
#line 3252 "Runnable.c"
}

static gboolean*
_bool_dup (gboolean* self)
{
	gboolean* dup;
#line 308 "../src/data/Runnable.vala"
	dup = g_new0 (gboolean, 1);
#line 308 "../src/data/Runnable.vala"
	memcpy (dup, self, sizeof (gboolean));
#line 308 "../src/data/Runnable.vala"
	return dup;
#line 3265 "Runnable.c"
}

static gpointer
__bool_dup0 (gpointer self)
{
#line 308 "../src/data/Runnable.vala"
	return self ? _bool_dup (self) : NULL;
#line 3273 "Runnable.c"
}

gboolean*
game_hub_data_runnable_get_compat_option_bool (GameHubDataRunnable* self,
                                               const gchar* key)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gboolean* result = NULL;
#line 300 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 300 "../src/data/Runnable.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 302 "../src/data/Runnable.vala"
	_tmp1_ = self->priv->_compat_tool_settings;
#line 302 "../src/data/Runnable.vala"
	if (_tmp1_ != NULL) {
#line 3291 "Runnable.c"
		const gchar* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 302 "../src/data/Runnable.vala"
		_tmp2_ = self->priv->_compat_tool_settings;
#line 302 "../src/data/Runnable.vala"
		_tmp3_ = strlen (_tmp2_);
#line 302 "../src/data/Runnable.vala"
		_tmp4_ = _tmp3_;
#line 302 "../src/data/Runnable.vala"
		_tmp0_ = _tmp4_ > 0;
#line 3303 "Runnable.c"
	} else {
#line 302 "../src/data/Runnable.vala"
		_tmp0_ = FALSE;
#line 3307 "Runnable.c"
	}
#line 302 "../src/data/Runnable.vala"
	if (_tmp0_) {
#line 3311 "Runnable.c"
		JsonNode* root = NULL;
		const gchar* _tmp5_;
		JsonNode* _tmp6_;
		gboolean _tmp7_ = FALSE;
		JsonNode* _tmp8_;
#line 304 "../src/data/Runnable.vala"
		_tmp5_ = self->priv->_compat_tool_settings;
#line 304 "../src/data/Runnable.vala"
		_tmp6_ = game_hub_utils_parser_parse_json (_tmp5_);
#line 304 "../src/data/Runnable.vala"
		root = _tmp6_;
#line 305 "../src/data/Runnable.vala"
		_tmp8_ = root;
#line 305 "../src/data/Runnable.vala"
		if (_tmp8_ != NULL) {
#line 3327 "Runnable.c"
			JsonNode* _tmp9_;
#line 305 "../src/data/Runnable.vala"
			_tmp9_ = root;
#line 305 "../src/data/Runnable.vala"
			_tmp7_ = json_node_get_node_type (_tmp9_) == JSON_NODE_OBJECT;
#line 3333 "Runnable.c"
		} else {
#line 305 "../src/data/Runnable.vala"
			_tmp7_ = FALSE;
#line 3337 "Runnable.c"
		}
#line 305 "../src/data/Runnable.vala"
		if (_tmp7_) {
#line 3341 "Runnable.c"
			JsonObject* obj = NULL;
			JsonNode* _tmp10_;
			JsonObject* _tmp11_;
			JsonObject* _tmp12_;
			JsonObject* _tmp13_;
#line 307 "../src/data/Runnable.vala"
			_tmp10_ = root;
#line 307 "../src/data/Runnable.vala"
			_tmp11_ = json_node_get_object (_tmp10_);
#line 307 "../src/data/Runnable.vala"
			_tmp12_ = _json_object_ref0 (_tmp11_);
#line 307 "../src/data/Runnable.vala"
			obj = _tmp12_;
#line 308 "../src/data/Runnable.vala"
			_tmp13_ = obj;
#line 308 "../src/data/Runnable.vala"
			if (json_object_has_member (_tmp13_, key)) {
#line 3359 "Runnable.c"
				JsonObject* _tmp14_;
				gboolean _tmp15_;
				gboolean* _tmp16_;
#line 308 "../src/data/Runnable.vala"
				_tmp14_ = obj;
#line 308 "../src/data/Runnable.vala"
				_tmp15_ = json_object_get_boolean_member (_tmp14_, key);
#line 308 "../src/data/Runnable.vala"
				_tmp16_ = __bool_dup0 (&_tmp15_);
#line 308 "../src/data/Runnable.vala"
				result = _tmp16_;
#line 308 "../src/data/Runnable.vala"
				_json_object_unref0 (obj);
#line 308 "../src/data/Runnable.vala"
				__vala_JsonNode_free0 (root);
#line 308 "../src/data/Runnable.vala"
				return result;
#line 3377 "Runnable.c"
			}
#line 305 "../src/data/Runnable.vala"
			_json_object_unref0 (obj);
#line 3381 "Runnable.c"
		}
#line 302 "../src/data/Runnable.vala"
		__vala_JsonNode_free0 (root);
#line 3385 "Runnable.c"
	}
#line 311 "../src/data/Runnable.vala"
	result = NULL;
#line 311 "../src/data/Runnable.vala"
	return result;
#line 3391 "Runnable.c"
}

void
game_hub_data_runnable_set_compat_option_bool (GameHubDataRunnable* self,
                                               const gchar* key,
                                               gboolean* value)
{
	JsonObject* root_object = NULL;
	JsonObject* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	JsonNode* root_node = NULL;
	JsonNode* _tmp16_;
	JsonObject* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
#line 314 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 314 "../src/data/Runnable.vala"
	g_return_if_fail (key != NULL);
#line 316 "../src/data/Runnable.vala"
	_tmp0_ = json_object_new ();
#line 316 "../src/data/Runnable.vala"
	root_object = _tmp0_;
#line 317 "../src/data/Runnable.vala"
	_tmp2_ = self->priv->_compat_tool_settings;
#line 317 "../src/data/Runnable.vala"
	if (_tmp2_ != NULL) {
#line 3420 "Runnable.c"
		const gchar* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
#line 317 "../src/data/Runnable.vala"
		_tmp3_ = self->priv->_compat_tool_settings;
#line 317 "../src/data/Runnable.vala"
		_tmp4_ = strlen (_tmp3_);
#line 317 "../src/data/Runnable.vala"
		_tmp5_ = _tmp4_;
#line 317 "../src/data/Runnable.vala"
		_tmp1_ = _tmp5_ > 0;
#line 3432 "Runnable.c"
	} else {
#line 317 "../src/data/Runnable.vala"
		_tmp1_ = FALSE;
#line 3436 "Runnable.c"
	}
#line 317 "../src/data/Runnable.vala"
	if (_tmp1_) {
#line 3440 "Runnable.c"
		JsonNode* root = NULL;
		const gchar* _tmp6_;
		JsonNode* _tmp7_;
		gboolean _tmp8_ = FALSE;
		JsonNode* _tmp9_;
#line 319 "../src/data/Runnable.vala"
		_tmp6_ = self->priv->_compat_tool_settings;
#line 319 "../src/data/Runnable.vala"
		_tmp7_ = game_hub_utils_parser_parse_json (_tmp6_);
#line 319 "../src/data/Runnable.vala"
		root = _tmp7_;
#line 320 "../src/data/Runnable.vala"
		_tmp9_ = root;
#line 320 "../src/data/Runnable.vala"
		if (_tmp9_ != NULL) {
#line 3456 "Runnable.c"
			JsonNode* _tmp10_;
#line 320 "../src/data/Runnable.vala"
			_tmp10_ = root;
#line 320 "../src/data/Runnable.vala"
			_tmp8_ = json_node_get_node_type (_tmp10_) == JSON_NODE_OBJECT;
#line 3462 "Runnable.c"
		} else {
#line 320 "../src/data/Runnable.vala"
			_tmp8_ = FALSE;
#line 3466 "Runnable.c"
		}
#line 320 "../src/data/Runnable.vala"
		if (_tmp8_) {
#line 3470 "Runnable.c"
			JsonNode* _tmp11_;
			JsonObject* _tmp12_;
			JsonObject* _tmp13_;
#line 322 "../src/data/Runnable.vala"
			_tmp11_ = root;
#line 322 "../src/data/Runnable.vala"
			_tmp12_ = json_node_get_object (_tmp11_);
#line 322 "../src/data/Runnable.vala"
			_tmp13_ = _json_object_ref0 (_tmp12_);
#line 322 "../src/data/Runnable.vala"
			_json_object_unref0 (root_object);
#line 322 "../src/data/Runnable.vala"
			root_object = _tmp13_;
#line 3484 "Runnable.c"
		}
#line 317 "../src/data/Runnable.vala"
		__vala_JsonNode_free0 (root);
#line 3488 "Runnable.c"
	}
#line 325 "../src/data/Runnable.vala"
	if (value != NULL) {
#line 3492 "Runnable.c"
		JsonObject* _tmp14_;
#line 327 "../src/data/Runnable.vala"
		_tmp14_ = root_object;
#line 327 "../src/data/Runnable.vala"
		json_object_set_boolean_member (_tmp14_, key, *value);
#line 3498 "Runnable.c"
	} else {
		JsonObject* _tmp15_;
#line 331 "../src/data/Runnable.vala"
		_tmp15_ = root_object;
#line 331 "../src/data/Runnable.vala"
		json_object_remove_member (_tmp15_, key);
#line 3505 "Runnable.c"
	}
#line 333 "../src/data/Runnable.vala"
	_tmp16_ = json_node_new (JSON_NODE_OBJECT);
#line 333 "../src/data/Runnable.vala"
	root_node = _tmp16_;
#line 334 "../src/data/Runnable.vala"
	_tmp17_ = root_object;
#line 334 "../src/data/Runnable.vala"
	json_node_set_object (root_node, _tmp17_);
#line 335 "../src/data/Runnable.vala"
	_tmp18_ = json_to_string (root_node, FALSE);
#line 335 "../src/data/Runnable.vala"
	_tmp19_ = _tmp18_;
#line 335 "../src/data/Runnable.vala"
	game_hub_data_runnable_set_compat_tool_settings (self, _tmp19_);
#line 335 "../src/data/Runnable.vala"
	_g_free0 (_tmp19_);
#line 336 "../src/data/Runnable.vala"
	game_hub_data_runnable_save (self);
#line 314 "../src/data/Runnable.vala"
	__vala_JsonNode_free0 (root_node);
#line 314 "../src/data/Runnable.vala"
	_json_object_unref0 (root_object);
#line 3529 "Runnable.c"
}

GameHubDataRunnable*
game_hub_data_runnable_construct (GType object_type)
{
	GameHubDataRunnable * self = NULL;
#line 27 "../src/data/Runnable.vala"
	self = (GameHubDataRunnable*) g_object_new (object_type, NULL);
#line 27 "../src/data/Runnable.vala"
	return self;
#line 3540 "Runnable.c"
}

const gchar*
game_hub_data_runnable_get_id (GameHubDataRunnable* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 29 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_id;
#line 29 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 29 "../src/data/Runnable.vala"
	return result;
#line 3556 "Runnable.c"
}

void
game_hub_data_runnable_set_id (GameHubDataRunnable* self,
                               const gchar* value)
{
#line 29 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/data/Runnable.vala"
	if (g_strcmp0 (value, game_hub_data_runnable_get_id (self)) != 0) {
#line 3567 "Runnable.c"
		gchar* _tmp0_;
#line 29 "../src/data/Runnable.vala"
		_tmp0_ = g_strdup (value);
#line 29 "../src/data/Runnable.vala"
		_g_free0 (self->priv->_id);
#line 29 "../src/data/Runnable.vala"
		self->priv->_id = _tmp0_;
#line 29 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_ID_PROPERTY]);
#line 3577 "Runnable.c"
	}
}

const gchar*
game_hub_data_runnable_get_escaped_name (GameHubDataRunnable* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_escaped_name;
#line 32 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 32 "../src/data/Runnable.vala"
	return result;
#line 3594 "Runnable.c"
}

void
game_hub_data_runnable_set_escaped_name (GameHubDataRunnable* self,
                                         const gchar* value)
{
#line 32 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/data/Runnable.vala"
	if (g_strcmp0 (value, game_hub_data_runnable_get_escaped_name (self)) != 0) {
#line 3605 "Runnable.c"
		gchar* _tmp0_;
#line 32 "../src/data/Runnable.vala"
		_tmp0_ = g_strdup (value);
#line 32 "../src/data/Runnable.vala"
		_g_free0 (self->priv->_escaped_name);
#line 32 "../src/data/Runnable.vala"
		self->priv->_escaped_name = _tmp0_;
#line 32 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_ESCAPED_NAME_PROPERTY]);
#line 3615 "Runnable.c"
	}
}

const gchar*
game_hub_data_runnable_get_normalized_name (GameHubDataRunnable* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 33 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_normalized_name;
#line 33 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 33 "../src/data/Runnable.vala"
	return result;
#line 3632 "Runnable.c"
}

void
game_hub_data_runnable_set_normalized_name (GameHubDataRunnable* self,
                                            const gchar* value)
{
#line 33 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/data/Runnable.vala"
	if (g_strcmp0 (value, game_hub_data_runnable_get_normalized_name (self)) != 0) {
#line 3643 "Runnable.c"
		gchar* _tmp0_;
#line 33 "../src/data/Runnable.vala"
		_tmp0_ = g_strdup (value);
#line 33 "../src/data/Runnable.vala"
		_g_free0 (self->priv->_normalized_name);
#line 33 "../src/data/Runnable.vala"
		self->priv->_normalized_name = _tmp0_;
#line 33 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_NORMALIZED_NAME_PROPERTY]);
#line 3653 "Runnable.c"
	}
}

const gchar*
game_hub_data_runnable_get_name (GameHubDataRunnable* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 37 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_name;
#line 39 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 39 "../src/data/Runnable.vala"
	return result;
#line 3670 "Runnable.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 1482 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1482 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1482 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1483 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1483 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 3692 "Runnable.c"
	} else {
#line 1483 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 3696 "Runnable.c"
	}
#line 1483 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1483 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 3702 "Runnable.c"
	} else {
#line 1483 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 3706 "Runnable.c"
	}
#line 1483 "glib-2.0.vapi"
	if (_tmp0_) {
#line 3710 "Runnable.c"
		gchar* _tmp2_;
#line 1484 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1484 "glib-2.0.vapi"
		result = _tmp2_;
#line 1484 "glib-2.0.vapi"
		return result;
#line 3718 "Runnable.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1487 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1487 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1487 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1487 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1487 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1487 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1487 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1487 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 3746 "Runnable.c"
				goto __catch5_g_regex_error;
			}
#line 1487 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1487 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1487 "glib-2.0.vapi"
			return NULL;
#line 3755 "Runnable.c"
		}
#line 1488 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1488 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1488 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1488 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1488 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1488 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 3769 "Runnable.c"
				goto __catch5_g_regex_error;
			}
#line 1488 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1488 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1488 "glib-2.0.vapi"
			return NULL;
#line 3778 "Runnable.c"
		}
#line 1488 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1488 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1488 "glib-2.0.vapi"
		result = _tmp10_;
#line 1488 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1488 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1488 "glib-2.0.vapi"
		return result;
#line 3792 "Runnable.c"
	}
	goto __finally5;
	__catch5_g_regex_error:
	{
		GError* e = NULL;
#line 1486 "glib-2.0.vapi"
		e = _inner_error0_;
#line 1486 "glib-2.0.vapi"
		_inner_error0_ = NULL;
#line 1490 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1486 "glib-2.0.vapi"
		_g_error_free0 (e);
#line 3806 "Runnable.c"
	}
	__finally5:
#line 1486 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1486 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1486 "glib-2.0.vapi"
	return NULL;
#line 3815 "Runnable.c"
}

void
game_hub_data_runnable_set_name (GameHubDataRunnable* self,
                                 const gchar* value)
{
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 41 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/data/Runnable.vala"
	_tmp0_ = g_strdup (value);
#line 43 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_name);
#line 43 "../src/data/Runnable.vala"
	self->priv->_name = _tmp0_;
#line 44 "../src/data/Runnable.vala"
	_tmp1_ = self->priv->_name;
#line 44 "../src/data/Runnable.vala"
	_tmp2_ = string_replace (_tmp1_, " ", "_");
#line 44 "../src/data/Runnable.vala"
	_tmp3_ = _tmp2_;
#line 44 "../src/data/Runnable.vala"
	_tmp4_ = game_hub_utils_strip_name (_tmp3_, "_.,", FALSE);
#line 44 "../src/data/Runnable.vala"
	_tmp5_ = _tmp4_;
#line 44 "../src/data/Runnable.vala"
	game_hub_data_runnable_set_escaped_name (self, _tmp5_);
#line 44 "../src/data/Runnable.vala"
	_g_free0 (_tmp5_);
#line 44 "../src/data/Runnable.vala"
	_g_free0 (_tmp3_);
#line 45 "../src/data/Runnable.vala"
	_tmp6_ = self->priv->_name;
#line 45 "../src/data/Runnable.vala"
	_tmp7_ = game_hub_utils_strip_name (_tmp6_, NULL, TRUE);
#line 45 "../src/data/Runnable.vala"
	_tmp8_ = _tmp7_;
#line 45 "../src/data/Runnable.vala"
	game_hub_data_runnable_set_normalized_name (self, _tmp8_);
#line 45 "../src/data/Runnable.vala"
	_g_free0 (_tmp8_);
#line 41 "../src/data/Runnable.vala"
	g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_NAME_PROPERTY]);
#line 3867 "Runnable.c"
}

const gchar*
game_hub_data_runnable_get_compat_tool (GameHubDataRunnable* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 49 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_compat_tool;
#line 49 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 49 "../src/data/Runnable.vala"
	return result;
#line 3883 "Runnable.c"
}

void
game_hub_data_runnable_set_compat_tool (GameHubDataRunnable* self,
                                        const gchar* value)
{
#line 49 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/data/Runnable.vala"
	if (g_strcmp0 (value, game_hub_data_runnable_get_compat_tool (self)) != 0) {
#line 3894 "Runnable.c"
		gchar* _tmp0_;
#line 49 "../src/data/Runnable.vala"
		_tmp0_ = g_strdup (value);
#line 49 "../src/data/Runnable.vala"
		_g_free0 (self->priv->_compat_tool);
#line 49 "../src/data/Runnable.vala"
		self->priv->_compat_tool = _tmp0_;
#line 49 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_COMPAT_TOOL_PROPERTY]);
#line 3904 "Runnable.c"
	}
}

const gchar*
game_hub_data_runnable_get_compat_tool_settings (GameHubDataRunnable* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 50 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_compat_tool_settings;
#line 50 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 50 "../src/data/Runnable.vala"
	return result;
#line 3921 "Runnable.c"
}

void
game_hub_data_runnable_set_compat_tool_settings (GameHubDataRunnable* self,
                                                 const gchar* value)
{
#line 50 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/data/Runnable.vala"
	if (g_strcmp0 (value, game_hub_data_runnable_get_compat_tool_settings (self)) != 0) {
#line 3932 "Runnable.c"
		gchar* _tmp0_;
#line 50 "../src/data/Runnable.vala"
		_tmp0_ = g_strdup (value);
#line 50 "../src/data/Runnable.vala"
		_g_free0 (self->priv->_compat_tool_settings);
#line 50 "../src/data/Runnable.vala"
		self->priv->_compat_tool_settings = _tmp0_;
#line 50 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_COMPAT_TOOL_SETTINGS_PROPERTY]);
#line 3942 "Runnable.c"
	}
}

const gchar*
game_hub_data_runnable_get_arguments (GameHubDataRunnable* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 52 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_arguments;
#line 52 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 52 "../src/data/Runnable.vala"
	return result;
#line 3959 "Runnable.c"
}

void
game_hub_data_runnable_set_arguments (GameHubDataRunnable* self,
                                      const gchar* value)
{
#line 52 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 52 "../src/data/Runnable.vala"
	if (g_strcmp0 (value, game_hub_data_runnable_get_arguments (self)) != 0) {
#line 3970 "Runnable.c"
		gchar* _tmp0_;
#line 52 "../src/data/Runnable.vala"
		_tmp0_ = g_strdup (value);
#line 52 "../src/data/Runnable.vala"
		_g_free0 (self->priv->_arguments);
#line 52 "../src/data/Runnable.vala"
		self->priv->_arguments = _tmp0_;
#line 52 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_ARGUMENTS_PROPERTY]);
#line 3980 "Runnable.c"
	}
}

gboolean
game_hub_data_runnable_get_is_running (GameHubDataRunnable* self)
{
	gboolean result;
#line 54 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 54 "../src/data/Runnable.vala"
	result = self->priv->_is_running;
#line 54 "../src/data/Runnable.vala"
	return result;
#line 3994 "Runnable.c"
}

void
game_hub_data_runnable_set_is_running (GameHubDataRunnable* self,
                                       gboolean value)
{
#line 54 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/data/Runnable.vala"
	if (game_hub_data_runnable_get_is_running (self) != value) {
#line 54 "../src/data/Runnable.vala"
		self->priv->_is_running = value;
#line 54 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_IS_RUNNING_PROPERTY]);
#line 4009 "Runnable.c"
	}
}

GeeArrayList*
game_hub_data_runnable_get_platforms (GameHubDataRunnable* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 56 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_platforms;
#line 56 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 56 "../src/data/Runnable.vala"
	return result;
#line 4026 "Runnable.c"
}

void
game_hub_data_runnable_set_platforms (GameHubDataRunnable* self,
                                      GeeArrayList* value)
{
#line 56 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/data/Runnable.vala"
	if (game_hub_data_runnable_get_platforms (self) != value) {
#line 4037 "Runnable.c"
		GeeArrayList* _tmp0_;
#line 56 "../src/data/Runnable.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 56 "../src/data/Runnable.vala"
		_g_object_unref0 (self->priv->_platforms);
#line 56 "../src/data/Runnable.vala"
		self->priv->_platforms = _tmp0_;
#line 56 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_PLATFORMS_PROPERTY]);
#line 4047 "Runnable.c"
	}
}

GFile*
game_hub_data_runnable_get_executable (GameHubDataRunnable* self)
{
#line 69 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 69 "../src/data/Runnable.vala"
	return GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->get_executable (self);
#line 4058 "Runnable.c"
}

void
game_hub_data_runnable_set_executable (GameHubDataRunnable* self,
                                       GFile* value)
{
#line 69 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 69 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->set_executable (self, value);
#line 4069 "Runnable.c"
}

GFile*
game_hub_data_runnable_get_install_dir (GameHubDataRunnable* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 70 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 70 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_install_dir;
#line 70 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 70 "../src/data/Runnable.vala"
	return result;
#line 4085 "Runnable.c"
}

void
game_hub_data_runnable_set_install_dir (GameHubDataRunnable* self,
                                        GFile* value)
{
#line 70 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 70 "../src/data/Runnable.vala"
	if (game_hub_data_runnable_get_install_dir (self) != value) {
#line 4096 "Runnable.c"
		GFile* _tmp0_;
#line 70 "../src/data/Runnable.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 70 "../src/data/Runnable.vala"
		_g_object_unref0 (self->priv->_install_dir);
#line 70 "../src/data/Runnable.vala"
		self->priv->_install_dir = _tmp0_;
#line 70 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_INSTALL_DIR_PROPERTY]);
#line 4106 "Runnable.c"
	}
}

GFile*
game_hub_data_runnable_get_work_dir (GameHubDataRunnable* self)
{
#line 71 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 71 "../src/data/Runnable.vala"
	return GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->get_work_dir (self);
#line 4117 "Runnable.c"
}

void
game_hub_data_runnable_set_work_dir (GameHubDataRunnable* self,
                                     GFile* value)
{
#line 71 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 71 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->set_work_dir (self, value);
#line 4128 "Runnable.c"
}

GFile*
game_hub_data_runnable_get_default_install_dir (GameHubDataRunnable* self)
{
#line 72 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 72 "../src/data/Runnable.vala"
	return GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->get_default_install_dir (self);
#line 4138 "Runnable.c"
}

static GFile*
game_hub_data_runnable_real_get_default_install_dir (GameHubDataRunnable* base)
{
	GFile* result;
	GameHubDataRunnable* self;
#line 72 "../src/data/Runnable.vala"
	self = base;
#line 72 "../src/data/Runnable.vala"
	result = NULL;
#line 72 "../src/data/Runnable.vala"
	return result;
#line 4152 "Runnable.c"
}

GeeArrayList*
game_hub_data_runnable_get_actions (GameHubDataRunnable* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 74 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 74 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_actions;
#line 74 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 74 "../src/data/Runnable.vala"
	return result;
#line 4168 "Runnable.c"
}

void
game_hub_data_runnable_set_actions (GameHubDataRunnable* self,
                                    GeeArrayList* value)
{
#line 74 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 74 "../src/data/Runnable.vala"
	if (game_hub_data_runnable_get_actions (self) != value) {
#line 4179 "Runnable.c"
		GeeArrayList* _tmp0_;
#line 74 "../src/data/Runnable.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 74 "../src/data/Runnable.vala"
		_g_object_unref0 (self->priv->_actions);
#line 74 "../src/data/Runnable.vala"
		self->priv->_actions = _tmp0_;
#line 74 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_ACTIONS_PROPERTY]);
#line 4189 "Runnable.c"
	}
}

gboolean
game_hub_data_runnable_get_use_compat (GameHubDataRunnable* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 214 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 216 "../src/data/Runnable.vala"
	_tmp1_ = game_hub_data_runnable_get_needs_compat (self);
#line 216 "../src/data/Runnable.vala"
	_tmp2_ = _tmp1_;
#line 216 "../src/data/Runnable.vala"
	if (_tmp2_) {
#line 216 "../src/data/Runnable.vala"
		_tmp0_ = TRUE;
#line 4210 "Runnable.c"
	} else {
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 216 "../src/data/Runnable.vala"
		_tmp3_ = game_hub_data_runnable_get_force_compat (self);
#line 216 "../src/data/Runnable.vala"
		_tmp4_ = _tmp3_;
#line 216 "../src/data/Runnable.vala"
		_tmp0_ = _tmp4_;
#line 4220 "Runnable.c"
	}
#line 216 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 216 "../src/data/Runnable.vala"
	return result;
#line 4226 "Runnable.c"
}

gboolean
game_hub_data_runnable_get_needs_compat (GameHubDataRunnable* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 222 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 224 "../src/data/Runnable.vala"
	if (!game_hub_data_runnable_is_supported (self, NULL, FALSE)) {
#line 224 "../src/data/Runnable.vala"
		_tmp1_ = game_hub_data_runnable_is_supported (self, NULL, TRUE);
#line 4241 "Runnable.c"
	} else {
#line 224 "../src/data/Runnable.vala"
		_tmp1_ = FALSE;
#line 4245 "Runnable.c"
	}
#line 224 "../src/data/Runnable.vala"
	if (_tmp1_) {
#line 224 "../src/data/Runnable.vala"
		_tmp0_ = TRUE;
#line 4251 "Runnable.c"
	} else {
		gboolean _tmp2_ = FALSE;
		GFile* _tmp3_;
		GFile* _tmp4_;
		GFile* _tmp5_;
		gboolean _tmp6_;
#line 224 "../src/data/Runnable.vala"
		_tmp3_ = game_hub_data_runnable_get_executable (self);
#line 224 "../src/data/Runnable.vala"
		_tmp4_ = _tmp3_;
#line 224 "../src/data/Runnable.vala"
		_tmp5_ = _tmp4_;
#line 224 "../src/data/Runnable.vala"
		_tmp6_ = _tmp5_ != NULL;
#line 224 "../src/data/Runnable.vala"
		_g_object_unref0 (_tmp5_);
#line 224 "../src/data/Runnable.vala"
		if (_tmp6_) {
#line 4270 "Runnable.c"
			GFile* _tmp7_;
			GFile* _tmp8_;
			GFile* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
#line 224 "../src/data/Runnable.vala"
			_tmp7_ = game_hub_data_runnable_get_executable (self);
#line 224 "../src/data/Runnable.vala"
			_tmp8_ = _tmp7_;
#line 224 "../src/data/Runnable.vala"
			_tmp9_ = _tmp8_;
#line 224 "../src/data/Runnable.vala"
			_tmp10_ = g_file_get_basename (_tmp9_);
#line 224 "../src/data/Runnable.vala"
			_tmp11_ = _tmp10_;
#line 224 "../src/data/Runnable.vala"
			_tmp12_ = g_utf8_strdown (_tmp11_, (gssize) -1);
#line 224 "../src/data/Runnable.vala"
			_tmp13_ = _tmp12_;
#line 224 "../src/data/Runnable.vala"
			_tmp2_ = g_str_has_suffix (_tmp13_, ".exe");
#line 224 "../src/data/Runnable.vala"
			_g_free0 (_tmp13_);
#line 224 "../src/data/Runnable.vala"
			_g_free0 (_tmp11_);
#line 224 "../src/data/Runnable.vala"
			_g_object_unref0 (_tmp9_);
#line 4300 "Runnable.c"
		} else {
#line 224 "../src/data/Runnable.vala"
			_tmp2_ = FALSE;
#line 4304 "Runnable.c"
		}
#line 224 "../src/data/Runnable.vala"
		_tmp0_ = _tmp2_;
#line 4308 "Runnable.c"
	}
#line 224 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 224 "../src/data/Runnable.vala"
	return result;
#line 4314 "Runnable.c"
}

static gboolean
_bool_equal (const gboolean * s1,
             const gboolean * s2)
{
#line 233 "../src/data/Runnable.vala"
	if (s1 == s2) {
#line 233 "../src/data/Runnable.vala"
		return TRUE;
#line 4325 "Runnable.c"
	}
#line 233 "../src/data/Runnable.vala"
	if (s1 == NULL) {
#line 233 "../src/data/Runnable.vala"
		return FALSE;
#line 4331 "Runnable.c"
	}
#line 233 "../src/data/Runnable.vala"
	if (s2 == NULL) {
#line 233 "../src/data/Runnable.vala"
		return FALSE;
#line 4337 "Runnable.c"
	}
#line 233 "../src/data/Runnable.vala"
	return (*s1) == (*s2);
#line 4341 "Runnable.c"
}

gboolean
game_hub_data_runnable_get_force_compat (GameHubDataRunnable* self)
{
	gboolean result;
	gboolean* _tmp0_;
	gboolean* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 230 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 232 "../src/data/Runnable.vala"
	if (GAME_HUB_DATA_SOURCES_STEAM_IS_STEAM_GAME (self)) {
#line 232 "../src/data/Runnable.vala"
		result = FALSE;
#line 232 "../src/data/Runnable.vala"
		return result;
#line 4360 "Runnable.c"
	}
#line 233 "../src/data/Runnable.vala"
	_tmp0_ = game_hub_data_runnable_get_compat_option_bool (self, "force_compat");
#line 233 "../src/data/Runnable.vala"
	_tmp1_ = _tmp0_;
#line 233 "../src/data/Runnable.vala"
	_tmp2_ = TRUE;
#line 233 "../src/data/Runnable.vala"
	_tmp3_ = _bool_equal (_tmp1_, &_tmp2_) == TRUE;
#line 233 "../src/data/Runnable.vala"
	_g_free0 (_tmp1_);
#line 233 "../src/data/Runnable.vala"
	if (_tmp3_) {
#line 233 "../src/data/Runnable.vala"
		result = TRUE;
#line 233 "../src/data/Runnable.vala"
		return result;
#line 4378 "Runnable.c"
	}
#line 234 "../src/data/Runnable.vala"
	result = FALSE;
#line 234 "../src/data/Runnable.vala"
	return result;
#line 4384 "Runnable.c"
}

void
game_hub_data_runnable_set_force_compat (GameHubDataRunnable* self,
                                         gboolean value)
{
#line 236 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 238 "../src/data/Runnable.vala"
	if (GAME_HUB_DATA_SOURCES_STEAM_IS_STEAM_GAME (self)) {
#line 238 "../src/data/Runnable.vala"
		return;
#line 4397 "Runnable.c"
	}
#line 239 "../src/data/Runnable.vala"
	game_hub_data_runnable_set_compat_option_bool (self, "force_compat", &value);
#line 240 "../src/data/Runnable.vala"
	g_object_notify ((GObject*) self, "use-compat");
#line 236 "../src/data/Runnable.vala"
	g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_FORCE_COMPAT_PROPERTY]);
#line 4405 "Runnable.c"
}

gboolean
game_hub_data_runnable_get_compat_options_saved (GameHubDataRunnable* self)
{
	gboolean result;
	gboolean* _tmp0_;
	gboolean* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 246 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 248 "../src/data/Runnable.vala"
	if (GAME_HUB_DATA_SOURCES_STEAM_IS_STEAM_GAME (self)) {
#line 248 "../src/data/Runnable.vala"
		result = FALSE;
#line 248 "../src/data/Runnable.vala"
		return result;
#line 4424 "Runnable.c"
	}
#line 249 "../src/data/Runnable.vala"
	_tmp0_ = game_hub_data_runnable_get_compat_option_bool (self, "compat_options_saved");
#line 249 "../src/data/Runnable.vala"
	_tmp1_ = _tmp0_;
#line 249 "../src/data/Runnable.vala"
	_tmp2_ = TRUE;
#line 249 "../src/data/Runnable.vala"
	_tmp3_ = _bool_equal (_tmp1_, &_tmp2_) == TRUE;
#line 249 "../src/data/Runnable.vala"
	_g_free0 (_tmp1_);
#line 249 "../src/data/Runnable.vala"
	result = _tmp3_;
#line 249 "../src/data/Runnable.vala"
	return result;
#line 4440 "Runnable.c"
}

void
game_hub_data_runnable_set_compat_options_saved (GameHubDataRunnable* self,
                                                 gboolean value)
{
#line 251 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 253 "../src/data/Runnable.vala"
	if (GAME_HUB_DATA_SOURCES_STEAM_IS_STEAM_GAME (self)) {
#line 253 "../src/data/Runnable.vala"
		return;
#line 4453 "Runnable.c"
	}
#line 254 "../src/data/Runnable.vala"
	game_hub_data_runnable_set_compat_option_bool (self, "compat_options_saved", &value);
#line 251 "../src/data/Runnable.vala"
	g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_COMPAT_OPTIONS_SAVED_PROPERTY]);
#line 4459 "Runnable.c"
}

static inline gpointer
game_hub_data_runnable_installer_get_instance_private (GameHubDataRunnableInstaller* self)
{
	return G_STRUCT_MEMBER_P (self, GameHubDataRunnableInstaller_private_offset);
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
#line 1307 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1308 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1308 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1309 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1310 "glib-2.0.vapi"
	result = _result_;
#line 1310 "glib-2.0.vapi"
	return result;
#line 4486 "Runnable.c"
}

GameHubDataRunnableInstallerInstallerType
game_hub_data_runnable_installer_installer_type_from_mime (const gchar* type)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 415 "../src/data/Runnable.vala"
	static GQuark _tmp2_label0 = 0;
#line 415 "../src/data/Runnable.vala"
	static GQuark _tmp2_label1 = 0;
#line 415 "../src/data/Runnable.vala"
	static GQuark _tmp2_label2 = 0;
#line 415 "../src/data/Runnable.vala"
	static GQuark _tmp2_label3 = 0;
#line 415 "../src/data/Runnable.vala"
	static GQuark _tmp2_label4 = 0;
#line 415 "../src/data/Runnable.vala"
	static GQuark _tmp2_label5 = 0;
#line 415 "../src/data/Runnable.vala"
	static GQuark _tmp2_label6 = 0;
#line 415 "../src/data/Runnable.vala"
	static GQuark _tmp2_label7 = 0;
#line 415 "../src/data/Runnable.vala"
	static GQuark _tmp2_label8 = 0;
#line 415 "../src/data/Runnable.vala"
	static GQuark _tmp2_label9 = 0;
#line 415 "../src/data/Runnable.vala"
	static GQuark _tmp2_label10 = 0;
#line 415 "../src/data/Runnable.vala"
	static GQuark _tmp2_label11 = 0;
#line 415 "../src/data/Runnable.vala"
	static GQuark _tmp2_label12 = 0;
#line 415 "../src/data/Runnable.vala"
	static GQuark _tmp2_label13 = 0;
#line 415 "../src/data/Runnable.vala"
	static GQuark _tmp2_label14 = 0;
#line 415 "../src/data/Runnable.vala"
	static GQuark _tmp2_label15 = 0;
#line 415 "../src/data/Runnable.vala"
	static GQuark _tmp2_label16 = 0;
#line 415 "../src/data/Runnable.vala"
	static GQuark _tmp2_label17 = 0;
#line 415 "../src/data/Runnable.vala"
	static GQuark _tmp2_label18 = 0;
#line 415 "../src/data/Runnable.vala"
	static GQuark _tmp2_label19 = 0;
#line 415 "../src/data/Runnable.vala"
	static GQuark _tmp2_label20 = 0;
#line 415 "../src/data/Runnable.vala"
	static GQuark _tmp2_label21 = 0;
#line 415 "../src/data/Runnable.vala"
	static GQuark _tmp2_label22 = 0;
#line 415 "../src/data/Runnable.vala"
	static GQuark _tmp2_label23 = 0;
#line 415 "../src/data/Runnable.vala"
	static GQuark _tmp2_label24 = 0;
#line 4545 "Runnable.c"
	GameHubDataRunnableInstallerInstallerType result = 0;
#line 413 "../src/data/Runnable.vala"
	g_return_val_if_fail (type != NULL, 0);
#line 415 "../src/data/Runnable.vala"
	_tmp0_ = string_strip (type);
#line 415 "../src/data/Runnable.vala"
	_tmp1_ = _tmp0_;
#line 415 "../src/data/Runnable.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 415 "../src/data/Runnable.vala"
	g_free (_tmp1_);
#line 415 "../src/data/Runnable.vala"
	if ((((_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("application/x-executable")))) || (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("application/x-elf"))))) || (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("application/x-sh"))))) || (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("application/x-shellscript"))))) {
#line 415 "../src/data/Runnable.vala"
		switch (0) {
#line 4561 "Runnable.c"
			default:
			{
#line 421 "../src/data/Runnable.vala"
				result = GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_EXECUTABLE;
#line 421 "../src/data/Runnable.vala"
				return result;
#line 4568 "Runnable.c"
			}
		}
	} else if (((((((((_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("application/x-dosexec")))) || (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("application/x-ms-dos-executable"))))) || (_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("application/dos-exe"))))) || (_tmp3_ == ((0 != _tmp2_label7) ? _tmp2_label7 : (_tmp2_label7 = g_quark_from_static_string ("application/exe"))))) || (_tmp3_ == ((0 != _tmp2_label8) ? _tmp2_label8 : (_tmp2_label8 = g_quark_from_static_string ("application/msdos-windows"))))) || (_tmp3_ == ((0 != _tmp2_label9) ? _tmp2_label9 : (_tmp2_label9 = g_quark_from_static_string ("application/x-exe"))))) || (_tmp3_ == ((0 != _tmp2_label10) ? _tmp2_label10 : (_tmp2_label10 = g_quark_from_static_string ("application/x-msdownload"))))) || (_tmp3_ == ((0 != _tmp2_label11) ? _tmp2_label11 : (_tmp2_label11 = g_quark_from_static_string ("application/x-winexe"))))) || (_tmp3_ == ((0 != _tmp2_label12) ? _tmp2_label12 : (_tmp2_label12 = g_quark_from_static_string ("application/x-msi"))))) {
#line 415 "../src/data/Runnable.vala"
		switch (0) {
#line 4574 "Runnable.c"
			default:
			{
#line 432 "../src/data/Runnable.vala"
				result = GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_WINDOWS_EXECUTABLE;
#line 432 "../src/data/Runnable.vala"
				return result;
#line 4581 "Runnable.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label13) ? _tmp2_label13 : (_tmp2_label13 = g_quark_from_static_string ("application/octet-stream")))) {
#line 415 "../src/data/Runnable.vala"
		switch (0) {
#line 4587 "Runnable.c"
			default:
			{
#line 435 "../src/data/Runnable.vala"
				result = GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_GOG_PART;
#line 435 "../src/data/Runnable.vala"
				return result;
#line 4594 "Runnable.c"
			}
		}
	} else if (((((((((((_tmp3_ == ((0 != _tmp2_label14) ? _tmp2_label14 : (_tmp2_label14 = g_quark_from_static_string ("application/zip")))) || (_tmp3_ == ((0 != _tmp2_label15) ? _tmp2_label15 : (_tmp2_label15 = g_quark_from_static_string ("application/x-tar"))))) || (_tmp3_ == ((0 != _tmp2_label16) ? _tmp2_label16 : (_tmp2_label16 = g_quark_from_static_string ("application/x-gtar"))))) || (_tmp3_ == ((0 != _tmp2_label17) ? _tmp2_label17 : (_tmp2_label17 = g_quark_from_static_string ("application/x-cpio"))))) || (_tmp3_ == ((0 != _tmp2_label18) ? _tmp2_label18 : (_tmp2_label18 = g_quark_from_static_string ("application/x-bzip2"))))) || (_tmp3_ == ((0 != _tmp2_label19) ? _tmp2_label19 : (_tmp2_label19 = g_quark_from_static_string ("application/gzip"))))) || (_tmp3_ == ((0 != _tmp2_label20) ? _tmp2_label20 : (_tmp2_label20 = g_quark_from_static_string ("application/x-lzip"))))) || (_tmp3_ == ((0 != _tmp2_label21) ? _tmp2_label21 : (_tmp2_label21 = g_quark_from_static_string ("application/x-lzma"))))) || (_tmp3_ == ((0 != _tmp2_label22) ? _tmp2_label22 : (_tmp2_label22 = g_quark_from_static_string ("application/x-7z-compressed"))))) || (_tmp3_ == ((0 != _tmp2_label23) ? _tmp2_label23 : (_tmp2_label23 = g_quark_from_static_string ("application/x-rar-compressed"))))) || (_tmp3_ == ((0 != _tmp2_label24) ? _tmp2_label24 : (_tmp2_label24 = g_quark_from_static_string ("application/x-compressed-tar"))))) {
#line 415 "../src/data/Runnable.vala"
		switch (0) {
#line 4600 "Runnable.c"
			default:
			{
#line 448 "../src/data/Runnable.vala"
				result = GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_ARCHIVE;
#line 448 "../src/data/Runnable.vala"
				return result;
#line 4607 "Runnable.c"
			}
		}
	}
#line 450 "../src/data/Runnable.vala"
	result = GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_UNKNOWN;
#line 450 "../src/data/Runnable.vala"
	return result;
#line 4615 "Runnable.c"
}

GType
game_hub_data_runnable_installer_installer_type_get_type (void)
{
	static volatile gsize game_hub_data_runnable_installer_installer_type_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_runnable_installer_installer_type_type_id__volatile)) {
		static const GEnumValue values[] = {{GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_UNKNOWN, "GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_UNKNOWN", "unknown"}, {GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_EXECUTABLE, "GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_EXECUTABLE", "executable"}, {GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_WINDOWS_EXECUTABLE, "GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_WINDOWS_EXECUTABLE", "windows-executable"}, {GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_GOG_PART, "GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_GOG_PART", "gog-part"}, {GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_ARCHIVE, "GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_ARCHIVE", "archive"}, {GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_WINDOWS_NSIS_INSTALLER, "GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_WINDOWS_NSIS_INSTALLER", "windows-nsis-installer"}, {0, NULL, NULL}};
		GType game_hub_data_runnable_installer_installer_type_type_id;
		game_hub_data_runnable_installer_installer_type_type_id = g_enum_register_static ("GameHubDataRunnableInstallerInstallerType", values);
		g_once_init_leave (&game_hub_data_runnable_installer_installer_type_type_id__volatile, game_hub_data_runnable_installer_installer_type_type_id);
	}
	return game_hub_data_runnable_installer_installer_type_type_id__volatile;
}

GType
game_hub_data_runnable_installer_install_mode_get_type (void)
{
	static volatile gsize game_hub_data_runnable_installer_install_mode_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_runnable_installer_install_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_INTERACTIVE, "GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_INTERACTIVE", "interactive"}, {GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_AUTOMATIC, "GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_AUTOMATIC", "automatic"}, {GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_AUTOMATIC_DOWNLOAD, "GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_AUTOMATIC_DOWNLOAD", "automatic-download"}, {0, NULL, NULL}};
		GType game_hub_data_runnable_installer_install_mode_type_id;
		game_hub_data_runnable_installer_install_mode_type_id = g_enum_register_static ("GameHubDataRunnableInstallerInstallMode", values);
		g_once_init_leave (&game_hub_data_runnable_installer_install_mode_type_id__volatile, game_hub_data_runnable_installer_install_mode_type_id);
	}
	return game_hub_data_runnable_installer_install_mode_type_id__volatile;
}

void
game_hub_data_runnable_installer_install (GameHubDataRunnableInstaller* self,
                                          GameHubDataRunnable* runnable,
                                          GameHubDataCompatTool* tool,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_)
{
#line 342 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_INSTALLER_GET_CLASS (self)->install (self, runnable, tool, _callback_, _user_data_);
#line 4653 "Runnable.c"
}

void
game_hub_data_runnable_installer_install_finish (GameHubDataRunnableInstaller* self,
                                                 GAsyncResult* _res_)
{
#line 342 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_INSTALLER_GET_CLASS (self)->install_finish (self, _res_);
#line 4662 "Runnable.c"
}

static void
game_hub_data_runnable_installer_guess_type_data_free (gpointer _data)
{
	GameHubDataRunnableInstallerGuessTypeData* _data_;
	_data_ = _data;
#line 342 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->file);
#line 342 "../src/data/Runnable.vala"
	g_slice_free (GameHubDataRunnableInstallerGuessTypeData, _data_);
#line 4674 "Runnable.c"
}

void
game_hub_data_runnable_installer_guess_type (GFile* file,
                                             gboolean is_part,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_)
{
	GameHubDataRunnableInstallerGuessTypeData* _data_;
	GFile* _tmp0_;
#line 342 "../src/data/Runnable.vala"
	_data_ = g_slice_new0 (GameHubDataRunnableInstallerGuessTypeData);
#line 342 "../src/data/Runnable.vala"
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
#line 342 "../src/data/Runnable.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_runnable_installer_guess_type_data_free);
#line 342 "../src/data/Runnable.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 342 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->file);
#line 342 "../src/data/Runnable.vala"
	_data_->file = _tmp0_;
#line 342 "../src/data/Runnable.vala"
	_data_->is_part = is_part;
#line 342 "../src/data/Runnable.vala"
	game_hub_data_runnable_installer_guess_type_co (_data_);
#line 4701 "Runnable.c"
}

GameHubDataRunnableInstallerInstallerType
game_hub_data_runnable_installer_guess_type_finish (GAsyncResult* _res_)
{
	GameHubDataRunnableInstallerInstallerType result;
	GameHubDataRunnableInstallerGuessTypeData* _data_;
#line 342 "../src/data/Runnable.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 342 "../src/data/Runnable.vala"
	result = _data_->result;
#line 342 "../src/data/Runnable.vala"
	return result;
#line 4715 "Runnable.c"
}

static void
game_hub_data_runnable_installer_guess_type_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_)
{
	GameHubDataRunnableInstallerGuessTypeData* _data_;
#line 360 "../src/data/Runnable.vala"
	_data_ = _user_data_;
#line 360 "../src/data/Runnable.vala"
	_data_->_source_object_ = source_object;
#line 360 "../src/data/Runnable.vala"
	_data_->_res_ = _res_;
#line 360 "../src/data/Runnable.vala"
	game_hub_data_runnable_installer_guess_type_co (_data_);
#line 4732 "Runnable.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
#line 1518 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1519 "glib-2.0.vapi"
	result = self;
#line 1519 "glib-2.0.vapi"
	return result;
#line 4745 "Runnable.c"
}

static gboolean
game_hub_data_runnable_installer_guess_type_co (GameHubDataRunnableInstallerGuessTypeData* _data_)
{
#line 353 "../src/data/Runnable.vala"
	switch (_data_->_state_) {
#line 353 "../src/data/Runnable.vala"
		case 0:
#line 4755 "Runnable.c"
		goto _state_0;
#line 353 "../src/data/Runnable.vala"
		case 1:
#line 4759 "Runnable.c"
		goto _state_1;
		default:
#line 353 "../src/data/Runnable.vala"
		g_assert_not_reached ();
#line 4764 "Runnable.c"
	}
	_state_0:
#line 355 "../src/data/Runnable.vala"
	_data_->type = GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_UNKNOWN;
#line 356 "../src/data/Runnable.vala"
	if (_data_->file == NULL) {
#line 356 "../src/data/Runnable.vala"
		_data_->result = _data_->type;
#line 356 "../src/data/Runnable.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 356 "../src/data/Runnable.vala"
		if (_data_->_state_ != 0) {
#line 356 "../src/data/Runnable.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 356 "../src/data/Runnable.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4781 "Runnable.c"
			}
		}
#line 356 "../src/data/Runnable.vala"
		g_object_unref (_data_->_async_result);
#line 356 "../src/data/Runnable.vala"
		return FALSE;
#line 4788 "Runnable.c"
	}
	{
#line 360 "../src/data/Runnable.vala"
		_data_->_state_ = 1;
#line 360 "../src/data/Runnable.vala"
		g_file_query_info_async (_data_->file, G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, G_FILE_QUERY_INFO_NONE, G_PRIORITY_DEFAULT, NULL, game_hub_data_runnable_installer_guess_type_ready, _data_);
#line 360 "../src/data/Runnable.vala"
		return FALSE;
#line 4797 "Runnable.c"
		_state_1:
#line 360 "../src/data/Runnable.vala"
		_data_->_tmp0_ = g_file_query_info_finish (_data_->file, _data_->_res_, &_data_->_inner_error0_);
#line 360 "../src/data/Runnable.vala"
		_data_->finfo = _data_->_tmp0_;
#line 360 "../src/data/Runnable.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 4805 "Runnable.c"
			goto __catch6_g_error;
		}
#line 361 "../src/data/Runnable.vala"
		_data_->_tmp1_ = _data_->finfo;
#line 361 "../src/data/Runnable.vala"
		_data_->_tmp2_ = g_file_info_get_content_type (_data_->_tmp1_);
#line 361 "../src/data/Runnable.vala"
		_data_->_tmp3_ = g_strdup (_data_->_tmp2_);
#line 361 "../src/data/Runnable.vala"
		_data_->mime = _data_->_tmp3_;
#line 362 "../src/data/Runnable.vala"
		_data_->_tmp4_ = _data_->mime;
#line 362 "../src/data/Runnable.vala"
		_data_->type = game_hub_data_runnable_installer_installer_type_from_mime (_data_->_tmp4_);
#line 364 "../src/data/Runnable.vala"
		_data_->_tmp5_ = _data_->type;
#line 364 "../src/data/Runnable.vala"
		if (_data_->_tmp5_ != GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_UNKNOWN) {
#line 364 "../src/data/Runnable.vala"
			_data_->result = _data_->type;
#line 364 "../src/data/Runnable.vala"
			_g_free0 (_data_->mime);
#line 364 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->finfo);
#line 364 "../src/data/Runnable.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 364 "../src/data/Runnable.vala"
			if (_data_->_state_ != 0) {
#line 364 "../src/data/Runnable.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 364 "../src/data/Runnable.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4838 "Runnable.c"
				}
			}
#line 364 "../src/data/Runnable.vala"
			g_object_unref (_data_->_async_result);
#line 364 "../src/data/Runnable.vala"
			return FALSE;
#line 4845 "Runnable.c"
		}
#line 366 "../src/data/Runnable.vala"
		_data_->_tmp6_ = g_strdup ("file");
#line 366 "../src/data/Runnable.vala"
		_data_->_tmp7_ = g_strdup ("-bi");
#line 366 "../src/data/Runnable.vala"
		_data_->_tmp8_ = g_file_get_path (_data_->file);
#line 366 "../src/data/Runnable.vala"
		_data_->_tmp9_ = g_new0 (gchar*, 3 + 1);
#line 366 "../src/data/Runnable.vala"
		_data_->_tmp9_[0] = _data_->_tmp6_;
#line 366 "../src/data/Runnable.vala"
		_data_->_tmp9_[1] = _data_->_tmp7_;
#line 366 "../src/data/Runnable.vala"
		_data_->_tmp9_[2] = _data_->_tmp8_;
#line 366 "../src/data/Runnable.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 366 "../src/data/Runnable.vala"
		_data_->_tmp10__length1 = 3;
#line 366 "../src/data/Runnable.vala"
		_data_->_tmp11_ = game_hub_utils_run (_data_->_tmp10_, (gint) 3);
#line 366 "../src/data/Runnable.vala"
		_data_->_tmp12_ = _data_->_tmp11_;
#line 366 "../src/data/Runnable.vala"
		_data_->_tmp13_ = game_hub_utils_run_task_log (_data_->_tmp12_, FALSE);
#line 366 "../src/data/Runnable.vala"
		_data_->_tmp14_ = _data_->_tmp13_;
#line 366 "../src/data/Runnable.vala"
		_data_->_tmp15_ = game_hub_utils_run_task_run_sync (_data_->_tmp14_, TRUE);
#line 366 "../src/data/Runnable.vala"
		_data_->_tmp16_ = _data_->_tmp15_;
#line 366 "../src/data/Runnable.vala"
		_data_->_tmp17_ = _data_->_tmp16_->output;
#line 366 "../src/data/Runnable.vala"
		_data_->_tmp18_ = g_strdup (_data_->_tmp17_);
#line 366 "../src/data/Runnable.vala"
		_data_->_tmp19_ = _data_->_tmp18_;
#line 366 "../src/data/Runnable.vala"
		_game_hub_utils_run_task_result_unref0 (_data_->_tmp16_);
#line 366 "../src/data/Runnable.vala"
		_game_hub_utils_run_task_unref0 (_data_->_tmp14_);
#line 366 "../src/data/Runnable.vala"
		_game_hub_utils_run_task_unref0 (_data_->_tmp12_);
#line 366 "../src/data/Runnable.vala"
		_data_->_tmp10_ = (_vala_array_free (_data_->_tmp10_, _data_->_tmp10__length1, (GDestroyNotify) g_free), NULL);
#line 366 "../src/data/Runnable.vala"
		_data_->info = _data_->_tmp19_;
#line 367 "../src/data/Runnable.vala"
		_data_->_tmp21_ = _data_->info;
#line 367 "../src/data/Runnable.vala"
		if (_data_->_tmp21_ != NULL) {
#line 367 "../src/data/Runnable.vala"
			_data_->_tmp22_ = _data_->info;
#line 367 "../src/data/Runnable.vala"
			_data_->_tmp23_ = strlen (_data_->_tmp22_);
#line 367 "../src/data/Runnable.vala"
			_data_->_tmp24_ = _data_->_tmp23_;
#line 367 "../src/data/Runnable.vala"
			_data_->_tmp20_ = _data_->_tmp24_ > 0;
#line 4905 "Runnable.c"
		} else {
#line 367 "../src/data/Runnable.vala"
			_data_->_tmp20_ = FALSE;
#line 4909 "Runnable.c"
		}
#line 367 "../src/data/Runnable.vala"
		if (_data_->_tmp20_) {
#line 369 "../src/data/Runnable.vala"
			_data_->_tmp25_ = _data_->info;
#line 369 "../src/data/Runnable.vala"
			_data_->_tmp27_ = _data_->_tmp26_ = g_strsplit (_data_->_tmp25_, ";", 0);
#line 369 "../src/data/Runnable.vala"
			_data_->_tmp28_ = _data_->_tmp27_;
#line 369 "../src/data/Runnable.vala"
			_data_->_tmp28__length1 = _vala_array_length (_data_->_tmp26_);
#line 369 "../src/data/Runnable.vala"
			_data_->_tmp29_ = _data_->_tmp28_[0];
#line 369 "../src/data/Runnable.vala"
			_data_->_tmp30_ = g_strdup (_data_->_tmp29_);
#line 369 "../src/data/Runnable.vala"
			_g_free0 (_data_->mime);
#line 369 "../src/data/Runnable.vala"
			_data_->mime = _data_->_tmp30_;
#line 369 "../src/data/Runnable.vala"
			_data_->_tmp28_ = (_vala_array_free (_data_->_tmp28_, _data_->_tmp28__length1, (GDestroyNotify) g_free), NULL);
#line 370 "../src/data/Runnable.vala"
			_data_->_tmp32_ = _data_->mime;
#line 370 "../src/data/Runnable.vala"
			if (_data_->_tmp32_ != NULL) {
#line 370 "../src/data/Runnable.vala"
				_data_->_tmp33_ = _data_->mime;
#line 370 "../src/data/Runnable.vala"
				_data_->_tmp34_ = strlen (_data_->_tmp33_);
#line 370 "../src/data/Runnable.vala"
				_data_->_tmp35_ = _data_->_tmp34_;
#line 370 "../src/data/Runnable.vala"
				_data_->_tmp31_ = _data_->_tmp35_ > 0;
#line 4943 "Runnable.c"
			} else {
#line 370 "../src/data/Runnable.vala"
				_data_->_tmp31_ = FALSE;
#line 4947 "Runnable.c"
			}
#line 370 "../src/data/Runnable.vala"
			if (_data_->_tmp31_) {
#line 372 "../src/data/Runnable.vala"
				_data_->_tmp36_ = _data_->mime;
#line 372 "../src/data/Runnable.vala"
				_data_->type = game_hub_data_runnable_installer_installer_type_from_mime (_data_->_tmp36_);
#line 4955 "Runnable.c"
			}
		}
#line 376 "../src/data/Runnable.vala"
		_data_->_tmp37_ = _data_->type;
#line 376 "../src/data/Runnable.vala"
		if (_data_->_tmp37_ != GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_UNKNOWN) {
#line 376 "../src/data/Runnable.vala"
			_data_->result = _data_->type;
#line 376 "../src/data/Runnable.vala"
			_g_free0 (_data_->info);
#line 376 "../src/data/Runnable.vala"
			_g_free0 (_data_->mime);
#line 376 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->finfo);
#line 376 "../src/data/Runnable.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 376 "../src/data/Runnable.vala"
			if (_data_->_state_ != 0) {
#line 376 "../src/data/Runnable.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 376 "../src/data/Runnable.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4978 "Runnable.c"
				}
			}
#line 376 "../src/data/Runnable.vala"
			g_object_unref (_data_->_async_result);
#line 376 "../src/data/Runnable.vala"
			return FALSE;
#line 4985 "Runnable.c"
		}
#line 378 "../src/data/Runnable.vala"
		_data_->_tmp38_ = g_strdup ("bin");
#line 378 "../src/data/Runnable.vala"
		_data_->_tmp39_ = g_new0 (gchar*, 1 + 1);
#line 378 "../src/data/Runnable.vala"
		_data_->_tmp39_[0] = _data_->_tmp38_;
#line 378 "../src/data/Runnable.vala"
		_data_->gog_part_ext = _data_->_tmp39_;
#line 378 "../src/data/Runnable.vala"
		_data_->gog_part_ext_length1 = 1;
#line 378 "../src/data/Runnable.vala"
		_data_->_gog_part_ext_size_ = _data_->gog_part_ext_length1;
#line 379 "../src/data/Runnable.vala"
		_data_->_tmp40_ = g_strdup ("sh");
#line 379 "../src/data/Runnable.vala"
		_data_->_tmp41_ = g_strdup ("elf");
#line 379 "../src/data/Runnable.vala"
		_data_->_tmp42_ = g_strdup ("bin");
#line 379 "../src/data/Runnable.vala"
		_data_->_tmp43_ = g_strdup ("run");
#line 379 "../src/data/Runnable.vala"
		_data_->_tmp44_ = g_new0 (gchar*, 4 + 1);
#line 379 "../src/data/Runnable.vala"
		_data_->_tmp44_[0] = _data_->_tmp40_;
#line 379 "../src/data/Runnable.vala"
		_data_->_tmp44_[1] = _data_->_tmp41_;
#line 379 "../src/data/Runnable.vala"
		_data_->_tmp44_[2] = _data_->_tmp42_;
#line 379 "../src/data/Runnable.vala"
		_data_->_tmp44_[3] = _data_->_tmp43_;
#line 379 "../src/data/Runnable.vala"
		_data_->exe_ext = _data_->_tmp44_;
#line 379 "../src/data/Runnable.vala"
		_data_->exe_ext_length1 = 4;
#line 379 "../src/data/Runnable.vala"
		_data_->_exe_ext_size_ = _data_->exe_ext_length1;
#line 380 "../src/data/Runnable.vala"
		_data_->_tmp45_ = g_strdup ("exe");
#line 380 "../src/data/Runnable.vala"
		_data_->_tmp46_ = g_strdup ("msi");
#line 380 "../src/data/Runnable.vala"
		_data_->_tmp47_ = g_new0 (gchar*, 2 + 1);
#line 380 "../src/data/Runnable.vala"
		_data_->_tmp47_[0] = _data_->_tmp45_;
#line 380 "../src/data/Runnable.vala"
		_data_->_tmp47_[1] = _data_->_tmp46_;
#line 380 "../src/data/Runnable.vala"
		_data_->win_exe_ext = _data_->_tmp47_;
#line 380 "../src/data/Runnable.vala"
		_data_->win_exe_ext_length1 = 2;
#line 380 "../src/data/Runnable.vala"
		_data_->_win_exe_ext_size_ = _data_->win_exe_ext_length1;
#line 381 "../src/data/Runnable.vala"
		_data_->_tmp48_ = g_strdup ("zip");
#line 381 "../src/data/Runnable.vala"
		_data_->_tmp49_ = g_strdup ("tar");
#line 381 "../src/data/Runnable.vala"
		_data_->_tmp50_ = g_strdup ("cpio");
#line 381 "../src/data/Runnable.vala"
		_data_->_tmp51_ = g_strdup ("bz2");
#line 381 "../src/data/Runnable.vala"
		_data_->_tmp52_ = g_strdup ("gz");
#line 381 "../src/data/Runnable.vala"
		_data_->_tmp53_ = g_strdup ("lz");
#line 381 "../src/data/Runnable.vala"
		_data_->_tmp54_ = g_strdup ("lzma");
#line 381 "../src/data/Runnable.vala"
		_data_->_tmp55_ = g_strdup ("7z");
#line 381 "../src/data/Runnable.vala"
		_data_->_tmp56_ = g_strdup ("rar");
#line 381 "../src/data/Runnable.vala"
		_data_->_tmp57_ = g_new0 (gchar*, 9 + 1);
#line 381 "../src/data/Runnable.vala"
		_data_->_tmp57_[0] = _data_->_tmp48_;
#line 381 "../src/data/Runnable.vala"
		_data_->_tmp57_[1] = _data_->_tmp49_;
#line 381 "../src/data/Runnable.vala"
		_data_->_tmp57_[2] = _data_->_tmp50_;
#line 381 "../src/data/Runnable.vala"
		_data_->_tmp57_[3] = _data_->_tmp51_;
#line 381 "../src/data/Runnable.vala"
		_data_->_tmp57_[4] = _data_->_tmp52_;
#line 381 "../src/data/Runnable.vala"
		_data_->_tmp57_[5] = _data_->_tmp53_;
#line 381 "../src/data/Runnable.vala"
		_data_->_tmp57_[6] = _data_->_tmp54_;
#line 381 "../src/data/Runnable.vala"
		_data_->_tmp57_[7] = _data_->_tmp55_;
#line 381 "../src/data/Runnable.vala"
		_data_->_tmp57_[8] = _data_->_tmp56_;
#line 381 "../src/data/Runnable.vala"
		_data_->arc_ext = _data_->_tmp57_;
#line 381 "../src/data/Runnable.vala"
		_data_->arc_ext_length1 = 9;
#line 381 "../src/data/Runnable.vala"
		_data_->_arc_ext_size_ = _data_->arc_ext_length1;
#line 383 "../src/data/Runnable.vala"
		if (_data_->is_part) {
#line 385 "../src/data/Runnable.vala"
			_data_->_tmp58_ = _data_->gog_part_ext;
#line 385 "../src/data/Runnable.vala"
			_data_->_tmp58__length1 = _data_->gog_part_ext_length1;
#line 5089 "Runnable.c"
			{
#line 385 "../src/data/Runnable.vala"
				_data_->ext_collection_length1 = 0;
#line 385 "../src/data/Runnable.vala"
				_data_->_ext_collection_size_ = 0;
#line 385 "../src/data/Runnable.vala"
				_data_->ext_collection = _data_->_tmp58_;
#line 385 "../src/data/Runnable.vala"
				_data_->ext_collection_length1 = _data_->_tmp58__length1;
#line 385 "../src/data/Runnable.vala"
				for (_data_->ext_it = 0; _data_->ext_it < _data_->ext_collection_length1; _data_->ext_it = _data_->ext_it + 1) {
#line 385 "../src/data/Runnable.vala"
					_data_->_tmp59_ = g_strdup (_data_->ext_collection[_data_->ext_it]);
#line 385 "../src/data/Runnable.vala"
					_data_->ext = _data_->_tmp59_;
#line 5105 "Runnable.c"
					{
#line 387 "../src/data/Runnable.vala"
						_data_->_tmp60_ = g_file_get_basename (_data_->file);
#line 387 "../src/data/Runnable.vala"
						_data_->_tmp61_ = _data_->_tmp60_;
#line 387 "../src/data/Runnable.vala"
						_data_->_tmp62_ = g_utf8_strdown (_data_->_tmp61_, (gssize) -1);
#line 387 "../src/data/Runnable.vala"
						_data_->_tmp63_ = _data_->_tmp62_;
#line 387 "../src/data/Runnable.vala"
						_data_->_tmp64_ = _data_->ext;
#line 387 "../src/data/Runnable.vala"
						_data_->_tmp65_ = string_to_string (_data_->_tmp64_);
#line 387 "../src/data/Runnable.vala"
						_data_->_tmp66_ = g_strconcat (".", _data_->_tmp65_, NULL);
#line 387 "../src/data/Runnable.vala"
						_data_->_tmp67_ = _data_->_tmp66_;
#line 387 "../src/data/Runnable.vala"
						_data_->_tmp68_ = g_str_has_suffix (_data_->_tmp63_, _data_->_tmp67_);
#line 387 "../src/data/Runnable.vala"
						_g_free0 (_data_->_tmp67_);
#line 387 "../src/data/Runnable.vala"
						_g_free0 (_data_->_tmp63_);
#line 387 "../src/data/Runnable.vala"
						_g_free0 (_data_->_tmp61_);
#line 387 "../src/data/Runnable.vala"
						if (_data_->_tmp68_) {
#line 387 "../src/data/Runnable.vala"
							_data_->result = GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_GOG_PART;
#line 387 "../src/data/Runnable.vala"
							_g_free0 (_data_->ext);
#line 387 "../src/data/Runnable.vala"
							_data_->arc_ext = (_vala_array_free (_data_->arc_ext, _data_->arc_ext_length1, (GDestroyNotify) g_free), NULL);
#line 387 "../src/data/Runnable.vala"
							_data_->win_exe_ext = (_vala_array_free (_data_->win_exe_ext, _data_->win_exe_ext_length1, (GDestroyNotify) g_free), NULL);
#line 387 "../src/data/Runnable.vala"
							_data_->exe_ext = (_vala_array_free (_data_->exe_ext, _data_->exe_ext_length1, (GDestroyNotify) g_free), NULL);
#line 387 "../src/data/Runnable.vala"
							_data_->gog_part_ext = (_vala_array_free (_data_->gog_part_ext, _data_->gog_part_ext_length1, (GDestroyNotify) g_free), NULL);
#line 387 "../src/data/Runnable.vala"
							_g_free0 (_data_->info);
#line 387 "../src/data/Runnable.vala"
							_g_free0 (_data_->mime);
#line 387 "../src/data/Runnable.vala"
							_g_object_unref0 (_data_->finfo);
#line 387 "../src/data/Runnable.vala"
							g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 387 "../src/data/Runnable.vala"
							if (_data_->_state_ != 0) {
#line 387 "../src/data/Runnable.vala"
								while (!g_task_get_completed (_data_->_async_result)) {
#line 387 "../src/data/Runnable.vala"
									g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5159 "Runnable.c"
								}
							}
#line 387 "../src/data/Runnable.vala"
							g_object_unref (_data_->_async_result);
#line 387 "../src/data/Runnable.vala"
							return FALSE;
#line 5166 "Runnable.c"
						}
#line 385 "../src/data/Runnable.vala"
						_g_free0 (_data_->ext);
#line 5170 "Runnable.c"
					}
				}
			}
		}
#line 391 "../src/data/Runnable.vala"
		_data_->_tmp69_ = _data_->exe_ext;
#line 391 "../src/data/Runnable.vala"
		_data_->_tmp69__length1 = _data_->exe_ext_length1;
#line 5179 "Runnable.c"
		{
#line 391 "../src/data/Runnable.vala"
			_data_->_vala1_ext_collection_length1 = 0;
#line 391 "../src/data/Runnable.vala"
			_data_->__vala1_ext_collection_size_ = 0;
#line 391 "../src/data/Runnable.vala"
			_data_->_vala1_ext_collection = _data_->_tmp69_;
#line 391 "../src/data/Runnable.vala"
			_data_->_vala1_ext_collection_length1 = _data_->_tmp69__length1;
#line 391 "../src/data/Runnable.vala"
			for (_data_->_vala1_ext_it = 0; _data_->_vala1_ext_it < _data_->_vala1_ext_collection_length1; _data_->_vala1_ext_it = _data_->_vala1_ext_it + 1) {
#line 391 "../src/data/Runnable.vala"
				_data_->_tmp70_ = g_strdup (_data_->_vala1_ext_collection[_data_->_vala1_ext_it]);
#line 391 "../src/data/Runnable.vala"
				_data_->_vala1_ext = _data_->_tmp70_;
#line 5195 "Runnable.c"
				{
#line 393 "../src/data/Runnable.vala"
					_data_->_tmp71_ = g_file_get_basename (_data_->file);
#line 393 "../src/data/Runnable.vala"
					_data_->_tmp72_ = _data_->_tmp71_;
#line 393 "../src/data/Runnable.vala"
					_data_->_tmp73_ = g_utf8_strdown (_data_->_tmp72_, (gssize) -1);
#line 393 "../src/data/Runnable.vala"
					_data_->_tmp74_ = _data_->_tmp73_;
#line 393 "../src/data/Runnable.vala"
					_data_->_tmp75_ = _data_->_vala1_ext;
#line 393 "../src/data/Runnable.vala"
					_data_->_tmp76_ = string_to_string (_data_->_tmp75_);
#line 393 "../src/data/Runnable.vala"
					_data_->_tmp77_ = g_strconcat (".", _data_->_tmp76_, NULL);
#line 393 "../src/data/Runnable.vala"
					_data_->_tmp78_ = _data_->_tmp77_;
#line 393 "../src/data/Runnable.vala"
					_data_->_tmp79_ = g_str_has_suffix (_data_->_tmp74_, _data_->_tmp78_);
#line 393 "../src/data/Runnable.vala"
					_g_free0 (_data_->_tmp78_);
#line 393 "../src/data/Runnable.vala"
					_g_free0 (_data_->_tmp74_);
#line 393 "../src/data/Runnable.vala"
					_g_free0 (_data_->_tmp72_);
#line 393 "../src/data/Runnable.vala"
					if (_data_->_tmp79_) {
#line 393 "../src/data/Runnable.vala"
						_data_->result = GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_EXECUTABLE;
#line 393 "../src/data/Runnable.vala"
						_g_free0 (_data_->_vala1_ext);
#line 393 "../src/data/Runnable.vala"
						_data_->arc_ext = (_vala_array_free (_data_->arc_ext, _data_->arc_ext_length1, (GDestroyNotify) g_free), NULL);
#line 393 "../src/data/Runnable.vala"
						_data_->win_exe_ext = (_vala_array_free (_data_->win_exe_ext, _data_->win_exe_ext_length1, (GDestroyNotify) g_free), NULL);
#line 393 "../src/data/Runnable.vala"
						_data_->exe_ext = (_vala_array_free (_data_->exe_ext, _data_->exe_ext_length1, (GDestroyNotify) g_free), NULL);
#line 393 "../src/data/Runnable.vala"
						_data_->gog_part_ext = (_vala_array_free (_data_->gog_part_ext, _data_->gog_part_ext_length1, (GDestroyNotify) g_free), NULL);
#line 393 "../src/data/Runnable.vala"
						_g_free0 (_data_->info);
#line 393 "../src/data/Runnable.vala"
						_g_free0 (_data_->mime);
#line 393 "../src/data/Runnable.vala"
						_g_object_unref0 (_data_->finfo);
#line 393 "../src/data/Runnable.vala"
						g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 393 "../src/data/Runnable.vala"
						if (_data_->_state_ != 0) {
#line 393 "../src/data/Runnable.vala"
							while (!g_task_get_completed (_data_->_async_result)) {
#line 393 "../src/data/Runnable.vala"
								g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5249 "Runnable.c"
							}
						}
#line 393 "../src/data/Runnable.vala"
						g_object_unref (_data_->_async_result);
#line 393 "../src/data/Runnable.vala"
						return FALSE;
#line 5256 "Runnable.c"
					}
#line 391 "../src/data/Runnable.vala"
					_g_free0 (_data_->_vala1_ext);
#line 5260 "Runnable.c"
				}
			}
		}
#line 395 "../src/data/Runnable.vala"
		_data_->_tmp80_ = _data_->win_exe_ext;
#line 395 "../src/data/Runnable.vala"
		_data_->_tmp80__length1 = _data_->win_exe_ext_length1;
#line 5268 "Runnable.c"
		{
#line 395 "../src/data/Runnable.vala"
			_data_->_vala2_ext_collection_length1 = 0;
#line 395 "../src/data/Runnable.vala"
			_data_->__vala2_ext_collection_size_ = 0;
#line 395 "../src/data/Runnable.vala"
			_data_->_vala2_ext_collection = _data_->_tmp80_;
#line 395 "../src/data/Runnable.vala"
			_data_->_vala2_ext_collection_length1 = _data_->_tmp80__length1;
#line 395 "../src/data/Runnable.vala"
			for (_data_->_vala2_ext_it = 0; _data_->_vala2_ext_it < _data_->_vala2_ext_collection_length1; _data_->_vala2_ext_it = _data_->_vala2_ext_it + 1) {
#line 395 "../src/data/Runnable.vala"
				_data_->_tmp81_ = g_strdup (_data_->_vala2_ext_collection[_data_->_vala2_ext_it]);
#line 395 "../src/data/Runnable.vala"
				_data_->_vala2_ext = _data_->_tmp81_;
#line 5284 "Runnable.c"
				{
#line 397 "../src/data/Runnable.vala"
					_data_->_tmp82_ = g_file_get_basename (_data_->file);
#line 397 "../src/data/Runnable.vala"
					_data_->_tmp83_ = _data_->_tmp82_;
#line 397 "../src/data/Runnable.vala"
					_data_->_tmp84_ = g_utf8_strdown (_data_->_tmp83_, (gssize) -1);
#line 397 "../src/data/Runnable.vala"
					_data_->_tmp85_ = _data_->_tmp84_;
#line 397 "../src/data/Runnable.vala"
					_data_->_tmp86_ = _data_->_vala2_ext;
#line 397 "../src/data/Runnable.vala"
					_data_->_tmp87_ = string_to_string (_data_->_tmp86_);
#line 397 "../src/data/Runnable.vala"
					_data_->_tmp88_ = g_strconcat (".", _data_->_tmp87_, NULL);
#line 397 "../src/data/Runnable.vala"
					_data_->_tmp89_ = _data_->_tmp88_;
#line 397 "../src/data/Runnable.vala"
					_data_->_tmp90_ = g_str_has_suffix (_data_->_tmp85_, _data_->_tmp89_);
#line 397 "../src/data/Runnable.vala"
					_g_free0 (_data_->_tmp89_);
#line 397 "../src/data/Runnable.vala"
					_g_free0 (_data_->_tmp85_);
#line 397 "../src/data/Runnable.vala"
					_g_free0 (_data_->_tmp83_);
#line 397 "../src/data/Runnable.vala"
					if (_data_->_tmp90_) {
#line 397 "../src/data/Runnable.vala"
						_data_->result = GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_WINDOWS_EXECUTABLE;
#line 397 "../src/data/Runnable.vala"
						_g_free0 (_data_->_vala2_ext);
#line 397 "../src/data/Runnable.vala"
						_data_->arc_ext = (_vala_array_free (_data_->arc_ext, _data_->arc_ext_length1, (GDestroyNotify) g_free), NULL);
#line 397 "../src/data/Runnable.vala"
						_data_->win_exe_ext = (_vala_array_free (_data_->win_exe_ext, _data_->win_exe_ext_length1, (GDestroyNotify) g_free), NULL);
#line 397 "../src/data/Runnable.vala"
						_data_->exe_ext = (_vala_array_free (_data_->exe_ext, _data_->exe_ext_length1, (GDestroyNotify) g_free), NULL);
#line 397 "../src/data/Runnable.vala"
						_data_->gog_part_ext = (_vala_array_free (_data_->gog_part_ext, _data_->gog_part_ext_length1, (GDestroyNotify) g_free), NULL);
#line 397 "../src/data/Runnable.vala"
						_g_free0 (_data_->info);
#line 397 "../src/data/Runnable.vala"
						_g_free0 (_data_->mime);
#line 397 "../src/data/Runnable.vala"
						_g_object_unref0 (_data_->finfo);
#line 397 "../src/data/Runnable.vala"
						g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 397 "../src/data/Runnable.vala"
						if (_data_->_state_ != 0) {
#line 397 "../src/data/Runnable.vala"
							while (!g_task_get_completed (_data_->_async_result)) {
#line 397 "../src/data/Runnable.vala"
								g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5338 "Runnable.c"
							}
						}
#line 397 "../src/data/Runnable.vala"
						g_object_unref (_data_->_async_result);
#line 397 "../src/data/Runnable.vala"
						return FALSE;
#line 5345 "Runnable.c"
					}
#line 395 "../src/data/Runnable.vala"
					_g_free0 (_data_->_vala2_ext);
#line 5349 "Runnable.c"
				}
			}
		}
#line 399 "../src/data/Runnable.vala"
		_data_->_tmp91_ = _data_->arc_ext;
#line 399 "../src/data/Runnable.vala"
		_data_->_tmp91__length1 = _data_->arc_ext_length1;
#line 5357 "Runnable.c"
		{
#line 399 "../src/data/Runnable.vala"
			_data_->_vala3_ext_collection_length1 = 0;
#line 399 "../src/data/Runnable.vala"
			_data_->__vala3_ext_collection_size_ = 0;
#line 399 "../src/data/Runnable.vala"
			_data_->_vala3_ext_collection = _data_->_tmp91_;
#line 399 "../src/data/Runnable.vala"
			_data_->_vala3_ext_collection_length1 = _data_->_tmp91__length1;
#line 399 "../src/data/Runnable.vala"
			for (_data_->_vala3_ext_it = 0; _data_->_vala3_ext_it < _data_->_vala3_ext_collection_length1; _data_->_vala3_ext_it = _data_->_vala3_ext_it + 1) {
#line 399 "../src/data/Runnable.vala"
				_data_->_tmp92_ = g_strdup (_data_->_vala3_ext_collection[_data_->_vala3_ext_it]);
#line 399 "../src/data/Runnable.vala"
				_data_->_vala3_ext = _data_->_tmp92_;
#line 5373 "Runnable.c"
				{
#line 401 "../src/data/Runnable.vala"
					_data_->_tmp93_ = g_file_get_basename (_data_->file);
#line 401 "../src/data/Runnable.vala"
					_data_->_tmp94_ = _data_->_tmp93_;
#line 401 "../src/data/Runnable.vala"
					_data_->_tmp95_ = g_utf8_strdown (_data_->_tmp94_, (gssize) -1);
#line 401 "../src/data/Runnable.vala"
					_data_->_tmp96_ = _data_->_tmp95_;
#line 401 "../src/data/Runnable.vala"
					_data_->_tmp97_ = _data_->_vala3_ext;
#line 401 "../src/data/Runnable.vala"
					_data_->_tmp98_ = string_to_string (_data_->_tmp97_);
#line 401 "../src/data/Runnable.vala"
					_data_->_tmp99_ = g_strconcat (".", _data_->_tmp98_, NULL);
#line 401 "../src/data/Runnable.vala"
					_data_->_tmp100_ = _data_->_tmp99_;
#line 401 "../src/data/Runnable.vala"
					_data_->_tmp101_ = g_str_has_suffix (_data_->_tmp96_, _data_->_tmp100_);
#line 401 "../src/data/Runnable.vala"
					_g_free0 (_data_->_tmp100_);
#line 401 "../src/data/Runnable.vala"
					_g_free0 (_data_->_tmp96_);
#line 401 "../src/data/Runnable.vala"
					_g_free0 (_data_->_tmp94_);
#line 401 "../src/data/Runnable.vala"
					if (_data_->_tmp101_) {
#line 401 "../src/data/Runnable.vala"
						_data_->result = GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_ARCHIVE;
#line 401 "../src/data/Runnable.vala"
						_g_free0 (_data_->_vala3_ext);
#line 401 "../src/data/Runnable.vala"
						_data_->arc_ext = (_vala_array_free (_data_->arc_ext, _data_->arc_ext_length1, (GDestroyNotify) g_free), NULL);
#line 401 "../src/data/Runnable.vala"
						_data_->win_exe_ext = (_vala_array_free (_data_->win_exe_ext, _data_->win_exe_ext_length1, (GDestroyNotify) g_free), NULL);
#line 401 "../src/data/Runnable.vala"
						_data_->exe_ext = (_vala_array_free (_data_->exe_ext, _data_->exe_ext_length1, (GDestroyNotify) g_free), NULL);
#line 401 "../src/data/Runnable.vala"
						_data_->gog_part_ext = (_vala_array_free (_data_->gog_part_ext, _data_->gog_part_ext_length1, (GDestroyNotify) g_free), NULL);
#line 401 "../src/data/Runnable.vala"
						_g_free0 (_data_->info);
#line 401 "../src/data/Runnable.vala"
						_g_free0 (_data_->mime);
#line 401 "../src/data/Runnable.vala"
						_g_object_unref0 (_data_->finfo);
#line 401 "../src/data/Runnable.vala"
						g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 401 "../src/data/Runnable.vala"
						if (_data_->_state_ != 0) {
#line 401 "../src/data/Runnable.vala"
							while (!g_task_get_completed (_data_->_async_result)) {
#line 401 "../src/data/Runnable.vala"
								g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5427 "Runnable.c"
							}
						}
#line 401 "../src/data/Runnable.vala"
						g_object_unref (_data_->_async_result);
#line 401 "../src/data/Runnable.vala"
						return FALSE;
#line 5434 "Runnable.c"
					}
#line 399 "../src/data/Runnable.vala"
					_g_free0 (_data_->_vala3_ext);
#line 5438 "Runnable.c"
				}
			}
		}
#line 358 "../src/data/Runnable.vala"
		_data_->arc_ext = (_vala_array_free (_data_->arc_ext, _data_->arc_ext_length1, (GDestroyNotify) g_free), NULL);
#line 358 "../src/data/Runnable.vala"
		_data_->win_exe_ext = (_vala_array_free (_data_->win_exe_ext, _data_->win_exe_ext_length1, (GDestroyNotify) g_free), NULL);
#line 358 "../src/data/Runnable.vala"
		_data_->exe_ext = (_vala_array_free (_data_->exe_ext, _data_->exe_ext_length1, (GDestroyNotify) g_free), NULL);
#line 358 "../src/data/Runnable.vala"
		_data_->gog_part_ext = (_vala_array_free (_data_->gog_part_ext, _data_->gog_part_ext_length1, (GDestroyNotify) g_free), NULL);
#line 358 "../src/data/Runnable.vala"
		_g_free0 (_data_->info);
#line 358 "../src/data/Runnable.vala"
		_g_free0 (_data_->mime);
#line 358 "../src/data/Runnable.vala"
		_g_object_unref0 (_data_->finfo);
#line 5456 "Runnable.c"
	}
	goto __finally6;
	__catch6_g_error:
	{
#line 358 "../src/data/Runnable.vala"
		_data_->e = _data_->_inner_error0_;
#line 358 "../src/data/Runnable.vala"
		_data_->_inner_error0_ = NULL;
#line 358 "../src/data/Runnable.vala"
		_g_error_free0 (_data_->e);
#line 5467 "Runnable.c"
	}
	__finally6:
#line 358 "../src/data/Runnable.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 358 "../src/data/Runnable.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 358 "../src/data/Runnable.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 358 "../src/data/Runnable.vala"
		g_object_unref (_data_->_async_result);
#line 358 "../src/data/Runnable.vala"
		return FALSE;
#line 5480 "Runnable.c"
	}
#line 406 "../src/data/Runnable.vala"
	_data_->result = _data_->type;
#line 406 "../src/data/Runnable.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 406 "../src/data/Runnable.vala"
	if (_data_->_state_ != 0) {
#line 406 "../src/data/Runnable.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 406 "../src/data/Runnable.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5492 "Runnable.c"
		}
	}
#line 406 "../src/data/Runnable.vala"
	g_object_unref (_data_->_async_result);
#line 406 "../src/data/Runnable.vala"
	return FALSE;
#line 5499 "Runnable.c"
}

GameHubDataRunnableInstaller*
game_hub_data_runnable_installer_construct (GType object_type)
{
	GameHubDataRunnableInstaller* self = NULL;
#line 342 "../src/data/Runnable.vala"
	self = (GameHubDataRunnableInstaller*) g_type_create_instance (object_type);
#line 342 "../src/data/Runnable.vala"
	return self;
#line 5510 "Runnable.c"
}

const gchar*
game_hub_data_runnable_installer_get_id (GameHubDataRunnableInstaller* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 344 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 344 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_id;
#line 344 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 344 "../src/data/Runnable.vala"
	return result;
#line 5526 "Runnable.c"
}

void
game_hub_data_runnable_installer_set_id (GameHubDataRunnableInstaller* self,
                                         const gchar* value)
{
	gchar* _tmp0_;
#line 344 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 344 "../src/data/Runnable.vala"
	_tmp0_ = g_strdup (value);
#line 344 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_id);
#line 344 "../src/data/Runnable.vala"
	self->priv->_id = _tmp0_;
#line 5542 "Runnable.c"
}

GameHubDataPlatform
game_hub_data_runnable_installer_get_platform (GameHubDataRunnableInstaller* self)
{
	GameHubDataPlatform result;
	GameHubDataPlatform _tmp0_;
#line 345 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 345 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_platform;
#line 345 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 345 "../src/data/Runnable.vala"
	return result;
#line 5558 "Runnable.c"
}

void
game_hub_data_runnable_installer_set_platform (GameHubDataRunnableInstaller* self,
                                               GameHubDataPlatform value)
{
#line 345 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 345 "../src/data/Runnable.vala"
	self->priv->_platform = value;
#line 5569 "Runnable.c"
}

gint64
game_hub_data_runnable_installer_get_full_size (GameHubDataRunnableInstaller* self)
{
	gint64 result;
#line 346 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 346 "../src/data/Runnable.vala"
	result = self->priv->_full_size;
#line 346 "../src/data/Runnable.vala"
	return result;
#line 5582 "Runnable.c"
}

void
game_hub_data_runnable_installer_set_full_size (GameHubDataRunnableInstaller* self,
                                                gint64 value)
{
#line 346 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 346 "../src/data/Runnable.vala"
	self->priv->_full_size = value;
#line 5593 "Runnable.c"
}

const gchar*
game_hub_data_runnable_installer_get_version (GameHubDataRunnableInstaller* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 347 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 347 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_version;
#line 347 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 347 "../src/data/Runnable.vala"
	return result;
#line 5609 "Runnable.c"
}

void
game_hub_data_runnable_installer_set_version (GameHubDataRunnableInstaller* self,
                                              const gchar* value)
{
	gchar* _tmp0_;
#line 347 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 347 "../src/data/Runnable.vala"
	_tmp0_ = g_strdup (value);
#line 347 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_version);
#line 347 "../src/data/Runnable.vala"
	self->priv->_version = _tmp0_;
#line 5625 "Runnable.c"
}

gchar*
game_hub_data_runnable_installer_get_name (GameHubDataRunnableInstaller* self)
{
#line 349 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 349 "../src/data/Runnable.vala"
	return GAME_HUB_DATA_RUNNABLE_INSTALLER_GET_CLASS (self)->get_name (self);
#line 5635 "Runnable.c"
}

static gchar*
game_hub_data_runnable_installer_real_get_name (GameHubDataRunnableInstaller* base)
{
	gchar* result;
	GameHubDataRunnableInstaller* self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 349 "../src/data/Runnable.vala"
	self = base;
#line 349 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_id;
#line 349 "../src/data/Runnable.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 349 "../src/data/Runnable.vala"
	result = _tmp1_;
#line 349 "../src/data/Runnable.vala"
	return result;
#line 5655 "Runnable.c"
}

static void
game_hub_data_runnable_value_installer_init (GValue* value)
{
#line 342 "../src/data/Runnable.vala"
	value->data[0].v_pointer = NULL;
#line 5663 "Runnable.c"
}

static void
game_hub_data_runnable_value_installer_free_value (GValue* value)
{
#line 342 "../src/data/Runnable.vala"
	if (value->data[0].v_pointer) {
#line 342 "../src/data/Runnable.vala"
		game_hub_data_runnable_installer_unref (value->data[0].v_pointer);
#line 5673 "Runnable.c"
	}
}

static void
game_hub_data_runnable_value_installer_copy_value (const GValue* src_value,
                                                   GValue* dest_value)
{
#line 342 "../src/data/Runnable.vala"
	if (src_value->data[0].v_pointer) {
#line 342 "../src/data/Runnable.vala"
		dest_value->data[0].v_pointer = game_hub_data_runnable_installer_ref (src_value->data[0].v_pointer);
#line 5685 "Runnable.c"
	} else {
#line 342 "../src/data/Runnable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 5689 "Runnable.c"
	}
}

static gpointer
game_hub_data_runnable_value_installer_peek_pointer (const GValue* value)
{
#line 342 "../src/data/Runnable.vala"
	return value->data[0].v_pointer;
#line 5698 "Runnable.c"
}

static gchar*
game_hub_data_runnable_value_installer_collect_value (GValue* value,
                                                      guint n_collect_values,
                                                      GTypeCValue* collect_values,
                                                      guint collect_flags)
{
#line 342 "../src/data/Runnable.vala"
	if (collect_values[0].v_pointer) {
#line 5709 "Runnable.c"
		GameHubDataRunnableInstaller * object;
		object = collect_values[0].v_pointer;
#line 342 "../src/data/Runnable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 342 "../src/data/Runnable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 5716 "Runnable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 342 "../src/data/Runnable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 5720 "Runnable.c"
		}
#line 342 "../src/data/Runnable.vala"
		value->data[0].v_pointer = game_hub_data_runnable_installer_ref (object);
#line 5724 "Runnable.c"
	} else {
#line 342 "../src/data/Runnable.vala"
		value->data[0].v_pointer = NULL;
#line 5728 "Runnable.c"
	}
#line 342 "../src/data/Runnable.vala"
	return NULL;
#line 5732 "Runnable.c"
}

static gchar*
game_hub_data_runnable_value_installer_lcopy_value (const GValue* value,
                                                    guint n_collect_values,
                                                    GTypeCValue* collect_values,
                                                    guint collect_flags)
{
	GameHubDataRunnableInstaller ** object_p;
	object_p = collect_values[0].v_pointer;
#line 342 "../src/data/Runnable.vala"
	if (!object_p) {
#line 342 "../src/data/Runnable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 5747 "Runnable.c"
	}
#line 342 "../src/data/Runnable.vala"
	if (!value->data[0].v_pointer) {
#line 342 "../src/data/Runnable.vala"
		*object_p = NULL;
#line 5753 "Runnable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 342 "../src/data/Runnable.vala"
		*object_p = value->data[0].v_pointer;
#line 5757 "Runnable.c"
	} else {
#line 342 "../src/data/Runnable.vala"
		*object_p = game_hub_data_runnable_installer_ref (value->data[0].v_pointer);
#line 5761 "Runnable.c"
	}
#line 342 "../src/data/Runnable.vala"
	return NULL;
#line 5765 "Runnable.c"
}

GParamSpec*
game_hub_data_runnable_param_spec_installer (const gchar* name,
                                             const gchar* nick,
                                             const gchar* blurb,
                                             GType object_type,
                                             GParamFlags flags)
{
	GameHubDataRunnableParamSpecInstaller* spec;
#line 342 "../src/data/Runnable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER), NULL);
#line 342 "../src/data/Runnable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 342 "../src/data/Runnable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 342 "../src/data/Runnable.vala"
	return G_PARAM_SPEC (spec);
#line 5784 "Runnable.c"
}

gpointer
game_hub_data_runnable_value_get_installer (const GValue* value)
{
#line 342 "../src/data/Runnable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER), NULL);
#line 342 "../src/data/Runnable.vala"
	return value->data[0].v_pointer;
#line 5794 "Runnable.c"
}

void
game_hub_data_runnable_value_set_installer (GValue* value,
                                            gpointer v_object)
{
	GameHubDataRunnableInstaller * old;
#line 342 "../src/data/Runnable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER));
#line 342 "../src/data/Runnable.vala"
	old = value->data[0].v_pointer;
#line 342 "../src/data/Runnable.vala"
	if (v_object) {
#line 342 "../src/data/Runnable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER));
#line 342 "../src/data/Runnable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 342 "../src/data/Runnable.vala"
		value->data[0].v_pointer = v_object;
#line 342 "../src/data/Runnable.vala"
		game_hub_data_runnable_installer_ref (value->data[0].v_pointer);
#line 5816 "Runnable.c"
	} else {
#line 342 "../src/data/Runnable.vala"
		value->data[0].v_pointer = NULL;
#line 5820 "Runnable.c"
	}
#line 342 "../src/data/Runnable.vala"
	if (old) {
#line 342 "../src/data/Runnable.vala"
		game_hub_data_runnable_installer_unref (old);
#line 5826 "Runnable.c"
	}
}

void
game_hub_data_runnable_value_take_installer (GValue* value,
                                             gpointer v_object)
{
	GameHubDataRunnableInstaller * old;
#line 342 "../src/data/Runnable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER));
#line 342 "../src/data/Runnable.vala"
	old = value->data[0].v_pointer;
#line 342 "../src/data/Runnable.vala"
	if (v_object) {
#line 342 "../src/data/Runnable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER));
#line 342 "../src/data/Runnable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 342 "../src/data/Runnable.vala"
		value->data[0].v_pointer = v_object;
#line 5847 "Runnable.c"
	} else {
#line 342 "../src/data/Runnable.vala"
		value->data[0].v_pointer = NULL;
#line 5851 "Runnable.c"
	}
#line 342 "../src/data/Runnable.vala"
	if (old) {
#line 342 "../src/data/Runnable.vala"
		game_hub_data_runnable_installer_unref (old);
#line 5857 "Runnable.c"
	}
}

static void
game_hub_data_runnable_installer_class_init (GameHubDataRunnableInstallerClass * klass,
                                             gpointer klass_data)
{
#line 342 "../src/data/Runnable.vala"
	game_hub_data_runnable_installer_parent_class = g_type_class_peek_parent (klass);
#line 342 "../src/data/Runnable.vala"
	((GameHubDataRunnableInstallerClass *) klass)->finalize = game_hub_data_runnable_installer_finalize;
#line 342 "../src/data/Runnable.vala"
	g_type_class_adjust_private_offset (klass, &GameHubDataRunnableInstaller_private_offset);
#line 342 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_INSTALLER_CLASS (klass)->get_name = game_hub_data_runnable_installer_real_get_name;
#line 5873 "Runnable.c"
}

static void
game_hub_data_runnable_installer_instance_init (GameHubDataRunnableInstaller * self,
                                                gpointer klass)
{
#line 342 "../src/data/Runnable.vala"
	self->priv = game_hub_data_runnable_installer_get_instance_private (self);
#line 345 "../src/data/Runnable.vala"
	self->priv->_platform = GAME_HUB_DATA_PLATFORM_CURRENT;
#line 346 "../src/data/Runnable.vala"
	self->priv->_full_size = (gint64) 0;
#line 342 "../src/data/Runnable.vala"
	self->ref_count = 1;
#line 5888 "Runnable.c"
}

static void
game_hub_data_runnable_installer_finalize (GameHubDataRunnableInstaller * obj)
{
	GameHubDataRunnableInstaller * self;
#line 342 "../src/data/Runnable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER, GameHubDataRunnableInstaller);
#line 342 "../src/data/Runnable.vala"
	g_signal_handlers_destroy (self);
#line 344 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_id);
#line 347 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_version);
#line 5903 "Runnable.c"
}

GType
game_hub_data_runnable_installer_get_type (void)
{
	static volatile gsize game_hub_data_runnable_installer_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_runnable_installer_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { game_hub_data_runnable_value_installer_init, game_hub_data_runnable_value_installer_free_value, game_hub_data_runnable_value_installer_copy_value, game_hub_data_runnable_value_installer_peek_pointer, "p", game_hub_data_runnable_value_installer_collect_value, "p", game_hub_data_runnable_value_installer_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GameHubDataRunnableInstallerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_runnable_installer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataRunnableInstaller), 0, (GInstanceInitFunc) game_hub_data_runnable_installer_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType game_hub_data_runnable_installer_type_id;
		game_hub_data_runnable_installer_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GameHubDataRunnableInstaller", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		GameHubDataRunnableInstaller_private_offset = g_type_add_instance_private (game_hub_data_runnable_installer_type_id, sizeof (GameHubDataRunnableInstallerPrivate));
		g_once_init_leave (&game_hub_data_runnable_installer_type_id__volatile, game_hub_data_runnable_installer_type_id);
	}
	return game_hub_data_runnable_installer_type_id__volatile;
}

gpointer
game_hub_data_runnable_installer_ref (gpointer instance)
{
	GameHubDataRunnableInstaller * self;
	self = instance;
#line 342 "../src/data/Runnable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 342 "../src/data/Runnable.vala"
	return instance;
#line 5931 "Runnable.c"
}

void
game_hub_data_runnable_installer_unref (gpointer instance)
{
	GameHubDataRunnableInstaller * self;
	self = instance;
#line 342 "../src/data/Runnable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 342 "../src/data/Runnable.vala"
		GAME_HUB_DATA_RUNNABLE_INSTALLER_GET_CLASS (self)->finalize (self);
#line 342 "../src/data/Runnable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 5945 "Runnable.c"
	}
}

static inline gpointer
game_hub_data_runnable_file_installer_get_instance_private (GameHubDataRunnableFileInstaller* self)
{
	return G_STRUCT_MEMBER_P (self, GameHubDataRunnableFileInstaller_private_offset);
}

static void
game_hub_data_runnable_file_installer_real_install_data_free (gpointer _data)
{
	GameHubDataRunnableFileInstallerInstallData* _data_;
	_data_ = _data;
#line 460 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->runnable);
#line 460 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->tool);
#line 460 "../src/data/Runnable.vala"
	_game_hub_data_runnable_installer_unref0 (_data_->self);
#line 460 "../src/data/Runnable.vala"
	g_slice_free (GameHubDataRunnableFileInstallerInstallData, _data_);
#line 5968 "Runnable.c"
}

static gpointer
_game_hub_data_runnable_installer_ref0 (gpointer self)
{
#line 460 "../src/data/Runnable.vala"
	return self ? game_hub_data_runnable_installer_ref (self) : NULL;
#line 5976 "Runnable.c"
}

static void
game_hub_data_runnable_file_installer_real_install (GameHubDataRunnableInstaller* base,
                                                    GameHubDataRunnable* runnable,
                                                    GameHubDataCompatTool* tool,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_)
{
	GameHubDataRunnableFileInstaller * self;
	GameHubDataRunnableFileInstallerInstallData* _data_;
	GameHubDataRunnableFileInstaller* _tmp0_;
	GameHubDataRunnable* _tmp1_;
	GameHubDataCompatTool* _tmp2_;
#line 460 "../src/data/Runnable.vala"
	self = (GameHubDataRunnableFileInstaller*) base;
#line 460 "../src/data/Runnable.vala"
	_data_ = g_slice_new0 (GameHubDataRunnableFileInstallerInstallData);
#line 460 "../src/data/Runnable.vala"
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
#line 460 "../src/data/Runnable.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_runnable_file_installer_real_install_data_free);
#line 460 "../src/data/Runnable.vala"
	_tmp0_ = _game_hub_data_runnable_installer_ref0 (self);
#line 460 "../src/data/Runnable.vala"
	_data_->self = _tmp0_;
#line 460 "../src/data/Runnable.vala"
	_tmp1_ = _g_object_ref0 (runnable);
#line 460 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->runnable);
#line 460 "../src/data/Runnable.vala"
	_data_->runnable = _tmp1_;
#line 460 "../src/data/Runnable.vala"
	_tmp2_ = _g_object_ref0 (tool);
#line 460 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->tool);
#line 460 "../src/data/Runnable.vala"
	_data_->tool = _tmp2_;
#line 460 "../src/data/Runnable.vala"
	game_hub_data_runnable_file_installer_real_install_co (_data_);
#line 6017 "Runnable.c"
}

static void
game_hub_data_runnable_file_installer_install_finish (GameHubDataRunnableInstaller* base,
                                                      GAsyncResult* _res_)
{
	GameHubDataRunnableFileInstallerInstallData* _data_;
#line 460 "../src/data/Runnable.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 6027 "Runnable.c"
}

static void
game_hub_data_runnable_file_installer_install_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_)
{
	GameHubDataRunnableFileInstallerInstallData* _data_;
#line 469 "../src/data/Runnable.vala"
	_data_ = _user_data_;
#line 469 "../src/data/Runnable.vala"
	_data_->_source_object_ = source_object;
#line 469 "../src/data/Runnable.vala"
	_data_->_res_ = _res_;
#line 469 "../src/data/Runnable.vala"
	game_hub_data_runnable_file_installer_real_install_co (_data_);
#line 6044 "Runnable.c"
}

static gboolean
game_hub_data_runnable_file_installer_real_install_co (GameHubDataRunnableFileInstallerInstallData* _data_)
{
#line 467 "../src/data/Runnable.vala"
	switch (_data_->_state_) {
#line 467 "../src/data/Runnable.vala"
		case 0:
#line 6054 "Runnable.c"
		goto _state_0;
#line 467 "../src/data/Runnable.vala"
		case 1:
#line 6058 "Runnable.c"
		goto _state_1;
		default:
#line 467 "../src/data/Runnable.vala"
		g_assert_not_reached ();
#line 6063 "Runnable.c"
	}
	_state_0:
#line 469 "../src/data/Runnable.vala"
	_data_->_tmp0_ = _data_->self->priv->_file;
#line 469 "../src/data/Runnable.vala"
	_data_->_state_ = 1;
#line 469 "../src/data/Runnable.vala"
	game_hub_data_runnable_file_installer_install_file (_data_->_tmp0_, FALSE, _data_->runnable, _data_->tool, game_hub_data_runnable_file_installer_install_ready, _data_);
#line 469 "../src/data/Runnable.vala"
	return FALSE;
#line 6074 "Runnable.c"
	_state_1:
#line 469 "../src/data/Runnable.vala"
	game_hub_data_runnable_file_installer_install_file_finish (_data_->_res_, NULL, NULL);
#line 467 "../src/data/Runnable.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 467 "../src/data/Runnable.vala"
	if (_data_->_state_ != 0) {
#line 467 "../src/data/Runnable.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 467 "../src/data/Runnable.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 6086 "Runnable.c"
		}
	}
#line 467 "../src/data/Runnable.vala"
	g_object_unref (_data_->_async_result);
#line 467 "../src/data/Runnable.vala"
	return FALSE;
#line 6093 "Runnable.c"
}

static void
game_hub_data_runnable_file_installer_install_file_data_free (gpointer _data)
{
	GameHubDataRunnableFileInstallerInstallFileData* _data_;
	_data_ = _data;
#line 460 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->file);
#line 460 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->runnable);
#line 460 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->tool);
#line 460 "../src/data/Runnable.vala"
	g_slice_free (GameHubDataRunnableFileInstallerInstallFileData, _data_);
#line 6109 "Runnable.c"
}

void
game_hub_data_runnable_file_installer_install_file (GFile* file,
                                                    gboolean is_part,
                                                    GameHubDataRunnable* runnable,
                                                    GameHubDataCompatTool* tool,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_)
{
	GameHubDataRunnableFileInstallerInstallFileData* _data_;
	GFile* _tmp0_;
	GameHubDataRunnable* _tmp1_;
	GameHubDataCompatTool* _tmp2_;
#line 460 "../src/data/Runnable.vala"
	_data_ = g_slice_new0 (GameHubDataRunnableFileInstallerInstallFileData);
#line 460 "../src/data/Runnable.vala"
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
#line 460 "../src/data/Runnable.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_runnable_file_installer_install_file_data_free);
#line 460 "../src/data/Runnable.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 460 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->file);
#line 460 "../src/data/Runnable.vala"
	_data_->file = _tmp0_;
#line 460 "../src/data/Runnable.vala"
	_data_->is_part = is_part;
#line 460 "../src/data/Runnable.vala"
	_tmp1_ = _g_object_ref0 (runnable);
#line 460 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->runnable);
#line 460 "../src/data/Runnable.vala"
	_data_->runnable = _tmp1_;
#line 460 "../src/data/Runnable.vala"
	_tmp2_ = _g_object_ref0 (tool);
#line 460 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->tool);
#line 460 "../src/data/Runnable.vala"
	_data_->tool = _tmp2_;
#line 460 "../src/data/Runnable.vala"
	game_hub_data_runnable_file_installer_install_file_co (_data_);
#line 6152 "Runnable.c"
}

void
game_hub_data_runnable_file_installer_install_file_finish (GAsyncResult* _res_,
                                                           gboolean* is_windows_installer,
                                                           gboolean* is_nsis_installer)
{
	GameHubDataRunnableFileInstallerInstallFileData* _data_;
#line 460 "../src/data/Runnable.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 460 "../src/data/Runnable.vala"
	if (is_windows_installer) {
#line 460 "../src/data/Runnable.vala"
		*is_windows_installer = _data_->is_windows_installer;
#line 6167 "Runnable.c"
	}
#line 460 "../src/data/Runnable.vala"
	if (is_nsis_installer) {
#line 460 "../src/data/Runnable.vala"
		*is_nsis_installer = _data_->is_nsis_installer;
#line 6173 "Runnable.c"
	}
}

static void
game_hub_data_runnable_file_installer_install_file_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_)
{
	GameHubDataRunnableFileInstallerInstallFileData* _data_;
#line 490 "../src/data/Runnable.vala"
	_data_ = _user_data_;
#line 490 "../src/data/Runnable.vala"
	_data_->_source_object_ = source_object;
#line 490 "../src/data/Runnable.vala"
	_data_->_res_ = _res_;
#line 490 "../src/data/Runnable.vala"
	game_hub_data_runnable_file_installer_install_file_co (_data_);
#line 6191 "Runnable.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
#line 1478 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1478 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1479 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1479 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1479 "glib-2.0.vapi"
	return result;
#line 6210 "Runnable.c"
}

static gboolean
game_hub_data_runnable_file_installer_install_file_co (GameHubDataRunnableFileInstallerInstallFileData* _data_)
{
#line 472 "../src/data/Runnable.vala"
	switch (_data_->_state_) {
#line 472 "../src/data/Runnable.vala"
		case 0:
#line 6220 "Runnable.c"
		goto _state_0;
#line 472 "../src/data/Runnable.vala"
		case 1:
#line 6224 "Runnable.c"
		goto _state_1;
#line 472 "../src/data/Runnable.vala"
		case 2:
#line 6228 "Runnable.c"
		goto _state_2;
#line 472 "../src/data/Runnable.vala"
		case 3:
#line 6232 "Runnable.c"
		goto _state_3;
		default:
#line 472 "../src/data/Runnable.vala"
		g_assert_not_reached ();
#line 6237 "Runnable.c"
	}
	_state_0:
#line 474 "../src/data/Runnable.vala"
	_data_->is_windows_installer = FALSE;
#line 475 "../src/data/Runnable.vala"
	_data_->is_nsis_installer = FALSE;
#line 477 "../src/data/Runnable.vala"
	if (_data_->file == NULL) {
#line 477 "../src/data/Runnable.vala"
		_data_->_tmp0_ = TRUE;
#line 6248 "Runnable.c"
	} else {
#line 477 "../src/data/Runnable.vala"
		_data_->_tmp0_ = !g_file_query_exists (_data_->file, NULL);
#line 6252 "Runnable.c"
	}
#line 477 "../src/data/Runnable.vala"
	if (_data_->_tmp0_) {
#line 477 "../src/data/Runnable.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 477 "../src/data/Runnable.vala"
		if (_data_->_state_ != 0) {
#line 477 "../src/data/Runnable.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 477 "../src/data/Runnable.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 6264 "Runnable.c"
			}
		}
#line 477 "../src/data/Runnable.vala"
		g_object_unref (_data_->_async_result);
#line 477 "../src/data/Runnable.vala"
		return FALSE;
#line 6271 "Runnable.c"
	}
#line 479 "../src/data/Runnable.vala"
	_data_->game = NULL;
#line 480 "../src/data/Runnable.vala"
	if (GAME_HUB_DATA_IS_GAME (_data_->runnable)) {
#line 482 "../src/data/Runnable.vala"
		_data_->_tmp1_ = _g_object_ref0 (GAME_HUB_DATA_IS_GAME (_data_->runnable) ? ((GameHubDataGame*) _data_->runnable) : NULL);
#line 482 "../src/data/Runnable.vala"
		_g_object_unref0 (_data_->game);
#line 482 "../src/data/Runnable.vala"
		_data_->game = _data_->_tmp1_;
#line 6283 "Runnable.c"
	}
#line 485 "../src/data/Runnable.vala"
	_data_->_tmp2_ = g_file_get_path (_data_->file);
#line 485 "../src/data/Runnable.vala"
	_data_->path = _data_->_tmp2_;
#line 486 "../src/data/Runnable.vala"
	_data_->_tmp3_ = g_strdup ("chmod");
#line 486 "../src/data/Runnable.vala"
	_data_->_tmp4_ = g_strdup ("+x");
#line 486 "../src/data/Runnable.vala"
	_data_->_tmp5_ = _data_->path;
#line 486 "../src/data/Runnable.vala"
	_data_->_tmp6_ = g_strdup (_data_->_tmp5_);
#line 486 "../src/data/Runnable.vala"
	_data_->_tmp7_ = g_new0 (gchar*, 3 + 1);
#line 486 "../src/data/Runnable.vala"
	_data_->_tmp7_[0] = _data_->_tmp3_;
#line 486 "../src/data/Runnable.vala"
	_data_->_tmp7_[1] = _data_->_tmp4_;
#line 486 "../src/data/Runnable.vala"
	_data_->_tmp7_[2] = _data_->_tmp6_;
#line 486 "../src/data/Runnable.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 486 "../src/data/Runnable.vala"
	_data_->_tmp8__length1 = 3;
#line 486 "../src/data/Runnable.vala"
	_data_->_tmp9_ = game_hub_utils_run (_data_->_tmp8_, (gint) 3);
#line 486 "../src/data/Runnable.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 486 "../src/data/Runnable.vala"
	_data_->_tmp11_ = game_hub_utils_run_task_run_sync (_data_->_tmp10_, FALSE);
#line 486 "../src/data/Runnable.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 486 "../src/data/Runnable.vala"
	_game_hub_utils_run_task_result_unref0 (_data_->_tmp12_);
#line 486 "../src/data/Runnable.vala"
	_game_hub_utils_run_task_unref0 (_data_->_tmp10_);
#line 486 "../src/data/Runnable.vala"
	_data_->_tmp8_ = (_vala_array_free (_data_->_tmp8_, _data_->_tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 488 "../src/data/Runnable.vala"
	_data_->_tmp13_ = game_hub_data_runnable_get_install_dir (_data_->runnable);
#line 488 "../src/data/Runnable.vala"
	_data_->_tmp14_ = _data_->_tmp13_;
#line 488 "../src/data/Runnable.vala"
	_data_->_tmp15_ = g_file_get_path (_data_->_tmp14_);
#line 488 "../src/data/Runnable.vala"
	_data_->_tmp16_ = _data_->_tmp15_;
#line 488 "../src/data/Runnable.vala"
	_data_->_tmp17_ = game_hub_utils_fs_utils_mkdir (_data_->_tmp16_, NULL, NULL);
#line 488 "../src/data/Runnable.vala"
	_data_->_tmp18_ = _data_->_tmp17_;
#line 488 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->_tmp18_);
#line 488 "../src/data/Runnable.vala"
	_g_free0 (_data_->_tmp16_);
#line 490 "../src/data/Runnable.vala"
	_data_->_state_ = 1;
#line 490 "../src/data/Runnable.vala"
	game_hub_data_runnable_installer_guess_type (_data_->file, _data_->is_part, game_hub_data_runnable_file_installer_install_file_ready, _data_);
#line 490 "../src/data/Runnable.vala"
	return FALSE;
#line 6345 "Runnable.c"
	_state_1:
#line 490 "../src/data/Runnable.vala"
	_data_->type = game_hub_data_runnable_installer_guess_type_finish (_data_->_res_);
#line 492 "../src/data/Runnable.vala"
	_data_->_tmp20_ = _data_->type;
#line 492 "../src/data/Runnable.vala"
	if (_data_->_tmp20_ == GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_WINDOWS_EXECUTABLE) {
#line 492 "../src/data/Runnable.vala"
		_data_->_tmp19_ = GAME_HUB_DATA_COMPAT_IS_INNOEXTRACT (_data_->tool);
#line 6355 "Runnable.c"
	} else {
#line 492 "../src/data/Runnable.vala"
		_data_->_tmp19_ = FALSE;
#line 6359 "Runnable.c"
	}
#line 492 "../src/data/Runnable.vala"
	if (_data_->_tmp19_) {
#line 494 "../src/data/Runnable.vala"
		_data_->_tmp21_ = g_strdup ("file");
#line 494 "../src/data/Runnable.vala"
		_data_->_tmp22_ = g_strdup ("-b");
#line 494 "../src/data/Runnable.vala"
		_data_->_tmp23_ = _data_->path;
#line 494 "../src/data/Runnable.vala"
		_data_->_tmp24_ = g_strdup (_data_->_tmp23_);
#line 494 "../src/data/Runnable.vala"
		_data_->_tmp25_ = g_new0 (gchar*, 3 + 1);
#line 494 "../src/data/Runnable.vala"
		_data_->_tmp25_[0] = _data_->_tmp21_;
#line 494 "../src/data/Runnable.vala"
		_data_->_tmp25_[1] = _data_->_tmp22_;
#line 494 "../src/data/Runnable.vala"
		_data_->_tmp25_[2] = _data_->_tmp24_;
#line 494 "../src/data/Runnable.vala"
		_data_->_tmp26_ = _data_->_tmp25_;
#line 494 "../src/data/Runnable.vala"
		_data_->_tmp26__length1 = 3;
#line 494 "../src/data/Runnable.vala"
		_data_->_tmp27_ = game_hub_utils_run (_data_->_tmp26_, (gint) 3);
#line 494 "../src/data/Runnable.vala"
		_data_->_tmp28_ = _data_->_tmp27_;
#line 494 "../src/data/Runnable.vala"
		_data_->_tmp29_ = game_hub_utils_run_task_log (_data_->_tmp28_, FALSE);
#line 494 "../src/data/Runnable.vala"
		_data_->_tmp30_ = _data_->_tmp29_;
#line 494 "../src/data/Runnable.vala"
		_data_->_tmp31_ = game_hub_utils_run_task_run_sync (_data_->_tmp30_, TRUE);
#line 494 "../src/data/Runnable.vala"
		_data_->_tmp32_ = _data_->_tmp31_;
#line 494 "../src/data/Runnable.vala"
		_data_->_tmp33_ = _data_->_tmp32_->output;
#line 494 "../src/data/Runnable.vala"
		_data_->_tmp34_ = g_strdup (_data_->_tmp33_);
#line 494 "../src/data/Runnable.vala"
		_data_->_tmp35_ = _data_->_tmp34_;
#line 494 "../src/data/Runnable.vala"
		_game_hub_utils_run_task_result_unref0 (_data_->_tmp32_);
#line 494 "../src/data/Runnable.vala"
		_game_hub_utils_run_task_unref0 (_data_->_tmp30_);
#line 494 "../src/data/Runnable.vala"
		_game_hub_utils_run_task_unref0 (_data_->_tmp28_);
#line 494 "../src/data/Runnable.vala"
		_data_->_tmp26_ = (_vala_array_free (_data_->_tmp26_, _data_->_tmp26__length1, (GDestroyNotify) g_free), NULL);
#line 494 "../src/data/Runnable.vala"
		_data_->desc = _data_->_tmp35_;
#line 495 "../src/data/Runnable.vala"
		_data_->_tmp38_ = _data_->desc;
#line 495 "../src/data/Runnable.vala"
		if (_data_->_tmp38_ != NULL) {
#line 495 "../src/data/Runnable.vala"
			_data_->_tmp39_ = _data_->desc;
#line 495 "../src/data/Runnable.vala"
			_data_->_tmp40_ = strlen (_data_->_tmp39_);
#line 495 "../src/data/Runnable.vala"
			_data_->_tmp41_ = _data_->_tmp40_;
#line 495 "../src/data/Runnable.vala"
			_data_->_tmp37_ = _data_->_tmp41_ > 0;
#line 6423 "Runnable.c"
		} else {
#line 495 "../src/data/Runnable.vala"
			_data_->_tmp37_ = FALSE;
#line 6427 "Runnable.c"
		}
#line 495 "../src/data/Runnable.vala"
		if (_data_->_tmp37_) {
#line 495 "../src/data/Runnable.vala"
			_data_->_tmp42_ = _data_->desc;
#line 495 "../src/data/Runnable.vala"
			_data_->_tmp36_ = string_contains (_data_->_tmp42_, GAME_HUB_DATA_RUNNABLE_FILE_INSTALLER_NSIS_INSTALLER_DESCRIPTION);
#line 6435 "Runnable.c"
		} else {
#line 495 "../src/data/Runnable.vala"
			_data_->_tmp36_ = FALSE;
#line 6439 "Runnable.c"
		}
#line 495 "../src/data/Runnable.vala"
		if (_data_->_tmp36_) {
#line 497 "../src/data/Runnable.vala"
			_data_->type = GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_WINDOWS_NSIS_INSTALLER;
#line 6445 "Runnable.c"
		}
#line 492 "../src/data/Runnable.vala"
		_g_free0 (_data_->desc);
#line 6449 "Runnable.c"
	}
#line 501 "../src/data/Runnable.vala"
	_data_->cmd = NULL;
#line 501 "../src/data/Runnable.vala"
	_data_->cmd_length1 = 0;
#line 501 "../src/data/Runnable.vala"
	_data_->_cmd_size_ = _data_->cmd_length1;
#line 503 "../src/data/Runnable.vala"
	_data_->_tmp43_ = _data_->type;
#line 503 "../src/data/Runnable.vala"
	switch (_data_->_tmp43_) {
#line 503 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_EXECUTABLE:
#line 6463 "Runnable.c"
		{
#line 506 "../src/data/Runnable.vala"
			_data_->_tmp44_ = _data_->path;
#line 506 "../src/data/Runnable.vala"
			_data_->_tmp45_ = g_strdup (_data_->_tmp44_);
#line 506 "../src/data/Runnable.vala"
			_data_->_tmp46_ = g_strdup ("--");
#line 506 "../src/data/Runnable.vala"
			_data_->_tmp47_ = g_strdup ("--i-agree-to-all-licenses");
#line 506 "../src/data/Runnable.vala"
			_data_->_tmp48_ = g_strdup ("--noreadme");
#line 506 "../src/data/Runnable.vala"
			_data_->_tmp49_ = g_strdup ("--nooptions");
#line 506 "../src/data/Runnable.vala"
			_data_->_tmp50_ = g_strdup ("--noprompt");
#line 506 "../src/data/Runnable.vala"
			_data_->_tmp51_ = g_strdup ("--destination");
#line 506 "../src/data/Runnable.vala"
			_data_->_tmp52_ = game_hub_data_runnable_get_install_dir (_data_->runnable);
#line 506 "../src/data/Runnable.vala"
			_data_->_tmp53_ = _data_->_tmp52_;
#line 506 "../src/data/Runnable.vala"
			_data_->_tmp54_ = g_file_get_path (_data_->_tmp53_);
#line 506 "../src/data/Runnable.vala"
			_data_->_tmp55_ = _data_->_tmp54_;
#line 506 "../src/data/Runnable.vala"
			_data_->_tmp56_ = string_replace (_data_->_tmp55_, "'", "\\'");
#line 506 "../src/data/Runnable.vala"
			_data_->_tmp57_ = g_new0 (gchar*, 8 + 1);
#line 506 "../src/data/Runnable.vala"
			_data_->_tmp57_[0] = _data_->_tmp45_;
#line 506 "../src/data/Runnable.vala"
			_data_->_tmp57_[1] = _data_->_tmp46_;
#line 506 "../src/data/Runnable.vala"
			_data_->_tmp57_[2] = _data_->_tmp47_;
#line 506 "../src/data/Runnable.vala"
			_data_->_tmp57_[3] = _data_->_tmp48_;
#line 506 "../src/data/Runnable.vala"
			_data_->_tmp57_[4] = _data_->_tmp49_;
#line 506 "../src/data/Runnable.vala"
			_data_->_tmp57_[5] = _data_->_tmp50_;
#line 506 "../src/data/Runnable.vala"
			_data_->_tmp57_[6] = _data_->_tmp51_;
#line 506 "../src/data/Runnable.vala"
			_data_->_tmp57_[7] = _data_->_tmp56_;
#line 506 "../src/data/Runnable.vala"
			_data_->cmd = (_vala_array_free (_data_->cmd, _data_->cmd_length1, (GDestroyNotify) g_free), NULL);
#line 506 "../src/data/Runnable.vala"
			_data_->cmd = _data_->_tmp57_;
#line 506 "../src/data/Runnable.vala"
			_data_->cmd_length1 = 8;
#line 506 "../src/data/Runnable.vala"
			_data_->_cmd_size_ = _data_->cmd_length1;
#line 506 "../src/data/Runnable.vala"
			_g_free0 (_data_->_tmp55_);
#line 509 "../src/data/Runnable.vala"
			break;
#line 6521 "Runnable.c"
		}
#line 503 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_ARCHIVE:
#line 503 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_WINDOWS_NSIS_INSTALLER:
#line 6527 "Runnable.c"
		{
#line 513 "../src/data/Runnable.vala"
			_data_->_tmp58_ = g_strdup ("file-roller");
#line 513 "../src/data/Runnable.vala"
			_data_->_tmp59_ = _data_->path;
#line 513 "../src/data/Runnable.vala"
			_data_->_tmp60_ = g_strdup (_data_->_tmp59_);
#line 513 "../src/data/Runnable.vala"
			_data_->_tmp61_ = g_strdup ("-e");
#line 513 "../src/data/Runnable.vala"
			_data_->_tmp62_ = game_hub_data_runnable_get_install_dir (_data_->runnable);
#line 513 "../src/data/Runnable.vala"
			_data_->_tmp63_ = _data_->_tmp62_;
#line 513 "../src/data/Runnable.vala"
			_data_->_tmp64_ = g_file_get_path (_data_->_tmp63_);
#line 513 "../src/data/Runnable.vala"
			_data_->_tmp65_ = g_new0 (gchar*, 4 + 1);
#line 513 "../src/data/Runnable.vala"
			_data_->_tmp65_[0] = _data_->_tmp58_;
#line 513 "../src/data/Runnable.vala"
			_data_->_tmp65_[1] = _data_->_tmp60_;
#line 513 "../src/data/Runnable.vala"
			_data_->_tmp65_[2] = _data_->_tmp61_;
#line 513 "../src/data/Runnable.vala"
			_data_->_tmp65_[3] = _data_->_tmp64_;
#line 513 "../src/data/Runnable.vala"
			_data_->cmd = (_vala_array_free (_data_->cmd, _data_->cmd_length1, (GDestroyNotify) g_free), NULL);
#line 513 "../src/data/Runnable.vala"
			_data_->cmd = _data_->_tmp65_;
#line 513 "../src/data/Runnable.vala"
			_data_->cmd_length1 = 4;
#line 513 "../src/data/Runnable.vala"
			_data_->_cmd_size_ = _data_->cmd_length1;
#line 514 "../src/data/Runnable.vala"
			break;
#line 6563 "Runnable.c"
		}
#line 503 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_WINDOWS_EXECUTABLE:
#line 503 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_GOG_PART:
#line 6569 "Runnable.c"
		{
#line 518 "../src/data/Runnable.vala"
			_data_->cmd = (_vala_array_free (_data_->cmd, _data_->cmd_length1, (GDestroyNotify) g_free), NULL);
#line 518 "../src/data/Runnable.vala"
			_data_->cmd = NULL;
#line 518 "../src/data/Runnable.vala"
			_data_->cmd_length1 = 0;
#line 518 "../src/data/Runnable.vala"
			_data_->_cmd_size_ = _data_->cmd_length1;
#line 519 "../src/data/Runnable.vala"
			break;
#line 6581 "Runnable.c"
		}
		default:
		{
#line 522 "../src/data/Runnable.vala"
			_data_->_tmp66_ = g_strdup ("xdg-open");
#line 522 "../src/data/Runnable.vala"
			_data_->_tmp67_ = _data_->path;
#line 522 "../src/data/Runnable.vala"
			_data_->_tmp68_ = g_strdup (_data_->_tmp67_);
#line 522 "../src/data/Runnable.vala"
			_data_->_tmp69_ = g_new0 (gchar*, 2 + 1);
#line 522 "../src/data/Runnable.vala"
			_data_->_tmp69_[0] = _data_->_tmp66_;
#line 522 "../src/data/Runnable.vala"
			_data_->_tmp69_[1] = _data_->_tmp68_;
#line 522 "../src/data/Runnable.vala"
			_data_->cmd = (_vala_array_free (_data_->cmd, _data_->cmd_length1, (GDestroyNotify) g_free), NULL);
#line 522 "../src/data/Runnable.vala"
			_data_->cmd = _data_->_tmp69_;
#line 522 "../src/data/Runnable.vala"
			_data_->cmd_length1 = 2;
#line 522 "../src/data/Runnable.vala"
			_data_->_cmd_size_ = _data_->cmd_length1;
#line 523 "../src/data/Runnable.vala"
			break;
#line 6607 "Runnable.c"
		}
	}
#line 526 "../src/data/Runnable.vala"
	_data_->_tmp70_ = _data_->game;
#line 526 "../src/data/Runnable.vala"
	if (_data_->_tmp70_ != NULL) {
#line 526 "../src/data/Runnable.vala"
		_data_->_tmp71_ = _data_->game;
#line 526 "../src/data/Runnable.vala"
		_data_->_tmp72_ = _data_->game;
#line 526 "../src/data/Runnable.vala"
		_data_->_tmp73_ = game_hub_data_game_status_new (GAME_HUB_DATA_GAME_STATE_INSTALLING, _data_->_tmp72_, NULL);
#line 526 "../src/data/Runnable.vala"
		_data_->_tmp74_ = _data_->_tmp73_;
#line 526 "../src/data/Runnable.vala"
		game_hub_data_game_set_status (_data_->_tmp71_, _data_->_tmp74_);
#line 526 "../src/data/Runnable.vala"
		_game_hub_data_game_status_unref0 (_data_->_tmp74_);
#line 6626 "Runnable.c"
	}
#line 528 "../src/data/Runnable.vala"
	_data_->_tmp75_ = _data_->cmd;
#line 528 "../src/data/Runnable.vala"
	_data_->_tmp75__length1 = _data_->cmd_length1;
#line 528 "../src/data/Runnable.vala"
	if (_data_->_tmp75_ != NULL) {
#line 530 "../src/data/Runnable.vala"
		_data_->_tmp76_ = _data_->cmd;
#line 530 "../src/data/Runnable.vala"
		_data_->_tmp76__length1 = _data_->cmd_length1;
#line 530 "../src/data/Runnable.vala"
		_data_->_tmp77_ = game_hub_utils_run (_data_->_tmp76_, (gint) _data_->_tmp76__length1);
#line 530 "../src/data/Runnable.vala"
		_data_->_tmp78_ = _data_->_tmp77_;
#line 530 "../src/data/Runnable.vala"
		_data_->_state_ = 2;
#line 530 "../src/data/Runnable.vala"
		game_hub_utils_run_task_run_async (_data_->_tmp78_, TRUE, game_hub_data_runnable_file_installer_install_file_ready, _data_);
#line 530 "../src/data/Runnable.vala"
		return FALSE;
#line 6648 "Runnable.c"
		_state_2:
#line 530 "../src/data/Runnable.vala"
		_data_->_tmp79_ = game_hub_utils_run_task_run_finish (_data_->_tmp78_, _data_->_res_);
#line 530 "../src/data/Runnable.vala"
		_data_->_tmp80_ = _data_->_tmp79_;
#line 530 "../src/data/Runnable.vala"
		_game_hub_utils_run_task_result_unref0 (_data_->_tmp80_);
#line 530 "../src/data/Runnable.vala"
		_game_hub_utils_run_task_unref0 (_data_->_tmp78_);
#line 6658 "Runnable.c"
	}
#line 532 "../src/data/Runnable.vala"
	_data_->_tmp81_ = _data_->type;
#line 532 "../src/data/Runnable.vala"
	if (_data_->_tmp81_ == GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_WINDOWS_EXECUTABLE) {
#line 534 "../src/data/Runnable.vala"
		_data_->is_windows_installer = TRUE;
#line 535 "../src/data/Runnable.vala"
		if (_data_->tool != NULL) {
#line 535 "../src/data/Runnable.vala"
			_data_->_tmp82_ = game_hub_data_compat_tool_can_install (_data_->tool, _data_->runnable);
#line 6670 "Runnable.c"
		} else {
#line 535 "../src/data/Runnable.vala"
			_data_->_tmp82_ = FALSE;
#line 6674 "Runnable.c"
		}
#line 535 "../src/data/Runnable.vala"
		if (_data_->_tmp82_) {
#line 537 "../src/data/Runnable.vala"
			_data_->_state_ = 3;
#line 537 "../src/data/Runnable.vala"
			game_hub_data_compat_tool_install (_data_->tool, _data_->runnable, _data_->file, game_hub_data_runnable_file_installer_install_file_ready, _data_);
#line 537 "../src/data/Runnable.vala"
			return FALSE;
#line 6684 "Runnable.c"
			_state_3:
#line 537 "../src/data/Runnable.vala"
			game_hub_data_compat_tool_install_finish (_data_->tool, _data_->_res_);
#line 6688 "Runnable.c"
		}
	} else {
#line 540 "../src/data/Runnable.vala"
		_data_->_tmp83_ = _data_->type;
#line 540 "../src/data/Runnable.vala"
		if (_data_->_tmp83_ == GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_WINDOWS_NSIS_INSTALLER) {
#line 542 "../src/data/Runnable.vala"
			_data_->is_nsis_installer = TRUE;
#line 6697 "Runnable.c"
		}
	}
#line 472 "../src/data/Runnable.vala"
	_data_->cmd = (_vala_array_free (_data_->cmd, _data_->cmd_length1, (GDestroyNotify) g_free), NULL);
#line 472 "../src/data/Runnable.vala"
	_g_free0 (_data_->path);
#line 472 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->game);
#line 472 "../src/data/Runnable.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 472 "../src/data/Runnable.vala"
	if (_data_->_state_ != 0) {
#line 472 "../src/data/Runnable.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 472 "../src/data/Runnable.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 6714 "Runnable.c"
		}
	}
#line 472 "../src/data/Runnable.vala"
	g_object_unref (_data_->_async_result);
#line 472 "../src/data/Runnable.vala"
	return FALSE;
#line 6721 "Runnable.c"
}

GameHubDataRunnableFileInstaller*
game_hub_data_runnable_file_installer_construct (GType object_type)
{
	GameHubDataRunnableFileInstaller* self = NULL;
#line 460 "../src/data/Runnable.vala"
	self = (GameHubDataRunnableFileInstaller*) game_hub_data_runnable_installer_construct (object_type);
#line 460 "../src/data/Runnable.vala"
	return self;
#line 6732 "Runnable.c"
}

GFile*
game_hub_data_runnable_file_installer_get_file (GameHubDataRunnableFileInstaller* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 464 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 464 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_file;
#line 464 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 464 "../src/data/Runnable.vala"
	return result;
#line 6748 "Runnable.c"
}

void
game_hub_data_runnable_file_installer_set_file (GameHubDataRunnableFileInstaller* self,
                                                GFile* value)
{
	GFile* _tmp0_;
#line 464 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 464 "../src/data/Runnable.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 464 "../src/data/Runnable.vala"
	_g_object_unref0 (self->priv->_file);
#line 464 "../src/data/Runnable.vala"
	self->priv->_file = _tmp0_;
#line 6764 "Runnable.c"
}

gint64
game_hub_data_runnable_file_installer_get_size (GameHubDataRunnableFileInstaller* self)
{
	gint64 result;
#line 465 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 465 "../src/data/Runnable.vala"
	result = self->priv->_size;
#line 465 "../src/data/Runnable.vala"
	return result;
#line 6777 "Runnable.c"
}

void
game_hub_data_runnable_file_installer_set_size (GameHubDataRunnableFileInstaller* self,
                                                gint64 value)
{
#line 465 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 465 "../src/data/Runnable.vala"
	self->priv->_size = value;
#line 6788 "Runnable.c"
}

static void
game_hub_data_runnable_file_installer_class_init (GameHubDataRunnableFileInstallerClass * klass,
                                                  gpointer klass_data)
{
#line 460 "../src/data/Runnable.vala"
	game_hub_data_runnable_file_installer_parent_class = g_type_class_peek_parent (klass);
#line 460 "../src/data/Runnable.vala"
	((GameHubDataRunnableInstallerClass *) klass)->finalize = game_hub_data_runnable_file_installer_finalize;
#line 460 "../src/data/Runnable.vala"
	g_type_class_adjust_private_offset (klass, &GameHubDataRunnableFileInstaller_private_offset);
#line 460 "../src/data/Runnable.vala"
	((GameHubDataRunnableInstallerClass *) klass)->install = (void (*) (GameHubDataRunnableInstaller*, GameHubDataRunnable*, GameHubDataCompatTool*, GAsyncReadyCallback, gpointer)) game_hub_data_runnable_file_installer_real_install;
#line 460 "../src/data/Runnable.vala"
	((GameHubDataRunnableInstallerClass *) klass)->install_finish = (void (*) (GameHubDataRunnableInstaller*, GAsyncResult*)) game_hub_data_runnable_file_installer_install_finish;
#line 6805 "Runnable.c"
}

static void
game_hub_data_runnable_file_installer_instance_init (GameHubDataRunnableFileInstaller * self,
                                                     gpointer klass)
{
#line 460 "../src/data/Runnable.vala"
	self->priv = game_hub_data_runnable_file_installer_get_instance_private (self);
#line 6814 "Runnable.c"
}

static void
game_hub_data_runnable_file_installer_finalize (GameHubDataRunnableInstaller * obj)
{
	GameHubDataRunnableFileInstaller * self;
#line 460 "../src/data/Runnable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_RUNNABLE_TYPE_FILE_INSTALLER, GameHubDataRunnableFileInstaller);
#line 464 "../src/data/Runnable.vala"
	_g_object_unref0 (self->priv->_file);
#line 460 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_INSTALLER_CLASS (game_hub_data_runnable_file_installer_parent_class)->finalize (obj);
#line 6827 "Runnable.c"
}

GType
game_hub_data_runnable_file_installer_get_type (void)
{
	static volatile gsize game_hub_data_runnable_file_installer_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_runnable_file_installer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameHubDataRunnableFileInstallerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_runnable_file_installer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataRunnableFileInstaller), 0, (GInstanceInitFunc) game_hub_data_runnable_file_installer_instance_init, NULL };
		GType game_hub_data_runnable_file_installer_type_id;
		game_hub_data_runnable_file_installer_type_id = g_type_register_static (GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER, "GameHubDataRunnableFileInstaller", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		GameHubDataRunnableFileInstaller_private_offset = g_type_add_instance_private (game_hub_data_runnable_file_installer_type_id, sizeof (GameHubDataRunnableFileInstallerPrivate));
		g_once_init_leave (&game_hub_data_runnable_file_installer_type_id__volatile, game_hub_data_runnable_file_installer_type_id);
	}
	return game_hub_data_runnable_file_installer_type_id__volatile;
}

static inline gpointer
game_hub_data_runnable_downloadable_installer_get_instance_private (GameHubDataRunnableDownloadableInstaller* self)
{
	return G_STRUCT_MEMBER_P (self, GameHubDataRunnableDownloadableInstaller_private_offset);
}

static void
game_hub_data_runnable_downloadable_installer_real_fetch_parts_data_free (gpointer _data)
{
	GameHubDataRunnableDownloadableInstallerFetchPartsData* _data_;
	_data_ = _data;
#line 547 "../src/data/Runnable.vala"
	_game_hub_data_runnable_installer_unref0 (_data_->self);
#line 547 "../src/data/Runnable.vala"
	g_slice_free (GameHubDataRunnableDownloadableInstallerFetchPartsData, _data_);
#line 6859 "Runnable.c"
}

static void
game_hub_data_runnable_downloadable_installer_real_fetch_parts (GameHubDataRunnableDownloadableInstaller* self,
                                                                GAsyncReadyCallback _callback_,
                                                                gpointer _user_data_)
{
	GameHubDataRunnableDownloadableInstallerFetchPartsData* _data_;
	GameHubDataRunnableDownloadableInstaller* _tmp0_;
#line 547 "../src/data/Runnable.vala"
	_data_ = g_slice_new0 (GameHubDataRunnableDownloadableInstallerFetchPartsData);
#line 547 "../src/data/Runnable.vala"
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
#line 547 "../src/data/Runnable.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_runnable_downloadable_installer_real_fetch_parts_data_free);
#line 547 "../src/data/Runnable.vala"
	_tmp0_ = _game_hub_data_runnable_installer_ref0 (self);
#line 547 "../src/data/Runnable.vala"
	_data_->self = _tmp0_;
#line 547 "../src/data/Runnable.vala"
	game_hub_data_runnable_downloadable_installer_real_fetch_parts_co (_data_);
#line 6881 "Runnable.c"
}

static void
game_hub_data_runnable_downloadable_installer_real_fetch_parts_finish (GameHubDataRunnableDownloadableInstaller* self,
                                                                       GAsyncResult* _res_)
{
	GameHubDataRunnableDownloadableInstallerFetchPartsData* _data_;
#line 547 "../src/data/Runnable.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 6891 "Runnable.c"
}

static gboolean
game_hub_data_runnable_downloadable_installer_real_fetch_parts_co (GameHubDataRunnableDownloadableInstallerFetchPartsData* _data_)
{
#line 580 "../src/data/Runnable.vala"
	switch (_data_->_state_) {
#line 580 "../src/data/Runnable.vala"
		case 0:
#line 6901 "Runnable.c"
		goto _state_0;
		default:
#line 580 "../src/data/Runnable.vala"
		g_assert_not_reached ();
#line 6906 "Runnable.c"
	}
	_state_0:
#line 580 "../src/data/Runnable.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 580 "../src/data/Runnable.vala"
	if (_data_->_state_ != 0) {
#line 580 "../src/data/Runnable.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 580 "../src/data/Runnable.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 6917 "Runnable.c"
		}
	}
#line 580 "../src/data/Runnable.vala"
	g_object_unref (_data_->_async_result);
#line 580 "../src/data/Runnable.vala"
	return FALSE;
#line 6924 "Runnable.c"
}

void
game_hub_data_runnable_downloadable_installer_fetch_parts (GameHubDataRunnableDownloadableInstaller* self,
                                                           GAsyncReadyCallback _callback_,
                                                           gpointer _user_data_)
{
#line 547 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_GET_CLASS (self)->fetch_parts (self, _callback_, _user_data_);
#line 6934 "Runnable.c"
}

void
game_hub_data_runnable_downloadable_installer_fetch_parts_finish (GameHubDataRunnableDownloadableInstaller* self,
                                                                  GAsyncResult* _res_)
{
#line 547 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_GET_CLASS (self)->fetch_parts_finish (self, _res_);
#line 6943 "Runnable.c"
}

static void
game_hub_data_runnable_downloadable_installer_download_data_free (gpointer _data)
{
	GameHubDataRunnableDownloadableInstallerDownloadData* _data_;
	_data_ = _data;
#line 547 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->result);
#line 547 "../src/data/Runnable.vala"
	_game_hub_data_runnable_installer_unref0 (_data_->self);
#line 547 "../src/data/Runnable.vala"
	g_slice_free (GameHubDataRunnableDownloadableInstallerDownloadData, _data_);
#line 6957 "Runnable.c"
}

void
game_hub_data_runnable_downloadable_installer_download (GameHubDataRunnableDownloadableInstaller* self,
                                                        GameHubDataRunnable* runnable,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_)
{
	GameHubDataRunnableDownloadableInstallerDownloadData* _data_;
	GameHubDataRunnableDownloadableInstaller* _tmp0_;
	GameHubDataRunnable* _tmp1_;
#line 547 "../src/data/Runnable.vala"
	_data_ = g_slice_new0 (GameHubDataRunnableDownloadableInstallerDownloadData);
#line 547 "../src/data/Runnable.vala"
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
#line 547 "../src/data/Runnable.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_runnable_downloadable_installer_download_data_free);
#line 547 "../src/data/Runnable.vala"
	_tmp0_ = _game_hub_data_runnable_installer_ref0 (self);
#line 547 "../src/data/Runnable.vala"
	_data_->self = _tmp0_;
#line 547 "../src/data/Runnable.vala"
	_tmp1_ = _g_object_ref0 (runnable);
#line 547 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->runnable);
#line 547 "../src/data/Runnable.vala"
	_data_->runnable = _tmp1_;
#line 547 "../src/data/Runnable.vala"
	game_hub_data_runnable_downloadable_installer_download_co (_data_);
#line 6987 "Runnable.c"
}

GeeArrayList*
game_hub_data_runnable_downloadable_installer_download_finish (GameHubDataRunnableDownloadableInstaller* self,
                                                               GAsyncResult* _res_)
{
	GeeArrayList* result;
	GameHubDataRunnableDownloadableInstallerDownloadData* _data_;
#line 547 "../src/data/Runnable.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 547 "../src/data/Runnable.vala"
	result = _data_->result;
#line 547 "../src/data/Runnable.vala"
	_data_->result = NULL;
#line 547 "../src/data/Runnable.vala"
	return result;
#line 7004 "Runnable.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 582 "../src/data/Runnable.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 582 "../src/data/Runnable.vala"
	return _data6_;
#line 7014 "Runnable.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 582 "../src/data/Runnable.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 7024 "Runnable.c"
		GameHubDataRunnableDownloadableInstaller* self;
#line 582 "../src/data/Runnable.vala"
		self = _data6_->self;
#line 582 "../src/data/Runnable.vala"
		_g_object_unref0 (_data6_->runnable);
#line 582 "../src/data/Runnable.vala"
		_game_hub_data_runnable_installer_unref0 (self);
#line 582 "../src/data/Runnable.vala"
		g_slice_free (Block6Data, _data6_);
#line 7034 "Runnable.c"
	}
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 585 "../src/data/Runnable.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 585 "../src/data/Runnable.vala"
	return _data7_;
#line 7045 "Runnable.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 585 "../src/data/Runnable.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 7055 "Runnable.c"
		GameHubDataRunnableDownloadableInstaller* self;
#line 585 "../src/data/Runnable.vala"
		self = _data7_->_data6_->self;
#line 585 "../src/data/Runnable.vala"
		_g_object_unref0 (_data7_->game);
#line 585 "../src/data/Runnable.vala"
		block6_data_unref (_data7_->_data6_);
#line 585 "../src/data/Runnable.vala"
		_data7_->_data6_ = NULL;
#line 585 "../src/data/Runnable.vala"
		g_slice_free (Block7Data, _data7_);
#line 7067 "Runnable.c"
	}
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 600 "../src/data/Runnable.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 600 "../src/data/Runnable.vala"
	return _data8_;
#line 7078 "Runnable.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 600 "../src/data/Runnable.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 7088 "Runnable.c"
		GameHubDataRunnableDownloadableInstaller* self;
#line 600 "../src/data/Runnable.vala"
		self = _data8_->_data7_->_data6_->self;
#line 600 "../src/data/Runnable.vala"
		_g_object_unref0 (_data8_->file);
#line 600 "../src/data/Runnable.vala"
		_g_object_unref0 (_data8_->part);
#line 600 "../src/data/Runnable.vala"
		block7_data_unref (_data8_->_data7_);
#line 600 "../src/data/Runnable.vala"
		_data8_->_data7_ = NULL;
#line 600 "../src/data/Runnable.vala"
		g_slice_free (Block8Data, _data8_);
#line 7102 "Runnable.c"
	}
}

static void
___lambda42_ (Block8Data* _data8_,
              GameHubUtilsDownloaderDownloadStatus* s)
{
	Block7Data* _data7_;
	Block6Data* _data6_;
	GameHubDataRunnableDownloadableInstaller* self;
	GameHubDataGame* _tmp0_;
	GameHubDataGame* _tmp1_;
	GameHubDataGameStatus* _tmp2_;
	GameHubDataGameStatus* _tmp3_;
#line 609 "../src/data/Runnable.vala"
	_data7_ = _data8_->_data7_;
#line 609 "../src/data/Runnable.vala"
	_data6_ = _data7_->_data6_;
#line 609 "../src/data/Runnable.vala"
	self = _data6_->self;
#line 610 "../src/data/Runnable.vala"
	_tmp0_ = _data7_->game;
#line 610 "../src/data/Runnable.vala"
	_tmp1_ = _data7_->game;
#line 610 "../src/data/Runnable.vala"
	_tmp2_ = game_hub_data_game_get_status (_tmp1_);
#line 610 "../src/data/Runnable.vala"
	_tmp3_ = _tmp2_;
#line 610 "../src/data/Runnable.vala"
	g_signal_emit_by_name (_tmp0_, "status-change", _tmp3_);
#line 7133 "Runnable.c"
}

static void
____lambda42__game_hub_utils_downloader_download_status_change (GameHubUtilsDownloaderDownload* _sender,
                                                                GameHubUtilsDownloaderDownloadStatus* status,
                                                                gpointer self)
{
#line 609 "../src/data/Runnable.vala"
	___lambda42_ (self, status);
#line 7143 "Runnable.c"
}

static void
_____lambda41_ (Block8Data* _data8_,
                GameHubUtilsDownloaderFileDownload* dl)
{
	Block7Data* _data7_;
	Block6Data* _data6_;
	GameHubDataRunnableDownloadableInstaller* self;
	GFile* _tmp0_;
	GameHubDataRunnableDownloadableInstallerPart* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GameHubDataGame* _tmp4_;
#line 604 "../src/data/Runnable.vala"
	_data7_ = _data8_->_data7_;
#line 604 "../src/data/Runnable.vala"
	_data6_ = _data7_->_data6_;
#line 604 "../src/data/Runnable.vala"
	self = _data6_->self;
#line 604 "../src/data/Runnable.vala"
	g_return_if_fail (dl != NULL);
#line 605 "../src/data/Runnable.vala"
	_tmp0_ = dl->remote;
#line 605 "../src/data/Runnable.vala"
	_tmp1_ = _data8_->part;
#line 605 "../src/data/Runnable.vala"
	_tmp2_ = game_hub_data_runnable_downloadable_installer_part_get_remote (_tmp1_);
#line 605 "../src/data/Runnable.vala"
	_tmp3_ = _tmp2_;
#line 605 "../src/data/Runnable.vala"
	if (_tmp0_ != _tmp3_) {
#line 605 "../src/data/Runnable.vala"
		return;
#line 7178 "Runnable.c"
	}
#line 606 "../src/data/Runnable.vala"
	_tmp4_ = _data7_->game;
#line 606 "../src/data/Runnable.vala"
	if (_tmp4_ != NULL) {
#line 7184 "Runnable.c"
		GameHubDataGame* _tmp5_;
		GameHubDataGame* _tmp6_;
		GameHubDataGameStatus* _tmp7_;
		GameHubDataGameStatus* _tmp8_;
#line 608 "../src/data/Runnable.vala"
		_tmp5_ = _data7_->game;
#line 608 "../src/data/Runnable.vala"
		_tmp6_ = _data7_->game;
#line 608 "../src/data/Runnable.vala"
		_tmp7_ = game_hub_data_game_status_new (GAME_HUB_DATA_GAME_STATE_DOWNLOADING, _tmp6_, (GameHubUtilsDownloaderDownload*) dl);
#line 608 "../src/data/Runnable.vala"
		_tmp8_ = _tmp7_;
#line 608 "../src/data/Runnable.vala"
		game_hub_data_game_set_status (_tmp5_, _tmp8_);
#line 608 "../src/data/Runnable.vala"
		_game_hub_data_game_status_unref0 (_tmp8_);
#line 609 "../src/data/Runnable.vala"
		g_signal_connect_data ((GameHubUtilsDownloaderDownload*) dl, "status-change", (GCallback) ____lambda42__game_hub_utils_downloader_download_status_change, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 7203 "Runnable.c"
	}
}

static void
______lambda41__game_hub_utils_downloader_download_manager_file_download_started (GameHubUtilsDownloaderDownloadManager* _sender,
                                                                                  GameHubUtilsDownloaderFileDownload* download,
                                                                                  gpointer self)
{
#line 604 "../src/data/Runnable.vala"
	_____lambda41_ (self, download);
#line 7214 "Runnable.c"
}

static void
game_hub_data_runnable_downloadable_installer_download_ready (GObject* source_object,
                                                              GAsyncResult* _res_,
                                                              gpointer _user_data_)
{
	GameHubDataRunnableDownloadableInstallerDownloadData* _data_;
#line 623 "../src/data/Runnable.vala"
	_data_ = _user_data_;
#line 623 "../src/data/Runnable.vala"
	_data_->_source_object_ = source_object;
#line 623 "../src/data/Runnable.vala"
	_data_->_res_ = _res_;
#line 623 "../src/data/Runnable.vala"
	game_hub_data_runnable_downloadable_installer_download_co (_data_);
#line 7231 "Runnable.c"
}

static GNotification*
_______lambda44_ (Block8Data* _data8_,
                  GNotification* n)
{
	Block7Data* _data7_;
	Block6Data* _data6_;
	GameHubDataRunnableDownloadableInstaller* self;
	GThemedIcon* _tmp0_;
	GThemedIcon* _tmp1_;
	GameHubDataGame* _tmp2_;
	gchar* _tmp26_ = NULL;
	GameHubDataGame* _tmp27_;
	GVariant* args = NULL;
	GFile* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	GVariant* _tmp37_;
	GVariant* _tmp38_;
	GNotification* _tmp39_;
	GNotification* result = NULL;
#line 645 "../src/data/Runnable.vala"
	_data7_ = _data8_->_data7_;
#line 645 "../src/data/Runnable.vala"
	_data6_ = _data7_->_data6_;
#line 645 "../src/data/Runnable.vala"
	self = _data6_->self;
#line 645 "../src/data/Runnable.vala"
	g_return_val_if_fail (n != NULL, NULL);
#line 646 "../src/data/Runnable.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("dialog-warning");
#line 646 "../src/data/Runnable.vala"
	_tmp1_ = _tmp0_;
#line 646 "../src/data/Runnable.vala"
	g_notification_set_icon (n, (GIcon*) _tmp1_);
#line 646 "../src/data/Runnable.vala"
	_g_object_unref0 (_tmp1_);
#line 647 "../src/data/Runnable.vala"
	_tmp2_ = _data7_->game;
#line 647 "../src/data/Runnable.vala"
	if (_tmp2_ != NULL) {
#line 7274 "Runnable.c"
		GFile* icon = NULL;
		GameHubDataGame* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		GameHubDataGame* _tmp6_;
		GameHubDataGameSource* _tmp7_;
		GameHubDataGameSource* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		GameHubDataGame* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		GFile* _tmp18_;
		GFile* _tmp19_;
		gboolean _tmp20_ = FALSE;
		GFile* _tmp21_;
#line 649 "../src/data/Runnable.vala"
		_tmp3_ = _data7_->game;
#line 649 "../src/data/Runnable.vala"
		_tmp4_ = game_hub_data_game_get_icon (_tmp3_);
#line 649 "../src/data/Runnable.vala"
		_tmp5_ = _tmp4_;
#line 649 "../src/data/Runnable.vala"
		_tmp6_ = _data7_->game;
#line 649 "../src/data/Runnable.vala"
		_tmp7_ = game_hub_data_game_get_source (_tmp6_);
#line 649 "../src/data/Runnable.vala"
		_tmp8_ = _tmp7_;
#line 649 "../src/data/Runnable.vala"
		_tmp9_ = game_hub_data_game_source_get_id (_tmp8_);
#line 649 "../src/data/Runnable.vala"
		_tmp10_ = _tmp9_;
#line 649 "../src/data/Runnable.vala"
		_tmp11_ = string_to_string (_tmp10_);
#line 649 "../src/data/Runnable.vala"
		_tmp12_ = _data7_->game;
#line 649 "../src/data/Runnable.vala"
		_tmp13_ = game_hub_data_runnable_get_id ((GameHubDataRunnable*) _tmp12_);
#line 649 "../src/data/Runnable.vala"
		_tmp14_ = _tmp13_;
#line 649 "../src/data/Runnable.vala"
		_tmp15_ = string_to_string (_tmp14_);
#line 649 "../src/data/Runnable.vala"
		_tmp16_ = g_strconcat ("games/", _tmp11_, "/", _tmp15_, "/icons/", NULL);
#line 649 "../src/data/Runnable.vala"
		_tmp17_ = _tmp16_;
#line 649 "../src/data/Runnable.vala"
		_tmp18_ = game_hub_utils_image_cache_local_file (_tmp5_, _tmp17_);
#line 649 "../src/data/Runnable.vala"
		_tmp19_ = _tmp18_;
#line 649 "../src/data/Runnable.vala"
		_g_free0 (_tmp17_);
#line 649 "../src/data/Runnable.vala"
		icon = _tmp19_;
#line 650 "../src/data/Runnable.vala"
		_tmp21_ = icon;
#line 650 "../src/data/Runnable.vala"
		if (_tmp21_ != NULL) {
#line 7337 "Runnable.c"
			GFile* _tmp22_;
#line 650 "../src/data/Runnable.vala"
			_tmp22_ = icon;
#line 650 "../src/data/Runnable.vala"
			_tmp20_ = g_file_query_exists (_tmp22_, NULL);
#line 7343 "Runnable.c"
		} else {
#line 650 "../src/data/Runnable.vala"
			_tmp20_ = FALSE;
#line 7347 "Runnable.c"
		}
#line 650 "../src/data/Runnable.vala"
		if (_tmp20_) {
#line 7351 "Runnable.c"
			GFile* _tmp23_;
			GFileIcon* _tmp24_;
			GFileIcon* _tmp25_;
#line 652 "../src/data/Runnable.vala"
			_tmp23_ = icon;
#line 652 "../src/data/Runnable.vala"
			_tmp24_ = (GFileIcon*) g_file_icon_new (_tmp23_);
#line 652 "../src/data/Runnable.vala"
			_tmp25_ = _tmp24_;
#line 652 "../src/data/Runnable.vala"
			g_notification_set_icon (n, (GIcon*) _tmp25_);
#line 652 "../src/data/Runnable.vala"
			_g_object_unref0 (_tmp25_);
#line 7365 "Runnable.c"
		}
#line 647 "../src/data/Runnable.vala"
		_g_object_unref0 (icon);
#line 7369 "Runnable.c"
	}
#line 655 "../src/data/Runnable.vala"
	_tmp27_ = _data7_->game;
#line 655 "../src/data/Runnable.vala"
	if (_tmp27_ != NULL) {
#line 7375 "Runnable.c"
		GameHubDataGame* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
#line 655 "../src/data/Runnable.vala"
		_tmp28_ = _data7_->game;
#line 655 "../src/data/Runnable.vala"
		_tmp29_ = game_hub_data_game_get_full_id (_tmp28_);
#line 655 "../src/data/Runnable.vala"
		_tmp30_ = _tmp29_;
#line 655 "../src/data/Runnable.vala"
		_g_free0 (_tmp26_);
#line 655 "../src/data/Runnable.vala"
		_tmp26_ = _tmp30_;
#line 7389 "Runnable.c"
	} else {
		const gchar* _tmp31_;
		const gchar* _tmp32_;
		gchar* _tmp33_;
#line 655 "../src/data/Runnable.vala"
		_tmp31_ = game_hub_data_runnable_get_id (_data6_->runnable);
#line 655 "../src/data/Runnable.vala"
		_tmp32_ = _tmp31_;
#line 655 "../src/data/Runnable.vala"
		_tmp33_ = g_strdup (_tmp32_);
#line 655 "../src/data/Runnable.vala"
		_g_free0 (_tmp26_);
#line 655 "../src/data/Runnable.vala"
		_tmp26_ = _tmp33_;
#line 7404 "Runnable.c"
	}
#line 655 "../src/data/Runnable.vala"
	_tmp34_ = _data8_->file;
#line 655 "../src/data/Runnable.vala"
	_tmp35_ = g_file_get_path (_tmp34_);
#line 655 "../src/data/Runnable.vala"
	_tmp36_ = _tmp35_;
#line 655 "../src/data/Runnable.vala"
	_tmp37_ = g_variant_new ("(ss)", _tmp26_, _tmp36_, NULL);
#line 655 "../src/data/Runnable.vala"
	g_variant_ref_sink (_tmp37_);
#line 655 "../src/data/Runnable.vala"
	_tmp38_ = _tmp37_;
#line 655 "../src/data/Runnable.vala"
	_g_free0 (_tmp36_);
#line 655 "../src/data/Runnable.vala"
	args = _tmp38_;
#line 656 "../src/data/Runnable.vala"
	g_notification_set_default_action_and_target_value (n, GAME_HUB_APPLICATION_ACTION_PREFIX GAME_HUB_APPLICATION_ACTION_CORRUPTED_INSTALLER_PICK_ACTION, args);
#line 657 "../src/data/Runnable.vala"
	g_notification_add_button_with_target_value (n, _ ("Show file"), GAME_HUB_APPLICATION_ACTION_PREFIX GAME_HUB_APPLICATION_ACTION_CORRUPTED_INSTALLER_SHOW, args);
#line 658 "../src/data/Runnable.vala"
	g_notification_add_button_with_target_value (n, _ ("Remove"), GAME_HUB_APPLICATION_ACTION_PREFIX GAME_HUB_APPLICATION_ACTION_CORRUPTED_INSTALLER_REMOVE, args);
#line 659 "../src/data/Runnable.vala"
	g_notification_add_button_with_target_value (n, _ ("Backup"), GAME_HUB_APPLICATION_ACTION_PREFIX GAME_HUB_APPLICATION_ACTION_CORRUPTED_INSTALLER_BACKUP, args);
#line 660 "../src/data/Runnable.vala"
	_tmp39_ = _g_object_ref0 (n);
#line 660 "../src/data/Runnable.vala"
	result = _tmp39_;
#line 660 "../src/data/Runnable.vala"
	_g_variant_unref0 (args);
#line 660 "../src/data/Runnable.vala"
	_g_free0 (_tmp26_);
#line 660 "../src/data/Runnable.vala"
	return result;
#line 7440 "Runnable.c"
}

static GNotification*
________lambda44__game_hub_utils_notification_configure_delegate (GNotification* notification,
                                                                  gpointer self)
{
	GNotification* result;
	result = _______lambda44_ (self, notification);
#line 641 "../src/data/Runnable.vala"
	return result;
#line 7451 "Runnable.c"
}

static gboolean
game_hub_data_runnable_downloadable_installer_download_co (GameHubDataRunnableDownloadableInstallerDownloadData* _data_)
{
#line 582 "../src/data/Runnable.vala"
	switch (_data_->_state_) {
#line 582 "../src/data/Runnable.vala"
		case 0:
#line 7461 "Runnable.c"
		goto _state_0;
#line 582 "../src/data/Runnable.vala"
		case 1:
#line 7465 "Runnable.c"
		goto _state_1;
#line 582 "../src/data/Runnable.vala"
		case 2:
#line 7469 "Runnable.c"
		goto _state_2;
		default:
#line 582 "../src/data/Runnable.vala"
		g_assert_not_reached ();
#line 7474 "Runnable.c"
	}
	_state_0:
#line 582 "../src/data/Runnable.vala"
	_data_->_data6_ = g_slice_new0 (Block6Data);
#line 582 "../src/data/Runnable.vala"
	_data_->_data6_->_ref_count_ = 1;
#line 582 "../src/data/Runnable.vala"
	_data_->_data6_->self = game_hub_data_runnable_installer_ref (_data_->self);
#line 582 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->_data6_->runnable);
#line 582 "../src/data/Runnable.vala"
	_data_->_data6_->runnable = _data_->runnable;
#line 582 "../src/data/Runnable.vala"
	_data_->_data6_->_async_data_ = _data_;
#line 584 "../src/data/Runnable.vala"
	_data_->_tmp0_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 584 "../src/data/Runnable.vala"
	_data_->files = _data_->_tmp0_;
#line 7493 "Runnable.c"
	{
#line 585 "../src/data/Runnable.vala"
		_data_->_data7_ = g_slice_new0 (Block7Data);
#line 585 "../src/data/Runnable.vala"
		_data_->_data7_->_ref_count_ = 1;
#line 585 "../src/data/Runnable.vala"
		_data_->_data7_->_data6_ = block6_data_ref (_data_->_data6_);
#line 587 "../src/data/Runnable.vala"
		_data_->_data7_->game = NULL;
#line 588 "../src/data/Runnable.vala"
		if (GAME_HUB_DATA_IS_GAME (_data_->_data6_->runnable)) {
#line 590 "../src/data/Runnable.vala"
			_data_->_tmp1_ = _g_object_ref0 (GAME_HUB_DATA_IS_GAME (_data_->_data6_->runnable) ? ((GameHubDataGame*) _data_->_data6_->runnable) : NULL);
#line 590 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->_data7_->game);
#line 590 "../src/data/Runnable.vala"
			_data_->_data7_->game = _data_->_tmp1_;
#line 7511 "Runnable.c"
		}
#line 593 "../src/data/Runnable.vala"
		_data_->_tmp2_ = _data_->_data7_->game;
#line 593 "../src/data/Runnable.vala"
		if (_data_->_tmp2_ != NULL) {
#line 593 "../src/data/Runnable.vala"
			_data_->_tmp3_ = _data_->_data7_->game;
#line 593 "../src/data/Runnable.vala"
			_data_->_tmp4_ = _data_->_data7_->game;
#line 593 "../src/data/Runnable.vala"
			_data_->_tmp5_ = game_hub_data_game_status_new (GAME_HUB_DATA_GAME_STATE_DOWNLOADING, _data_->_tmp4_, NULL);
#line 593 "../src/data/Runnable.vala"
			_data_->_tmp6_ = _data_->_tmp5_;
#line 593 "../src/data/Runnable.vala"
			game_hub_data_game_set_status (_data_->_tmp3_, _data_->_tmp6_);
#line 593 "../src/data/Runnable.vala"
			_game_hub_data_game_status_unref0 (_data_->_tmp6_);
#line 7529 "Runnable.c"
		}
#line 595 "../src/data/Runnable.vala"
		_data_->_tmp8_ = game_hub_data_runnable_get_install_dir (_data_->_data6_->runnable);
#line 595 "../src/data/Runnable.vala"
		_data_->_tmp9_ = _data_->_tmp8_;
#line 595 "../src/data/Runnable.vala"
		_data_->_tmp10_ = _g_object_ref0 (_data_->_tmp9_);
#line 595 "../src/data/Runnable.vala"
		_data_->_tmp7_ = _data_->_tmp10_;
#line 595 "../src/data/Runnable.vala"
		if (_data_->_tmp7_ == NULL) {
#line 595 "../src/data/Runnable.vala"
			_data_->_tmp11_ = game_hub_data_runnable_get_default_install_dir (_data_->_data6_->runnable);
#line 595 "../src/data/Runnable.vala"
			_data_->_tmp12_ = _data_->_tmp11_;
#line 595 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->_tmp7_);
#line 595 "../src/data/Runnable.vala"
			_data_->_tmp7_ = _data_->_tmp12_;
#line 7549 "Runnable.c"
		}
#line 595 "../src/data/Runnable.vala"
		_data_->_tmp13_ = _g_object_ref0 (_data_->_tmp7_);
#line 595 "../src/data/Runnable.vala"
		_data_->runnable_install_dir = _data_->_tmp13_;
#line 596 "../src/data/Runnable.vala"
		_data_->_tmp14_ = _data_->runnable_install_dir;
#line 596 "../src/data/Runnable.vala"
		if (_data_->_tmp14_ == NULL) {
#line 596 "../src/data/Runnable.vala"
			_data_->result = _data_->files;
#line 596 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->runnable_install_dir);
#line 596 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->_tmp7_);
#line 596 "../src/data/Runnable.vala"
			block7_data_unref (_data_->_data7_);
#line 596 "../src/data/Runnable.vala"
			_data_->_data7_ = NULL;
#line 596 "../src/data/Runnable.vala"
			block6_data_unref (_data_->_data6_);
#line 596 "../src/data/Runnable.vala"
			_data_->_data6_ = NULL;
#line 596 "../src/data/Runnable.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 596 "../src/data/Runnable.vala"
			if (_data_->_state_ != 0) {
#line 596 "../src/data/Runnable.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 596 "../src/data/Runnable.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 7581 "Runnable.c"
				}
			}
#line 596 "../src/data/Runnable.vala"
			g_object_unref (_data_->_async_result);
#line 596 "../src/data/Runnable.vala"
			return FALSE;
#line 7588 "Runnable.c"
		}
#line 597 "../src/data/Runnable.vala"
		_data_->_tmp15_ = _data_->runnable_install_dir;
#line 597 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_install_dir (_data_->_data6_->runnable, _data_->_tmp15_);
#line 599 "../src/data/Runnable.vala"
		_data_->p = (guint) 1;
#line 7596 "Runnable.c"
		{
#line 600 "../src/data/Runnable.vala"
			_data_->_tmp16_ = _data_->self->priv->_parts;
#line 600 "../src/data/Runnable.vala"
			_data_->_tmp17_ = _g_object_ref0 (_data_->_tmp16_);
#line 600 "../src/data/Runnable.vala"
			_data_->_part_list = _data_->_tmp17_;
#line 600 "../src/data/Runnable.vala"
			_data_->_tmp18_ = _data_->_part_list;
#line 600 "../src/data/Runnable.vala"
			_data_->_tmp19_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp18_);
#line 600 "../src/data/Runnable.vala"
			_data_->_tmp20_ = _data_->_tmp19_;
#line 600 "../src/data/Runnable.vala"
			_data_->_part_size = _data_->_tmp20_;
#line 600 "../src/data/Runnable.vala"
			_data_->_part_index = -1;
#line 600 "../src/data/Runnable.vala"
			while (TRUE) {
#line 600 "../src/data/Runnable.vala"
				_data_->_data8_ = g_slice_new0 (Block8Data);
#line 600 "../src/data/Runnable.vala"
				_data_->_data8_->_ref_count_ = 1;
#line 600 "../src/data/Runnable.vala"
				_data_->_data8_->_data7_ = block7_data_ref (_data_->_data7_);
#line 600 "../src/data/Runnable.vala"
				_data_->_part_index = _data_->_part_index + 1;
#line 600 "../src/data/Runnable.vala"
				if (!(_data_->_part_index < _data_->_part_size)) {
#line 600 "../src/data/Runnable.vala"
					block8_data_unref (_data_->_data8_);
#line 600 "../src/data/Runnable.vala"
					_data_->_data8_ = NULL;
#line 600 "../src/data/Runnable.vala"
					break;
#line 7632 "Runnable.c"
				}
#line 600 "../src/data/Runnable.vala"
				_data_->_tmp21_ = _data_->_part_list;
#line 600 "../src/data/Runnable.vala"
				_data_->_tmp22_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp21_, _data_->_part_index);
#line 600 "../src/data/Runnable.vala"
				_data_->_data8_->part = (GameHubDataRunnableDownloadableInstallerPart*) _data_->_tmp22_;
#line 602 "../src/data/Runnable.vala"
				_data_->_tmp23_ = _data_->_data8_->part;
#line 602 "../src/data/Runnable.vala"
				_data_->_tmp24_ = game_hub_data_runnable_downloadable_installer_part_get_local (_data_->_tmp23_);
#line 602 "../src/data/Runnable.vala"
				_data_->_tmp25_ = _data_->_tmp24_;
#line 602 "../src/data/Runnable.vala"
				_data_->_tmp26_ = g_file_get_parent (_data_->_tmp25_);
#line 602 "../src/data/Runnable.vala"
				_data_->_tmp27_ = _data_->_tmp26_;
#line 602 "../src/data/Runnable.vala"
				_data_->_tmp28_ = g_file_get_path (_data_->_tmp27_);
#line 602 "../src/data/Runnable.vala"
				_data_->_tmp29_ = _data_->_tmp28_;
#line 602 "../src/data/Runnable.vala"
				_data_->_tmp30_ = game_hub_utils_fs_utils_mkdir (_data_->_tmp29_, NULL, NULL);
#line 602 "../src/data/Runnable.vala"
				_data_->_tmp31_ = _data_->_tmp30_;
#line 602 "../src/data/Runnable.vala"
				_g_object_unref0 (_data_->_tmp31_);
#line 602 "../src/data/Runnable.vala"
				_g_free0 (_data_->_tmp29_);
#line 602 "../src/data/Runnable.vala"
				_g_object_unref0 (_data_->_tmp27_);
#line 604 "../src/data/Runnable.vala"
				_data_->_tmp32_ = game_hub_utils_downloader_download_manager ();
#line 604 "../src/data/Runnable.vala"
				_data_->_tmp33_ = _data_->_tmp32_;
#line 604 "../src/data/Runnable.vala"
				_data_->_tmp34_ = g_signal_connect_data (_data_->_tmp33_, "file-download-started", (GCallback) ______lambda41__game_hub_utils_downloader_download_manager_file_download_started, block8_data_ref (_data_->_data8_), (GClosureNotify) block8_data_unref, 0);
#line 604 "../src/data/Runnable.vala"
				_data_->_tmp35_ = _data_->_tmp34_;
#line 604 "../src/data/Runnable.vala"
				_g_object_unref0 (_data_->_tmp33_);
#line 604 "../src/data/Runnable.vala"
				_data_->ds_id = _data_->_tmp35_;
#line 615 "../src/data/Runnable.vala"
				_data_->_tmp36_ = _data_->_data8_->part;
#line 615 "../src/data/Runnable.vala"
				_data_->_tmp37_ = game_hub_data_runnable_downloadable_installer_part_get_id (_data_->_tmp36_);
#line 615 "../src/data/Runnable.vala"
				_data_->_tmp38_ = _data_->_tmp37_;
#line 615 "../src/data/Runnable.vala"
				_data_->_tmp39_ = g_strdup (_data_->_tmp38_);
#line 615 "../src/data/Runnable.vala"
				_data_->partDesc = _data_->_tmp39_;
#line 617 "../src/data/Runnable.vala"
				_data_->_tmp40_ = _data_->self->priv->_parts;
#line 617 "../src/data/Runnable.vala"
				_data_->_tmp41_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp40_);
#line 617 "../src/data/Runnable.vala"
				_data_->_tmp42_ = _data_->_tmp41_;
#line 617 "../src/data/Runnable.vala"
				if (_data_->_tmp42_ > 1) {
#line 619 "../src/data/Runnable.vala"
					_data_->_tmp43_ = _data_->self->priv->_parts;
#line 619 "../src/data/Runnable.vala"
					_data_->_tmp44_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp43_);
#line 619 "../src/data/Runnable.vala"
					_data_->_tmp45_ = _data_->_tmp44_;
#line 619 "../src/data/Runnable.vala"
					_data_->_tmp46_ = _data_->_data8_->part;
#line 619 "../src/data/Runnable.vala"
					_data_->_tmp47_ = game_hub_data_runnable_downloadable_installer_part_get_id (_data_->_tmp46_);
#line 619 "../src/data/Runnable.vala"
					_data_->_tmp48_ = _data_->_tmp47_;
#line 619 "../src/data/Runnable.vala"
					_data_->_tmp49_ = g_strdup_printf (_ ("Part %1$u of %2$u: %3$s"), _data_->p, _data_->_tmp45_, _data_->_tmp48_);
#line 619 "../src/data/Runnable.vala"
					_g_free0 (_data_->partDesc);
#line 619 "../src/data/Runnable.vala"
					_data_->partDesc = _data_->_tmp49_;
#line 7712 "Runnable.c"
				}
#line 622 "../src/data/Runnable.vala"
				_data_->_tmp51_ = _data_->_data7_->game;
#line 622 "../src/data/Runnable.vala"
				if (_data_->_tmp51_ != NULL) {
#line 622 "../src/data/Runnable.vala"
					_data_->_tmp52_ = _data_->_data7_->game;
#line 622 "../src/data/Runnable.vala"
					_data_->_tmp53_ = game_hub_data_game_get_icon (_data_->_tmp52_);
#line 622 "../src/data/Runnable.vala"
					_data_->_tmp54_ = _data_->_tmp53_;
#line 622 "../src/data/Runnable.vala"
					_data_->_tmp50_ = _data_->_tmp54_;
#line 7726 "Runnable.c"
				} else {
#line 622 "../src/data/Runnable.vala"
					_data_->_tmp50_ = NULL;
#line 7730 "Runnable.c"
				}
#line 622 "../src/data/Runnable.vala"
				_data_->_tmp56_ = _data_->_data7_->game;
#line 622 "../src/data/Runnable.vala"
				if (_data_->_tmp56_ != NULL) {
#line 622 "../src/data/Runnable.vala"
					_data_->_tmp57_ = _data_->_data7_->game;
#line 622 "../src/data/Runnable.vala"
					_data_->_tmp58_ = game_hub_data_game_get_source (_data_->_tmp57_);
#line 622 "../src/data/Runnable.vala"
					_data_->_tmp59_ = _data_->_tmp58_;
#line 622 "../src/data/Runnable.vala"
					_data_->_tmp60_ = game_hub_data_game_source_get_icon (_data_->_tmp59_);
#line 622 "../src/data/Runnable.vala"
					_data_->_tmp61_ = _data_->_tmp60_;
#line 622 "../src/data/Runnable.vala"
					_data_->_tmp55_ = _data_->_tmp61_;
#line 7748 "Runnable.c"
				} else {
#line 622 "../src/data/Runnable.vala"
					_data_->_tmp55_ = NULL;
#line 7752 "Runnable.c"
				}
#line 622 "../src/data/Runnable.vala"
				_data_->_tmp62_ = game_hub_data_runnable_get_name (_data_->_data6_->runnable);
#line 622 "../src/data/Runnable.vala"
				_data_->_tmp63_ = _data_->_tmp62_;
#line 622 "../src/data/Runnable.vala"
				_data_->_tmp64_ = _data_->partDesc;
#line 622 "../src/data/Runnable.vala"
				_data_->_tmp65_ = game_hub_utils_downloader_download_info_new (_data_->_tmp63_, _data_->_tmp64_, _data_->_tmp50_, NULL, NULL, _data_->_tmp55_);
#line 622 "../src/data/Runnable.vala"
				_data_->info = _data_->_tmp65_;
#line 623 "../src/data/Runnable.vala"
				_data_->_tmp66_ = _data_->_data8_->part;
#line 623 "../src/data/Runnable.vala"
				_data_->_tmp67_ = game_hub_data_runnable_downloadable_installer_part_get_remote (_data_->_tmp66_);
#line 623 "../src/data/Runnable.vala"
				_data_->_tmp68_ = _data_->_tmp67_;
#line 623 "../src/data/Runnable.vala"
				_data_->_tmp69_ = _data_->_data8_->part;
#line 623 "../src/data/Runnable.vala"
				_data_->_tmp70_ = game_hub_data_runnable_downloadable_installer_part_get_local (_data_->_tmp69_);
#line 623 "../src/data/Runnable.vala"
				_data_->_tmp71_ = _data_->_tmp70_;
#line 623 "../src/data/Runnable.vala"
				_data_->_tmp72_ = _data_->info;
#line 623 "../src/data/Runnable.vala"
				_data_->_state_ = 1;
#line 623 "../src/data/Runnable.vala"
				game_hub_utils_downloader_download_file (_data_->_tmp68_, _data_->_tmp71_, _data_->_tmp72_, TRUE, TRUE, game_hub_data_runnable_downloadable_installer_download_ready, _data_);
#line 623 "../src/data/Runnable.vala"
				return FALSE;
#line 7784 "Runnable.c"
				_state_1:
#line 623 "../src/data/Runnable.vala"
				_data_->_tmp73_ = game_hub_utils_downloader_download_file_finish (_data_->_res_, &_data_->_inner_error0_);
#line 623 "../src/data/Runnable.vala"
				_data_->_data8_->file = _data_->_tmp73_;
#line 623 "../src/data/Runnable.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 623 "../src/data/Runnable.vala"
					_g_object_unref0 (_data_->info);
#line 623 "../src/data/Runnable.vala"
					_g_free0 (_data_->partDesc);
#line 623 "../src/data/Runnable.vala"
					block8_data_unref (_data_->_data8_);
#line 623 "../src/data/Runnable.vala"
					_data_->_data8_ = NULL;
#line 623 "../src/data/Runnable.vala"
					_g_object_unref0 (_data_->_part_list);
#line 623 "../src/data/Runnable.vala"
					_g_object_unref0 (_data_->runnable_install_dir);
#line 623 "../src/data/Runnable.vala"
					_g_object_unref0 (_data_->_tmp7_);
#line 623 "../src/data/Runnable.vala"
					block7_data_unref (_data_->_data7_);
#line 623 "../src/data/Runnable.vala"
					_data_->_data7_ = NULL;
#line 623 "../src/data/Runnable.vala"
					if (g_error_matches (_data_->_inner_error0_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 7812 "Runnable.c"
						goto __catch7_g_io_error_cancelled;
					}
					goto __catch7_g_error;
				}
#line 624 "../src/data/Runnable.vala"
				_data_->_tmp75_ = _data_->_data8_->file;
#line 624 "../src/data/Runnable.vala"
				if (_data_->_tmp75_ != NULL) {
#line 624 "../src/data/Runnable.vala"
					_data_->_tmp76_ = _data_->_data8_->file;
#line 624 "../src/data/Runnable.vala"
					_data_->_tmp74_ = g_file_query_exists (_data_->_tmp76_, NULL);
#line 7825 "Runnable.c"
				} else {
#line 624 "../src/data/Runnable.vala"
					_data_->_tmp74_ = FALSE;
#line 7829 "Runnable.c"
				}
#line 624 "../src/data/Runnable.vala"
				if (_data_->_tmp74_) {
#line 626 "../src/data/Runnable.vala"
					_data_->file_checksum = NULL;
#line 627 "../src/data/Runnable.vala"
					_data_->_tmp77_ = _data_->_data8_->part;
#line 627 "../src/data/Runnable.vala"
					_data_->_tmp78_ = game_hub_data_runnable_downloadable_installer_part_get_checksum (_data_->_tmp77_);
#line 627 "../src/data/Runnable.vala"
					_data_->_tmp79_ = _data_->_tmp78_;
#line 627 "../src/data/Runnable.vala"
					if (_data_->_tmp79_ != NULL) {
#line 629 "../src/data/Runnable.vala"
						_data_->_tmp80_ = _data_->_data8_->file;
#line 629 "../src/data/Runnable.vala"
						_data_->_tmp81_ = g_file_get_path (_data_->_tmp80_);
#line 629 "../src/data/Runnable.vala"
						_data_->_tmp82_ = _data_->_tmp81_;
#line 629 "../src/data/Runnable.vala"
						_data_->_tmp83_ = g_strconcat (_data_->_tmp82_, ".", NULL);
#line 629 "../src/data/Runnable.vala"
						_data_->_tmp84_ = _data_->_tmp83_;
#line 629 "../src/data/Runnable.vala"
						_data_->_tmp85_ = _data_->_data8_->part;
#line 629 "../src/data/Runnable.vala"
						_data_->_tmp86_ = game_hub_data_runnable_downloadable_installer_part_get_checksum_type_string (_data_->_tmp85_);
#line 629 "../src/data/Runnable.vala"
						_data_->_tmp87_ = _data_->_tmp86_;
#line 629 "../src/data/Runnable.vala"
						_data_->_tmp88_ = g_strconcat (_data_->_tmp84_, _data_->_tmp87_, NULL);
#line 629 "../src/data/Runnable.vala"
						_data_->_tmp89_ = _data_->_tmp88_;
#line 629 "../src/data/Runnable.vala"
						_data_->_tmp90_ = _data_->_data8_->part;
#line 629 "../src/data/Runnable.vala"
						_data_->_tmp91_ = game_hub_data_runnable_downloadable_installer_part_get_checksum (_data_->_tmp90_);
#line 629 "../src/data/Runnable.vala"
						_data_->_tmp92_ = _data_->_tmp91_;
#line 629 "../src/data/Runnable.vala"
						g_file_set_contents (_data_->_tmp89_, _data_->_tmp92_, (gssize) -1, &_data_->_inner_error0_);
#line 629 "../src/data/Runnable.vala"
						_g_free0 (_data_->_tmp89_);
#line 629 "../src/data/Runnable.vala"
						_g_free0 (_data_->_tmp84_);
#line 629 "../src/data/Runnable.vala"
						_g_free0 (_data_->_tmp82_);
#line 629 "../src/data/Runnable.vala"
						if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 629 "../src/data/Runnable.vala"
							_g_free0 (_data_->file_checksum);
#line 629 "../src/data/Runnable.vala"
							_g_object_unref0 (_data_->info);
#line 629 "../src/data/Runnable.vala"
							_g_free0 (_data_->partDesc);
#line 629 "../src/data/Runnable.vala"
							block8_data_unref (_data_->_data8_);
#line 629 "../src/data/Runnable.vala"
							_data_->_data8_ = NULL;
#line 629 "../src/data/Runnable.vala"
							_g_object_unref0 (_data_->_part_list);
#line 629 "../src/data/Runnable.vala"
							_g_object_unref0 (_data_->runnable_install_dir);
#line 629 "../src/data/Runnable.vala"
							_g_object_unref0 (_data_->_tmp7_);
#line 629 "../src/data/Runnable.vala"
							block7_data_unref (_data_->_data7_);
#line 629 "../src/data/Runnable.vala"
							_data_->_data7_ = NULL;
#line 629 "../src/data/Runnable.vala"
							if (g_error_matches (_data_->_inner_error0_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 7901 "Runnable.c"
								goto __catch7_g_io_error_cancelled;
							}
							goto __catch7_g_error;
						}
#line 630 "../src/data/Runnable.vala"
						_data_->_tmp93_ = _data_->_data7_->game;
#line 630 "../src/data/Runnable.vala"
						if (_data_->_tmp93_ != NULL) {
#line 630 "../src/data/Runnable.vala"
							_data_->_tmp94_ = _data_->_data7_->game;
#line 630 "../src/data/Runnable.vala"
							_data_->_tmp95_ = _data_->_data7_->game;
#line 630 "../src/data/Runnable.vala"
							_data_->_tmp96_ = game_hub_data_game_status_new (GAME_HUB_DATA_GAME_STATE_VERIFYING_INSTALLER_INTEGRITY, _data_->_tmp95_, NULL);
#line 630 "../src/data/Runnable.vala"
							_data_->_tmp97_ = _data_->_tmp96_;
#line 630 "../src/data/Runnable.vala"
							game_hub_data_game_set_status (_data_->_tmp94_, _data_->_tmp97_);
#line 630 "../src/data/Runnable.vala"
							_game_hub_data_game_status_unref0 (_data_->_tmp97_);
#line 7922 "Runnable.c"
						}
#line 631 "../src/data/Runnable.vala"
						_data_->_tmp98_ = _data_->_data8_->file;
#line 631 "../src/data/Runnable.vala"
						_data_->_tmp99_ = _data_->_data8_->part;
#line 631 "../src/data/Runnable.vala"
						_data_->_tmp100_ = game_hub_data_runnable_downloadable_installer_part_get_checksum_type (_data_->_tmp99_);
#line 631 "../src/data/Runnable.vala"
						_data_->_tmp101_ = _data_->_tmp100_;
#line 631 "../src/data/Runnable.vala"
						_data_->_state_ = 2;
#line 631 "../src/data/Runnable.vala"
						game_hub_utils_compute_file_checksum (_data_->_tmp98_, _data_->_tmp101_, game_hub_data_runnable_downloadable_installer_download_ready, _data_);
#line 631 "../src/data/Runnable.vala"
						return FALSE;
#line 7938 "Runnable.c"
						_state_2:
#line 631 "../src/data/Runnable.vala"
						_data_->_tmp102_ = game_hub_utils_compute_file_checksum_finish (_data_->_res_);
#line 631 "../src/data/Runnable.vala"
						_g_free0 (_data_->file_checksum);
#line 631 "../src/data/Runnable.vala"
						_data_->file_checksum = _data_->_tmp102_;
#line 632 "../src/data/Runnable.vala"
						_data_->_tmp103_ = _data_->_data7_->game;
#line 632 "../src/data/Runnable.vala"
						if (_data_->_tmp103_ != NULL) {
#line 632 "../src/data/Runnable.vala"
							_data_->_tmp104_ = _data_->_data7_->game;
#line 632 "../src/data/Runnable.vala"
							_data_->_tmp105_ = _data_->_data7_->game;
#line 632 "../src/data/Runnable.vala"
							_data_->_tmp106_ = game_hub_data_game_status_new (GAME_HUB_DATA_GAME_STATE_DOWNLOADING, _data_->_tmp105_, NULL);
#line 632 "../src/data/Runnable.vala"
							_data_->_tmp107_ = _data_->_tmp106_;
#line 632 "../src/data/Runnable.vala"
							game_hub_data_game_set_status (_data_->_tmp104_, _data_->_tmp107_);
#line 632 "../src/data/Runnable.vala"
							_game_hub_data_game_status_unref0 (_data_->_tmp107_);
#line 7962 "Runnable.c"
						}
					}
#line 635 "../src/data/Runnable.vala"
					_data_->_tmp110_ = _data_->_data8_->part;
#line 635 "../src/data/Runnable.vala"
					_data_->_tmp111_ = game_hub_data_runnable_downloadable_installer_part_get_checksum (_data_->_tmp110_);
#line 635 "../src/data/Runnable.vala"
					_data_->_tmp112_ = _data_->_tmp111_;
#line 635 "../src/data/Runnable.vala"
					if (_data_->_tmp112_ == NULL) {
#line 635 "../src/data/Runnable.vala"
						_data_->_tmp109_ = TRUE;
#line 7975 "Runnable.c"
					} else {
#line 635 "../src/data/Runnable.vala"
						_data_->_tmp113_ = _data_->file_checksum;
#line 635 "../src/data/Runnable.vala"
						_data_->_tmp109_ = _data_->_tmp113_ == NULL;
#line 7981 "Runnable.c"
					}
#line 635 "../src/data/Runnable.vala"
					if (_data_->_tmp109_) {
#line 635 "../src/data/Runnable.vala"
						_data_->_tmp108_ = TRUE;
#line 7987 "Runnable.c"
					} else {
#line 635 "../src/data/Runnable.vala"
						_data_->_tmp114_ = _data_->_data8_->part;
#line 635 "../src/data/Runnable.vala"
						_data_->_tmp115_ = game_hub_data_runnable_downloadable_installer_part_get_checksum (_data_->_tmp114_);
#line 635 "../src/data/Runnable.vala"
						_data_->_tmp116_ = _data_->_tmp115_;
#line 635 "../src/data/Runnable.vala"
						_data_->_tmp117_ = _data_->file_checksum;
#line 635 "../src/data/Runnable.vala"
						_data_->_tmp108_ = g_strcmp0 (_data_->_tmp116_, _data_->_tmp117_) == 0;
#line 7999 "Runnable.c"
					}
#line 635 "../src/data/Runnable.vala"
					if (_data_->_tmp108_) {
#line 637 "../src/data/Runnable.vala"
						_data_->_tmp118_ = _data_->files;
#line 637 "../src/data/Runnable.vala"
						_data_->_tmp119_ = _data_->_data8_->file;
#line 637 "../src/data/Runnable.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp118_, _data_->_tmp119_);
#line 8009 "Runnable.c"
					} else {
#line 641 "../src/data/Runnable.vala"
						_data_->_tmp120_ = game_hub_data_runnable_get_name (_data_->_data6_->runnable);
#line 641 "../src/data/Runnable.vala"
						_data_->_tmp121_ = _data_->_tmp120_;
#line 641 "../src/data/Runnable.vala"
						_data_->_tmp122_ = g_strdup_printf (_ ("%s: corrupted installer"), _data_->_tmp121_);
#line 641 "../src/data/Runnable.vala"
						_data_->_tmp123_ = _data_->_tmp122_;
#line 641 "../src/data/Runnable.vala"
						_data_->_tmp124_ = _data_->_data8_->file;
#line 641 "../src/data/Runnable.vala"
						_data_->_tmp125_ = g_file_get_basename (_data_->_tmp124_);
#line 641 "../src/data/Runnable.vala"
						_data_->_tmp126_ = _data_->_tmp125_;
#line 641 "../src/data/Runnable.vala"
						_data_->_tmp127_ = g_strdup_printf (_ ("Checksum mismatch in %s"), _data_->_tmp126_);
#line 641 "../src/data/Runnable.vala"
						_data_->_tmp128_ = _data_->_tmp127_;
#line 641 "../src/data/Runnable.vala"
						game_hub_utils_notify (_data_->_tmp123_, _data_->_tmp128_, G_NOTIFICATION_PRIORITY_HIGH, ________lambda44__game_hub_utils_notification_configure_delegate, _data_->_data8_);
#line 641 "../src/data/Runnable.vala"
						_g_free0 (_data_->_tmp128_);
#line 641 "../src/data/Runnable.vala"
						_g_free0 (_data_->_tmp126_);
#line 641 "../src/data/Runnable.vala"
						_g_free0 (_data_->_tmp123_);
#line 664 "../src/data/Runnable.vala"
						_data_->_tmp129_ = _data_->_data8_->file;
#line 664 "../src/data/Runnable.vala"
						_data_->_tmp130_ = g_file_get_basename (_data_->_tmp129_);
#line 664 "../src/data/Runnable.vala"
						_data_->_tmp131_ = _data_->_tmp130_;
#line 664 "../src/data/Runnable.vala"
						_data_->_tmp132_ = _data_->_data8_->part;
#line 664 "../src/data/Runnable.vala"
						_data_->_tmp133_ = game_hub_data_runnable_downloadable_installer_part_get_checksum (_data_->_tmp132_);
#line 664 "../src/data/Runnable.vala"
						_data_->_tmp134_ = _data_->_tmp133_;
#line 664 "../src/data/Runnable.vala"
						_data_->_tmp135_ = _data_->file_checksum;
#line 664 "../src/data/Runnable.vala"
						g_warning ("Runnable.vala:664: Checksum mismatch in `%s`, skipping; expected: `%s`" \
", actual: `%s`", _data_->_tmp131_, _data_->_tmp134_, _data_->_tmp135_);
#line 664 "../src/data/Runnable.vala"
						_g_free0 (_data_->_tmp131_);
#line 8055 "Runnable.c"
					}
#line 624 "../src/data/Runnable.vala"
					_g_free0 (_data_->file_checksum);
#line 8059 "Runnable.c"
				}
#line 667 "../src/data/Runnable.vala"
				_data_->_tmp136_ = game_hub_utils_downloader_download_manager ();
#line 667 "../src/data/Runnable.vala"
				_data_->_tmp137_ = _data_->_tmp136_;
#line 667 "../src/data/Runnable.vala"
				g_signal_handler_disconnect ((GObject*) _data_->_tmp137_, _data_->ds_id);
#line 667 "../src/data/Runnable.vala"
				_g_object_unref0 (_data_->_tmp137_);
#line 669 "../src/data/Runnable.vala"
				_data_->_tmp138_ = _data_->p;
#line 669 "../src/data/Runnable.vala"
				_data_->p = _data_->_tmp138_ + 1;
#line 600 "../src/data/Runnable.vala"
				_g_object_unref0 (_data_->info);
#line 600 "../src/data/Runnable.vala"
				_g_free0 (_data_->partDesc);
#line 600 "../src/data/Runnable.vala"
				block8_data_unref (_data_->_data8_);
#line 600 "../src/data/Runnable.vala"
				_data_->_data8_ = NULL;
#line 8081 "Runnable.c"
			}
#line 600 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->_part_list);
#line 8085 "Runnable.c"
		}
#line 672 "../src/data/Runnable.vala"
		_data_->_tmp139_ = _data_->_data7_->game;
#line 672 "../src/data/Runnable.vala"
		if (_data_->_tmp139_ != NULL) {
#line 672 "../src/data/Runnable.vala"
			_data_->_tmp140_ = _data_->_data7_->game;
#line 672 "../src/data/Runnable.vala"
			_data_->_tmp141_ = _data_->_data7_->game;
#line 672 "../src/data/Runnable.vala"
			_data_->_tmp142_ = game_hub_data_game_status_new (GAME_HUB_DATA_GAME_STATE_UNINSTALLED, _data_->_tmp141_, NULL);
#line 672 "../src/data/Runnable.vala"
			_data_->_tmp143_ = _data_->_tmp142_;
#line 672 "../src/data/Runnable.vala"
			game_hub_data_game_set_status (_data_->_tmp140_, _data_->_tmp143_);
#line 672 "../src/data/Runnable.vala"
			_game_hub_data_game_status_unref0 (_data_->_tmp143_);
#line 8103 "Runnable.c"
		}
#line 673 "../src/data/Runnable.vala"
		game_hub_data_runnable_update_status (_data_->_data6_->runnable);
#line 585 "../src/data/Runnable.vala"
		_g_object_unref0 (_data_->runnable_install_dir);
#line 585 "../src/data/Runnable.vala"
		_g_object_unref0 (_data_->_tmp7_);
#line 585 "../src/data/Runnable.vala"
		block7_data_unref (_data_->_data7_);
#line 585 "../src/data/Runnable.vala"
		_data_->_data7_ = NULL;
#line 8115 "Runnable.c"
	}
	goto __finally7;
	__catch7_g_io_error_cancelled:
	{
#line 585 "../src/data/Runnable.vala"
		_data_->e = _data_->_inner_error0_;
#line 585 "../src/data/Runnable.vala"
		_data_->_inner_error0_ = NULL;
#line 585 "../src/data/Runnable.vala"
		_g_error_free0 (_data_->e);
#line 8126 "Runnable.c"
	}
	goto __finally7;
	__catch7_g_error:
	{
#line 585 "../src/data/Runnable.vala"
		_data_->_vala1_e = _data_->_inner_error0_;
#line 585 "../src/data/Runnable.vala"
		_data_->_inner_error0_ = NULL;
#line 678 "../src/data/Runnable.vala"
		_data_->_tmp144_ = _data_->_vala1_e;
#line 678 "../src/data/Runnable.vala"
		_data_->_tmp145_ = _data_->_tmp144_->message;
#line 678 "../src/data/Runnable.vala"
		g_warning ("Runnable.vala:678: [DownloadableInstaller.download] %s", _data_->_tmp145_);
#line 585 "../src/data/Runnable.vala"
		_g_error_free0 (_data_->_vala1_e);
#line 8143 "Runnable.c"
	}
	__finally7:
#line 585 "../src/data/Runnable.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 585 "../src/data/Runnable.vala"
		_g_object_unref0 (_data_->files);
#line 585 "../src/data/Runnable.vala"
		block6_data_unref (_data_->_data6_);
#line 585 "../src/data/Runnable.vala"
		_data_->_data6_ = NULL;
#line 585 "../src/data/Runnable.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 585 "../src/data/Runnable.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 585 "../src/data/Runnable.vala"
		g_object_unref (_data_->_async_result);
#line 585 "../src/data/Runnable.vala"
		return FALSE;
#line 8162 "Runnable.c"
	}
#line 680 "../src/data/Runnable.vala"
	_data_->result = _data_->files;
#line 680 "../src/data/Runnable.vala"
	block6_data_unref (_data_->_data6_);
#line 680 "../src/data/Runnable.vala"
	_data_->_data6_ = NULL;
#line 680 "../src/data/Runnable.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 680 "../src/data/Runnable.vala"
	if (_data_->_state_ != 0) {
#line 680 "../src/data/Runnable.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 680 "../src/data/Runnable.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8178 "Runnable.c"
		}
	}
#line 680 "../src/data/Runnable.vala"
	g_object_unref (_data_->_async_result);
#line 680 "../src/data/Runnable.vala"
	return FALSE;
#line 8185 "Runnable.c"
}

static void
game_hub_data_runnable_downloadable_installer_real_install_data_free (gpointer _data)
{
	GameHubDataRunnableDownloadableInstallerInstallData* _data_;
	_data_ = _data;
#line 547 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->runnable);
#line 547 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->tool);
#line 547 "../src/data/Runnable.vala"
	_game_hub_data_runnable_installer_unref0 (_data_->self);
#line 547 "../src/data/Runnable.vala"
	g_slice_free (GameHubDataRunnableDownloadableInstallerInstallData, _data_);
#line 8201 "Runnable.c"
}

static void
game_hub_data_runnable_downloadable_installer_real_install (GameHubDataRunnableInstaller* base,
                                                            GameHubDataRunnable* runnable,
                                                            GameHubDataCompatTool* tool,
                                                            GAsyncReadyCallback _callback_,
                                                            gpointer _user_data_)
{
	GameHubDataRunnableDownloadableInstaller * self;
	GameHubDataRunnableDownloadableInstallerInstallData* _data_;
	GameHubDataRunnableDownloadableInstaller* _tmp0_;
	GameHubDataRunnable* _tmp1_;
	GameHubDataCompatTool* _tmp2_;
#line 547 "../src/data/Runnable.vala"
	self = (GameHubDataRunnableDownloadableInstaller*) base;
#line 547 "../src/data/Runnable.vala"
	_data_ = g_slice_new0 (GameHubDataRunnableDownloadableInstallerInstallData);
#line 547 "../src/data/Runnable.vala"
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
#line 547 "../src/data/Runnable.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_runnable_downloadable_installer_real_install_data_free);
#line 547 "../src/data/Runnable.vala"
	_tmp0_ = _game_hub_data_runnable_installer_ref0 (self);
#line 547 "../src/data/Runnable.vala"
	_data_->self = _tmp0_;
#line 547 "../src/data/Runnable.vala"
	_tmp1_ = _g_object_ref0 (runnable);
#line 547 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->runnable);
#line 547 "../src/data/Runnable.vala"
	_data_->runnable = _tmp1_;
#line 547 "../src/data/Runnable.vala"
	_tmp2_ = _g_object_ref0 (tool);
#line 547 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->tool);
#line 547 "../src/data/Runnable.vala"
	_data_->tool = _tmp2_;
#line 547 "../src/data/Runnable.vala"
	game_hub_data_runnable_downloadable_installer_real_install_co (_data_);
#line 8242 "Runnable.c"
}

static void
game_hub_data_runnable_downloadable_installer_install_finish (GameHubDataRunnableInstaller* base,
                                                              GAsyncResult* _res_)
{
	GameHubDataRunnableDownloadableInstallerInstallData* _data_;
#line 547 "../src/data/Runnable.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 8252 "Runnable.c"
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 685 "../src/data/Runnable.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 685 "../src/data/Runnable.vala"
	return _data9_;
#line 8262 "Runnable.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 685 "../src/data/Runnable.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 8272 "Runnable.c"
		GameHubDataRunnableDownloadableInstaller* self;
#line 685 "../src/data/Runnable.vala"
		self = _data9_->self;
#line 685 "../src/data/Runnable.vala"
		_g_object_unref0 (_data9_->game);
#line 685 "../src/data/Runnable.vala"
		_game_hub_data_runnable_installer_unref0 (self);
#line 685 "../src/data/Runnable.vala"
		g_slice_free (Block9Data, _data9_);
#line 8282 "Runnable.c"
	}
}

static void
game_hub_data_runnable_downloadable_installer_install_ready (GObject* source_object,
                                                             GAsyncResult* _res_,
                                                             gpointer _user_data_)
{
	GameHubDataRunnableDownloadableInstallerInstallData* _data_;
#line 687 "../src/data/Runnable.vala"
	_data_ = _user_data_;
#line 687 "../src/data/Runnable.vala"
	_data_->_source_object_ = source_object;
#line 687 "../src/data/Runnable.vala"
	_data_->_res_ = _res_;
#line 687 "../src/data/Runnable.vala"
	game_hub_data_runnable_downloadable_installer_real_install_co (_data_);
#line 8300 "Runnable.c"
}

static GNotification*
_____lambda46_ (Block9Data* _data9_,
                GNotification* n)
{
	GameHubDataRunnableDownloadableInstaller* self;
	GThemedIcon* _tmp0_;
	GThemedIcon* _tmp1_;
	GameHubDataGame* _tmp2_;
	GameHubDataGame* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	GVariant* _tmp30_;
	GVariant* _tmp31_;
	GNotification* _tmp32_;
	GNotification* result = NULL;
#line 781 "../src/data/Runnable.vala"
	self = _data9_->self;
#line 781 "../src/data/Runnable.vala"
	g_return_val_if_fail (n != NULL, NULL);
#line 782 "../src/data/Runnable.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("dialog-warning");
#line 782 "../src/data/Runnable.vala"
	_tmp1_ = _tmp0_;
#line 782 "../src/data/Runnable.vala"
	g_notification_set_icon (n, (GIcon*) _tmp1_);
#line 782 "../src/data/Runnable.vala"
	_g_object_unref0 (_tmp1_);
#line 783 "../src/data/Runnable.vala"
	_tmp2_ = _data9_->game;
#line 783 "../src/data/Runnable.vala"
	if (_tmp2_ != NULL) {
#line 8335 "Runnable.c"
		GFile* icon = NULL;
		GameHubDataGame* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		GameHubDataGame* _tmp6_;
		GameHubDataGameSource* _tmp7_;
		GameHubDataGameSource* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		GameHubDataGame* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		GFile* _tmp18_;
		GFile* _tmp19_;
		gboolean _tmp20_ = FALSE;
		GFile* _tmp21_;
#line 785 "../src/data/Runnable.vala"
		_tmp3_ = _data9_->game;
#line 785 "../src/data/Runnable.vala"
		_tmp4_ = game_hub_data_game_get_icon (_tmp3_);
#line 785 "../src/data/Runnable.vala"
		_tmp5_ = _tmp4_;
#line 785 "../src/data/Runnable.vala"
		_tmp6_ = _data9_->game;
#line 785 "../src/data/Runnable.vala"
		_tmp7_ = game_hub_data_game_get_source (_tmp6_);
#line 785 "../src/data/Runnable.vala"
		_tmp8_ = _tmp7_;
#line 785 "../src/data/Runnable.vala"
		_tmp9_ = game_hub_data_game_source_get_id (_tmp8_);
#line 785 "../src/data/Runnable.vala"
		_tmp10_ = _tmp9_;
#line 785 "../src/data/Runnable.vala"
		_tmp11_ = string_to_string (_tmp10_);
#line 785 "../src/data/Runnable.vala"
		_tmp12_ = _data9_->game;
#line 785 "../src/data/Runnable.vala"
		_tmp13_ = game_hub_data_runnable_get_id ((GameHubDataRunnable*) _tmp12_);
#line 785 "../src/data/Runnable.vala"
		_tmp14_ = _tmp13_;
#line 785 "../src/data/Runnable.vala"
		_tmp15_ = string_to_string (_tmp14_);
#line 785 "../src/data/Runnable.vala"
		_tmp16_ = g_strconcat ("games/", _tmp11_, "/", _tmp15_, "/icons/", NULL);
#line 785 "../src/data/Runnable.vala"
		_tmp17_ = _tmp16_;
#line 785 "../src/data/Runnable.vala"
		_tmp18_ = game_hub_utils_image_cache_local_file (_tmp5_, _tmp17_);
#line 785 "../src/data/Runnable.vala"
		_tmp19_ = _tmp18_;
#line 785 "../src/data/Runnable.vala"
		_g_free0 (_tmp17_);
#line 785 "../src/data/Runnable.vala"
		icon = _tmp19_;
#line 786 "../src/data/Runnable.vala"
		_tmp21_ = icon;
#line 786 "../src/data/Runnable.vala"
		if (_tmp21_ != NULL) {
#line 8398 "Runnable.c"
			GFile* _tmp22_;
#line 786 "../src/data/Runnable.vala"
			_tmp22_ = icon;
#line 786 "../src/data/Runnable.vala"
			_tmp20_ = g_file_query_exists (_tmp22_, NULL);
#line 8404 "Runnable.c"
		} else {
#line 786 "../src/data/Runnable.vala"
			_tmp20_ = FALSE;
#line 8408 "Runnable.c"
		}
#line 786 "../src/data/Runnable.vala"
		if (_tmp20_) {
#line 8412 "Runnable.c"
			GFile* _tmp23_;
			GFileIcon* _tmp24_;
			GFileIcon* _tmp25_;
#line 788 "../src/data/Runnable.vala"
			_tmp23_ = icon;
#line 788 "../src/data/Runnable.vala"
			_tmp24_ = (GFileIcon*) g_file_icon_new (_tmp23_);
#line 788 "../src/data/Runnable.vala"
			_tmp25_ = _tmp24_;
#line 788 "../src/data/Runnable.vala"
			g_notification_set_icon (n, (GIcon*) _tmp25_);
#line 788 "../src/data/Runnable.vala"
			_g_object_unref0 (_tmp25_);
#line 8426 "Runnable.c"
		}
#line 783 "../src/data/Runnable.vala"
		_g_object_unref0 (icon);
#line 8430 "Runnable.c"
	}
#line 791 "../src/data/Runnable.vala"
	_tmp26_ = _data9_->game;
#line 791 "../src/data/Runnable.vala"
	_tmp27_ = game_hub_data_game_get_full_id (_tmp26_);
#line 791 "../src/data/Runnable.vala"
	_tmp28_ = _tmp27_;
#line 791 "../src/data/Runnable.vala"
	_tmp29_ = _tmp28_;
#line 791 "../src/data/Runnable.vala"
	_tmp30_ = g_variant_new_string (_tmp29_);
#line 791 "../src/data/Runnable.vala"
	g_variant_ref_sink (_tmp30_);
#line 791 "../src/data/Runnable.vala"
	_tmp31_ = _tmp30_;
#line 791 "../src/data/Runnable.vala"
	g_notification_set_default_action_and_target_value (n, GAME_HUB_APPLICATION_ACTION_PREFIX GAME_HUB_APPLICATION_ACTION_GAME_PROPERTIES, _tmp31_);
#line 791 "../src/data/Runnable.vala"
	_g_variant_unref0 (_tmp31_);
#line 791 "../src/data/Runnable.vala"
	_g_free0 (_tmp29_);
#line 792 "../src/data/Runnable.vala"
	_tmp32_ = _g_object_ref0 (n);
#line 792 "../src/data/Runnable.vala"
	result = _tmp32_;
#line 792 "../src/data/Runnable.vala"
	return result;
#line 8458 "Runnable.c"
}

static GNotification*
______lambda46__game_hub_utils_notification_configure_delegate (GNotification* notification,
                                                                gpointer self)
{
	GNotification* result;
	result = _____lambda46_ (self, notification);
#line 777 "../src/data/Runnable.vala"
	return result;
#line 8469 "Runnable.c"
}

static gboolean
game_hub_data_runnable_downloadable_installer_real_install_co (GameHubDataRunnableDownloadableInstallerInstallData* _data_)
{
#line 683 "../src/data/Runnable.vala"
	switch (_data_->_state_) {
#line 683 "../src/data/Runnable.vala"
		case 0:
#line 8479 "Runnable.c"
		goto _state_0;
#line 683 "../src/data/Runnable.vala"
		case 1:
#line 8483 "Runnable.c"
		goto _state_1;
#line 683 "../src/data/Runnable.vala"
		case 2:
#line 8487 "Runnable.c"
		goto _state_2;
#line 683 "../src/data/Runnable.vala"
		case 3:
#line 8491 "Runnable.c"
		goto _state_3;
		default:
#line 683 "../src/data/Runnable.vala"
		g_assert_not_reached ();
#line 8496 "Runnable.c"
	}
	_state_0:
	{
#line 685 "../src/data/Runnable.vala"
		_data_->_data9_ = g_slice_new0 (Block9Data);
#line 685 "../src/data/Runnable.vala"
		_data_->_data9_->_ref_count_ = 1;
#line 685 "../src/data/Runnable.vala"
		_data_->_data9_->self = game_hub_data_runnable_installer_ref (_data_->self);
#line 687 "../src/data/Runnable.vala"
		_data_->_state_ = 1;
#line 687 "../src/data/Runnable.vala"
		game_hub_data_runnable_downloadable_installer_download (_data_->self, _data_->runnable, game_hub_data_runnable_downloadable_installer_install_ready, _data_);
#line 687 "../src/data/Runnable.vala"
		return FALSE;
#line 8512 "Runnable.c"
		_state_1:
#line 687 "../src/data/Runnable.vala"
		_data_->_tmp0_ = game_hub_data_runnable_downloadable_installer_download_finish (_data_->self, _data_->_res_);
#line 687 "../src/data/Runnable.vala"
		_data_->files = _data_->_tmp0_;
#line 689 "../src/data/Runnable.vala"
		_data_->_data9_->game = NULL;
#line 690 "../src/data/Runnable.vala"
		if (GAME_HUB_DATA_IS_GAME (_data_->runnable)) {
#line 692 "../src/data/Runnable.vala"
			_data_->_tmp1_ = _g_object_ref0 (GAME_HUB_DATA_IS_GAME (_data_->runnable) ? ((GameHubDataGame*) _data_->runnable) : NULL);
#line 692 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->_data9_->game);
#line 692 "../src/data/Runnable.vala"
			_data_->_data9_->game = _data_->_tmp1_;
#line 8528 "Runnable.c"
		}
#line 695 "../src/data/Runnable.vala"
		_data_->_tmp2_ = _data_->_data9_->game;
#line 695 "../src/data/Runnable.vala"
		if (_data_->_tmp2_ != NULL) {
#line 695 "../src/data/Runnable.vala"
			_data_->_tmp3_ = _data_->_data9_->game;
#line 695 "../src/data/Runnable.vala"
			_data_->_tmp4_ = _data_->_data9_->game;
#line 695 "../src/data/Runnable.vala"
			_data_->_tmp5_ = game_hub_data_game_status_new (GAME_HUB_DATA_GAME_STATE_UNINSTALLED, _data_->_tmp4_, NULL);
#line 695 "../src/data/Runnable.vala"
			_data_->_tmp6_ = _data_->_tmp5_;
#line 695 "../src/data/Runnable.vala"
			game_hub_data_game_set_status (_data_->_tmp3_, _data_->_tmp6_);
#line 695 "../src/data/Runnable.vala"
			_game_hub_data_game_status_unref0 (_data_->_tmp6_);
#line 8546 "Runnable.c"
		}
#line 696 "../src/data/Runnable.vala"
		game_hub_data_runnable_update_status (_data_->runnable);
#line 698 "../src/data/Runnable.vala"
		_data_->_tmp7_ = _data_->files;
#line 698 "../src/data/Runnable.vala"
		_data_->_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp7_);
#line 698 "../src/data/Runnable.vala"
		_data_->_tmp9_ = _data_->_tmp8_;
#line 698 "../src/data/Runnable.vala"
		if (_data_->_tmp9_ == 0) {
#line 698 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->files);
#line 698 "../src/data/Runnable.vala"
			block9_data_unref (_data_->_data9_);
#line 698 "../src/data/Runnable.vala"
			_data_->_data9_ = NULL;
#line 698 "../src/data/Runnable.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 698 "../src/data/Runnable.vala"
			if (_data_->_state_ != 0) {
#line 698 "../src/data/Runnable.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 698 "../src/data/Runnable.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8572 "Runnable.c"
				}
			}
#line 698 "../src/data/Runnable.vala"
			g_object_unref (_data_->_async_result);
#line 698 "../src/data/Runnable.vala"
			return FALSE;
#line 8579 "Runnable.c"
		}
#line 700 "../src/data/Runnable.vala"
		_data_->f = (guint) 0;
#line 701 "../src/data/Runnable.vala"
		_data_->windows_installer = FALSE;
#line 702 "../src/data/Runnable.vala"
		_data_->nsis_installer = FALSE;
#line 8587 "Runnable.c"
		{
#line 703 "../src/data/Runnable.vala"
			_data_->_tmp10_ = _data_->files;
#line 703 "../src/data/Runnable.vala"
			_data_->_tmp11_ = _g_object_ref0 (_data_->_tmp10_);
#line 703 "../src/data/Runnable.vala"
			_data_->_file_list = _data_->_tmp11_;
#line 703 "../src/data/Runnable.vala"
			_data_->_tmp12_ = _data_->_file_list;
#line 703 "../src/data/Runnable.vala"
			_data_->_tmp13_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp12_);
#line 703 "../src/data/Runnable.vala"
			_data_->_tmp14_ = _data_->_tmp13_;
#line 703 "../src/data/Runnable.vala"
			_data_->_file_size = _data_->_tmp14_;
#line 703 "../src/data/Runnable.vala"
			_data_->_file_index = -1;
#line 703 "../src/data/Runnable.vala"
			while (TRUE) {
#line 703 "../src/data/Runnable.vala"
				_data_->_file_index = _data_->_file_index + 1;
#line 703 "../src/data/Runnable.vala"
				if (!(_data_->_file_index < _data_->_file_size)) {
#line 703 "../src/data/Runnable.vala"
					break;
#line 8613 "Runnable.c"
				}
#line 703 "../src/data/Runnable.vala"
				_data_->_tmp15_ = _data_->_file_list;
#line 703 "../src/data/Runnable.vala"
				_data_->_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp15_, _data_->_file_index);
#line 703 "../src/data/Runnable.vala"
				_data_->file = (GFile*) _data_->_tmp16_;
#line 707 "../src/data/Runnable.vala"
				_data_->_tmp17_ = _data_->file;
#line 707 "../src/data/Runnable.vala"
				_data_->_tmp18_ = _data_->f;
#line 707 "../src/data/Runnable.vala"
				_data_->f = _data_->_tmp18_ + 1;
#line 707 "../src/data/Runnable.vala"
				_data_->_tmp19_ = FALSE;
#line 707 "../src/data/Runnable.vala"
				_data_->_tmp20_ = FALSE;
#line 707 "../src/data/Runnable.vala"
				_data_->_state_ = 2;
#line 707 "../src/data/Runnable.vala"
				game_hub_data_runnable_file_installer_install_file (_data_->_tmp17_, _data_->_tmp18_ > ((guint) 0), _data_->runnable, _data_->tool, game_hub_data_runnable_downloadable_installer_install_ready, _data_);
#line 707 "../src/data/Runnable.vala"
				return FALSE;
#line 8637 "Runnable.c"
				_state_2:
#line 707 "../src/data/Runnable.vala"
				game_hub_data_runnable_file_installer_install_file_finish (_data_->_res_, &_data_->_tmp19_, &_data_->_tmp20_);
#line 707 "../src/data/Runnable.vala"
				_data_->win = _data_->_tmp19_;
#line 707 "../src/data/Runnable.vala"
				_data_->nsis = _data_->_tmp20_;
#line 708 "../src/data/Runnable.vala"
				if (_data_->windows_installer) {
#line 708 "../src/data/Runnable.vala"
					_data_->_tmp21_ = TRUE;
#line 8649 "Runnable.c"
				} else {
#line 708 "../src/data/Runnable.vala"
					_data_->_tmp21_ = _data_->win;
#line 8653 "Runnable.c"
				}
#line 708 "../src/data/Runnable.vala"
				_data_->windows_installer = _data_->_tmp21_;
#line 709 "../src/data/Runnable.vala"
				if (_data_->nsis_installer) {
#line 709 "../src/data/Runnable.vala"
					_data_->_tmp22_ = TRUE;
#line 8661 "Runnable.c"
				} else {
#line 709 "../src/data/Runnable.vala"
					_data_->_tmp22_ = _data_->nsis;
#line 8665 "Runnable.c"
				}
#line 709 "../src/data/Runnable.vala"
				_data_->nsis_installer = _data_->_tmp22_;
#line 703 "../src/data/Runnable.vala"
				_g_object_unref0 (_data_->file);
#line 8671 "Runnable.c"
			}
#line 703 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->_file_list);
#line 8675 "Runnable.c"
		}
		{
#line 714 "../src/data/Runnable.vala"
			if (_data_->nsis_installer) {
#line 716 "../src/data/Runnable.vala"
				_data_->_tmp23_ = game_hub_data_runnable_get_install_dir (_data_->runnable);
#line 716 "../src/data/Runnable.vala"
				_data_->_tmp24_ = _data_->_tmp23_;
#line 716 "../src/data/Runnable.vala"
				_data_->_tmp25_ = g_file_get_path (_data_->_tmp24_);
#line 716 "../src/data/Runnable.vala"
				_data_->_tmp26_ = _data_->_tmp25_;
#line 716 "../src/data/Runnable.vala"
				game_hub_utils_fs_utils_rm (_data_->_tmp26_, "\\$*DIR", "-rf", NULL);
#line 716 "../src/data/Runnable.vala"
				_g_free0 (_data_->_tmp26_);
#line 8692 "Runnable.c"
			}
#line 719 "../src/data/Runnable.vala"
			_data_->dircount = 0;
#line 720 "../src/data/Runnable.vala"
			_data_->dirname = NULL;
#line 721 "../src/data/Runnable.vala"
			_data_->finfo = NULL;
#line 722 "../src/data/Runnable.vala"
			_data_->_tmp27_ = game_hub_data_runnable_get_install_dir (_data_->runnable);
#line 722 "../src/data/Runnable.vala"
			_data_->_tmp28_ = _data_->_tmp27_;
#line 722 "../src/data/Runnable.vala"
			_data_->_state_ = 3;
#line 722 "../src/data/Runnable.vala"
			g_file_enumerate_children_async (_data_->_tmp28_, "standard::*", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, G_PRIORITY_DEFAULT, NULL, game_hub_data_runnable_downloadable_installer_install_ready, _data_);
#line 722 "../src/data/Runnable.vala"
			return FALSE;
#line 8710 "Runnable.c"
			_state_3:
#line 722 "../src/data/Runnable.vala"
			_data_->_tmp29_ = g_file_enumerate_children_finish (_data_->_tmp28_, _data_->_res_, &_data_->_inner_error0_);
#line 722 "../src/data/Runnable.vala"
			_data_->enumerator = _data_->_tmp29_;
#line 722 "../src/data/Runnable.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 722 "../src/data/Runnable.vala"
				_g_object_unref0 (_data_->finfo);
#line 722 "../src/data/Runnable.vala"
				_g_free0 (_data_->dirname);
#line 8722 "Runnable.c"
				goto __catch9_g_error;
			}
#line 723 "../src/data/Runnable.vala"
			while (TRUE) {
#line 723 "../src/data/Runnable.vala"
				_data_->_tmp31_ = _data_->enumerator;
#line 723 "../src/data/Runnable.vala"
				_data_->_tmp32_ = g_file_enumerator_next_file (_data_->_tmp31_, NULL, &_data_->_inner_error0_);
#line 723 "../src/data/Runnable.vala"
				_data_->_tmp30_ = _data_->_tmp32_;
#line 723 "../src/data/Runnable.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 723 "../src/data/Runnable.vala"
					_g_object_unref0 (_data_->enumerator);
#line 723 "../src/data/Runnable.vala"
					_g_object_unref0 (_data_->finfo);
#line 723 "../src/data/Runnable.vala"
					_g_free0 (_data_->dirname);
#line 8741 "Runnable.c"
					goto __catch9_g_error;
				}
#line 723 "../src/data/Runnable.vala"
				_data_->_tmp33_ = _data_->_tmp30_;
#line 723 "../src/data/Runnable.vala"
				_data_->_tmp30_ = NULL;
#line 723 "../src/data/Runnable.vala"
				_g_object_unref0 (_data_->finfo);
#line 723 "../src/data/Runnable.vala"
				_data_->finfo = _data_->_tmp33_;
#line 723 "../src/data/Runnable.vala"
				_data_->_tmp34_ = _data_->finfo;
#line 723 "../src/data/Runnable.vala"
				if (!(_data_->_tmp34_ != NULL)) {
#line 723 "../src/data/Runnable.vala"
					_g_object_unref0 (_data_->_tmp30_);
#line 723 "../src/data/Runnable.vala"
					break;
#line 8760 "Runnable.c"
				}
#line 725 "../src/data/Runnable.vala"
				_data_->_tmp36_ = _data_->finfo;
#line 725 "../src/data/Runnable.vala"
				if (g_file_info_get_file_type (_data_->_tmp36_) == G_FILE_TYPE_DIRECTORY) {
#line 725 "../src/data/Runnable.vala"
					_data_->_tmp37_ = _data_->finfo;
#line 725 "../src/data/Runnable.vala"
					_data_->_tmp38_ = g_file_info_get_name (_data_->_tmp37_);
#line 725 "../src/data/Runnable.vala"
					_data_->_tmp35_ = g_strcmp0 (_data_->_tmp38_, GAME_HUB_UTILS_FS_UTILS_GAMEHUB_DIR) != 0;
#line 8772 "Runnable.c"
				} else {
#line 725 "../src/data/Runnable.vala"
					_data_->_tmp35_ = FALSE;
#line 8776 "Runnable.c"
				}
#line 725 "../src/data/Runnable.vala"
				if (_data_->_tmp35_) {
#line 727 "../src/data/Runnable.vala"
					_data_->_tmp39_ = _data_->dircount;
#line 727 "../src/data/Runnable.vala"
					_data_->dircount = _data_->_tmp39_ + 1;
#line 728 "../src/data/Runnable.vala"
					_data_->_tmp42_ = _data_->dirname;
#line 728 "../src/data/Runnable.vala"
					if (_data_->_tmp42_ == NULL) {
#line 728 "../src/data/Runnable.vala"
						_data_->_tmp41_ = _data_->dircount == 1;
#line 8790 "Runnable.c"
					} else {
#line 728 "../src/data/Runnable.vala"
						_data_->_tmp41_ = FALSE;
#line 8794 "Runnable.c"
					}
#line 728 "../src/data/Runnable.vala"
					if (_data_->_tmp41_) {
#line 728 "../src/data/Runnable.vala"
						_data_->_tmp43_ = _data_->finfo;
#line 728 "../src/data/Runnable.vala"
						_data_->_tmp44_ = g_file_info_get_name (_data_->_tmp43_);
#line 728 "../src/data/Runnable.vala"
						_data_->_tmp40_ = _data_->_tmp44_;
#line 8804 "Runnable.c"
					} else {
#line 728 "../src/data/Runnable.vala"
						_data_->_tmp40_ = NULL;
#line 8808 "Runnable.c"
					}
#line 728 "../src/data/Runnable.vala"
					_data_->_tmp45_ = g_strdup (_data_->_tmp40_);
#line 728 "../src/data/Runnable.vala"
					_g_free0 (_data_->dirname);
#line 728 "../src/data/Runnable.vala"
					_data_->dirname = _data_->_tmp45_;
#line 8816 "Runnable.c"
				} else {
#line 730 "../src/data/Runnable.vala"
					_data_->_tmp46_ = _data_->finfo;
#line 730 "../src/data/Runnable.vala"
					if (g_file_info_get_file_type (_data_->_tmp46_) != G_FILE_TYPE_DIRECTORY) {
#line 732 "../src/data/Runnable.vala"
						_g_free0 (_data_->dirname);
#line 732 "../src/data/Runnable.vala"
						_data_->dirname = NULL;
#line 733 "../src/data/Runnable.vala"
						_g_object_unref0 (_data_->_tmp30_);
#line 733 "../src/data/Runnable.vala"
						break;
#line 8830 "Runnable.c"
					}
				}
#line 723 "../src/data/Runnable.vala"
				_g_object_unref0 (_data_->_tmp30_);
#line 8835 "Runnable.c"
			}
#line 737 "../src/data/Runnable.vala"
			_data_->_tmp48_ = _data_->dirname;
#line 737 "../src/data/Runnable.vala"
			if (_data_->_tmp48_ != NULL) {
#line 737 "../src/data/Runnable.vala"
				_data_->_tmp47_ = !GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_IS_DLC (_data_->runnable);
#line 8843 "Runnable.c"
			} else {
#line 737 "../src/data/Runnable.vala"
				_data_->_tmp47_ = FALSE;
#line 8847 "Runnable.c"
			}
#line 737 "../src/data/Runnable.vala"
			if (_data_->_tmp47_) {
#line 739 "../src/data/Runnable.vala"
				_data_->_tmp49_ = game_hub_data_runnable_get_install_dir (_data_->runnable);
#line 739 "../src/data/Runnable.vala"
				_data_->_tmp50_ = _data_->_tmp49_;
#line 739 "../src/data/Runnable.vala"
				_data_->_tmp51_ = _data_->dirname;
#line 739 "../src/data/Runnable.vala"
				_data_->_tmp52_ = string_replace (_data_->_tmp51_, " ", "\\ ");
#line 739 "../src/data/Runnable.vala"
				_data_->_tmp53_ = _data_->_tmp52_;
#line 739 "../src/data/Runnable.vala"
				game_hub_utils_fs_utils_mv_up (_data_->_tmp50_, _data_->_tmp53_);
#line 739 "../src/data/Runnable.vala"
				_g_free0 (_data_->_tmp53_);
#line 8865 "Runnable.c"
			}
#line 742 "../src/data/Runnable.vala"
			if (_data_->windows_installer) {
#line 742 "../src/data/Runnable.vala"
				_data_->_tmp54_ = TRUE;
#line 8871 "Runnable.c"
			} else {
#line 742 "../src/data/Runnable.vala"
				_data_->_tmp55_ = game_hub_data_runnable_installer_get_platform ((GameHubDataRunnableInstaller*) _data_->self);
#line 742 "../src/data/Runnable.vala"
				_data_->_tmp56_ = _data_->_tmp55_;
#line 742 "../src/data/Runnable.vala"
				_data_->_tmp54_ = _data_->_tmp56_ == GAME_HUB_DATA_PLATFORM_WINDOWS;
#line 8879 "Runnable.c"
			}
#line 742 "../src/data/Runnable.vala"
			if (_data_->_tmp54_) {
#line 744 "../src/data/Runnable.vala"
				game_hub_data_runnable_set_force_compat (_data_->runnable, TRUE);
#line 8885 "Runnable.c"
			}
#line 712 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->enumerator);
#line 712 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->finfo);
#line 712 "../src/data/Runnable.vala"
			_g_free0 (_data_->dirname);
#line 8893 "Runnable.c"
		}
		goto __finally9;
		__catch9_g_error:
		{
#line 712 "../src/data/Runnable.vala"
			_data_->e = _data_->_inner_error0_;
#line 712 "../src/data/Runnable.vala"
			_data_->_inner_error0_ = NULL;
#line 712 "../src/data/Runnable.vala"
			_g_error_free0 (_data_->e);
#line 8904 "Runnable.c"
		}
		__finally9:
#line 712 "../src/data/Runnable.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 712 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->files);
#line 712 "../src/data/Runnable.vala"
			block9_data_unref (_data_->_data9_);
#line 712 "../src/data/Runnable.vala"
			_data_->_data9_ = NULL;
#line 8915 "Runnable.c"
			goto __catch8_g_error;
		}
#line 749 "../src/data/Runnable.vala"
		game_hub_data_runnable_update_status (_data_->runnable);
#line 751 "../src/data/Runnable.vala"
		if (GAME_HUB_DATA_SOURCES_GOG_IS_GOG_GAME (_data_->runnable)) {
#line 751 "../src/data/Runnable.vala"
			_data_->_tmp58_ = !GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_IS_DLC (_data_->runnable);
#line 8924 "Runnable.c"
		} else {
#line 751 "../src/data/Runnable.vala"
			_data_->_tmp58_ = FALSE;
#line 8928 "Runnable.c"
		}
#line 751 "../src/data/Runnable.vala"
		if (_data_->_tmp58_) {
#line 751 "../src/data/Runnable.vala"
			_data_->_tmp60_ = game_hub_data_runnable_get_executable (_data_->runnable);
#line 751 "../src/data/Runnable.vala"
			_data_->_tmp61_ = _data_->_tmp60_;
#line 751 "../src/data/Runnable.vala"
			_data_->_tmp62_ = _data_->_tmp61_;
#line 751 "../src/data/Runnable.vala"
			_data_->_tmp63_ = _data_->_tmp62_ == NULL;
#line 751 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->_tmp62_);
#line 751 "../src/data/Runnable.vala"
			if (_data_->_tmp63_) {
#line 751 "../src/data/Runnable.vala"
				_data_->_tmp59_ = TRUE;
#line 8946 "Runnable.c"
			} else {
#line 751 "../src/data/Runnable.vala"
				_data_->_tmp64_ = game_hub_data_runnable_get_executable (_data_->runnable);
#line 751 "../src/data/Runnable.vala"
				_data_->_tmp65_ = _data_->_tmp64_;
#line 751 "../src/data/Runnable.vala"
				_data_->_tmp66_ = _data_->_tmp65_;
#line 751 "../src/data/Runnable.vala"
				_data_->_tmp59_ = !g_file_query_exists (_data_->_tmp66_, NULL);
#line 751 "../src/data/Runnable.vala"
				_g_object_unref0 (_data_->_tmp66_);
#line 8958 "Runnable.c"
			}
#line 751 "../src/data/Runnable.vala"
			_data_->_tmp57_ = _data_->_tmp59_;
#line 8962 "Runnable.c"
		} else {
#line 751 "../src/data/Runnable.vala"
			_data_->_tmp57_ = FALSE;
#line 8966 "Runnable.c"
		}
#line 751 "../src/data/Runnable.vala"
		if (_data_->_tmp57_) {
#line 753 "../src/data/Runnable.vala"
			_data_->_tmp68_ = game_hub_data_runnable_get_actions (_data_->runnable);
#line 753 "../src/data/Runnable.vala"
			_data_->_tmp69_ = _data_->_tmp68_;
#line 753 "../src/data/Runnable.vala"
			if (_data_->_tmp69_ != NULL) {
#line 753 "../src/data/Runnable.vala"
				_data_->_tmp70_ = game_hub_data_runnable_get_actions (_data_->runnable);
#line 753 "../src/data/Runnable.vala"
				_data_->_tmp71_ = _data_->_tmp70_;
#line 753 "../src/data/Runnable.vala"
				_data_->_tmp72_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp71_);
#line 753 "../src/data/Runnable.vala"
				_data_->_tmp73_ = _data_->_tmp72_;
#line 753 "../src/data/Runnable.vala"
				_data_->_tmp67_ = _data_->_tmp73_ > 0;
#line 8986 "Runnable.c"
			} else {
#line 753 "../src/data/Runnable.vala"
				_data_->_tmp67_ = FALSE;
#line 8990 "Runnable.c"
			}
#line 753 "../src/data/Runnable.vala"
			if (_data_->_tmp67_) {
#line 8994 "Runnable.c"
				{
#line 755 "../src/data/Runnable.vala"
					_data_->_tmp74_ = game_hub_data_runnable_get_actions (_data_->runnable);
#line 755 "../src/data/Runnable.vala"
					_data_->_tmp75_ = _data_->_tmp74_;
#line 755 "../src/data/Runnable.vala"
					_data_->_tmp76_ = _g_object_ref0 (_data_->_tmp75_);
#line 755 "../src/data/Runnable.vala"
					_data_->_action_list = _data_->_tmp76_;
#line 755 "../src/data/Runnable.vala"
					_data_->_tmp77_ = _data_->_action_list;
#line 755 "../src/data/Runnable.vala"
					_data_->_tmp78_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp77_);
#line 755 "../src/data/Runnable.vala"
					_data_->_tmp79_ = _data_->_tmp78_;
#line 755 "../src/data/Runnable.vala"
					_data_->_action_size = _data_->_tmp79_;
#line 755 "../src/data/Runnable.vala"
					_data_->_action_index = -1;
#line 755 "../src/data/Runnable.vala"
					while (TRUE) {
#line 755 "../src/data/Runnable.vala"
						_data_->_action_index = _data_->_action_index + 1;
#line 755 "../src/data/Runnable.vala"
						if (!(_data_->_action_index < _data_->_action_size)) {
#line 755 "../src/data/Runnable.vala"
							break;
#line 9022 "Runnable.c"
						}
#line 755 "../src/data/Runnable.vala"
						_data_->_tmp80_ = _data_->_action_list;
#line 755 "../src/data/Runnable.vala"
						_data_->_tmp81_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp80_, _data_->_action_index);
#line 755 "../src/data/Runnable.vala"
						_data_->action = (GameHubDataRunnableRunnableAction*) _data_->_tmp81_;
#line 757 "../src/data/Runnable.vala"
						_data_->_tmp82_ = _data_->action;
#line 757 "../src/data/Runnable.vala"
						_data_->_tmp83_ = game_hub_data_runnable_runnable_action_get_is_primary (_data_->_tmp82_);
#line 757 "../src/data/Runnable.vala"
						_data_->_tmp84_ = _data_->_tmp83_;
#line 757 "../src/data/Runnable.vala"
						if (_data_->_tmp84_) {
#line 759 "../src/data/Runnable.vala"
							_data_->_tmp86_ = _data_->action;
#line 759 "../src/data/Runnable.vala"
							_data_->_tmp87_ = game_hub_data_runnable_runnable_action_get_file (_data_->_tmp86_);
#line 759 "../src/data/Runnable.vala"
							_data_->_tmp88_ = _data_->_tmp87_;
#line 759 "../src/data/Runnable.vala"
							if (_data_->_tmp88_ != NULL) {
#line 759 "../src/data/Runnable.vala"
								_data_->_tmp89_ = _data_->action;
#line 759 "../src/data/Runnable.vala"
								_data_->_tmp90_ = game_hub_data_runnable_runnable_action_get_file (_data_->_tmp89_);
#line 759 "../src/data/Runnable.vala"
								_data_->_tmp91_ = _data_->_tmp90_;
#line 759 "../src/data/Runnable.vala"
								_data_->_tmp85_ = g_file_query_exists (_data_->_tmp91_, NULL);
#line 9054 "Runnable.c"
							} else {
#line 759 "../src/data/Runnable.vala"
								_data_->_tmp85_ = FALSE;
#line 9058 "Runnable.c"
							}
#line 759 "../src/data/Runnable.vala"
							if (_data_->_tmp85_) {
#line 761 "../src/data/Runnable.vala"
								_data_->_tmp92_ = _data_->action;
#line 761 "../src/data/Runnable.vala"
								_data_->_tmp93_ = game_hub_data_runnable_runnable_action_get_file (_data_->_tmp92_);
#line 761 "../src/data/Runnable.vala"
								_data_->_tmp94_ = _data_->_tmp93_;
#line 761 "../src/data/Runnable.vala"
								game_hub_data_runnable_set_executable (_data_->runnable, _data_->_tmp94_);
#line 762 "../src/data/Runnable.vala"
								_data_->_tmp95_ = _data_->action;
#line 762 "../src/data/Runnable.vala"
								_data_->_tmp96_ = game_hub_data_runnable_runnable_action_get_workdir (_data_->_tmp95_);
#line 762 "../src/data/Runnable.vala"
								_data_->_tmp97_ = _data_->_tmp96_;
#line 762 "../src/data/Runnable.vala"
								game_hub_data_runnable_set_work_dir (_data_->runnable, _data_->_tmp97_);
#line 763 "../src/data/Runnable.vala"
								_data_->_tmp98_ = _data_->action;
#line 763 "../src/data/Runnable.vala"
								_data_->_tmp99_ = game_hub_data_runnable_runnable_action_get_args (_data_->_tmp98_);
#line 763 "../src/data/Runnable.vala"
								_data_->_tmp100_ = _data_->_tmp99_;
#line 763 "../src/data/Runnable.vala"
								game_hub_data_runnable_set_arguments (_data_->runnable, _data_->_tmp100_);
#line 764 "../src/data/Runnable.vala"
								_game_hub_data_runnable_runnable_action_unref0 (_data_->action);
#line 764 "../src/data/Runnable.vala"
								break;
#line 9090 "Runnable.c"
							}
						}
#line 755 "../src/data/Runnable.vala"
						_game_hub_data_runnable_runnable_action_unref0 (_data_->action);
#line 9095 "Runnable.c"
					}
#line 755 "../src/data/Runnable.vala"
					_g_object_unref0 (_data_->_action_list);
#line 9099 "Runnable.c"
				}
			}
#line 770 "../src/data/Runnable.vala"
			game_hub_data_runnable_update_status (_data_->runnable);
#line 9104 "Runnable.c"
		}
#line 773 "../src/data/Runnable.vala"
		_data_->_tmp103_ = game_hub_data_runnable_get_executable (_data_->runnable);
#line 773 "../src/data/Runnable.vala"
		_data_->_tmp104_ = _data_->_tmp103_;
#line 773 "../src/data/Runnable.vala"
		_data_->_tmp105_ = _data_->_tmp104_;
#line 773 "../src/data/Runnable.vala"
		_data_->_tmp106_ = _data_->_tmp105_ == NULL;
#line 773 "../src/data/Runnable.vala"
		_g_object_unref0 (_data_->_tmp105_);
#line 773 "../src/data/Runnable.vala"
		if (_data_->_tmp106_) {
#line 773 "../src/data/Runnable.vala"
			_data_->_tmp102_ = TRUE;
#line 9120 "Runnable.c"
		} else {
#line 773 "../src/data/Runnable.vala"
			_data_->_tmp107_ = game_hub_data_runnable_get_executable (_data_->runnable);
#line 773 "../src/data/Runnable.vala"
			_data_->_tmp108_ = _data_->_tmp107_;
#line 773 "../src/data/Runnable.vala"
			_data_->_tmp109_ = _data_->_tmp108_;
#line 773 "../src/data/Runnable.vala"
			_data_->_tmp102_ = !g_file_query_exists (_data_->_tmp109_, NULL);
#line 773 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->_tmp109_);
#line 9132 "Runnable.c"
		}
#line 773 "../src/data/Runnable.vala"
		if (_data_->_tmp102_) {
#line 773 "../src/data/Runnable.vala"
			_data_->_tmp101_ = !GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_IS_DLC (_data_->runnable);
#line 9138 "Runnable.c"
		} else {
#line 773 "../src/data/Runnable.vala"
			_data_->_tmp101_ = FALSE;
#line 9142 "Runnable.c"
		}
#line 773 "../src/data/Runnable.vala"
		if (_data_->_tmp101_) {
#line 775 "../src/data/Runnable.vala"
			_data_->_tmp110_ = _data_->_data9_->game;
#line 775 "../src/data/Runnable.vala"
			if (_data_->_tmp110_ != NULL) {
#line 777 "../src/data/Runnable.vala"
				_data_->_tmp111_ = _data_->_data9_->game;
#line 777 "../src/data/Runnable.vala"
				_data_->_tmp112_ = game_hub_data_runnable_get_name ((GameHubDataRunnable*) _data_->_tmp111_);
#line 777 "../src/data/Runnable.vala"
				_data_->_tmp113_ = _data_->_tmp112_;
#line 777 "../src/data/Runnable.vala"
				_data_->_tmp114_ = g_strdup_printf (_ ("%s: cannot detect main executable"), _data_->_tmp113_);
#line 777 "../src/data/Runnable.vala"
				_data_->_tmp115_ = _data_->_tmp114_;
#line 777 "../src/data/Runnable.vala"
				game_hub_utils_notify (_data_->_tmp115_, _ ("Main executable file for this game cannot be detected automatically.\n" \
"Please set main executable in game's properties."), G_NOTIFICATION_PRIORITY_HIGH, ______lambda46__game_hub_utils_notification_configure_delegate, _data_->_data9_);
#line 777 "../src/data/Runnable.vala"
				_g_free0 (_data_->_tmp115_);
#line 9164 "Runnable.c"
			} else {
#line 798 "../src/data/Runnable.vala"
				game_hub_data_runnable_choose_executable (_data_->runnable, TRUE);
#line 9168 "Runnable.c"
			}
		}
#line 802 "../src/data/Runnable.vala"
		_data_->_tmp117_ = _data_->_data9_->game;
#line 802 "../src/data/Runnable.vala"
		if (_data_->_tmp117_ != NULL) {
#line 802 "../src/data/Runnable.vala"
			_data_->_tmp118_ = game_hub_data_runnable_installer_get_version ((GameHubDataRunnableInstaller*) _data_->self);
#line 802 "../src/data/Runnable.vala"
			_data_->_tmp119_ = _data_->_tmp118_;
#line 802 "../src/data/Runnable.vala"
			_data_->_tmp116_ = _data_->_tmp119_ != NULL;
#line 9181 "Runnable.c"
		} else {
#line 802 "../src/data/Runnable.vala"
			_data_->_tmp116_ = FALSE;
#line 9185 "Runnable.c"
		}
#line 802 "../src/data/Runnable.vala"
		if (_data_->_tmp116_) {
#line 804 "../src/data/Runnable.vala"
			_data_->_tmp120_ = _data_->_data9_->game;
#line 804 "../src/data/Runnable.vala"
			_data_->_tmp121_ = game_hub_data_runnable_installer_get_version ((GameHubDataRunnableInstaller*) _data_->self);
#line 804 "../src/data/Runnable.vala"
			_data_->_tmp122_ = _data_->_tmp121_;
#line 804 "../src/data/Runnable.vala"
			game_hub_data_game_save_version (_data_->_tmp120_, _data_->_tmp122_);
#line 9197 "Runnable.c"
		}
#line 807 "../src/data/Runnable.vala"
		_data_->_tmp123_ = game_hub_data_runnable_get_install_dir (_data_->runnable);
#line 807 "../src/data/Runnable.vala"
		_data_->_tmp124_ = _data_->_tmp123_;
#line 807 "../src/data/Runnable.vala"
		_data_->_tmp125_ = game_hub_data_runnable_get_id (_data_->runnable);
#line 807 "../src/data/Runnable.vala"
		_data_->_tmp126_ = _data_->_tmp125_;
#line 807 "../src/data/Runnable.vala"
		_data_->_tmp127_ = g_strconcat (".gamehub_", _data_->_tmp126_, NULL);
#line 807 "../src/data/Runnable.vala"
		_data_->_tmp128_ = _data_->_tmp127_;
#line 807 "../src/data/Runnable.vala"
		_data_->_tmp129_ = g_file_get_child (_data_->_tmp124_, _data_->_tmp128_);
#line 807 "../src/data/Runnable.vala"
		_data_->_tmp130_ = _data_->_tmp129_;
#line 807 "../src/data/Runnable.vala"
		_g_free0 (_data_->_tmp128_);
#line 807 "../src/data/Runnable.vala"
		_data_->gh_marker = _data_->_tmp130_;
#line 808 "../src/data/Runnable.vala"
		_data_->_tmp131_ = _data_->gh_marker;
#line 808 "../src/data/Runnable.vala"
		if (_data_->_tmp131_ != NULL) {
#line 810 "../src/data/Runnable.vala"
			_data_->_tmp132_ = _data_->gh_marker;
#line 810 "../src/data/Runnable.vala"
			_data_->_tmp133_ = g_file_get_path (_data_->_tmp132_);
#line 810 "../src/data/Runnable.vala"
			_data_->_tmp134_ = _data_->_tmp133_;
#line 810 "../src/data/Runnable.vala"
			g_file_set_contents (_data_->_tmp134_, "", (gssize) -1, &_data_->_inner_error0_);
#line 810 "../src/data/Runnable.vala"
			_g_free0 (_data_->_tmp134_);
#line 810 "../src/data/Runnable.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 810 "../src/data/Runnable.vala"
				_g_object_unref0 (_data_->gh_marker);
#line 810 "../src/data/Runnable.vala"
				_g_object_unref0 (_data_->files);
#line 810 "../src/data/Runnable.vala"
				block9_data_unref (_data_->_data9_);
#line 810 "../src/data/Runnable.vala"
				_data_->_data9_ = NULL;
#line 9243 "Runnable.c"
				goto __catch8_g_error;
			}
		}
#line 685 "../src/data/Runnable.vala"
		_g_object_unref0 (_data_->gh_marker);
#line 685 "../src/data/Runnable.vala"
		_g_object_unref0 (_data_->files);
#line 685 "../src/data/Runnable.vala"
		block9_data_unref (_data_->_data9_);
#line 685 "../src/data/Runnable.vala"
		_data_->_data9_ = NULL;
#line 9255 "Runnable.c"
	}
	goto __finally8;
	__catch8_g_error:
	{
#line 685 "../src/data/Runnable.vala"
		_data_->_vala1_e = _data_->_inner_error0_;
#line 685 "../src/data/Runnable.vala"
		_data_->_inner_error0_ = NULL;
#line 815 "../src/data/Runnable.vala"
		_data_->_tmp135_ = _data_->_vala1_e;
#line 815 "../src/data/Runnable.vala"
		_data_->_tmp136_ = _data_->_tmp135_->message;
#line 815 "../src/data/Runnable.vala"
		g_warning ("Runnable.vala:815: [DownloadableInstaller.install] %s", _data_->_tmp136_);
#line 685 "../src/data/Runnable.vala"
		_g_error_free0 (_data_->_vala1_e);
#line 9272 "Runnable.c"
	}
	__finally8:
#line 685 "../src/data/Runnable.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 685 "../src/data/Runnable.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 685 "../src/data/Runnable.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 685 "../src/data/Runnable.vala"
		g_object_unref (_data_->_async_result);
#line 685 "../src/data/Runnable.vala"
		return FALSE;
#line 9285 "Runnable.c"
	}
#line 817 "../src/data/Runnable.vala"
	game_hub_data_runnable_update_status (_data_->runnable);
#line 683 "../src/data/Runnable.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 683 "../src/data/Runnable.vala"
	if (_data_->_state_ != 0) {
#line 683 "../src/data/Runnable.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 683 "../src/data/Runnable.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 9297 "Runnable.c"
		}
	}
#line 683 "../src/data/Runnable.vala"
	g_object_unref (_data_->_async_result);
#line 683 "../src/data/Runnable.vala"
	return FALSE;
#line 9304 "Runnable.c"
}

GameHubDataRunnableDownloadableInstaller*
game_hub_data_runnable_downloadable_installer_construct (GType object_type)
{
	GameHubDataRunnableDownloadableInstaller* self = NULL;
#line 547 "../src/data/Runnable.vala"
	self = (GameHubDataRunnableDownloadableInstaller*) game_hub_data_runnable_installer_construct (object_type);
#line 547 "../src/data/Runnable.vala"
	return self;
#line 9315 "Runnable.c"
}

GeeArrayList*
game_hub_data_runnable_downloadable_installer_get_parts (GameHubDataRunnableDownloadableInstaller* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 579 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 579 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_parts;
#line 579 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 579 "../src/data/Runnable.vala"
	return result;
#line 9331 "Runnable.c"
}

void
game_hub_data_runnable_downloadable_installer_set_parts (GameHubDataRunnableDownloadableInstaller* self,
                                                         GeeArrayList* value)
{
	GeeArrayList* _tmp0_;
#line 579 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 579 "../src/data/Runnable.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 579 "../src/data/Runnable.vala"
	_g_object_unref0 (self->priv->_parts);
#line 579 "../src/data/Runnable.vala"
	self->priv->_parts = _tmp0_;
#line 9347 "Runnable.c"
}

static inline gpointer
game_hub_data_runnable_downloadable_installer_part_get_instance_private (GameHubDataRunnableDownloadableInstallerPart* self)
{
	return G_STRUCT_MEMBER_P (self, GameHubDataRunnableDownloadableInstallerPart_private_offset);
}

GameHubDataRunnableDownloadableInstallerPart*
game_hub_data_runnable_downloadable_installer_part_construct (GType object_type,
                                                              const gchar* id,
                                                              const gchar* url,
                                                              gint64 size,
                                                              GFile* remote,
                                                              GFile* local,
                                                              const gchar* checksum,
                                                              GChecksumType checksum_type)
{
	GameHubDataRunnableDownloadableInstallerPart * self = NULL;
#line 558 "../src/data/Runnable.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 558 "../src/data/Runnable.vala"
	g_return_val_if_fail (url != NULL, NULL);
#line 558 "../src/data/Runnable.vala"
	g_return_val_if_fail (remote != NULL, NULL);
#line 558 "../src/data/Runnable.vala"
	g_return_val_if_fail (local != NULL, NULL);
#line 560 "../src/data/Runnable.vala"
	self = (GameHubDataRunnableDownloadableInstallerPart*) g_object_new (object_type, "id", id, "url", url, "size", size, "remote", remote, "local", local, "checksum", checksum, "checksum-type", checksum_type, NULL);
#line 558 "../src/data/Runnable.vala"
	return self;
#line 9379 "Runnable.c"
}

GameHubDataRunnableDownloadableInstallerPart*
game_hub_data_runnable_downloadable_installer_part_new (const gchar* id,
                                                        const gchar* url,
                                                        gint64 size,
                                                        GFile* remote,
                                                        GFile* local,
                                                        const gchar* checksum,
                                                        GChecksumType checksum_type)
{
#line 558 "../src/data/Runnable.vala"
	return game_hub_data_runnable_downloadable_installer_part_construct (GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_TYPE_PART, id, url, size, remote, local, checksum, checksum_type);
#line 9393 "Runnable.c"
}

const gchar*
game_hub_data_runnable_downloadable_installer_part_get_id (GameHubDataRunnableDownloadableInstallerPart* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 551 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 551 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_id;
#line 551 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 551 "../src/data/Runnable.vala"
	return result;
#line 9409 "Runnable.c"
}

void
game_hub_data_runnable_downloadable_installer_part_set_id (GameHubDataRunnableDownloadableInstallerPart* self,
                                                           const gchar* value)
{
#line 551 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 551 "../src/data/Runnable.vala"
	if (g_strcmp0 (value, game_hub_data_runnable_downloadable_installer_part_get_id (self)) != 0) {
#line 9420 "Runnable.c"
		gchar* _tmp0_;
#line 551 "../src/data/Runnable.vala"
		_tmp0_ = g_strdup (value);
#line 551 "../src/data/Runnable.vala"
		_g_free0 (self->priv->_id);
#line 551 "../src/data/Runnable.vala"
		self->priv->_id = _tmp0_;
#line 551 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_downloadable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_ID_PROPERTY]);
#line 9430 "Runnable.c"
	}
}

const gchar*
game_hub_data_runnable_downloadable_installer_part_get_url (GameHubDataRunnableDownloadableInstallerPart* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 552 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 552 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_url;
#line 552 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 552 "../src/data/Runnable.vala"
	return result;
#line 9447 "Runnable.c"
}

void
game_hub_data_runnable_downloadable_installer_part_set_url (GameHubDataRunnableDownloadableInstallerPart* self,
                                                            const gchar* value)
{
#line 552 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 552 "../src/data/Runnable.vala"
	if (g_strcmp0 (value, game_hub_data_runnable_downloadable_installer_part_get_url (self)) != 0) {
#line 9458 "Runnable.c"
		gchar* _tmp0_;
#line 552 "../src/data/Runnable.vala"
		_tmp0_ = g_strdup (value);
#line 552 "../src/data/Runnable.vala"
		_g_free0 (self->priv->_url);
#line 552 "../src/data/Runnable.vala"
		self->priv->_url = _tmp0_;
#line 552 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_downloadable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_URL_PROPERTY]);
#line 9468 "Runnable.c"
	}
}

gint64
game_hub_data_runnable_downloadable_installer_part_get_size (GameHubDataRunnableDownloadableInstallerPart* self)
{
	gint64 result;
#line 553 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 553 "../src/data/Runnable.vala"
	result = self->priv->_size;
#line 553 "../src/data/Runnable.vala"
	return result;
#line 9482 "Runnable.c"
}

void
game_hub_data_runnable_downloadable_installer_part_set_size (GameHubDataRunnableDownloadableInstallerPart* self,
                                                             gint64 value)
{
#line 553 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 553 "../src/data/Runnable.vala"
	if (game_hub_data_runnable_downloadable_installer_part_get_size (self) != value) {
#line 553 "../src/data/Runnable.vala"
		self->priv->_size = value;
#line 553 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_downloadable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_SIZE_PROPERTY]);
#line 9497 "Runnable.c"
	}
}

GFile*
game_hub_data_runnable_downloadable_installer_part_get_remote (GameHubDataRunnableDownloadableInstallerPart* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 554 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 554 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_remote;
#line 554 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 554 "../src/data/Runnable.vala"
	return result;
#line 9514 "Runnable.c"
}

void
game_hub_data_runnable_downloadable_installer_part_set_remote (GameHubDataRunnableDownloadableInstallerPart* self,
                                                               GFile* value)
{
#line 554 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 554 "../src/data/Runnable.vala"
	if (game_hub_data_runnable_downloadable_installer_part_get_remote (self) != value) {
#line 9525 "Runnable.c"
		GFile* _tmp0_;
#line 554 "../src/data/Runnable.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 554 "../src/data/Runnable.vala"
		_g_object_unref0 (self->priv->_remote);
#line 554 "../src/data/Runnable.vala"
		self->priv->_remote = _tmp0_;
#line 554 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_downloadable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_REMOTE_PROPERTY]);
#line 9535 "Runnable.c"
	}
}

GFile*
game_hub_data_runnable_downloadable_installer_part_get_local (GameHubDataRunnableDownloadableInstallerPart* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 555 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 555 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_local;
#line 555 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 555 "../src/data/Runnable.vala"
	return result;
#line 9552 "Runnable.c"
}

void
game_hub_data_runnable_downloadable_installer_part_set_local (GameHubDataRunnableDownloadableInstallerPart* self,
                                                              GFile* value)
{
#line 555 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 555 "../src/data/Runnable.vala"
	if (game_hub_data_runnable_downloadable_installer_part_get_local (self) != value) {
#line 9563 "Runnable.c"
		GFile* _tmp0_;
#line 555 "../src/data/Runnable.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 555 "../src/data/Runnable.vala"
		_g_object_unref0 (self->priv->_local);
#line 555 "../src/data/Runnable.vala"
		self->priv->_local = _tmp0_;
#line 555 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_downloadable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_LOCAL_PROPERTY]);
#line 9573 "Runnable.c"
	}
}

const gchar*
game_hub_data_runnable_downloadable_installer_part_get_checksum (GameHubDataRunnableDownloadableInstallerPart* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 556 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 556 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_checksum;
#line 556 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 556 "../src/data/Runnable.vala"
	return result;
#line 9590 "Runnable.c"
}

void
game_hub_data_runnable_downloadable_installer_part_set_checksum (GameHubDataRunnableDownloadableInstallerPart* self,
                                                                 const gchar* value)
{
#line 556 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 556 "../src/data/Runnable.vala"
	if (g_strcmp0 (value, game_hub_data_runnable_downloadable_installer_part_get_checksum (self)) != 0) {
#line 9601 "Runnable.c"
		gchar* _tmp0_;
#line 556 "../src/data/Runnable.vala"
		_tmp0_ = g_strdup (value);
#line 556 "../src/data/Runnable.vala"
		_g_free0 (self->priv->_checksum);
#line 556 "../src/data/Runnable.vala"
		self->priv->_checksum = _tmp0_;
#line 556 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_downloadable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_CHECKSUM_PROPERTY]);
#line 9611 "Runnable.c"
	}
}

GChecksumType
game_hub_data_runnable_downloadable_installer_part_get_checksum_type (GameHubDataRunnableDownloadableInstallerPart* self)
{
	GChecksumType result;
	GChecksumType _tmp0_;
#line 557 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 557 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_checksum_type;
#line 557 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 557 "../src/data/Runnable.vala"
	return result;
#line 9628 "Runnable.c"
}

void
game_hub_data_runnable_downloadable_installer_part_set_checksum_type (GameHubDataRunnableDownloadableInstallerPart* self,
                                                                      GChecksumType value)
{
#line 557 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 557 "../src/data/Runnable.vala"
	if (game_hub_data_runnable_downloadable_installer_part_get_checksum_type (self) != value) {
#line 557 "../src/data/Runnable.vala"
		self->priv->_checksum_type = value;
#line 557 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_downloadable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_CHECKSUM_TYPE_PROPERTY]);
#line 9643 "Runnable.c"
	}
}

const gchar*
game_hub_data_runnable_downloadable_installer_part_get_checksum_type_string (GameHubDataRunnableDownloadableInstallerPart* self)
{
	const gchar* result;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	GChecksumType _tmp5_;
#line 564 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 566 "../src/data/Runnable.vala"
	_tmp1_ = self->priv->_checksum;
#line 566 "../src/data/Runnable.vala"
	if (_tmp1_ == NULL) {
#line 566 "../src/data/Runnable.vala"
		_tmp0_ = TRUE;
#line 9662 "Runnable.c"
	} else {
		const gchar* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 566 "../src/data/Runnable.vala"
		_tmp2_ = self->priv->_checksum;
#line 566 "../src/data/Runnable.vala"
		_tmp3_ = strlen (_tmp2_);
#line 566 "../src/data/Runnable.vala"
		_tmp4_ = _tmp3_;
#line 566 "../src/data/Runnable.vala"
		_tmp0_ = _tmp4_ == 0;
#line 9675 "Runnable.c"
	}
#line 566 "../src/data/Runnable.vala"
	if (_tmp0_) {
#line 566 "../src/data/Runnable.vala"
		result = NULL;
#line 566 "../src/data/Runnable.vala"
		return result;
#line 9683 "Runnable.c"
	}
#line 567 "../src/data/Runnable.vala"
	_tmp5_ = self->priv->_checksum_type;
#line 567 "../src/data/Runnable.vala"
	switch (_tmp5_) {
#line 567 "../src/data/Runnable.vala"
		case G_CHECKSUM_MD5:
#line 9691 "Runnable.c"
		{
#line 569 "../src/data/Runnable.vala"
			result = "md5";
#line 569 "../src/data/Runnable.vala"
			return result;
#line 9697 "Runnable.c"
		}
#line 567 "../src/data/Runnable.vala"
		case G_CHECKSUM_SHA1:
#line 9701 "Runnable.c"
		{
#line 570 "../src/data/Runnable.vala"
			result = "sha1";
#line 570 "../src/data/Runnable.vala"
			return result;
#line 9707 "Runnable.c"
		}
#line 567 "../src/data/Runnable.vala"
		case G_CHECKSUM_SHA256:
#line 9711 "Runnable.c"
		{
#line 571 "../src/data/Runnable.vala"
			result = "sha256";
#line 571 "../src/data/Runnable.vala"
			return result;
#line 9717 "Runnable.c"
		}
#line 567 "../src/data/Runnable.vala"
		case G_CHECKSUM_SHA512:
#line 9721 "Runnable.c"
		{
#line 572 "../src/data/Runnable.vala"
			result = "sha512";
#line 572 "../src/data/Runnable.vala"
			return result;
#line 9727 "Runnable.c"
		}
		default:
#line 567 "../src/data/Runnable.vala"
		break;
#line 9732 "Runnable.c"
	}
#line 574 "../src/data/Runnable.vala"
	result = NULL;
#line 574 "../src/data/Runnable.vala"
	return result;
#line 9738 "Runnable.c"
}

static void
game_hub_data_runnable_downloadable_installer_part_class_init (GameHubDataRunnableDownloadableInstallerPartClass * klass,
                                                               gpointer klass_data)
{
#line 549 "../src/data/Runnable.vala"
	game_hub_data_runnable_downloadable_installer_part_parent_class = g_type_class_peek_parent (klass);
#line 549 "../src/data/Runnable.vala"
	g_type_class_adjust_private_offset (klass, &GameHubDataRunnableDownloadableInstallerPart_private_offset);
#line 549 "../src/data/Runnable.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_hub_data_runnable_downloadable_installer_part_get_property;
#line 549 "../src/data/Runnable.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_game_hub_data_runnable_downloadable_installer_part_set_property;
#line 549 "../src/data/Runnable.vala"
	G_OBJECT_CLASS (klass)->finalize = game_hub_data_runnable_downloadable_installer_part_finalize;
#line 549 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_ID_PROPERTY, game_hub_data_runnable_downloadable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 549 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_URL_PROPERTY, game_hub_data_runnable_downloadable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_URL_PROPERTY] = g_param_spec_string ("url", "url", "url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 549 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_SIZE_PROPERTY, game_hub_data_runnable_downloadable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_SIZE_PROPERTY] = g_param_spec_int64 ("size", "size", "size", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 549 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_REMOTE_PROPERTY, game_hub_data_runnable_downloadable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_REMOTE_PROPERTY] = g_param_spec_object ("remote", "remote", "remote", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 549 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_LOCAL_PROPERTY, game_hub_data_runnable_downloadable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_LOCAL_PROPERTY] = g_param_spec_object ("local", "local", "local", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 549 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_CHECKSUM_PROPERTY, game_hub_data_runnable_downloadable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_CHECKSUM_PROPERTY] = g_param_spec_string ("checksum", "checksum", "checksum", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 549 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_CHECKSUM_TYPE_PROPERTY, game_hub_data_runnable_downloadable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_CHECKSUM_TYPE_PROPERTY] = g_param_spec_int ("checksum-type", "checksum-type", "checksum-type", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 549 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_CHECKSUM_TYPE_STRING_PROPERTY, game_hub_data_runnable_downloadable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_CHECKSUM_TYPE_STRING_PROPERTY] = g_param_spec_string ("checksum-type-string", "checksum-type-string", "checksum-type-string", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 9771 "Runnable.c"
}

static void
game_hub_data_runnable_downloadable_installer_part_instance_init (GameHubDataRunnableDownloadableInstallerPart * self,
                                                                  gpointer klass)
{
#line 549 "../src/data/Runnable.vala"
	self->priv = game_hub_data_runnable_downloadable_installer_part_get_instance_private (self);
#line 9780 "Runnable.c"
}

static void
game_hub_data_runnable_downloadable_installer_part_finalize (GObject * obj)
{
	GameHubDataRunnableDownloadableInstallerPart * self;
#line 549 "../src/data/Runnable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_TYPE_PART, GameHubDataRunnableDownloadableInstallerPart);
#line 551 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_id);
#line 552 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_url);
#line 554 "../src/data/Runnable.vala"
	_g_object_unref0 (self->priv->_remote);
#line 555 "../src/data/Runnable.vala"
	_g_object_unref0 (self->priv->_local);
#line 556 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_checksum);
#line 549 "../src/data/Runnable.vala"
	G_OBJECT_CLASS (game_hub_data_runnable_downloadable_installer_part_parent_class)->finalize (obj);
#line 9801 "Runnable.c"
}

GType
game_hub_data_runnable_downloadable_installer_part_get_type (void)
{
	static volatile gsize game_hub_data_runnable_downloadable_installer_part_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_runnable_downloadable_installer_part_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameHubDataRunnableDownloadableInstallerPartClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_runnable_downloadable_installer_part_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataRunnableDownloadableInstallerPart), 0, (GInstanceInitFunc) game_hub_data_runnable_downloadable_installer_part_instance_init, NULL };
		GType game_hub_data_runnable_downloadable_installer_part_type_id;
		game_hub_data_runnable_downloadable_installer_part_type_id = g_type_register_static (G_TYPE_OBJECT, "GameHubDataRunnableDownloadableInstallerPart", &g_define_type_info, 0);
		GameHubDataRunnableDownloadableInstallerPart_private_offset = g_type_add_instance_private (game_hub_data_runnable_downloadable_installer_part_type_id, sizeof (GameHubDataRunnableDownloadableInstallerPartPrivate));
		g_once_init_leave (&game_hub_data_runnable_downloadable_installer_part_type_id__volatile, game_hub_data_runnable_downloadable_installer_part_type_id);
	}
	return game_hub_data_runnable_downloadable_installer_part_type_id__volatile;
}

static void
_vala_game_hub_data_runnable_downloadable_installer_part_get_property (GObject * object,
                                                                       guint property_id,
                                                                       GValue * value,
                                                                       GParamSpec * pspec)
{
	GameHubDataRunnableDownloadableInstallerPart * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_TYPE_PART, GameHubDataRunnableDownloadableInstallerPart);
#line 549 "../src/data/Runnable.vala"
	switch (property_id) {
#line 549 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_ID_PROPERTY:
#line 549 "../src/data/Runnable.vala"
		g_value_set_string (value, game_hub_data_runnable_downloadable_installer_part_get_id (self));
#line 549 "../src/data/Runnable.vala"
		break;
#line 549 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_URL_PROPERTY:
#line 549 "../src/data/Runnable.vala"
		g_value_set_string (value, game_hub_data_runnable_downloadable_installer_part_get_url (self));
#line 549 "../src/data/Runnable.vala"
		break;
#line 549 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_SIZE_PROPERTY:
#line 549 "../src/data/Runnable.vala"
		g_value_set_int64 (value, game_hub_data_runnable_downloadable_installer_part_get_size (self));
#line 549 "../src/data/Runnable.vala"
		break;
#line 549 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_REMOTE_PROPERTY:
#line 549 "../src/data/Runnable.vala"
		g_value_set_object (value, game_hub_data_runnable_downloadable_installer_part_get_remote (self));
#line 549 "../src/data/Runnable.vala"
		break;
#line 549 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_LOCAL_PROPERTY:
#line 549 "../src/data/Runnable.vala"
		g_value_set_object (value, game_hub_data_runnable_downloadable_installer_part_get_local (self));
#line 549 "../src/data/Runnable.vala"
		break;
#line 549 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_CHECKSUM_PROPERTY:
#line 549 "../src/data/Runnable.vala"
		g_value_set_string (value, game_hub_data_runnable_downloadable_installer_part_get_checksum (self));
#line 549 "../src/data/Runnable.vala"
		break;
#line 549 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_CHECKSUM_TYPE_PROPERTY:
#line 549 "../src/data/Runnable.vala"
		g_value_set_int (value, game_hub_data_runnable_downloadable_installer_part_get_checksum_type (self));
#line 549 "../src/data/Runnable.vala"
		break;
#line 549 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_CHECKSUM_TYPE_STRING_PROPERTY:
#line 549 "../src/data/Runnable.vala"
		g_value_set_string (value, game_hub_data_runnable_downloadable_installer_part_get_checksum_type_string (self));
#line 549 "../src/data/Runnable.vala"
		break;
#line 9876 "Runnable.c"
		default:
#line 549 "../src/data/Runnable.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 549 "../src/data/Runnable.vala"
		break;
#line 9882 "Runnable.c"
	}
}

static void
_vala_game_hub_data_runnable_downloadable_installer_part_set_property (GObject * object,
                                                                       guint property_id,
                                                                       const GValue * value,
                                                                       GParamSpec * pspec)
{
	GameHubDataRunnableDownloadableInstallerPart * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_TYPE_PART, GameHubDataRunnableDownloadableInstallerPart);
#line 549 "../src/data/Runnable.vala"
	switch (property_id) {
#line 549 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_ID_PROPERTY:
#line 549 "../src/data/Runnable.vala"
		game_hub_data_runnable_downloadable_installer_part_set_id (self, g_value_get_string (value));
#line 549 "../src/data/Runnable.vala"
		break;
#line 549 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_URL_PROPERTY:
#line 549 "../src/data/Runnable.vala"
		game_hub_data_runnable_downloadable_installer_part_set_url (self, g_value_get_string (value));
#line 549 "../src/data/Runnable.vala"
		break;
#line 549 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_SIZE_PROPERTY:
#line 549 "../src/data/Runnable.vala"
		game_hub_data_runnable_downloadable_installer_part_set_size (self, g_value_get_int64 (value));
#line 549 "../src/data/Runnable.vala"
		break;
#line 549 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_REMOTE_PROPERTY:
#line 549 "../src/data/Runnable.vala"
		game_hub_data_runnable_downloadable_installer_part_set_remote (self, g_value_get_object (value));
#line 549 "../src/data/Runnable.vala"
		break;
#line 549 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_LOCAL_PROPERTY:
#line 549 "../src/data/Runnable.vala"
		game_hub_data_runnable_downloadable_installer_part_set_local (self, g_value_get_object (value));
#line 549 "../src/data/Runnable.vala"
		break;
#line 549 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_CHECKSUM_PROPERTY:
#line 549 "../src/data/Runnable.vala"
		game_hub_data_runnable_downloadable_installer_part_set_checksum (self, g_value_get_string (value));
#line 549 "../src/data/Runnable.vala"
		break;
#line 549 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_PART_CHECKSUM_TYPE_PROPERTY:
#line 549 "../src/data/Runnable.vala"
		game_hub_data_runnable_downloadable_installer_part_set_checksum_type (self, g_value_get_int (value));
#line 549 "../src/data/Runnable.vala"
		break;
#line 9938 "Runnable.c"
		default:
#line 549 "../src/data/Runnable.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 549 "../src/data/Runnable.vala"
		break;
#line 9944 "Runnable.c"
	}
}

static void
game_hub_data_runnable_downloadable_installer_class_init (GameHubDataRunnableDownloadableInstallerClass * klass,
                                                          gpointer klass_data)
{
#line 547 "../src/data/Runnable.vala"
	game_hub_data_runnable_downloadable_installer_parent_class = g_type_class_peek_parent (klass);
#line 547 "../src/data/Runnable.vala"
	((GameHubDataRunnableInstallerClass *) klass)->finalize = game_hub_data_runnable_downloadable_installer_finalize;
#line 547 "../src/data/Runnable.vala"
	g_type_class_adjust_private_offset (klass, &GameHubDataRunnableDownloadableInstaller_private_offset);
#line 547 "../src/data/Runnable.vala"
	((GameHubDataRunnableDownloadableInstallerClass *) klass)->fetch_parts = (void (*) (GameHubDataRunnableDownloadableInstaller*, GAsyncReadyCallback, gpointer)) game_hub_data_runnable_downloadable_installer_real_fetch_parts;
#line 547 "../src/data/Runnable.vala"
	((GameHubDataRunnableDownloadableInstallerClass *) klass)->fetch_parts_finish = (void (*) (GameHubDataRunnableDownloadableInstaller*, GAsyncResult*)) game_hub_data_runnable_downloadable_installer_real_fetch_parts_finish;
#line 547 "../src/data/Runnable.vala"
	((GameHubDataRunnableInstallerClass *) klass)->install = (void (*) (GameHubDataRunnableInstaller*, GameHubDataRunnable*, GameHubDataCompatTool*, GAsyncReadyCallback, gpointer)) game_hub_data_runnable_downloadable_installer_real_install;
#line 547 "../src/data/Runnable.vala"
	((GameHubDataRunnableInstallerClass *) klass)->install_finish = (void (*) (GameHubDataRunnableInstaller*, GAsyncResult*)) game_hub_data_runnable_downloadable_installer_install_finish;
#line 9966 "Runnable.c"
}

static void
game_hub_data_runnable_downloadable_installer_instance_init (GameHubDataRunnableDownloadableInstaller * self,
                                                             gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 547 "../src/data/Runnable.vala"
	self->priv = game_hub_data_runnable_downloadable_installer_get_instance_private (self);
#line 579 "../src/data/Runnable.vala"
	_tmp0_ = gee_array_list_new (GAME_HUB_DATA_RUNNABLE_DOWNLOADABLE_INSTALLER_TYPE_PART, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 579 "../src/data/Runnable.vala"
	self->priv->_parts = _tmp0_;
#line 9980 "Runnable.c"
}

static void
game_hub_data_runnable_downloadable_installer_finalize (GameHubDataRunnableInstaller * obj)
{
	GameHubDataRunnableDownloadableInstaller * self;
#line 547 "../src/data/Runnable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_RUNNABLE_TYPE_DOWNLOADABLE_INSTALLER, GameHubDataRunnableDownloadableInstaller);
#line 579 "../src/data/Runnable.vala"
	_g_object_unref0 (self->priv->_parts);
#line 547 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_INSTALLER_CLASS (game_hub_data_runnable_downloadable_installer_parent_class)->finalize (obj);
#line 9993 "Runnable.c"
}

GType
game_hub_data_runnable_downloadable_installer_get_type (void)
{
	static volatile gsize game_hub_data_runnable_downloadable_installer_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_runnable_downloadable_installer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameHubDataRunnableDownloadableInstallerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_runnable_downloadable_installer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataRunnableDownloadableInstaller), 0, (GInstanceInitFunc) game_hub_data_runnable_downloadable_installer_instance_init, NULL };
		GType game_hub_data_runnable_downloadable_installer_type_id;
		game_hub_data_runnable_downloadable_installer_type_id = g_type_register_static (GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER, "GameHubDataRunnableDownloadableInstaller", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		GameHubDataRunnableDownloadableInstaller_private_offset = g_type_add_instance_private (game_hub_data_runnable_downloadable_installer_type_id, sizeof (GameHubDataRunnableDownloadableInstallerPrivate));
		g_once_init_leave (&game_hub_data_runnable_downloadable_installer_type_id__volatile, game_hub_data_runnable_downloadable_installer_type_id);
	}
	return game_hub_data_runnable_downloadable_installer_type_id__volatile;
}

static inline gpointer
game_hub_data_runnable_runnable_action_get_instance_private (GameHubDataRunnableRunnableAction* self)
{
	return G_STRUCT_MEMBER_P (self, GameHubDataRunnableRunnableAction_private_offset);
}

static GType*
_g_type_dup (GType* self)
{
	GType* dup;
#line 848 "../src/data/Runnable.vala"
	dup = g_new0 (GType, 1);
#line 848 "../src/data/Runnable.vala"
	memcpy (dup, self, sizeof (GType));
#line 848 "../src/data/Runnable.vala"
	return dup;
#line 10026 "Runnable.c"
}

static gpointer
__g_type_dup0 (gpointer self)
{
#line 848 "../src/data/Runnable.vala"
	return self ? _g_type_dup (self) : NULL;
#line 10034 "Runnable.c"
}

gboolean
game_hub_data_runnable_runnable_action_is_available (GameHubDataRunnableRunnableAction* self,
                                                     GameHubDataCompatTool* tool)
{
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_;
	GType t = 0UL;
	GType** _tmp9_;
	gint _tmp9__length1;
	GType** _tmp10_;
	gint _tmp10__length1;
	gboolean result = FALSE;
#line 834 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 836 "../src/data/Runnable.vala"
	_tmp1_ = self->priv->_file;
#line 836 "../src/data/Runnable.vala"
	if (_tmp1_ == NULL) {
#line 10055 "Runnable.c"
		const gchar* _tmp2_;
#line 836 "../src/data/Runnable.vala"
		_tmp2_ = self->priv->_uri;
#line 836 "../src/data/Runnable.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 10061 "Runnable.c"
	} else {
#line 836 "../src/data/Runnable.vala"
		_tmp0_ = FALSE;
#line 10065 "Runnable.c"
	}
#line 836 "../src/data/Runnable.vala"
	if (_tmp0_) {
#line 838 "../src/data/Runnable.vala"
		result = TRUE;
#line 838 "../src/data/Runnable.vala"
		return result;
#line 10073 "Runnable.c"
	}
#line 841 "../src/data/Runnable.vala"
	if (tool == NULL) {
#line 10077 "Runnable.c"
		gboolean _tmp3_ = FALSE;
		GType** _tmp4_;
		gint _tmp4__length1;
		GType** _tmp5_;
		gint _tmp5__length1;
#line 843 "../src/data/Runnable.vala"
		_tmp4_ = game_hub_data_runnable_runnable_action_get_compat_tools (self, &_tmp4__length1);
#line 843 "../src/data/Runnable.vala"
		_tmp5_ = _tmp4_;
#line 843 "../src/data/Runnable.vala"
		_tmp5__length1 = _tmp4__length1;
#line 843 "../src/data/Runnable.vala"
		if (_tmp5__length1 == 0) {
#line 843 "../src/data/Runnable.vala"
			_tmp3_ = TRUE;
#line 10093 "Runnable.c"
		} else {
			GType** _tmp6_;
			gint _tmp6__length1;
			GType** _tmp7_;
			gint _tmp7__length1;
			GType* _tmp8_;
#line 843 "../src/data/Runnable.vala"
			_tmp6_ = game_hub_data_runnable_runnable_action_get_compat_tools (self, &_tmp6__length1);
#line 843 "../src/data/Runnable.vala"
			_tmp7_ = _tmp6_;
#line 843 "../src/data/Runnable.vala"
			_tmp7__length1 = _tmp6__length1;
#line 843 "../src/data/Runnable.vala"
			_tmp8_ = _tmp7_[0];
#line 843 "../src/data/Runnable.vala"
			_tmp3_ = _tmp8_ == NULL;
#line 10110 "Runnable.c"
		}
#line 843 "../src/data/Runnable.vala"
		result = _tmp3_;
#line 843 "../src/data/Runnable.vala"
		return result;
#line 10116 "Runnable.c"
	}
#line 846 "../src/data/Runnable.vala"
	t = G_TYPE_FROM_INSTANCE ((GObject*) tool);
#line 848 "../src/data/Runnable.vala"
	_tmp9_ = game_hub_data_runnable_runnable_action_get_compat_tools (self, &_tmp9__length1);
#line 848 "../src/data/Runnable.vala"
	_tmp10_ = _tmp9_;
#line 848 "../src/data/Runnable.vala"
	_tmp10__length1 = _tmp9__length1;
#line 10126 "Runnable.c"
	{
		GType** type_collection = NULL;
		gint type_collection_length1 = 0;
		gint _type_collection_size_ = 0;
		gint type_it = 0;
#line 848 "../src/data/Runnable.vala"
		type_collection = _tmp10_;
#line 848 "../src/data/Runnable.vala"
		type_collection_length1 = _tmp10__length1;
#line 848 "../src/data/Runnable.vala"
		for (type_it = 0; type_it < type_collection_length1; type_it = type_it + 1) {
#line 10138 "Runnable.c"
			GType* _tmp11_;
			GType* type = NULL;
#line 848 "../src/data/Runnable.vala"
			_tmp11_ = __g_type_dup0 (type_collection[type_it]);
#line 848 "../src/data/Runnable.vala"
			type = _tmp11_;
#line 10145 "Runnable.c"
			{
				gboolean _tmp12_ = FALSE;
				GType* _tmp13_;
#line 850 "../src/data/Runnable.vala"
				_tmp13_ = type;
#line 850 "../src/data/Runnable.vala"
				if (_tmp13_ != NULL) {
#line 10153 "Runnable.c"
					GType* _tmp14_;
#line 850 "../src/data/Runnable.vala"
					_tmp14_ = type;
#line 850 "../src/data/Runnable.vala"
					_tmp12_ = g_type_is_a (t, *_tmp14_);
#line 10159 "Runnable.c"
				} else {
#line 850 "../src/data/Runnable.vala"
					_tmp12_ = FALSE;
#line 10163 "Runnable.c"
				}
#line 850 "../src/data/Runnable.vala"
				if (_tmp12_) {
#line 852 "../src/data/Runnable.vala"
					result = TRUE;
#line 852 "../src/data/Runnable.vala"
					_g_free0 (type);
#line 852 "../src/data/Runnable.vala"
					return result;
#line 10173 "Runnable.c"
				}
#line 848 "../src/data/Runnable.vala"
				_g_free0 (type);
#line 10177 "Runnable.c"
			}
		}
	}
#line 856 "../src/data/Runnable.vala"
	result = FALSE;
#line 856 "../src/data/Runnable.vala"
	return result;
#line 10185 "Runnable.c"
}

static void
game_hub_data_runnable_runnable_action_invoke_data_free (gpointer _data)
{
	GameHubDataRunnableRunnableActionInvokeData* _data_;
	_data_ = _data;
#line 821 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->tool);
#line 821 "../src/data/Runnable.vala"
	_game_hub_data_runnable_runnable_action_unref0 (_data_->self);
#line 821 "../src/data/Runnable.vala"
	g_slice_free (GameHubDataRunnableRunnableActionInvokeData, _data_);
#line 10199 "Runnable.c"
}

static gpointer
_game_hub_data_runnable_runnable_action_ref0 (gpointer self)
{
#line 821 "../src/data/Runnable.vala"
	return self ? game_hub_data_runnable_runnable_action_ref (self) : NULL;
#line 10207 "Runnable.c"
}

void
game_hub_data_runnable_runnable_action_invoke (GameHubDataRunnableRunnableAction* self,
                                               GameHubDataCompatTool* tool,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_)
{
	GameHubDataRunnableRunnableActionInvokeData* _data_;
	GameHubDataRunnableRunnableAction* _tmp0_;
	GameHubDataCompatTool* _tmp1_;
#line 821 "../src/data/Runnable.vala"
	_data_ = g_slice_new0 (GameHubDataRunnableRunnableActionInvokeData);
#line 821 "../src/data/Runnable.vala"
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
#line 821 "../src/data/Runnable.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_runnable_runnable_action_invoke_data_free);
#line 821 "../src/data/Runnable.vala"
	_tmp0_ = _game_hub_data_runnable_runnable_action_ref0 (self);
#line 821 "../src/data/Runnable.vala"
	_data_->self = _tmp0_;
#line 821 "../src/data/Runnable.vala"
	_tmp1_ = _g_object_ref0 (tool);
#line 821 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->tool);
#line 821 "../src/data/Runnable.vala"
	_data_->tool = _tmp1_;
#line 821 "../src/data/Runnable.vala"
	game_hub_data_runnable_runnable_action_invoke_co (_data_);
#line 10237 "Runnable.c"
}

void
game_hub_data_runnable_runnable_action_invoke_finish (GameHubDataRunnableRunnableAction* self,
                                                      GAsyncResult* _res_)
{
	GameHubDataRunnableRunnableActionInvokeData* _data_;
#line 821 "../src/data/Runnable.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 10247 "Runnable.c"
}

static void
game_hub_data_runnable_runnable_action_invoke_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_)
{
	GameHubDataRunnableRunnableActionInvokeData* _data_;
#line 869 "../src/data/Runnable.vala"
	_data_ = _user_data_;
#line 869 "../src/data/Runnable.vala"
	_data_->_source_object_ = source_object;
#line 869 "../src/data/Runnable.vala"
	_data_->_res_ = _res_;
#line 869 "../src/data/Runnable.vala"
	game_hub_data_runnable_runnable_action_invoke_co (_data_);
#line 10264 "Runnable.c"
}

static gboolean
game_hub_data_runnable_runnable_action_invoke_co (GameHubDataRunnableRunnableActionInvokeData* _data_)
{
#line 859 "../src/data/Runnable.vala"
	switch (_data_->_state_) {
#line 859 "../src/data/Runnable.vala"
		case 0:
#line 10274 "Runnable.c"
		goto _state_0;
#line 859 "../src/data/Runnable.vala"
		case 1:
#line 10278 "Runnable.c"
		goto _state_1;
		default:
#line 859 "../src/data/Runnable.vala"
		g_assert_not_reached ();
#line 10283 "Runnable.c"
	}
	_state_0:
#line 861 "../src/data/Runnable.vala"
	_data_->_tmp1_ = _data_->self->priv->_file;
#line 861 "../src/data/Runnable.vala"
	if (_data_->_tmp1_ == NULL) {
#line 861 "../src/data/Runnable.vala"
		_data_->_tmp2_ = _data_->self->priv->_uri;
#line 861 "../src/data/Runnable.vala"
		_data_->_tmp0_ = _data_->_tmp2_ != NULL;
#line 10294 "Runnable.c"
	} else {
#line 861 "../src/data/Runnable.vala"
		_data_->_tmp0_ = FALSE;
#line 10298 "Runnable.c"
	}
#line 861 "../src/data/Runnable.vala"
	if (_data_->_tmp0_) {
#line 863 "../src/data/Runnable.vala"
		_data_->_tmp3_ = _data_->self->priv->_uri;
#line 863 "../src/data/Runnable.vala"
		game_hub_utils_open_uri (_data_->_tmp3_);
#line 864 "../src/data/Runnable.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 864 "../src/data/Runnable.vala"
		if (_data_->_state_ != 0) {
#line 864 "../src/data/Runnable.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 864 "../src/data/Runnable.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 10314 "Runnable.c"
			}
		}
#line 864 "../src/data/Runnable.vala"
		g_object_unref (_data_->_async_result);
#line 864 "../src/data/Runnable.vala"
		return FALSE;
#line 10321 "Runnable.c"
	}
#line 867 "../src/data/Runnable.vala"
	if (game_hub_data_runnable_runnable_action_is_available (_data_->self, _data_->tool)) {
#line 867 "../src/data/Runnable.vala"
		_data_->_tmp5_ = _data_->self->priv->_runnable;
#line 867 "../src/data/Runnable.vala"
		_data_->_tmp4_ = game_hub_data_compat_tool_can_run_action (_data_->tool, _data_->_tmp5_, _data_->self);
#line 10329 "Runnable.c"
	} else {
#line 867 "../src/data/Runnable.vala"
		_data_->_tmp4_ = FALSE;
#line 10333 "Runnable.c"
	}
#line 867 "../src/data/Runnable.vala"
	if (_data_->_tmp4_) {
#line 869 "../src/data/Runnable.vala"
		_data_->_tmp6_ = _data_->self->priv->_runnable;
#line 869 "../src/data/Runnable.vala"
		_data_->_state_ = 1;
#line 869 "../src/data/Runnable.vala"
		game_hub_data_compat_tool_run_action (_data_->tool, _data_->_tmp6_, _data_->self, game_hub_data_runnable_runnable_action_invoke_ready, _data_);
#line 869 "../src/data/Runnable.vala"
		return FALSE;
#line 10345 "Runnable.c"
		_state_1:
#line 869 "../src/data/Runnable.vala"
		game_hub_data_compat_tool_run_action_finish (_data_->tool, _data_->_res_);
#line 10349 "Runnable.c"
	}
#line 859 "../src/data/Runnable.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 859 "../src/data/Runnable.vala"
	if (_data_->_state_ != 0) {
#line 859 "../src/data/Runnable.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 859 "../src/data/Runnable.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 10359 "Runnable.c"
		}
	}
#line 859 "../src/data/Runnable.vala"
	g_object_unref (_data_->_async_result);
#line 859 "../src/data/Runnable.vala"
	return FALSE;
#line 10366 "Runnable.c"
}

GameHubDataRunnableRunnableAction*
game_hub_data_runnable_runnable_action_construct (GType object_type)
{
	GameHubDataRunnableRunnableAction* self = NULL;
#line 821 "../src/data/Runnable.vala"
	self = (GameHubDataRunnableRunnableAction*) g_type_create_instance (object_type);
#line 821 "../src/data/Runnable.vala"
	return self;
#line 10377 "Runnable.c"
}

GameHubDataRunnable*
game_hub_data_runnable_runnable_action_get_runnable (GameHubDataRunnableRunnableAction* self)
{
	GameHubDataRunnable* result;
	GameHubDataRunnable* _tmp0_;
#line 823 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 823 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_runnable;
#line 823 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 823 "../src/data/Runnable.vala"
	return result;
#line 10393 "Runnable.c"
}

void
game_hub_data_runnable_runnable_action_set_runnable (GameHubDataRunnableRunnableAction* self,
                                                     GameHubDataRunnable* value)
{
	GameHubDataRunnable* _tmp0_;
#line 823 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 823 "../src/data/Runnable.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 823 "../src/data/Runnable.vala"
	_g_object_unref0 (self->priv->_runnable);
#line 823 "../src/data/Runnable.vala"
	self->priv->_runnable = _tmp0_;
#line 10409 "Runnable.c"
}

gboolean
game_hub_data_runnable_runnable_action_get_is_primary (GameHubDataRunnableRunnableAction* self)
{
	gboolean result;
#line 825 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 825 "../src/data/Runnable.vala"
	result = self->priv->_is_primary;
#line 825 "../src/data/Runnable.vala"
	return result;
#line 10422 "Runnable.c"
}

void
game_hub_data_runnable_runnable_action_set_is_primary (GameHubDataRunnableRunnableAction* self,
                                                       gboolean value)
{
#line 825 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 825 "../src/data/Runnable.vala"
	self->priv->_is_primary = value;
#line 10433 "Runnable.c"
}

gboolean
game_hub_data_runnable_runnable_action_get_is_hidden (GameHubDataRunnableRunnableAction* self)
{
	gboolean result;
#line 826 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 826 "../src/data/Runnable.vala"
	result = self->priv->_is_hidden;
#line 826 "../src/data/Runnable.vala"
	return result;
#line 10446 "Runnable.c"
}

void
game_hub_data_runnable_runnable_action_set_is_hidden (GameHubDataRunnableRunnableAction* self,
                                                      gboolean value)
{
#line 826 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 826 "../src/data/Runnable.vala"
	self->priv->_is_hidden = value;
#line 10457 "Runnable.c"
}

const gchar*
game_hub_data_runnable_runnable_action_get_name (GameHubDataRunnableRunnableAction* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 827 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 827 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_name;
#line 827 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 827 "../src/data/Runnable.vala"
	return result;
#line 10473 "Runnable.c"
}

void
game_hub_data_runnable_runnable_action_set_name (GameHubDataRunnableRunnableAction* self,
                                                 const gchar* value)
{
	gchar* _tmp0_;
#line 827 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 827 "../src/data/Runnable.vala"
	_tmp0_ = g_strdup (value);
#line 827 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_name);
#line 827 "../src/data/Runnable.vala"
	self->priv->_name = _tmp0_;
#line 10489 "Runnable.c"
}

GFile*
game_hub_data_runnable_runnable_action_get_file (GameHubDataRunnableRunnableAction* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 828 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 828 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_file;
#line 828 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 828 "../src/data/Runnable.vala"
	return result;
#line 10505 "Runnable.c"
}

void
game_hub_data_runnable_runnable_action_set_file (GameHubDataRunnableRunnableAction* self,
                                                 GFile* value)
{
	GFile* _tmp0_;
#line 828 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 828 "../src/data/Runnable.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 828 "../src/data/Runnable.vala"
	_g_object_unref0 (self->priv->_file);
#line 828 "../src/data/Runnable.vala"
	self->priv->_file = _tmp0_;
#line 10521 "Runnable.c"
}

GFile*
game_hub_data_runnable_runnable_action_get_workdir (GameHubDataRunnableRunnableAction* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 829 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 829 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_workdir;
#line 829 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 829 "../src/data/Runnable.vala"
	return result;
#line 10537 "Runnable.c"
}

void
game_hub_data_runnable_runnable_action_set_workdir (GameHubDataRunnableRunnableAction* self,
                                                    GFile* value)
{
	GFile* _tmp0_;
#line 829 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 829 "../src/data/Runnable.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 829 "../src/data/Runnable.vala"
	_g_object_unref0 (self->priv->_workdir);
#line 829 "../src/data/Runnable.vala"
	self->priv->_workdir = _tmp0_;
#line 10553 "Runnable.c"
}

const gchar*
game_hub_data_runnable_runnable_action_get_args (GameHubDataRunnableRunnableAction* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 830 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 830 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_args;
#line 830 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 830 "../src/data/Runnable.vala"
	return result;
#line 10569 "Runnable.c"
}

void
game_hub_data_runnable_runnable_action_set_args (GameHubDataRunnableRunnableAction* self,
                                                 const gchar* value)
{
	gchar* _tmp0_;
#line 830 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 830 "../src/data/Runnable.vala"
	_tmp0_ = g_strdup (value);
#line 830 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_args);
#line 830 "../src/data/Runnable.vala"
	self->priv->_args = _tmp0_;
#line 10585 "Runnable.c"
}

GType**
game_hub_data_runnable_runnable_action_get_compat_tools (GameHubDataRunnableRunnableAction* self,
                                                         gint* result_length1)
{
	GType** result;
	GType** _tmp0_;
	gint _tmp0__length1;
	GType** _tmp1_;
	gint _tmp1__length1;
#line 831 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 831 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_compat_tools;
#line 831 "../src/data/Runnable.vala"
	_tmp0__length1 = self->priv->_compat_tools_length1;
#line 831 "../src/data/Runnable.vala"
	_tmp1_ = _tmp0_;
#line 831 "../src/data/Runnable.vala"
	_tmp1__length1 = _tmp0__length1;
#line 831 "../src/data/Runnable.vala"
	if (result_length1) {
#line 831 "../src/data/Runnable.vala"
		*result_length1 = _tmp1__length1;
#line 10611 "Runnable.c"
	}
#line 831 "../src/data/Runnable.vala"
	result = _tmp1_;
#line 831 "../src/data/Runnable.vala"
	return result;
#line 10617 "Runnable.c"
}

static GType**
_vala_array_dup4 (GType** self,
                  int length)
{
	GType** result;
	int i;
#line 831 "../src/data/Runnable.vala"
	result = g_new0 (GType*, length);
#line 831 "../src/data/Runnable.vala"
	for (i = 0; i < length; i++) {
#line 10630 "Runnable.c"
		GType* _tmp0_;
#line 831 "../src/data/Runnable.vala"
		_tmp0_ = __g_type_dup0 (self[i]);
#line 831 "../src/data/Runnable.vala"
		result[i] = _tmp0_;
#line 10636 "Runnable.c"
	}
#line 831 "../src/data/Runnable.vala"
	return result;
#line 10640 "Runnable.c"
}

void
game_hub_data_runnable_runnable_action_set_compat_tools (GameHubDataRunnableRunnableAction* self,
                                                         GType** value,
                                                         gint value_length1)
{
	GType** _tmp0_;
	gint _tmp0__length1;
#line 831 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 831 "../src/data/Runnable.vala"
	_tmp0_ = (value != NULL) ? _vala_array_dup4 (value, value_length1) : ((gpointer) value);
#line 831 "../src/data/Runnable.vala"
	_tmp0__length1 = value_length1;
#line 831 "../src/data/Runnable.vala"
	self->priv->_compat_tools = (_vala_array_free (self->priv->_compat_tools, self->priv->_compat_tools_length1, (GDestroyNotify) g_free), NULL);
#line 831 "../src/data/Runnable.vala"
	self->priv->_compat_tools = _tmp0_;
#line 831 "../src/data/Runnable.vala"
	self->priv->_compat_tools_length1 = _tmp0__length1;
#line 831 "../src/data/Runnable.vala"
	self->priv->__compat_tools_size_ = self->priv->_compat_tools_length1;
#line 10664 "Runnable.c"
}

const gchar*
game_hub_data_runnable_runnable_action_get_uri (GameHubDataRunnableRunnableAction* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 832 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 832 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_uri;
#line 832 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 832 "../src/data/Runnable.vala"
	return result;
#line 10680 "Runnable.c"
}

void
game_hub_data_runnable_runnable_action_set_uri (GameHubDataRunnableRunnableAction* self,
                                                const gchar* value)
{
	gchar* _tmp0_;
#line 832 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 832 "../src/data/Runnable.vala"
	_tmp0_ = g_strdup (value);
#line 832 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_uri);
#line 832 "../src/data/Runnable.vala"
	self->priv->_uri = _tmp0_;
#line 10696 "Runnable.c"
}

static void
game_hub_data_runnable_value_runnable_action_init (GValue* value)
{
#line 821 "../src/data/Runnable.vala"
	value->data[0].v_pointer = NULL;
#line 10704 "Runnable.c"
}

static void
game_hub_data_runnable_value_runnable_action_free_value (GValue* value)
{
#line 821 "../src/data/Runnable.vala"
	if (value->data[0].v_pointer) {
#line 821 "../src/data/Runnable.vala"
		game_hub_data_runnable_runnable_action_unref (value->data[0].v_pointer);
#line 10714 "Runnable.c"
	}
}

static void
game_hub_data_runnable_value_runnable_action_copy_value (const GValue* src_value,
                                                         GValue* dest_value)
{
#line 821 "../src/data/Runnable.vala"
	if (src_value->data[0].v_pointer) {
#line 821 "../src/data/Runnable.vala"
		dest_value->data[0].v_pointer = game_hub_data_runnable_runnable_action_ref (src_value->data[0].v_pointer);
#line 10726 "Runnable.c"
	} else {
#line 821 "../src/data/Runnable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 10730 "Runnable.c"
	}
}

static gpointer
game_hub_data_runnable_value_runnable_action_peek_pointer (const GValue* value)
{
#line 821 "../src/data/Runnable.vala"
	return value->data[0].v_pointer;
#line 10739 "Runnable.c"
}

static gchar*
game_hub_data_runnable_value_runnable_action_collect_value (GValue* value,
                                                            guint n_collect_values,
                                                            GTypeCValue* collect_values,
                                                            guint collect_flags)
{
#line 821 "../src/data/Runnable.vala"
	if (collect_values[0].v_pointer) {
#line 10750 "Runnable.c"
		GameHubDataRunnableRunnableAction * object;
		object = collect_values[0].v_pointer;
#line 821 "../src/data/Runnable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 821 "../src/data/Runnable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 10757 "Runnable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 821 "../src/data/Runnable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 10761 "Runnable.c"
		}
#line 821 "../src/data/Runnable.vala"
		value->data[0].v_pointer = game_hub_data_runnable_runnable_action_ref (object);
#line 10765 "Runnable.c"
	} else {
#line 821 "../src/data/Runnable.vala"
		value->data[0].v_pointer = NULL;
#line 10769 "Runnable.c"
	}
#line 821 "../src/data/Runnable.vala"
	return NULL;
#line 10773 "Runnable.c"
}

static gchar*
game_hub_data_runnable_value_runnable_action_lcopy_value (const GValue* value,
                                                          guint n_collect_values,
                                                          GTypeCValue* collect_values,
                                                          guint collect_flags)
{
	GameHubDataRunnableRunnableAction ** object_p;
	object_p = collect_values[0].v_pointer;
#line 821 "../src/data/Runnable.vala"
	if (!object_p) {
#line 821 "../src/data/Runnable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 10788 "Runnable.c"
	}
#line 821 "../src/data/Runnable.vala"
	if (!value->data[0].v_pointer) {
#line 821 "../src/data/Runnable.vala"
		*object_p = NULL;
#line 10794 "Runnable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 821 "../src/data/Runnable.vala"
		*object_p = value->data[0].v_pointer;
#line 10798 "Runnable.c"
	} else {
#line 821 "../src/data/Runnable.vala"
		*object_p = game_hub_data_runnable_runnable_action_ref (value->data[0].v_pointer);
#line 10802 "Runnable.c"
	}
#line 821 "../src/data/Runnable.vala"
	return NULL;
#line 10806 "Runnable.c"
}

GParamSpec*
game_hub_data_runnable_param_spec_runnable_action (const gchar* name,
                                                   const gchar* nick,
                                                   const gchar* blurb,
                                                   GType object_type,
                                                   GParamFlags flags)
{
	GameHubDataRunnableParamSpecRunnableAction* spec;
#line 821 "../src/data/Runnable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION), NULL);
#line 821 "../src/data/Runnable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 821 "../src/data/Runnable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 821 "../src/data/Runnable.vala"
	return G_PARAM_SPEC (spec);
#line 10825 "Runnable.c"
}

gpointer
game_hub_data_runnable_value_get_runnable_action (const GValue* value)
{
#line 821 "../src/data/Runnable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION), NULL);
#line 821 "../src/data/Runnable.vala"
	return value->data[0].v_pointer;
#line 10835 "Runnable.c"
}

void
game_hub_data_runnable_value_set_runnable_action (GValue* value,
                                                  gpointer v_object)
{
	GameHubDataRunnableRunnableAction * old;
#line 821 "../src/data/Runnable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION));
#line 821 "../src/data/Runnable.vala"
	old = value->data[0].v_pointer;
#line 821 "../src/data/Runnable.vala"
	if (v_object) {
#line 821 "../src/data/Runnable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION));
#line 821 "../src/data/Runnable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 821 "../src/data/Runnable.vala"
		value->data[0].v_pointer = v_object;
#line 821 "../src/data/Runnable.vala"
		game_hub_data_runnable_runnable_action_ref (value->data[0].v_pointer);
#line 10857 "Runnable.c"
	} else {
#line 821 "../src/data/Runnable.vala"
		value->data[0].v_pointer = NULL;
#line 10861 "Runnable.c"
	}
#line 821 "../src/data/Runnable.vala"
	if (old) {
#line 821 "../src/data/Runnable.vala"
		game_hub_data_runnable_runnable_action_unref (old);
#line 10867 "Runnable.c"
	}
}

void
game_hub_data_runnable_value_take_runnable_action (GValue* value,
                                                   gpointer v_object)
{
	GameHubDataRunnableRunnableAction * old;
#line 821 "../src/data/Runnable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION));
#line 821 "../src/data/Runnable.vala"
	old = value->data[0].v_pointer;
#line 821 "../src/data/Runnable.vala"
	if (v_object) {
#line 821 "../src/data/Runnable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION));
#line 821 "../src/data/Runnable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 821 "../src/data/Runnable.vala"
		value->data[0].v_pointer = v_object;
#line 10888 "Runnable.c"
	} else {
#line 821 "../src/data/Runnable.vala"
		value->data[0].v_pointer = NULL;
#line 10892 "Runnable.c"
	}
#line 821 "../src/data/Runnable.vala"
	if (old) {
#line 821 "../src/data/Runnable.vala"
		game_hub_data_runnable_runnable_action_unref (old);
#line 10898 "Runnable.c"
	}
}

static void
game_hub_data_runnable_runnable_action_class_init (GameHubDataRunnableRunnableActionClass * klass,
                                                   gpointer klass_data)
{
#line 821 "../src/data/Runnable.vala"
	game_hub_data_runnable_runnable_action_parent_class = g_type_class_peek_parent (klass);
#line 821 "../src/data/Runnable.vala"
	((GameHubDataRunnableRunnableActionClass *) klass)->finalize = game_hub_data_runnable_runnable_action_finalize;
#line 821 "../src/data/Runnable.vala"
	g_type_class_adjust_private_offset (klass, &GameHubDataRunnableRunnableAction_private_offset);
#line 10912 "Runnable.c"
}

static void
game_hub_data_runnable_runnable_action_instance_init (GameHubDataRunnableRunnableAction * self,
                                                      gpointer klass)
{
	GType** _tmp0_;
#line 821 "../src/data/Runnable.vala"
	self->priv = game_hub_data_runnable_runnable_action_get_instance_private (self);
#line 825 "../src/data/Runnable.vala"
	self->priv->_is_primary = FALSE;
#line 826 "../src/data/Runnable.vala"
	self->priv->_is_hidden = FALSE;
#line 831 "../src/data/Runnable.vala"
	_tmp0_ = g_new0 (GType*, 1);
#line 831 "../src/data/Runnable.vala"
	_tmp0_[0] = NULL;
#line 831 "../src/data/Runnable.vala"
	self->priv->_compat_tools = _tmp0_;
#line 831 "../src/data/Runnable.vala"
	self->priv->_compat_tools_length1 = 1;
#line 831 "../src/data/Runnable.vala"
	self->priv->__compat_tools_size_ = self->priv->_compat_tools_length1;
#line 821 "../src/data/Runnable.vala"
	self->ref_count = 1;
#line 10938 "Runnable.c"
}

static void
game_hub_data_runnable_runnable_action_finalize (GameHubDataRunnableRunnableAction * obj)
{
	GameHubDataRunnableRunnableAction * self;
#line 821 "../src/data/Runnable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION, GameHubDataRunnableRunnableAction);
#line 821 "../src/data/Runnable.vala"
	g_signal_handlers_destroy (self);
#line 823 "../src/data/Runnable.vala"
	_g_object_unref0 (self->priv->_runnable);
#line 827 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_name);
#line 828 "../src/data/Runnable.vala"
	_g_object_unref0 (self->priv->_file);
#line 829 "../src/data/Runnable.vala"
	_g_object_unref0 (self->priv->_workdir);
#line 830 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_args);
#line 831 "../src/data/Runnable.vala"
	self->priv->_compat_tools = (_vala_array_free (self->priv->_compat_tools, self->priv->_compat_tools_length1, (GDestroyNotify) g_free), NULL);
#line 832 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_uri);
#line 10963 "Runnable.c"
}

GType
game_hub_data_runnable_runnable_action_get_type (void)
{
	static volatile gsize game_hub_data_runnable_runnable_action_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_runnable_runnable_action_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { game_hub_data_runnable_value_runnable_action_init, game_hub_data_runnable_value_runnable_action_free_value, game_hub_data_runnable_value_runnable_action_copy_value, game_hub_data_runnable_value_runnable_action_peek_pointer, "p", game_hub_data_runnable_value_runnable_action_collect_value, "p", game_hub_data_runnable_value_runnable_action_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GameHubDataRunnableRunnableActionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_runnable_runnable_action_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataRunnableRunnableAction), 0, (GInstanceInitFunc) game_hub_data_runnable_runnable_action_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType game_hub_data_runnable_runnable_action_type_id;
		game_hub_data_runnable_runnable_action_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GameHubDataRunnableRunnableAction", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		GameHubDataRunnableRunnableAction_private_offset = g_type_add_instance_private (game_hub_data_runnable_runnable_action_type_id, sizeof (GameHubDataRunnableRunnableActionPrivate));
		g_once_init_leave (&game_hub_data_runnable_runnable_action_type_id__volatile, game_hub_data_runnable_runnable_action_type_id);
	}
	return game_hub_data_runnable_runnable_action_type_id__volatile;
}

gpointer
game_hub_data_runnable_runnable_action_ref (gpointer instance)
{
	GameHubDataRunnableRunnableAction * self;
	self = instance;
#line 821 "../src/data/Runnable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 821 "../src/data/Runnable.vala"
	return instance;
#line 10991 "Runnable.c"
}

void
game_hub_data_runnable_runnable_action_unref (gpointer instance)
{
	GameHubDataRunnableRunnableAction * self;
	self = instance;
#line 821 "../src/data/Runnable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 821 "../src/data/Runnable.vala"
		GAME_HUB_DATA_RUNNABLE_RUNNABLE_ACTION_GET_CLASS (self)->finalize (self);
#line 821 "../src/data/Runnable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 11005 "Runnable.c"
	}
}

static void
game_hub_data_runnable_class_init (GameHubDataRunnableClass * klass,
                                   gpointer klass_data)
{
#line 27 "../src/data/Runnable.vala"
	game_hub_data_runnable_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/data/Runnable.vala"
	g_type_class_adjust_private_offset (klass, &GameHubDataRunnable_private_offset);
#line 27 "../src/data/Runnable.vala"
	((GameHubDataRunnableClass *) klass)->is_supported = (gboolean (*) (GameHubDataRunnable*, GameHubDataPlatform*, gboolean)) game_hub_data_runnable_real_is_supported;
#line 27 "../src/data/Runnable.vala"
	((GameHubDataRunnableClass *) klass)->can_be_launched = (gboolean (*) (GameHubDataRunnable*, gboolean)) game_hub_data_runnable_real_can_be_launched;
#line 27 "../src/data/Runnable.vala"
	((GameHubDataRunnableClass *) klass)->run_with_compat = (void (*) (GameHubDataRunnable*, gboolean, GAsyncReadyCallback, gpointer)) game_hub_data_runnable_real_run_with_compat;
#line 27 "../src/data/Runnable.vala"
	((GameHubDataRunnableClass *) klass)->run_with_compat_finish = (void (*) (GameHubDataRunnable*, GAsyncResult*)) game_hub_data_runnable_real_run_with_compat_finish;
#line 27 "../src/data/Runnable.vala"
	((GameHubDataRunnableClass *) klass)->setup_executable_chooser = (GtkFileChooser* (*) (GameHubDataRunnable*)) game_hub_data_runnable_real_setup_executable_chooser;
#line 27 "../src/data/Runnable.vala"
	((GameHubDataRunnableClass *) klass)->choose_executable = (void (*) (GameHubDataRunnable*, gboolean)) game_hub_data_runnable_real_choose_executable;
#line 27 "../src/data/Runnable.vala"
	((GameHubDataRunnableClass *) klass)->set_chosen_executable = (void (*) (GameHubDataRunnable*, GFile*, gboolean)) game_hub_data_runnable_real_set_chosen_executable;
#line 27 "../src/data/Runnable.vala"
	((GameHubDataRunnableClass *) klass)->save = (void (*) (GameHubDataRunnable*)) game_hub_data_runnable_real_save;
#line 27 "../src/data/Runnable.vala"
	((GameHubDataRunnableClass *) klass)->update_status = (void (*) (GameHubDataRunnable*)) game_hub_data_runnable_real_update_status;
#line 27 "../src/data/Runnable.vala"
	((GameHubDataRunnableClass *) klass)->import = (void (*) (GameHubDataRunnable*, gboolean)) game_hub_data_runnable_real_import;
#line 27 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_CLASS (klass)->get_default_install_dir = game_hub_data_runnable_real_get_default_install_dir;
#line 27 "../src/data/Runnable.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_hub_data_runnable_get_property;
#line 27 "../src/data/Runnable.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_game_hub_data_runnable_set_property;
#line 27 "../src/data/Runnable.vala"
	G_OBJECT_CLASS (klass)->finalize = game_hub_data_runnable_finalize;
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_ID_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_ESCAPED_NAME_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_ESCAPED_NAME_PROPERTY] = g_param_spec_string ("escaped-name", "escaped-name", "escaped-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_NORMALIZED_NAME_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_NORMALIZED_NAME_PROPERTY] = g_param_spec_string ("normalized-name", "normalized-name", "normalized-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_NAME_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_COMPAT_TOOL_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_COMPAT_TOOL_PROPERTY] = g_param_spec_string ("compat-tool", "compat-tool", "compat-tool", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_COMPAT_TOOL_SETTINGS_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_COMPAT_TOOL_SETTINGS_PROPERTY] = g_param_spec_string ("compat-tool-settings", "compat-tool-settings", "compat-tool-settings", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_ARGUMENTS_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_ARGUMENTS_PROPERTY] = g_param_spec_string ("arguments", "arguments", "arguments", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_IS_RUNNING_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_IS_RUNNING_PROPERTY] = g_param_spec_boolean ("is-running", "is-running", "is-running", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_PLATFORMS_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_PLATFORMS_PROPERTY] = g_param_spec_object ("platforms", "platforms", "platforms", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_EXECUTABLE_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_EXECUTABLE_PROPERTY] = g_param_spec_object ("executable", "executable", "executable", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_INSTALL_DIR_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_INSTALL_DIR_PROPERTY] = g_param_spec_object ("install-dir", "install-dir", "install-dir", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_WORK_DIR_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_WORK_DIR_PROPERTY] = g_param_spec_object ("work-dir", "work-dir", "work-dir", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_DEFAULT_INSTALL_DIR_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_DEFAULT_INSTALL_DIR_PROPERTY] = g_param_spec_object ("default-install-dir", "default-install-dir", "default-install-dir", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_ACTIONS_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_ACTIONS_PROPERTY] = g_param_spec_object ("actions", "actions", "actions", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_USE_COMPAT_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_USE_COMPAT_PROPERTY] = g_param_spec_boolean ("use-compat", "use-compat", "use-compat", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_NEEDS_COMPAT_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_NEEDS_COMPAT_PROPERTY] = g_param_spec_boolean ("needs-compat", "needs-compat", "needs-compat", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_FORCE_COMPAT_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_FORCE_COMPAT_PROPERTY] = g_param_spec_boolean ("force-compat", "force-compat", "force-compat", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_COMPAT_OPTIONS_SAVED_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_COMPAT_OPTIONS_SAVED_PROPERTY] = g_param_spec_boolean ("compat-options-saved", "compat-options-saved", "compat-options-saved", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 340 "../src/data/Runnable.vala"
	g_rec_mutex_init (&__lock_game_hub_data_runnable_game_hub_data_runnable_LastLaunchAttempt);
#line 11083 "Runnable.c"
}

static void
game_hub_data_runnable_instance_init (GameHubDataRunnable * self,
                                      gpointer klass)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
#line 27 "../src/data/Runnable.vala"
	self->priv = game_hub_data_runnable_get_instance_private (self);
#line 54 "../src/data/Runnable.vala"
	self->priv->_is_running = FALSE;
#line 56 "../src/data/Runnable.vala"
	_tmp0_ = gee_array_list_new (GAME_HUB_DATA_TYPE_PLATFORM, NULL, NULL, NULL, NULL, NULL);
#line 56 "../src/data/Runnable.vala"
	self->priv->_platforms = _tmp0_;
#line 74 "../src/data/Runnable.vala"
	_tmp1_ = gee_array_list_new (GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION, (GBoxedCopyFunc) game_hub_data_runnable_runnable_action_ref, (GDestroyNotify) game_hub_data_runnable_runnable_action_unref, NULL, NULL, NULL);
#line 74 "../src/data/Runnable.vala"
	self->priv->_actions = _tmp1_;
#line 11104 "Runnable.c"
}

static void
game_hub_data_runnable_finalize (GObject * obj)
{
	GameHubDataRunnable * self;
#line 27 "../src/data/Runnable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnable);
#line 29 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_id);
#line 31 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_name);
#line 32 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_escaped_name);
#line 33 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_normalized_name);
#line 49 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_compat_tool);
#line 50 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_compat_tool_settings);
#line 52 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_arguments);
#line 56 "../src/data/Runnable.vala"
	_g_object_unref0 (self->priv->_platforms);
#line 70 "../src/data/Runnable.vala"
	_g_object_unref0 (self->priv->_install_dir);
#line 74 "../src/data/Runnable.vala"
	_g_object_unref0 (self->priv->_actions);
#line 27 "../src/data/Runnable.vala"
	G_OBJECT_CLASS (game_hub_data_runnable_parent_class)->finalize (obj);
#line 11135 "Runnable.c"
}

GType
game_hub_data_runnable_get_type (void)
{
	static volatile gsize game_hub_data_runnable_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_runnable_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameHubDataRunnableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_runnable_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataRunnable), 0, (GInstanceInitFunc) game_hub_data_runnable_instance_init, NULL };
		GType game_hub_data_runnable_type_id;
		game_hub_data_runnable_type_id = g_type_register_static (G_TYPE_OBJECT, "GameHubDataRunnable", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		GameHubDataRunnable_private_offset = g_type_add_instance_private (game_hub_data_runnable_type_id, sizeof (GameHubDataRunnablePrivate));
		g_once_init_leave (&game_hub_data_runnable_type_id__volatile, game_hub_data_runnable_type_id);
	}
	return game_hub_data_runnable_type_id__volatile;
}

static void
_vala_game_hub_data_runnable_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	GameHubDataRunnable * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnable);
#line 27 "../src/data/Runnable.vala"
	switch (property_id) {
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_ID_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_string (value, game_hub_data_runnable_get_id (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_ESCAPED_NAME_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_string (value, game_hub_data_runnable_get_escaped_name (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_NORMALIZED_NAME_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_string (value, game_hub_data_runnable_get_normalized_name (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_NAME_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_string (value, game_hub_data_runnable_get_name (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_COMPAT_TOOL_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_string (value, game_hub_data_runnable_get_compat_tool (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_COMPAT_TOOL_SETTINGS_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_string (value, game_hub_data_runnable_get_compat_tool_settings (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_ARGUMENTS_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_string (value, game_hub_data_runnable_get_arguments (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_IS_RUNNING_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_boolean (value, game_hub_data_runnable_get_is_running (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_PLATFORMS_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_object (value, game_hub_data_runnable_get_platforms (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_INSTALL_DIR_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_object (value, game_hub_data_runnable_get_install_dir (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_DEFAULT_INSTALL_DIR_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_take_object (value, game_hub_data_runnable_get_default_install_dir (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_ACTIONS_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_object (value, game_hub_data_runnable_get_actions (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_USE_COMPAT_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_boolean (value, game_hub_data_runnable_get_use_compat (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_NEEDS_COMPAT_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_boolean (value, game_hub_data_runnable_get_needs_compat (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_FORCE_COMPAT_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_boolean (value, game_hub_data_runnable_get_force_compat (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_COMPAT_OPTIONS_SAVED_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_boolean (value, game_hub_data_runnable_get_compat_options_saved (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 11258 "Runnable.c"
		default:
#line 27 "../src/data/Runnable.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/data/Runnable.vala"
		break;
#line 11264 "Runnable.c"
	}
}

static void
_vala_game_hub_data_runnable_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	GameHubDataRunnable * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnable);
#line 27 "../src/data/Runnable.vala"
	switch (property_id) {
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_ID_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_id (self, g_value_get_string (value));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_ESCAPED_NAME_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_escaped_name (self, g_value_get_string (value));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_NORMALIZED_NAME_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_normalized_name (self, g_value_get_string (value));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_NAME_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_name (self, g_value_get_string (value));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_COMPAT_TOOL_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_compat_tool (self, g_value_get_string (value));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_COMPAT_TOOL_SETTINGS_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_compat_tool_settings (self, g_value_get_string (value));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_ARGUMENTS_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_arguments (self, g_value_get_string (value));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_IS_RUNNING_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_is_running (self, g_value_get_boolean (value));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_PLATFORMS_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_platforms (self, g_value_get_object (value));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_INSTALL_DIR_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_install_dir (self, g_value_get_object (value));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_ACTIONS_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_actions (self, g_value_get_object (value));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_FORCE_COMPAT_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_force_compat (self, g_value_get_boolean (value));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_COMPAT_OPTIONS_SAVED_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_compat_options_saved (self, g_value_get_boolean (value));
#line 27 "../src/data/Runnable.vala"
		break;
#line 11356 "Runnable.c"
		default:
#line 27 "../src/data/Runnable.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/data/Runnable.vala"
		break;
#line 11362 "Runnable.c"
	}
}

gchar*
game_hub_data_platform_id (GameHubDataPlatform self)
{
	gchar* result = NULL;
#line 891 "../src/data/Runnable.vala"
	switch (self) {
#line 891 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_PLATFORM_LINUX:
#line 11374 "Runnable.c"
		{
			gchar* _tmp0_;
#line 893 "../src/data/Runnable.vala"
			_tmp0_ = g_strdup ("linux");
#line 893 "../src/data/Runnable.vala"
			result = _tmp0_;
#line 893 "../src/data/Runnable.vala"
			return result;
#line 11383 "Runnable.c"
		}
#line 891 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_PLATFORM_WINDOWS:
#line 11387 "Runnable.c"
		{
			gchar* _tmp1_;
#line 894 "../src/data/Runnable.vala"
			_tmp1_ = g_strdup ("windows");
#line 894 "../src/data/Runnable.vala"
			result = _tmp1_;
#line 894 "../src/data/Runnable.vala"
			return result;
#line 11396 "Runnable.c"
		}
#line 891 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_PLATFORM_MACOS:
#line 11400 "Runnable.c"
		{
			gchar* _tmp2_;
#line 895 "../src/data/Runnable.vala"
			_tmp2_ = g_strdup ("mac");
#line 895 "../src/data/Runnable.vala"
			result = _tmp2_;
#line 895 "../src/data/Runnable.vala"
			return result;
#line 11409 "Runnable.c"
		}
#line 891 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_PLATFORM_EMULATED:
#line 11413 "Runnable.c"
		{
			gchar* _tmp3_;
#line 896 "../src/data/Runnable.vala"
			_tmp3_ = g_strdup ("emulated");
#line 896 "../src/data/Runnable.vala"
			result = _tmp3_;
#line 896 "../src/data/Runnable.vala"
			return result;
#line 11422 "Runnable.c"
		}
		default:
#line 891 "../src/data/Runnable.vala"
		break;
#line 11427 "Runnable.c"
	}
#line 898 "../src/data/Runnable.vala"
	g_assert_not_reached ();
#line 11431 "Runnable.c"
}

gchar*
game_hub_data_platform_name (GameHubDataPlatform self)
{
	gchar* result = NULL;
#line 903 "../src/data/Runnable.vala"
	switch (self) {
#line 903 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_PLATFORM_LINUX:
#line 11442 "Runnable.c"
		{
			gchar* _tmp0_;
#line 905 "../src/data/Runnable.vala"
			_tmp0_ = g_strdup ("Linux");
#line 905 "../src/data/Runnable.vala"
			result = _tmp0_;
#line 905 "../src/data/Runnable.vala"
			return result;
#line 11451 "Runnable.c"
		}
#line 903 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_PLATFORM_WINDOWS:
#line 11455 "Runnable.c"
		{
			gchar* _tmp1_;
#line 906 "../src/data/Runnable.vala"
			_tmp1_ = g_strdup ("Windows");
#line 906 "../src/data/Runnable.vala"
			result = _tmp1_;
#line 906 "../src/data/Runnable.vala"
			return result;
#line 11464 "Runnable.c"
		}
#line 903 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_PLATFORM_MACOS:
#line 11468 "Runnable.c"
		{
			gchar* _tmp2_;
#line 907 "../src/data/Runnable.vala"
			_tmp2_ = g_strdup ("macOS");
#line 907 "../src/data/Runnable.vala"
			result = _tmp2_;
#line 907 "../src/data/Runnable.vala"
			return result;
#line 11477 "Runnable.c"
		}
#line 903 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_PLATFORM_EMULATED:
#line 11481 "Runnable.c"
		{
			gchar* _tmp3_;
#line 908 "../src/data/Runnable.vala"
			_tmp3_ = g_strdup (C_ ("platform", "Emulated"));
#line 908 "../src/data/Runnable.vala"
			result = _tmp3_;
#line 908 "../src/data/Runnable.vala"
			return result;
#line 11490 "Runnable.c"
		}
		default:
#line 903 "../src/data/Runnable.vala"
		break;
#line 11495 "Runnable.c"
	}
#line 910 "../src/data/Runnable.vala"
	g_assert_not_reached ();
#line 11499 "Runnable.c"
}

gchar*
game_hub_data_platform_icon (GameHubDataPlatform self)
{
	gchar* result = NULL;
#line 915 "../src/data/Runnable.vala"
	switch (self) {
#line 915 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_PLATFORM_LINUX:
#line 11510 "Runnable.c"
		{
			gchar* _tmp0_;
#line 917 "../src/data/Runnable.vala"
			_tmp0_ = g_strdup ("platform-linux-symbolic");
#line 917 "../src/data/Runnable.vala"
			result = _tmp0_;
#line 917 "../src/data/Runnable.vala"
			return result;
#line 11519 "Runnable.c"
		}
#line 915 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_PLATFORM_WINDOWS:
#line 11523 "Runnable.c"
		{
			gchar* _tmp1_;
#line 918 "../src/data/Runnable.vala"
			_tmp1_ = g_strdup ("platform-windows-symbolic");
#line 918 "../src/data/Runnable.vala"
			result = _tmp1_;
#line 918 "../src/data/Runnable.vala"
			return result;
#line 11532 "Runnable.c"
		}
#line 915 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_PLATFORM_MACOS:
#line 11536 "Runnable.c"
		{
			gchar* _tmp2_;
#line 919 "../src/data/Runnable.vala"
			_tmp2_ = g_strdup ("platform-macos-symbolic");
#line 919 "../src/data/Runnable.vala"
			result = _tmp2_;
#line 919 "../src/data/Runnable.vala"
			return result;
#line 11545 "Runnable.c"
		}
#line 915 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_PLATFORM_EMULATED:
#line 11549 "Runnable.c"
		{
			gchar* _tmp3_;
#line 920 "../src/data/Runnable.vala"
			_tmp3_ = g_strdup ("gamehub-symbolic");
#line 920 "../src/data/Runnable.vala"
			result = _tmp3_;
#line 920 "../src/data/Runnable.vala"
			return result;
#line 11558 "Runnable.c"
		}
		default:
#line 915 "../src/data/Runnable.vala"
		break;
#line 11563 "Runnable.c"
	}
#line 922 "../src/data/Runnable.vala"
	g_assert_not_reached ();
#line 11567 "Runnable.c"
}

GType
game_hub_data_platform_get_type (void)
{
	static volatile gsize game_hub_data_platform_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_platform_type_id__volatile)) {
		static const GEnumValue values[] = {{GAME_HUB_DATA_PLATFORM_LINUX, "GAME_HUB_DATA_PLATFORM_LINUX", "linux"}, {GAME_HUB_DATA_PLATFORM_WINDOWS, "GAME_HUB_DATA_PLATFORM_WINDOWS", "windows"}, {GAME_HUB_DATA_PLATFORM_MACOS, "GAME_HUB_DATA_PLATFORM_MACOS", "macos"}, {GAME_HUB_DATA_PLATFORM_EMULATED, "GAME_HUB_DATA_PLATFORM_EMULATED", "emulated"}, {0, NULL, NULL}};
		GType game_hub_data_platform_type_id;
		game_hub_data_platform_type_id = g_enum_register_static ("GameHubDataPlatform", values);
		g_once_init_leave (&game_hub_data_platform_type_id__volatile, game_hub_data_platform_type_id);
	}
	return game_hub_data_platform_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

